-- SR3 City Lua file for Sandbox+ - Things To Do In Dominatrix Edition V3.7

-- ****************************************************************************************************
-- CREATED BY:
-- * Fan of Saints - leader of this project, creator of this completely reworked version of Sandbox+.
-- * IdolNinja - creator of original Sandbox+.
-- * Quantum - creator of Working Elevators Mod, he helped me a lot with Three Count crib functions.
-- ****************************************************************************************************
-- CREDITS:
-- * Admixon - I used his Blue Hell TOD as example in custom TOD cycle and he sent me few commands (such as superpower attacks in vehicles or vehicle lights toggle).
-- * Erza Scarlet - I included his Hotspot reset commands, Image as Design fix and Wear simulation clothing while on ship (HTSSC patch).
-- * flow754 - for giving me idea to add unique scripts for Expanded Arsenal Mod weapons and testing co-op features with me.
-- * shitface - I used parts of his NPC Behaviour (weather files and lowered glitch effect frequency), his less TODs add-on from SR4 Ultimate Mod Compilation helped me with removing broken TODs from the cycle (though I didn't remove ugly TODs, I deleted just those completely useless ones).
-- * SkaterSaints - I used some stuff from his version of Sandbox+ (new animations for Playa dance party, Ghost Town modes cycle, break the mission command).
-- * ThatsMe - for giving me plenty of suggestions for enhancing Three Count crib and testing co-op features with me.
-- ****************************************************************************************************
-- TRANSLATION TEAM (IN-GAME SUBTITLES):
-- * Singa - German translation.
-- * -Iker- - Spanish translation.
-- * rastaman289 - French translation.
-- * Arondight - Italian translation.
-- * {JP}OchreHomo Mixer - Japanese translation.
-- * Fan of Saints - Polish translation.
-- * P610 - Russian translation.
-- ****************************************************************************************************
-- IN MEMORY OF JAREK KLOFTA (AKA BADMADSCIENTIST) - REST IN PEACE, WE WILL NEVER FORGET YOU
-- ****************************************************************************************************


-- ****************************************************************************************************
-- BROKEN STUFF AND OTHER NOTES (HELP APPRECIATED):
-- * Parachuting doesn't work properly (parachute and animations aren't preloaded).
-- * Hopefully there's a way to add more hotkeys...
-- ****************************************************************************************************


-- ****************************************************************************************************
-- MODDING PATCH SETTINGS
-- DO NOT TOUCH THOSE IF YOU DON'T HAVE MODDING PATCH!
-- ****************************************************************************************************

-- *** MODDING PATCH ***
-- MODDING_PATCH = false (default) - go with this setting if you don't have modding patch installed.
-- MODDING_PATCH = true enables all commands which require modding patch. Currently it's just VEHICLE_EXPLODE, more to come once Knobby adds something cool.
MODDING_PATCH = false

-- *** VEHICLES EXPLODE WHEN UPSIDE DOWN ***
-- VEHICLE_EXPLODE = false (default) prevents vehicles from catching fire and exploding when upside down. Works only if you have modding patch!
-- VEHICLE_EXPLODE = true makes vehicles explode when upside down.
VEHICLE_EXPLODE = false


-- ****************************************************************************************************
-- MISC SETTINGS
-- ****************************************************************************************************

-- *** GLITCH EFFECT ***
-- GLITCH = false (default) disables simulation on-screen glitch effect.
-- GLITCH = true restores the glitch effect so it's just like in the vanilla game.
GLITCH = false

-- *** POLICE SHOOT FROM VEHICLES (AT SECOND NOTORIETY LEVEL OR HIGHER) ***
-- POLICE_DRIVEBY = true (default) allows cops to start shooting at you from their vehicles at second notoriety level or higher.
-- POLICE_DRIVEBY = false prevents them from shooting at you from their cars. This is the original behavior of the vanilla game.
POLICE_DRIVEBY = true

-- *** TUTORIAL POPUPS - DOES NOT AFFECT MISSIONS! ***
-- SHOW_TUTORIAL = false (default) disables all open world tutorial messages (does not affect missions).
-- SHOW_TUTORIAL = true enables tutorial messages.
SHOW_TUTORIAL = false

-- *** SUPERPOWER ATTACKS IN VEHICLES ***
-- VEHICLE_SUPERPOWERS = true (default) allows you to use superpower attacks in vehicles. It's a bit buggy but fun.
-- VEHICLE_SUPERPOWERS = false locks superpower attacks in vehicles.
VEHICLE_SUPERPOWERS = true


-- ****************************************************************************************************
-- SANDBOX+ SETTINGS
-- ****************************************************************************************************

-- *** SANDBOX+ HOTKEYS ***
-- KEYCOMBO_THREAD_ON = 1 (default) enables Sandbox+ hotkeys. You can use them whenever you want, even during missions.
-- KEYCOMBO_THREAD_ON = 0 disables all Sandbox+ hotkeys. Use this setting if you would like to start a new game and those hotkeys are too tempting for you.
local KEYCOMBO_THREAD_ON = 1

-- *** CO-OP COMMANDS ***
-- COOP_COMMANDS = true (default) makes all Sandbox+ commands affect your co-op partner (if co-op is active).
-- COOP_COMMANDS = false makes Sandbox+ commands affect the host only.
COOP_COMMANDS = true

-- *** HUD MESSAGES AND SOUND EFFECTS ***
-- HUD_MSG = true (default) displays Sandbox+ messages every time you use a hotkey. Some hotkeys have unique sound effects too.
-- HUD_MSG = false disables all Sandbox+ messages and sound effects (except error alerts).
HUD_MSG = true

-- *** LOCK NOTORIETY (AFFECTS JUST NOTORIETY CYCLE!) ***
-- LOCK_NOTORIETY = true (default) locks notoriety at specified level so it can't be decreased nor increased as long as notoriety cycle is active.
-- LOCK_NOTORIETY = false allows notoriety to be decreased/increased depending on player's actions, despite notoriety cycle being active.
LOCK_NOTORIETY = true


-- ****************************************************************************************************
-- EXPANDED ARSENAL MOD SETTINGS
-- THOSE WON'T AFFECT THE GAME IF EXPANDED ARSENAL MOD ISN'T INSTALLED
-- ****************************************************************************************************

-- *** ENHANCED WEAPONS SCRIPT ***
-- EAM_WEAPONS = true (default) enables unique scripts for Expanded Arsenal Mod weapons (currently there are scripts for Fear Gun, Micronizer, Glitch Gun and Lazarus Rifle).
-- EAM_WEAPONS = false disables scripts for Expanded Arsenal Mod weapons.
EAM_WEAPONS = true

-- *** SATCHEL CHARGES FIX ***
-- EAM_SATCHEL = true (default) disables superpower attacks if satchel charges are equipped. This way you can detonate them without throwing an attack.
-- EAM_SATCHEL = false leaves superpower attacks enabled if satchel charges are equipped.
EAM_SATCHEL = true


-- ****************************************************************************************************
-- CRIB SETTINGS
-- THOSE WORK ONLY ONCE YOU COMPLETE THE STORYLINE! OTHERWISE THEY WILL BE IGNORED
-- ****************************************************************************************************

-- *** MENU PROMPTS INSIDE CRIBS ***
-- CRIB_PROMPTS = true (default) enables menu prompts inside cribs. You can activate Gateway, Terminal Z-01, character creation and Friendly Fire menus in most of cribs.
-- CRIB_PROMPTS = false disables all menu prompts inside cribs.
CRIB_PROMPTS = true

-- *** NOTORIETY INSIDE THE CRIB ***
-- CRIB_NOTORIETY = true (default) leaves notoriety at current level inside cribs. Zin portals spawn inside and it's quite fun to fight them.
-- CRIB_NOTORIETY = false resets notoriety inside cribs. That's how cribs worked in Saints Row: The Third but I don't think it was a good idea.
CRIB_NOTORIETY = true

-- *** CUTSCENE TELEPORT ***
-- CRIB_CUTSCENE = "threecount" (default) teleports the player to Three Count crib after replaying a cutscene via hotkey.
-- CRIB_CUTSCENE = "brokenshillelagh" teleports the player to Broken Shillelagh after replaying a cutscene via hotkey.
-- CRIB_CUTSCENE = "kinziewarehouse" teleports the player to Kinzie's Warehouse after replaying a cutscene via hotkey.
-- CRIB_CUTSCENE = "saintshq" teleports the player to Saints HQ after replaying a cutscene via hotkey.
-- CRIB_CUTSCENE = false teleports the player to Gateway in Sunset Park after replaying a cutscene via hotkey. This is setting from original Sandbox+.
CRIB_CUTSCENE = "threecount"

-- *** TELEPORT TO CRIB AT STARTUP ***
-- CRIB_STARTUP = "threecount" (default) teleports the player to Three Count crib right after loading a save.
-- CRIB_STARTUP = "brokenshillelagh" teleports the player to Broken Shillelagh right after loading a save.
-- CRIB_STARTUP = "kinziewarehouse" teleports the player to Kinzie's Warehouse right after loading a save.
-- CRIB_STARTUP = "saintshq" teleports the player to Saints HQ right after loading a save.
-- CRIB_STARTUP = false disables teleport to crib at startup feature.
-- WARNING! THIS MIGHT CAUSE MUCH LONGER LOAD TIME AND PERFORMANCE ISSUES ON LOW END COMPUTERS! MAKE SURE YOU DIDN'T SAVE THE GAME ON THE SHIP!
CRIB_STARTUP = "threecount"

-- *** BROKEN SHILLELAGH CRIB ***
-- BROKEN_SHILLELAGH = true (default) enables menu prompts inside Broken Shillelagh so it works just like Saints HQ and Three Count. It also resets your notoriety once you go inside (if CRIB_NOTORIETY is set to false).
-- BROKEN_SHILLELAGH = false disables all crib functions inside Broken Shillelagh.
BROKEN_SHILLELAGH = true

-- *** KINZIE'S WAREHOUSE CRIB ***
-- KINZIE_WAREHOUSE = true (default) enables menu prompts inside Kinzie's Warehouse so it works just like Saints HQ and Three Count. It also resets your notoriety once you go inside (if CRIB_NOTORIETY is set to false).
-- KINZIE_WAREHOUSE = false disables all crib functions inside Kinzie's Warehouse.
KINZIE_WAREHOUSE = true

-- ****************************************************************************************************
-- SAINTS HQ SETTINGS
-- THOSE WORK ONLY ONCE YOU COMPLETE THE STORYLINE! OTHERWISE THEY WILL BE IGNORED
-- ****************************************************************************************************

-- *** MAGARAC ISLAND STATE ***
-- SAINTSHQ_JOE = true (default) puts statue of Joe Magarac on the Magarac Island.
-- SAINTSHQ_JOE = false removes statue of Joe Magarac from the Magarac Island.
SAINTSHQ_JOE = true

-- *** SUPERPOWERS INSIDE SAINTS HQ ***
-- SAINTSHQ_SUPERPOWERS = false (default) disables superpower movement inside Saints HQ by default. This way you won't destroy whole crib by just running but you also won't be able to explore locations outside.
-- SAINTSHQ_SUPERPOWERS = true enables superpower movement inside Saints HQ by default. It's useful if you'd like to go sightseeing but might be annoying inside the interior. It's also toggleable via prompt.
SAINTSHQ_SUPERPOWERS = false

-- *** TIME OF DAY INSIDE SAINTS HQ ***
-- SAINTSHQ_TOD = "nm_dark_tod_override" (default) forces The Saints Flow time of day once you enter Saints HQ. You can type any other TODX filename there if you want.
-- SAINTSHQ_TOD = false disables Saints HQ time of day override.
SAINTSHQ_TOD = "nm_dark_tod_override"


-- ****************************************************************************************************
-- THREE COUNT SETTINGS
-- THOSE WORK ONLY ONCE YOU COMPLETE THE STORYLINE! OTHERWISE THEY WILL BE IGNORED
-- ****************************************************************************************************

-- *** AMBIENT MUSIC INSIDE THREE COUNT INTERIOR ***
-- THREECOUNT_MUSIC = true (default) enables ambient music inside Three Count interior. It will mute automatically once you enable on-foot radio.
-- THREECOUNT_MUSIC = false disables ambient music inside Three Count interior.
-- WARNING! THIS MIGHT CAUSE AUDIO ISSUES IF YOU RELOAD A SAVE WHEN INSIDE THREE COUNT INTERIOR!
THREECOUNT_MUSIC = true

-- *** CHANGE THREE COUNT STATE TO SAINTS CRIB ***
-- THREECOUNT_SAINTS = true (default) turns Three Count into Saints crib.
-- THREECOUNT_SAINTS = false resets Three Count to its original state.
THREECOUNT_SAINTS = true

-- *** TIME OF DAY INSIDE THREE COUNT CRIB ***
-- THREECOUNT_TOD = "dlc1_m01_tod_override" (default) forces Enter the Dominatrix time of day once you enter Three Count crib. You can type any other TODX filename there if you want.
-- THREECOUNT_TOD = false disables Three Count time of day override.
THREECOUNT_TOD = "dlc1_m01_tod_override"


-- ****************************************************************************************************
-- QUANTUM'S WORKING ELEVATORS MOD SETTINGS
-- THIS MOD IS ALREADY INCLUDED IN SANDBOX+, YOU DON'T HAVE TO INSTALL ANY EXTERNAL MODS!
-- ****************************************************************************************************

-- *** QUANTUM'S WORKING ELEVATORS MOD ***
-- ELEVATOR_MOD = true (default) enables elevator functions from Quantum's Working Elevators Mod. It enables plenty of unusable elevators, it's also required for functional cribs.
-- ELEVATOR_MOD = false disables all elevator functions from Quantum's Working Elevators Mod. There's hardly a reason to disable them.
ELEVATOR_MOD = true


-- ****************************************************************************************************
-- SANDBOX+ ON-FOOT RADIO SETTINGS
-- ****************************************************************************************************

-- *** RANDOMIZE MUSIC ***
-- randomize_music = "off" (default) puts all tracks in the order you see them below in the RadioData table.
-- randomize_music = "on" forces all playlists to reshuffle automatically.
local randomize_music = "off"

-- *** MIXTAPE PLAYLIST ***
-- NOTE: This applies to each entry in the following RadioData table.
-- mixtape = true will add the track to your on-foot custom playlist.
-- mixtape = false (default) will exclude that track from your on-foot custom playlist.

local RadioData =
{
	-- MISSION MUSIC
	{ mixtape = false	,SongString = "Misc - Loading Screen",										SongData = "LOAD_MUSIC",						station = "MISSION" },
	{ mixtape = false	,SongString = "Misc - Romance Music",										SongData = "CS_FUCKBUDDY_MUSIC",				station = "MISSION" },
	{ mixtape = false	,SongString = "Misc - Sleazy Music",										SongData = "AMB_DT_SLEAZYMUSIC",				station = "MISSION" },
	{ mixtape = false	,SongString = "Misc - Warden Music",										SongData = "WARDEN_MUSIC_START",				station = "MISSION" },
	{ mixtape = false	,SongString = "A Pleasant Day - Pleasantville Music",						SongData = "M02_MUSIC",							station = "MISSION" },
	{ mixtape = false	,SongString = "A Pleasant Day - Leave it to the Saints",					SongData = "M02_TITLEMUSIC",					station = "MISSION" },
	{ mixtape = false	,SongString = "A Pleasant Day - Dreamin' Skeemen",							SongData = "M02_MUSIC_DRIVING_01",				station = "MISSION" },
	{ mixtape = false	,SongString = "The Saints Flow - Intro",									SongData = "M09_MUSIC_PH_INTRO",				station = "MISSION" },
	{ mixtape = false	,SongString = "The Saints Flow - Penthouse",								SongData = "M09_MUSIC_CP_PENTHOUSE",			station = "MISSION" },
	{ mixtape = false	,SongString = "The Saints Flow - Rooftop",									SongData = "M09_MUSIC_CP_ROOFTOP",				station = "MISSION" },
	{ mixtape = false	,SongString = "The Saints Flow - Final Battle",								SongData = "M09_MUISIC_FINAL_BATTLE_CP",		station = "MISSION" },
	{ mixtape = false	,SongString = "Saints of Rage - Winners Don't Use Drugs",					SongData = "SAINTS_OF_RAGE_MENU_START",			station = "MISSION" },
	{ mixtape = false	,SongString = "Saints of Rage - Stage 1",									SongData = "M15_MUSIC_S1_A_START",				station = "MISSION" },
	{ mixtape = false	,SongString = "Saints of Rage - Stage 1 Boss (Warren's Bodyguards)",		SongData = "M15_MUSIC_S1_BOSS_START",			station = "MISSION" },
	{ mixtape = false	,SongString = "Saints of Rage - Stage 1 Clear",								SongData = "M15_MUSIC_S1_STAGE_CLEAR",			station = "MISSION" },
	{ mixtape = false	,SongString = "Saints of Rage - Stage 2",									SongData = "M15_MUSIC_S2_A_START",				station = "MISSION" },
	{ mixtape = false	,SongString = "Saints of Rage - Stage 2 Boss (Warren Williams)",			SongData = "M15_MUSIC_S2_BOSS_START",			station = "MISSION" },
	{ mixtape = false	,SongString = "Saints of Rage - Stage 2 Clear",								SongData = "M15_MUSIC_S2_STAGE_CLEAR",			station = "MISSION" },
	{ mixtape = false	,SongString = "Saints of Rage - Stage 3",									SongData = "M15_MUSIC_S3_A",					station = "MISSION" },
	{ mixtape = false	,SongString = "Saints of Rage - Stage 3 Boss (Jyunichi)",					SongData = "M15_MUSIC_S3_BOSS_START",			station = "MISSION" }

}

-- ****************************************************************************************************
-- END OF THE SETTINGS - DO NOT CHANGE ANYTHING BELOW IF YOU AREN'T FAMILIAR WITH LUA!
-- ****************************************************************************************************


-- Sandbox+ on-foot radio thread vars
local MixtapeData = {}
local MissionData = {}

local radio_song_status = "off"
local current_radio_song = ""
local Custom_Radio_Handle = INVALID_THREAD_HANDLE
local CUSTOM_RADIO_THREAD_ON = 1

local Mixtape_Counter = 1
local Mission_Counter = 1

-- Buttons:
B_INSERT = "CBA_VDC_OFFHAND_GRENADE"
B_HOME = "CBA_WRECKER_EXTEND_CORD"
B_PGUP = "CBA_WRECKER_RETRACT_CORD"
B_DELETE = "CBA_GAC_CANCEL_ACTIVITY"
B_END = "CBA_VDC_WATERCRAFT_FIRE_SECONDARY"
B_PGDWN = "CBA_OFC_DEBUG_PRATFALL"
B_RIGHT = "CBA_SKYDIVE_DIVE"
B_DOWN = "CBA_TOW_TRUCK_TOWING_RIGHT"
B_LEFT = "CBA_TOW_TRUCK_TOWING_LEFT"
B_UP = "CBA_TOW_TRUCK_RELEASE_VEHICLE"
B_LBRACKET = "CBA_FIGHT_CLUB_BLOCK"
B_RBRACKET = "CBA_MP_SCOREBOARD"

-- Misc thread vars
Misc_Handle = INVALID_THREAD_HANDLE
MISC_THREAD_ON = 1
SANDBOX_COP_NOTORIETY_CHECK = 0.0

-- Keycombo thread vars
local Keycombo_Handle = INVALID_THREAD_HANDLE
SUPERPOWER_MOVEMENT = 1
SUPERPOWER_ATTACKS = true
SUPERPOWER_COOLDOWN = true
GOD_MODE = 1
GHOST_TOWN = 1
CIV_GLITCHED = false
GRAVITY = true
ANIM_SWAP = 1
DRUNK = 1
DRUGS = 1
VIRTUAL_REALITY = false
HEIGHT_DOWN = 1
HEIGHT_UP = 1
TEAM = 1
FLWR_WEAPS = 1
CUSTOM_SPAWNING = 1
CUSTOM_NOTORIETY = 1
NOTORIETY_ZIN = 1
WARDEN_INSTANT = false
SLEW_MODE = 1
TOD_COUNTER = 1
TOD_COUNTER_GOOH = 1
TOD_COUNTER_SRTT = 1
TOD_COUNTER_CUSTOM = 1
WARDEN_NOTORIETY = true
RESTRICTED_ZONES = true
ASCII_MODE = false
RETICLE_OVERRIDE = 1
FOLLOWERS_INSANE = false
VEHICLE_INVULNERABLE = false
VEHICLE_MASS = false
VEHICLE_KNEECAPPERS = false
VEHICLE_LIGHTS = false
VEHICLE_LOCKED = false
VEHICLE_NOFLIP = false
VEHICLE_FIRE = false
PASSENGER_MODE = 0
PLAYA_DANCE_PARTY = 1
GOD_MODE_FOLLOWERS = 1
TRAFFIC_DENSITY = 1
PHONE_ON = false
PED = 1
GENDER = true
FOLLOWER_TEAM = 1
FOLLOWERS_PSYCHO = true
DRUNK_ANIMS = false
PLAYER_VISIBLE = false
PLAYA_DANCE_COUNTER = 1
GOD_MODE_FOLLOWERS = 1
passenger_activated = 0
COMBAT_READY = false
TEAM_CIVILIAN = 1
TEAM_FIRE = 1
FOLLOWER_WEAPONS = 1
PED = 1
NOTORIETY_ZERO = false
FOLLOWERS_INVULNERABLE = true
DRUNK_COUNTER = 1
UNDERCOVER_TEAM = 7
FOLLOWER_WEAPONS = 1
PLAYA_DANCE_COUNTER = 1
MISSION_WEAPONS = 1
PLAYA_DANCE_COUNTER_B = 1
SEATS = 1
MISSION_WEAPONS2 = 1
PICKUP = true

-- Attach effects thread vars
Effects_Handle = INVALID_THREAD_HANDLE
EFFECTS_THREAD_ON = 1
effects_count = 1
effects_current = ""
effects_delay = 0.5
effects_toggle = false

-- Expanded Arsenal Mod thread vars
EAM_Handle = INVALID_THREAD_HANDLE
EAM_THREAD_ON = 1
EAM_FEARGUN = false
EAM_MICRONIZER = false
EAM_GLITCHGUN = false
EAM_SATCHEL_TEMP = false

-- Crib thread vars
Crib_Handle = INVALID_THREAD_HANDLE
CRIB_THREAD_ON = 1
AMBIENT_MUSIC = ""
CRIB_DRUG = false
INSIDE_SAINTSHQ = false
INSIDE_THREECOUNT = false
THREECOUNT_SAINTS_ALT = false
THREECOUNT_SAINTS_REPLAY = false
THREECOUNT_SAINTS_TEMP = false

-- Working Elevators Mod thread vars
Elevator_Handle = INVALID_THREAD_HANDLE
ELEVATOR_THREAD_ON = 1

-- HUD stuff
local Openworld_hud_state = {
	hide_minimap = -1,
	hide_everything = -1
}
HUD_NORMAL = true

-- Pivot states for key combos
CROUCH_PUSHED = false
RECRUIT_PUSHED = false
TAUNT_PUSHED = false
COMPLIMENT_PUSHED = false
USE_PUSHED = false
GRENADE_PUSHED = false
RELOAD_PUSHED = false
MELEE_PUSHED = false
ONE_PUSHED = false
TWO_PUSHED = false
THREE_PUSHED = false
FOUR_PUSHED = false
FIVE_PUSHED = false
SIX_PUSHED = false
SEVEN_PUSHED = false
EIGHT_PUSHED = false

-- Used for custom teleports
ctele_Posx = 1361.8412
ctele_Posy = -818.131
ctele_Posz = 32.8916


-- ****************************************************************************************************
-- BEGIN SANDBOX+ ON-FOOT RADIO THREAD
-- ****************************************************************************************************

function Create_Radio_Station_Tables(randomize)
	-- This function is for the on foot radio. It loops through the big RadioData table and populates a bunch of individual station tables with specfic songs. This is so the player can remove lines or change mixtape to true/false for his playlist in RadioData and still have it dynamically build everything correctly.
	local MissionIndex = 1
	local MixtapeIndex = 1
	local entries = {}

	kill_radio_music()
	if randomize == "on" then
		shuffle(RadioData)
	end
	for idx, song in pairs(RadioData) do
		if song.station == "MISSION" then
			local entry = { playnumber = MissionIndex, SongString = song.SongString, SongData = song.SongData, station = song.station }
			MissionData[MissionIndex] = entry
			MissionIndex = MissionIndex + 1
		end

		-- Any RadioData table entry with mixtape set to true will add that song to the on-foot mixtape table
		if song.mixtape then
			local entry = { playnumber = MixtapeIndex, SongString = song.SongString, SongData = song.SongData, station = song.station }
			MixtapeData[MixtapeIndex] = entry
			MixtapeIndex = MixtapeIndex + 1
		end
	end
end

function shuffle(table)
	local tmpCounter = #table
	while tmpCounter >= 2 do
		local random_pos = rand_int(1,tmpCounter)
		table[tmpCounter], table[random_pos] = table[random_pos], table[tmpCounter]
		tmpCounter = tmpCounter - 1
	end
	return table
end

function advance_next_song(station)
	radio_on_foot_enable(false)
	if station == "Mission" then
		for idx, song in pairs(MissionData) do
			if song.playnumber == Mission_Counter then
				current_radio_song = audio_object_post_event(song.SongData)
				sandbox_message(" NOW PLAYING:".."\n"..song.SongString)
			end
		end
		if Mission_Counter == #MissionData then
			Mission_Counter = 1
		else
			Mission_Counter = Mission_Counter + 1
		end
		radio_song_status = "Mission"
	elseif station == "Mixtape" then
		for idx, song in pairs(MixtapeData) do
			if song.playnumber == Mixtape_Counter then
				current_radio_song = audio_object_post_event(song.SongData)
				sandbox_message("NOW PLAYING:".."\n"..song.SongString)
			end
		end
		if Mixtape_Counter == #MixtapeData then
			Mixtape_Counter = 1
		else
			Mixtape_Counter = Mixtape_Counter + 1
		end
		radio_song_status = "Mixtape"
	end
end

function custom_radio_monitor()
	local playtest
	while CUSTOM_RADIO_THREAD_ON == 1 do
		if radio_song_status == "off" then
		else
			playtest = audio_is_playing(current_radio_song)
			if not playtest then
				advance_next_song(radio_song_status)
			end
		end
	delay(4.0)
	end
end

function kill_radio_music()
	audio_stop(current_radio_song)
	radio_song_status = "off"
	radio_on_foot_enable(true)
end

-- ****************************************************************************************************
-- END SANDBOX+ ON-FOOT RADIO THREAD
-- ****************************************************************************************************


-- ****************************************************************************************************
-- BEGIN MISC THREAD
-- THIS IS THE MOST IMPORTANT THREAD, EVERYTHING WILL FALL APART IF IT'S DISABLED!
-- ****************************************************************************************************

function misc_thread()
	while MISC_THREAD_ON == 1 do

		-- ALWAYS CLEAR HUD PROMPTS BEFORE GOING TO OTHER THREADS
		-- THIS IS VERY IMPORTANT FOR EAM_WEAPONS, CRIB_PROMPTS AND ELEVATOR_MOD SETTINGS
		hud_prompt_clear(LOCAL_PLAYER)

		-- RESET CRIBS IF PLAYER DIES INSIDE
		if character_is_dead(LOCAL_PLAYER) then
			reset_crib_interior()
		end

		-- CHECK NOTORIETY LEVEL
		SANDBOX_COP_NOTORIETY_CHECK = notoriety_get_decimal("police")	-- Used by POLICE_DRIVEBY and WARDEN_INSTANT

		-- KILL SANDBOX+ ON-FOOT RADIO IF STORE INTERFACE IS ACTIVE
		if store_interface_is_active() then
			kill_radio_music()
		end

		-- SET GLITCH
		if not GLITCH then
			set_glitch_override(-1.0, true)	-- Disable glitch effect at startup (default setting)
		else
			set_glitch_override(0.0, false)	-- Revert glitch effect to vanilla
		end

		-- SET POLICE_DRIVEBY
		if POLICE_DRIVEBY then
			if SANDBOX_COP_NOTORIETY_CHECK >= 2.0 then
				set_cops_shooting_from_vehicles(true)	-- Enable police shooting from vehicles (default setting)
			elseif SANDBOX_COP_NOTORIETY_CHECK < 2.0 then
				set_cops_shooting_from_vehicles(false)	-- Revert police behavior to vanilla (if notoriety level is lower than 2)
			end
		else
			set_cops_shooting_from_vehicles(false)	-- Revert police behavior to vanilla (if POLICE_DRIVEBY is set to false)
		end

		-- SET SHOW_TUTORIAL
		if not mission_is_active() and not SHOW_TUTORIAL then
			tutorial_suspend_all(true)	-- Disable tutorial popups if mission is not active (default setting)
		else
			tutorial_suspend_all(false)	-- Revert tutorial popups to vanilla
		end

		-- SET VEHICLE_EXPLODE
		if MODDING_PATCH then
			if not VEHICLE_EXPLODE then
				vehicle_disable_fire_when_upside_down(true)	-- Disable vehicles exploding when upside down (only if modding patch is installed)
			else
				vehicle_disable_fire_when_upside_down(false)	-- Revert vehicle behavior to vanilla
			end
		end

		-- SET VEHICLE_SUPERPOWERS
		if VEHICLE_SUPERPOWERS and SUPERPOWER_ATTACKS then
			player_can_use_super_powers_in_vehicle(LOCAL_PLAYER, true)	-- Enable superpower attacks in vehicles (default setting)
			if coop_is_active() then
				player_can_use_super_powers_in_vehicle(REMOTE_PLAYER, true)	-- Enable superpower attacks in vehicles for co-op partner (if co-op is active)
			end
		else
			player_can_use_super_powers_in_vehicle(LOCAL_PLAYER, false)	-- Revert superpower attacks to vanilla (if SUPERPOWER_ATTACKS is set to false)
			if coop_is_active() then
				player_can_use_super_powers_in_vehicle(REMOTE_PLAYER, false)	-- Revert superpower attacks to vanilla for co-op partner (if co-op is active)
			end
		end

		delay(0.5)
	end
end

-- ****************************************************************************************************
-- END MISC THREAD
-- ****************************************************************************************************


-- ****************************************************************************************************
-- BEGIN KEYCOMBO THREAD
-- ****************************************************************************************************

function keycombo_thread()
	while KEYCOMBO_THREAD_ON == 1 do
		if player_action_is_pressed("CBA_GAC_RECRUIT_DISMISS") then -- Z (recruit/dismiss) - TELEPORTS
			if player_action_is_pressed(B_INSERT) and not RECRUIT_PUSHED then
				-- TELEPORT TO SAINTS ZERO THIRTY INSIDE BASE
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("M_00", true)
				local tposx,tposy,tposz = (2760.611 - ctele_Posx), (-304.804 - ctele_Posy), (445.112 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Zero Saints Thirty")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				RECRUIT_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not RECRUIT_PUSHED then
				-- TELEPORT TO SAINTS ZERO THIRTY CUTSCENE (OUTSIDE)
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("M_00", true)
				local tposx,tposy,tposz = (2051.361 - ctele_Posx), (-2492.004 - ctele_Posy), (545.961 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Zero Saints Thirty - Outside base")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				RECRUIT_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not RECRUIT_PUSHED then
				-- TELEPORT TO WHITE HOUSE - CUTSCENE FLOOR
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("wh", true)
				local tposx,tposy,tposz = (589.623 - ctele_Posx), (2014.219 - ctele_Posy), (317.826 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to White House - Cutscene Floor")
				-- Found By Pliskin Hunter
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				RECRUIT_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not RECRUIT_PUSHED then
				-- TELEPORT TO WHITE HOUSE PRESS CONFERENCE
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("wh", true)
				local tposx,tposy,tposz = (633.256 - ctele_Posx), (1960.711 - ctele_Posy), (326.396 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to White House - Press conference")
				-- Found By Pliskin Hunter
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				RECRUIT_PUSHED = true
			elseif player_action_is_pressed(B_END) and not RECRUIT_PUSHED then
				-- TELEPORT TO WHITE CRIB 1
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("wh", true)
				local tposx,tposy,tposz = (681.894 - ctele_Posx), (1961.763 - ctele_Posy), (340.132 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to White House 1 destroyed")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				RECRUIT_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not RECRUIT_PUSHED then
				-- TELEPORT TO WHITE CRIB 2
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("wh", true)
				local tposx,tposy,tposz = (683.452 - ctele_Posx), (1978.624 - ctele_Posy), (340.132 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to White House 2 destroyed")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				RECRUIT_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not RECRUIT_PUSHED then
				-- TELEPORT TO PLEASANTVILLE
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("pv", true)
				local tposx,tposy,tposz = (242.062 - ctele_Posx), (-2288.013 - ctele_Posy), (5.606 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Pleasantville")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				RECRUIT_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not RECRUIT_PUSHED then
				-- TELEPORT TO ZIN SHIP - THE ESCAPE
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("m3_escape", true)
				local tposx,tposy,tposz = (-2184.858 - ctele_Posx), (-2441.276 - ctele_Posy), (351.005 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to The Escape - Zin ship")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				RECRUIT_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not RECRUIT_PUSHED then
				-- TELEPORT TO ZIN SHIP - FYING SECTION
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("m3_fox", true)
				local tposx,tposy,tposz = (-1681.257 - ctele_Posx), (-1243.657 - ctele_Posy), (1094.517 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to The Escape - Flying section")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				RECRUIT_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not RECRUIT_PUSHED then
				-- TELEPORT TO MILLER SPACE VIRTUAL PRISON
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("vr", true)
				local tposx,tposy,tposz = (-2326.832 - ctele_Posx), (1035.341 - ctele_Posy), (1183.765 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Miller Space - Virtual Prison")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				RECRUIT_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not RECRUIT_PUSHED then
				-- TELEPORT TO MILLER SPACE CHOOSE DOOR
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("vr", true)
				local tposx,tposy,tposz = (-1793.410 - ctele_Posx), (1580.336 - ctele_Posy), (1020.260  - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Miller Space - Virtual Prison")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				RECRUIT_PUSHED = true
			elseif player_action_is_pressed(B_RBRACKET) and not RECRUIT_PUSHED then
				-- TELEPORT TO MATT MILLER RESCUE
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("m7_matt", true)
				local tposx,tposy,tposz = (2094.197 - ctele_Posx), (-2327.994 - ctele_Posy), (387.246 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Matt Miller rescue")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				RECRUIT_PUSHED = true
			end

		elseif player_action_is_pressed("CBA_OFC_TAUNT_TWO") then -- X (taunt) - TELEPORTS
			if player_action_is_pressed(B_INSERT) and not TAUNT_PUSHED then
				-- TELEPORT TO DE PLANE 1
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("m3", true)
				city_zone_swap("int_m2", true)
				local tposx,tposy,tposz = (1885.904 - ctele_Posx), (1508.658 - ctele_Posy), (1422.657 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to De Plane 1")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				TAUNT_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not TAUNT_PUSHED then
				-- TELEPORT TO DE PLANE 2
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("m3", true)
				city_zone_swap("int_m2", true)
				local tposx,tposy,tposz = (1835.632 - ctele_Posx), (1433.058 - ctele_Posy), (1416.290 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to De Plane 2")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				TAUNT_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not TAUNT_PUSHED then
				-- TELEPORT TO ON TRACK NIGHT CLUB
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("m3", true)
				city_zone_swap("int_m2", true)
				local tposx,tposy,tposz = (-536.369 - ctele_Posx), (1908.538 - ctele_Posy), (73.901 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to De Plane - On Track Night Club")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				TAUNT_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not TAUNT_PUSHED then
				-- TELEPORT TO STILWATER
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("m3", true)
				local tposx,tposy,tposz = (-725.875 - ctele_Posx), (2048.167 - ctele_Posy), (61.127 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Stilwater")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				TAUNT_PUSHED = true
			elseif player_action_is_pressed(B_END) and not TAUNT_PUSHED then
				-- TELEPORT TO FROM ASHA WITH LOVE
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("m11", true)
				local tposx,tposy,tposz = (357.622 - ctele_Posx), (-940.384 - ctele_Posy), (279.261 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to From Asha with Love")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				TAUNT_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not TAUNT_PUSHED then
				-- TELEPORT TO GAT SIDESCROLLER
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("2D", true)
				local tposx,tposy,tposz = (1245.076 - ctele_Posx), (2099.174 - ctele_Posy), (7.705 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to 2D Sidescroller")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				TAUNT_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not TAUNT_PUSHED then
				-- TELEPORT TO GAT RESCUE
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("m15_gat", true)
				local tposx,tposy,tposz = (2038.271 - ctele_Posx), (-2283.120 - ctele_Posy), (405.005 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Gat rescue")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				TAUNT_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not TAUNT_PUSHED then
				-- TELEPORT TO KINZIE GAMIT GENKI AREA TURRETS
				reset_crib_interior()
				reset_all_zones()
				local tposx,tposy,tposz = (492.145 - ctele_Posx), (108.695 - ctele_Posy), (-313.874 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Kinzie Gambit - Genki area turrets")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				TAUNT_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not TAUNT_PUSHED then
				-- TELEPORT TO KINZIE GAMBIT GENKI AREA KILLING FLOOR
				reset_crib_interior()
				reset_all_zones()
				local tposx,tposy,tposz = (470.699 - ctele_Posx), (107.970 - ctele_Posy), (-313.979 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Kinzie Gambit - Genki area killing floor")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				TAUNT_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not TAUNT_PUSHED then
				-- TELEPORT TO ALL HANDS ON DECK
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("m17", true)
				local tposx,tposy,tposz = (108.406 - ctele_Posx), (1096.709 - ctele_Posy), (-209.037 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to All Hands on Deck - Zin Ship")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				TAUNT_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not TAUNT_PUSHED then
				-- TELEPORT TO HE LIVES - OFFICE
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("m18_tv", true)
				local tposx,tposy,tposz = (-25.826 - ctele_Posx), (-153.637 - ctele_Posy), (14.444 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to He Lives - Office")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				TAUNT_PUSHED = true
			elseif player_action_is_pressed(B_RBRACKET) and not TAUNT_PUSHED then
				-- TELEPORT TO HE LIVES - NIGHTMARE
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("m18_tv", true)
				local tposx,tposy,tposz = (825.227 - ctele_Posx), (-2552.652 - ctele_Posy), (26.037 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to He Lives - Nightmare")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				TAUNT_PUSHED = true
			end

		elseif player_action_is_pressed("CBA_OFC_TAUNT_THREE") then -- C (compliment) - TELEPORTS
			if player_action_is_pressed(B_INSERT) and not COMPLIMENT_PUSHED then
				-- TELEPORT TO GRAND FINALE - KEY ESCORT
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("m5", true)
				local tposx,tposy,tposz = (-2501.221 - ctele_Posx), (1559.409 - ctele_Posy), (618.120 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Grand Finale - Key Escort")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				COMPLIMENT_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not COMPLIMENT_PUSHED then
				-- TELEPORT TO GRAND FINALE - ARMORY
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("m22_3_ship", true)
				city_zone_swap("m22_3_dive", true)
				local tposx,tposy,tposz = (0.939 - ctele_Posx), (-1578.150 - ctele_Posy), (799.945 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Grand Finale - Armory")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				COMPLIMENT_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not COMPLIMENT_PUSHED then
				-- TELEPORT TO GRAND FINALE - SHAFT
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("m22_3_ship", true)
				city_zone_swap("m22_3_dive", true)
				local tposx,tposy,tposz = (-1568.2395 - ctele_Posx), (-2234.990 - ctele_Posy), (2512.079 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Grand Finale - Shaft")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				COMPLIMENT_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not COMPLIMENT_PUSHED then
				-- TELEPORT TO GRAND FINALE - THRONE ROOM
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("arena", true)
				local tposx,tposy,tposz = (-2452.131 - ctele_Posx), (2401.561 - ctele_Posy), (22.626 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Grand Finale - Throne Room")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				COMPLIMENT_PUSHED = true
			elseif player_action_is_pressed(B_END) and not COMPLIMENT_PUSHED then
				-- TELEPORT TO GAT LOYALTY 1
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("gat_loyalty", true)
				local tposx,tposy,tposz = (-78.600 - ctele_Posx), (2329.628 - ctele_Posy), (-299.193 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Gat Loyalty - Genki SERC")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				COMPLIMENT_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not COMPLIMENT_PUSHED then
				-- TELEPORT TO GAT LOYALTY 2
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("gat_loyalty", true)
				local tposx,tposy,tposz = (28.512 - ctele_Posx), (2215.292 - ctele_Posy), (-298.9195 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Gat Loyalty - Apocalypse Genki")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				COMPLIMENT_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not COMPLIMENT_PUSHED then
				-- TELEPORT TO TRAINING AREA
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("training", true)
				local tposx,tposy,tposz = (2232.040 - ctele_Posx), (-1424.475 - ctele_Posy), (144.102 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Training area")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				COMPLIMENT_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not COMPLIMENT_PUSHED then
				-- TELEPORT TO SUPER POWERED FIGHT CLUB
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("spfc", true)
				city_zone_swap("layout01", true)
				local tposx,tposy,tposz = (1989.319 - ctele_Posx), (1157.757 - ctele_Posy), (61.024 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Super Powered Fight Club")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				COMPLIMENT_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not COMPLIMENT_PUSHED then
				-- TELEPORT TO PLATFORMING RIFT
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("leap_1", true)
				city_zone_swap("leap_2_swap", true)
				local tposx,tposy,tposz = (-2163.471 - ctele_Posx), (264.569 - ctele_Posy), (229.531 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Platforming Rift")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				COMPLIMENT_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not COMPLIMENT_PUSHED then
				-- TELEPORT TO SPEED RIFT
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("sprint_1", true)
				city_zone_swap("sprint_2", true)
				city_zone_swap("sprint_3", true)
				local tposx,tposy,tposz = (-1312.139 - ctele_Posx), (2146.673 - ctele_Posy), (488.989 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Speed Rift")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				COMPLIMENT_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not COMPLIMENT_PUSHED then
				-- TELEPORT TO TK RIFT
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("tk_1_swap", true)
				city_zone_swap("tk_2", true)
				local tposx,tposy,tposz = (-139.698 - ctele_Posx), (2164.676 - ctele_Posy), (496.015 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to TK Rift")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				COMPLIMENT_PUSHED = true
			elseif player_action_is_pressed(B_RBRACKET) and not COMPLIMENT_PUSHED then
				-- TELEPORT TO PENETRATOR CAVE
				reset_crib_interior()
				reset_all_zones()
				local tposx,tposy,tposz = (1188.403 - ctele_Posx), (81.164 - ctele_Posy), (7.770 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Penetrator cave")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				COMPLIMENT_PUSHED = true
			end

		elseif player_action_is_pressed("CBA_OFC_MELEE_NUT_SHOT") then -- F (melee/horn) - TELEPORTS
			if player_action_is_pressed(B_INSERT) and not MELEE_PUSHED then
				-- TELEPORT TO SIGN TEXTURES
				reset_crib_interior()
				reset_all_zones()
				local tposx,tposy,tposz = (-115.949 - ctele_Posx), (-148.183 - ctele_Posy), (-68.661 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to sign textures")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				MELEE_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not MELEE_PUSHED then
				-- TELEPORT TO SHIP
				reset_crib_interior()
				reset_all_zones()
				local tposx,tposy,tposz = (104.3626 - ctele_Posx), (1074.9542 - ctele_Posy), (-201.839 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Crib Ship")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				MELEE_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not MELEE_PUSHED then
				-- TELEPORT TO GATEWAY CAMANO PLACE
				reset_crib_interior()
				reset_all_zones()
				local tposx,tposy,tposz = (-1554.136 - ctele_Posx), (-869.053 - ctele_Posy), (8.332 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Gateway - Camano Place")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				MELEE_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not MELEE_PUSHED then
				-- TELEPORT TO GATEWAY ESPINA
				reset_crib_interior()
				reset_all_zones()
				local tposx,tposy,tposz = (-1217.657 - ctele_Posx), (102.067 - ctele_Posy), (21.222 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Gateway - Espina")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				MELEE_PUSHED = true
			elseif player_action_is_pressed(B_END) and not MELEE_PUSHED then
				-- TELEPORT TO GATEWAY HENRY STEEL MILLS
				reset_crib_interior()
				reset_all_zones()
				local tposx,tposy,tposz = (-303.231 - ctele_Posx), (-887.995 - ctele_Posy), (4.790 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Gateway - Henry Steel Mills")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				MELEE_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not MELEE_PUSHED then
				-- TELEPORT TO GATEWAY LOREN SQUARE
				reset_crib_interior()
				reset_all_zones()
				local tposx,tposy,tposz = (45.482 - ctele_Posx), (-42.570 - ctele_Posy), (11.900 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Gateway - Loren Square")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				MELEE_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not MELEE_PUSHED then
				-- TELEPORT TO GATEWAY SUNSET PARK
				reset_crib_interior()
				reset_all_zones()
				local tposx,tposy,tposz = (40.008 - ctele_Posx), (673.332 - ctele_Posy), (7.833 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Gateway - Sunset Park")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				MELEE_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not MELEE_PUSHED then
				-- TELEPORT TO GATEWAY ASHWOOD
				reset_crib_interior()
				reset_all_zones()
				local tposx,tposy,tposz = (949.493 - ctele_Posx), (-968.512 - ctele_Posy), (14.141 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Gateway - Ashwood")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				MELEE_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not MELEE_PUSHED then
				-- TELEPORT TO GATEWAY BRICKSTON
				reset_crib_interior()
				reset_all_zones()
				local tposx,tposy,tposz = (1427.560 - ctele_Posx), (-158.404 - ctele_Posy), (24.921 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Gateway - Brickston")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				MELEE_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not MELEE_PUSHED then
				-- TELEPORT TO GATEWAY ARAPICE ISLAND
				reset_crib_interior()
				reset_all_zones()
				local tposx,tposy,tposz = (952.741 - ctele_Posx), (-115.701 - ctele_Posy), (8.175 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Gateway - Arapice Island")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				MELEE_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not MELEE_PUSHED then
				-- TELEPORT TO GATEWAY YEARWOOD
				reset_crib_interior()
				reset_all_zones()
				local tposx,tposy,tposz = (1498.986 - ctele_Posx), (590.451 - ctele_Posy), (40.213 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Gateway - Yearwood")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				MELEE_PUSHED = true
			elseif player_action_is_pressed(B_RBRACKET) and not MELEE_PUSHED then
				-- TELEPORT TO GATEWAY BRIDGEPORT
				reset_crib_interior()
				reset_all_zones()
				local tposx,tposy,tposz = (754.792 - ctele_Posx), (891.596 - ctele_Posy), (6.057 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Gateway - Bridgeport")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				MELEE_PUSHED = true
			end

		elseif player_action_is_pressed("CBA_GAC_GRENADE_SWITCH") then -- G (grenade switch) - TELEPORTS
			if player_action_is_pressed(B_INSERT) and not GRENADE_PUSHED then
				-- TELEPORT TO ETD INSIDE PAUL
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("dlc1_4p", true)
				local tposx,tposy,tposz = (2460.130 - ctele_Posx), (-2150.197 - ctele_Posy), (499.316 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to inside Paul")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				GRENADE_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not GRENADE_PUSHED then
				-- TELEPORT TO ETD DOMINATRIX CLUB
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("dlc1_bdclub", true)
				local tposx,tposy,tposz = (1962.042 - ctele_Posx), (48.175 - ctele_Posy), (320.802 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Dominatrix Club")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				GRENADE_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not GRENADE_PUSHED then
				-- TELEPORT TO HTSSC PLEASANTVILLE
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("dlc2_wpv", true)
				local tposx,tposy,tposz = (38.010 - ctele_Posx), (-2092.464 - ctele_Posy), (0.225 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Winter Pleasantville")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				GRENADE_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not GRENADE_PUSHED then
				-- TELEPORT TO HTSSC NORTH POLE
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("dlc2_nps", true)
				local tposx,tposy,tposz = (-1495.037 - ctele_Posx), (-1780.043 - ctele_Posy), (686.521 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to North Pole")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				GRENADE_PUSHED = true
			elseif player_action_is_pressed(B_END) and not GRENADE_PUSHED then
				-- TELEPORT TO HTSSC SANTA'S WORKSHOP
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("dlc2_nps", true)
				local tposx,tposy,tposz = (-1608.141 - ctele_Posx), (-2202.854 - ctele_Posy), (745.005 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Santa's Workshop")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				GRENADE_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not GRENADE_PUSHED then
				-- TELEPORT TO HTSSC LOREN SQUARE
				reset_crib_interior()
				reset_all_zones()
				city_zone_swap("dlc2_r", true)
				local tposx,tposy,tposz = (-251.028 - ctele_Posx), (-550.206 - ctele_Posy), (14.159 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to Winter Steelport - Loren Square")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				GRENADE_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not GRENADE_PUSHED then
				-- TELEPORT TO SAINTS HQ
				if not mission_is_active("m09") then
					reset_crib_interior()
					reset_all_zones()
					arrive_saintshq_int()
					local tposx,tposy,tposz = (-1478.377 - ctele_Posx), (1098.159 - ctele_Posy), (145.782 - ctele_Posz)
					teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
					sandbox_message(" Teleported to Saints HQ")
					if COOP_COMMANDS and coop_is_active() then
						teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
					end
				else
					alert_message(" You cannot use this command during this mission!")
				end
				GRENADE_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not GRENADE_PUSHED then
				-- TELEPORT TO THREE COUNT CRIB
				if not mission_is_active("mol_mm_01") and not mission_is_active("dlc1_m01") then
					reset_crib_interior()
					reset_all_zones()
					arrive_threecount_int()
					local tposx,tposy,tposz = (1203.540 - ctele_Posx), (1450.141 - ctele_Posy), (228.156 - ctele_Posz)
					teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
					sandbox_message(" Teleported to Three Count crib")
					if COOP_COMMANDS and coop_is_active() then
						teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
					end
				else
					alert_message(" You cannot use this command during this mission!")
				end
				GRENADE_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not GRENADE_PUSHED then
				-- TELEPORT TO THE SAINTS FLOW - MAGARAC ISLAND
				if not mission_is_active("m09") then
					reset_crib_interior()
					reset_all_zones()
					arrive_saintshq_int()
					local tposx,tposy,tposz = (-2169.375 - ctele_Posx), (1072.984 - ctele_Posy), (7.913 - ctele_Posz)
					teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
					sandbox_message(" Teleported to The Saints Flow - Magarac Island")
					if COOP_COMMANDS and coop_is_active() then
						teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
					end
				else
					alert_message(" You cannot use this command during this mission!")
				end
				GRENADE_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not GRENADE_PUSHED then
				-- TOGGLE MAGARAC ISLAND STATE (THE SAINTS FLOW)
				if INSIDE_SAINTSHQ then
					ding_finish_audio()
					if SAINTSHQ_JOE then
						city_zone_swap("molp1_joe", false)
						city_zone_swap("molp1_no", true)
						sandbox_message(" Statue of Joe Magarac removed")
					else
						city_zone_swap("molp1_no", false)
						city_zone_swap("molp1_joe", true)
						sandbox_message(" Statue of Joe Magarac restored")
					end
					SAINTSHQ_JOE = not SAINTSHQ_JOE
					delay(0.75)
				else
					alert_message(" You have to teleport to The Saints Flow zone first!")
					GRENADE_PUSHED = true
				end
			elseif player_action_is_pressed(B_LBRACKET) and not GRENADE_PUSHED then
				-- TELEPORT YOUR CO-OP PARTNER TO YOUR LOCATION FWIP
														if mission_is_active() then
				if FOLLOWERS_INVULNERABLE then --zimos
													ding_finish_audio()
					character_set_always_combat_ready(M18_group.alley_vp.roddy, true)
										character_set_always_combat_ready(M18_group.alley_vp.julius, true)

					sandbox_message("Roddy and Keith are ready for combat")
				else
													ding_finish_audio()
					character_set_always_combat_ready(M18_group.alley_vp.roddy, false)
										character_set_always_combat_ready(M18_group.alley_vp.julius, false)
					sandbox_message("Roddy and Keith stops his combat")
					end
												else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
									FOLLOWERS_INVULNERABLE = not FOLLOWERS_INVULNERABLE

				delay(0.75)
					--GRENADE_PUSHED = true
			elseif player_action_is_pressed(B_RBRACKET) and not GRENADE_PUSHED then
				-- TELEPORT YOURSELF TO YOUR CO-OP PARTNER LOCATION
				if PLAYA_DANCE_COUNTER == 1 then
					set_animation_state(LOCAL_PLAYER, "tai chi")
					sandbox_message(" Reactions: tai chi")
				elseif PLAYA_DANCE_COUNTER == 2 then
					set_animation_state(LOCAL_PLAYER, "yoga")
					sandbox_message(" Reactions: yoga")
				elseif PLAYA_DANCE_COUNTER == 3 then
					set_animation_state(LOCAL_PLAYER, "talk stand")
					sandbox_message(" Reactions: talk stand")
				elseif PLAYA_DANCE_COUNTER == 4 then
					set_animation_state(LOCAL_PLAYER, "vomitting")
					sandbox_message(" Reactions: vomitting")
				elseif PLAYA_DANCE_COUNTER == 5 then
					set_animation_state(LOCAL_PLAYER, "hoe talk a")
					sandbox_message(" Reactions: hoe talk a")
				elseif PLAYA_DANCE_COUNTER == 6 then
					set_animation_state(LOCAL_PLAYER, "hoe talk b")
					sandbox_message(" Reactions: hoe talk b")
				elseif PLAYA_DANCE_COUNTER == 7 then
					set_animation_state(LOCAL_PLAYER, "hoe talk c")
					sandbox_message(" Reactions: hoe talk c")
				elseif PLAYA_DANCE_COUNTER == 8 then
					set_animation_state(LOCAL_PLAYER, "hoe talk d")
					sandbox_message(" Reactions: hoe talk d")
				elseif PLAYA_DANCE_COUNTER == 9 then
					set_animation_state(LOCAL_PLAYER, "m10 watch sell")
					sandbox_message(" Reactions: m10 watch sell")
				elseif PLAYA_DANCE_COUNTER == 10 then
					set_animation_state(LOCAL_PLAYER, "m10 vk tag a")
					sandbox_message(" Reactions: m10 vk tag a")
				elseif PLAYA_DANCE_COUNTER == 11 then
					set_animation_state(LOCAL_PLAYER, "m10 vk tag b")
					sandbox_message(" Reactions: m10 vk tag b")
				elseif PLAYA_DANCE_COUNTER == 12 then
					set_animation_state(LOCAL_PLAYER, "m10 vk tag c")
					sandbox_message(" Reactions: m10 vk tag c")
				elseif PLAYA_DANCE_COUNTER == 13 then
					clear_animation_state(LOCAL_PLAYER)
					sandbox_message(" Party's over")
			
				end
				if PLAYA_DANCE_COUNTER == 13 then
					PLAYA_DANCE_COUNTER = 1
				else
					PLAYA_DANCE_COUNTER = PLAYA_DANCE_COUNTER + 1
				end		
				delay(0.75)
					--GRENADE_PUSHED = true
			end

		elseif player_action_is_pressed("CBA_OFC_CROUCH") then -- CTRL (crouch) - SPECIAL COMMANDS
			if player_action_is_pressed(B_INSERT) and not CROUCH_PUSHED then
				-- TOGGLE SUPERPOWER MOVEMENT
				-- PARACHUTING DOESN'T WORK PROPERLY (MISSING PARACHUTE, BROKEN ANIMATIONS)
				if SUPERPOWER_MOVEMENT == 1 then
					SAINTSHQ_SUPERPOWERS = false
					player_super_movement_enable(false)
					sandbox_message(" Superpower movement deactivated")
				elseif SUPERPOWER_MOVEMENT == 2 then
					human_allow_freefall(true)
										player_super_movement_enable(false)
					sandbox_message(" Freefall enabled")
				elseif SUPERPOWER_MOVEMENT == 3 then
					human_allow_parachute(true)
										player_super_movement_enable(false)
					sandbox_message(" Parachuting enabled")
				elseif SUPERPOWER_MOVEMENT == 4 then
					SAINTSHQ_SUPERPOWERS = true
					player_super_movement_enable(true)
					human_allow_freefall(false)
					human_allow_parachute(false)
					sandbox_message(" Superpower movement activated")
				end
				if SUPERPOWER_MOVEMENT == 4 then
					SUPERPOWER_MOVEMENT = 1
				else
					SUPERPOWER_MOVEMENT = SUPERPOWER_MOVEMENT + 1
				end
				delay(0.75)
			elseif player_action_is_pressed(B_HOME) and not CROUCH_PUSHED then
				-- TOGGLE SUPERPOWER ATTACKS
				if SUPERPOWER_ATTACKS then
					player_super_attacks_enable(false)
					sandbox_message(" Superpower attacks deactivated")
				else
					player_super_attacks_enable(true)
					sandbox_message(" Superpower attacks activated")
				end
				SUPERPOWER_ATTACKS = not SUPERPOWER_ATTACKS
				delay(0.75)
			elseif player_action_is_pressed(B_PGUP) and not CROUCH_PUSHED then
				-- TOGGLE SUPERPOWER ATTACKS IN VEHICLES
				if VEHICLE_SUPERPOWERS then
					sandbox_message(" You can't use superpower attacks in vehicles anymore")
				else
					sandbox_message(" You can now use superpower attacks in vehicles")
				end
				VEHICLE_SUPERPOWERS = not VEHICLE_SUPERPOWERS
				delay(0.75)
			elseif player_action_is_pressed(B_DELETE) and not CROUCH_PUSHED then
				-- TOGGLE SUPERPOWER COOLDOWN
				if SUPERPOWER_COOLDOWN then
					player_super_power_set_temp_charge(1.0)
					heaven_audio()
					sandbox_message(" Superpower cooldown disabled")
				else
					player_super_power_set_temp_charge(-1.0)
					sandbox_message(" Superpower cooldown restored")
				end
				SUPERPOWER_COOLDOWN = not SUPERPOWER_COOLDOWN
				delay(0.75)
			elseif player_action_is_pressed(B_END) and not CROUCH_PUSHED then
				-- TOGGLE INVULNERABLE MODE AND GOD MODE
				if GOD_MODE == 1 then
									player_movement_enable(LOCAL_PLAYER)
					player_actions_enable(LOCAL_PLAYER)
					turn_invulnerable(LOCAL_PLAYER)
					character_set_damage_multiplier(LOCAL_PLAYER, 0.00)
					sandbox_message(" Player is now invulnerable")
					if COOP_COMMANDS and coop_is_active() then
					character_set_damage_multiplier(REMOTE_PLAYER, 0.00)
						turn_invulnerable(REMOTE_PLAYER)
					end
				elseif GOD_MODE == 2 then
					turn_invulnerable(LOCAL_PLAYER)
					character_set_damage_multiplier(LOCAL_PLAYER, 0.00)
					character_prevent_explosion_fling(LOCAL_PLAYER, true)
					character_set_never_catch_fire(LOCAL_PLAYER, true)
					character_set_never_fall(LOCAL_PLAYER, true)
					character_allow_ragdoll(LOCAL_PLAYER, false)
					character_prevent_bumping(LOCAL_PLAYER, true)
					player_movement_enable(LOCAL_PLAYER)
					player_actions_enable(LOCAL_PLAYER)
					human_set_invulnerable_to_telekinesis(LOCAL_PLAYER, true)
					human_set_invulnerable_to_freeze(LOCAL_PLAYER, true)
					character_set_immune_to_explosion_vomit(LOCAL_PLAYER, true)
	                                character_prevent_flinching(LOCAL_PLAYER, true)
					heaven_audio()
					sandbox_message(" No one man should have all that power...")
					if COOP_COMMANDS and coop_is_active() then
						character_allow_ragdoll(REMOTE_PLAYER, false)
						character_prevent_bumping(REMOTE_PLAYER, true)
						character_prevent_explosion_fling(REMOTE_PLAYER, true)
						character_prevent_flinching(REMOTE_PLAYER, true)
						character_prevent_kneecapping(REMOTE_PLAYER, true)
						character_set_never_catch_fire(REMOTE_PLAYER, true)
						character_set_never_fall(REMOTE_PLAYER, true)
				                                human_set_invulnerable_to_telekinesis(REMOTE_PLAYER, true)
					human_set_invulnerable_to_freeze(REMOTE_PLAYER, true)
					character_set_immune_to_explosion_vomit(LOCAL_PLAYER, true)
						character_set_damage_multiplier(REMOTE_PLAYER, 0.00)
					end
				elseif GOD_MODE == 3 then
									player_movement_enable(LOCAL_PLAYER)
					player_actions_enable(LOCAL_PLAYER)
					character_allow_ragdoll(LOCAL_PLAYER, true)
					character_prevent_bumping(LOCAL_PLAYER, false)
					character_prevent_explosion_fling(LOCAL_PLAYER, false)
					character_prevent_flinching(LOCAL_PLAYER, false)
					character_prevent_kneecapping(LOCAL_PLAYER, false)
					character_set_never_catch_fire(LOCAL_PLAYER, false)
					character_set_never_fall(LOCAL_PLAYER, false)
					human_set_invulnerable_to_telekinesis(LOCAL_PLAYER, false)
					human_set_invulnerable_to_freeze(LOCAL_PLAYER, false)
					character_set_immune_to_explosion_vomit(LOCAL_PLAYER, false)
					turn_vulnerable(LOCAL_PLAYER)
					character_set_damage_multiplier(LOCAL_PLAYER, 1.00)
					sandbox_message(" Player is now vulnerable")
					if COOP_COMMANDS and coop_is_active() then
						                                human_set_invulnerable_to_telekinesis(REMOTE_PLAYER, false)
					human_set_invulnerable_to_freeze(REMOTE_PLAYER, false)
						character_allow_ragdoll(REMOTE_PLAYER, true)
						character_prevent_bumping(REMOTE_PLAYER, false)
						character_set_immune_to_explosion_vomit(LOCAL_PLAYER, false)
						character_prevent_explosion_fling(REMOTE_PLAYER, false)
						character_prevent_flinching(REMOTE_PLAYER, false)
						character_prevent_kneecapping(REMOTE_PLAYER, false)
						character_set_never_catch_fire(REMOTE_PLAYER, false)
						character_set_never_fall(REMOTE_PLAYER, false)
						turn_vulnerable(REMOTE_PLAYER)
						character_set_damage_multiplier(REMOTE_PLAYER, 1.00)
					end
				end
				if GOD_MODE == 3 then
					GOD_MODE = 1
				else
					GOD_MODE = GOD_MODE + 1
				end
				delay(0.75)
			elseif player_action_is_pressed(B_PGDWN) and not CROUCH_PUSHED then
							-- CYCLE GHOST TOWN MODES
				if GHOST_TOWN == 1 then
					spawning_pedestrians(false)
					spawning_vehicles(false)
	action_nodes_enable(false)
					parking_spot_disable_all(true)	
					sandbox_message(" Ghost Town - no traffic")
				elseif GHOST_TOWN == 2 then
					spawning_pedestrians(false)
					spawning_vehicles(false)
				spawning_distant_vehicles(false)
	action_nodes_enable(true)
					parking_spot_disable_all(false)	
					sandbox_message(" Ghost Town - parked cars only")
				elseif GHOST_TOWN == 3 then
					spawning_pedestrians(true)
					spawning_vehicles(false)
			spawning_distant_vehicles(false)
	action_nodes_enable(true)
					parking_spot_disable_all(true)
					sandbox_message(" Ghost Town - peds only")
				elseif GHOST_TOWN == 4 then
					spawning_pedestrians(false)
					spawning_vehicles(true)
					spawning_distant_vehicles(false)
	action_nodes_enable(false)
					parking_spot_disable_all(true)
					sandbox_message(" Ghost Town - vehicles only")
				elseif GHOST_TOWN == 5 then
								spawning_distant_vehicles(true)
					spawning_pedestrians(true)
					spawning_vehicles(true)
					action_nodes_enable(true)
					parking_spot_disable_all(false)	
					sandbox_message(" Traffic enabled")
				end
				if GHOST_TOWN == 5 then
					GHOST_TOWN = 1
				else
					GHOST_TOWN = GHOST_TOWN + 1
				end
				delay(0.75)
			elseif player_action_is_pressed(B_RIGHT) and not CROUCH_PUSHED then
				-- SANDBOX+ ON-FOOT RADIO - MISSION PLAYLIST
				kill_radio_music()
				advance_next_song("Mission")
				delay(0.75)
			elseif player_action_is_pressed(B_LEFT) and not CROUCH_PUSHED then
				-- SANDBOX+ ON-FOOT RADIO - MIXTAPE PLAYLIST
				local mixtest = #MixtapeData
				if mixtest > 0 then
					kill_radio_music()
					advance_next_song("Mixtape")
					delay(0.75)
				else
					alert_message(" No Mixtape tracks selected. Edit 'sr3_city.lua' file and set Mixtape to true for your choices")
					CROUCH_PUSHED = true
				end
			elseif player_action_is_pressed(B_DOWN) and not CROUCH_PUSHED then
				-- TURN OFF SANDBOX+ ON-FOOT RADIO
				kill_radio_music()
				current_radio_song = ""
				sandbox_message(" Sandbox+ on-foot radio turned off")
				CROUCH_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not CROUCH_PUSHED then
				-- RESHUFFLE MUSIC FOR SANDBOX+ ON-FOOT RADIO
				randomize_music = "on"
				Create_Radio_Station_Tables(randomize_music)
				sandbox_message(" Sandbox+ on-foot radio music reshuffled")
				CROUCH_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not CROUCH_PUSHED then
				-- TOGGLE GLITCHED PEDESTRIANS
				if not CIV_GLITCHED then
					set_civilians_glitching(true)
					sandbox_message(" Glitched pedestrians enabled")
				else
					set_civilians_glitching(false)
					sandbox_message(" Glitched pedestrians disabled")
				end
				CIV_GLITCHED = not CIV_GLITCHED
				delay(0.75)
			elseif player_action_is_pressed(B_RBRACKET) and not CROUCH_PUSHED then
				-- TOGGLE GRAVITY FOR THE PLAYER
				if GRAVITY then
					human_gravity_enable(LOCAL_PLAYER, false)
					heaven_audio()
					sandbox_message(" Gravity disabled for the player")
					if COOP_COMMANDS and coop_is_active() then
						human_gravity_enable(REMOTE_PLAYER, false)
					end
				else
					human_gravity_enable(LOCAL_PLAYER, true)
					sandbox_message(" Gravity enabled for the player")
					if COOP_COMMANDS and coop_is_active() then
						human_gravity_enable(REMOTE_PLAYER, true)
					end
				end
				GRAVITY = not GRAVITY
				delay(0.75)
			end

		elseif player_action_is_pressed("CBA_GAC_ACTION") then -- E (action/use) - SPECIAL COMMANDS
			if player_action_is_pressed(B_INSERT) and not USE_PUSHED then
				-- ENABLE ALL WEAPON SLOTS AND DISMISSING/RECRUITING HOMIES (BREAK THE MISSION) 
				if PHONE_ON then
					clear_all_personas()
										player_controls_enable(LOCAL_PLAYER)
					player_movement_enable(LOCAL_PLAYER)
					player_actions_enable(LOCAL_PLAYER)
						audio_suppress_ambient_player_lines(false)
	persona_suppress_ambient_lines(false)
	                        cell_menu_disable_map(false)
	                        cell_menu_disable_phone(false)
                            player_force_vehicle_seat(LOCAL_PLAYER, 0)
				crib_disable_simulation_exit(false)
				player_inventory_restore_on_mission_exit(LOCAL_PLAYER)
				set_player_can_exit_vehicles(LOCAL_PLAYER, true)
				set_player_can_exit_vehicles(REMOTE_PLAYER, true)
	                        party_set_recruitable(true)
				cellphone_lock(false)
				character_dont_regenerate(LOCAL_PLAYER, false)
				player_controls_enable(LOCAL_PLAYER)
	                        customization_item_revert(SYNC_ALL)
	                        customization_restore_player_rig(SYNC_ALL)
				party_allow_max_followers(true)
		--		set_never_turn_on_player("#Follower1#", true)
		--		set_never_turn_on_player("#Follower2#", true)
		--		set_never_turn_on_player("#Follower3#", true)
				set_player_can_enter_exit_vehicles(LOCAL_PLAYER, true)
                                inv_weapon_disable_all_slots(false)
				golden_cid_enable(true)
									radio_on_foot_enable(true)
				player_warp_to_shore_enable(LOCAL_PLAYER)
				health_pickups_enable(true)
				party_set_recruitable(true)
				auto_pickup_weapons(true)
				player_super_power_set_wall_jump_and_sprint_disabled(false, false)
				crib_disable_simulation_exit(false)
				player_human_shield_lock(LOCAL_PLAYER, false)
				camera_shake_stop()
						set_never_crouch_flag(LOCAL_PLAYER, false)
				spawn_global_override_clear_category()
				local dual_wielding = false
					clear_animation_state(LOCAL_PLAYER)
					m00_character_combat_movement_enable(LOCAL_PLAYER, false)
					character_set_always_combat_ready(LOCAL_PLAYER, false)
					set_never_crouch_flag(LOCAL_PLAYER, false)
					hdr_bloom_set_multiplier(1)
					refraction_situation_clear()
						player_can_sprint(true)
														                                party_set_dismissable(true)
												player_force_walk(LOCAL_PLAYER, false)
					set_player_can_take_human_shields(LOCAL_PLAYER, true) 
					sandbox_message("Breaking the Mission for the Player's Settings and never turn on the player is on")
				else
									player_controls_enable(LOCAL_PLAYER)
					player_movement_enable(LOCAL_PLAYER)
					player_actions_enable(LOCAL_PLAYER)
					audio_suppress_ambient_player_lines(false)
	persona_suppress_ambient_lines(false)
						player_force_walk(LOCAL_PLAYER, false)
					clear_all_personas()
						player_can_sprint(true)
					party_set_recruitable(true)
									radio_on_foot_enable(true)
	                        cell_menu_disable_map(false)
	                        cell_menu_disable_phone(false)
                            player_force_vehicle_seat(LOCAL_PLAYER, 0)
				player_human_shield_lock(LOCAL_PLAYER, false)
				player_inventory_restore_on_mission_exit(LOCAL_PLAYER)
				auto_pickup_weapons(false)
				player_warp_to_shore_enable(LOCAL_PLAYER)
				cellphone_lock(false)
												                                party_set_dismissable(true)
		--		set_never_turn_on_player("#Follower1#", false)
		--		set_never_turn_on_player("#Follower2#", false)
		--		set_never_turn_on_player("#Follower3#", false)
				health_pickups_enable(true)
				player_super_power_set_wall_jump_and_sprint_disabled(false, false)
				camera_shake_stop()
				player_can_sprint(true)
				spawn_global_override_clear_category()
				character_dont_regenerate(LOCAL_PLAYER, false)
				health_pickups_enable(true)
				crib_disable_simulation_exit(false)
				party_allow_max_followers(true)
				player_warp_to_shore_enable(LOCAL_PLAYER)
				player_controls_enable(LOCAL_PLAYER)
									set_player_can_take_human_shields(LOCAL_PLAYER, true) 
									set_never_crouch_flag(LOCAL_PLAYER, false)
				set_player_can_exit_vehicles(LOCAL_PLAYER, true)
				set_player_can_exit_vehicles(REMOTE_PLAYER, true)
				player_inventory_restore_on_mission_exit(LOCAL_PLAYER)
                                party_set_recruitable(true)
				golden_cid_enable(false)
				local dual_wielding = true
				player_can_sprint(true)
					hdr_bloom_set_multiplier(1)
					refraction_situation_clear()
				m00_character_combat_movement_enable(LOCAL_PLAYER, false)
                                inv_weapon_disable_all_slots(false)
					clear_animation_state(LOCAL_PLAYER)
					sandbox_message("Break the Mission, now allows you to call homies or do anything but fun, doh and never turn on the player is off")
				end
				PHONE_ON = not PHONE_ON
				USE_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not USE_PUSHED then
				-- CYCLE ANIMATION SWAPS
				if ANIM_SWAP == 1 then
					set_animation_set(LOCAL_PLAYER, "Sidescroll_PLYM")
					player_super_attacks_enable(false)
					player_super_movement_enable(false)
					sandbox_message(" 2D Sidescroller animations activated")
					if COOP_COMMANDS and coop_is_active() then
						set_animation_set(REMOTE_PLAYER, "Sidescroll_PLYM")
					end
				elseif ANIM_SWAP == 2 then
					set_animation_set(LOCAL_PLAYER, "Terminator")
					player_can_sprint(false)
					character_allow_ragdoll(LOCAL_PLAYER, false)
					sandbox_message(" Murderbot animations activated")
					if COOP_COMMANDS and coop_is_active() then
						set_animation_set(REMOTE_PLAYER, "Terminator")
						character_allow_ragdoll(REMOTE_PLAYER, false)
					end
				elseif ANIM_SWAP == 3 then
					set_animation_for_gender(LOCAL_PLAYER)
					character_set_animation_overrides(LOCAL_PLAYER, "M02 confused stand", "M02 confused walk", "M02 confused walk")
					hud_unarmed_icon_override_set("ui_hud_inv_thumbs_up")
					player_can_sprint(true)
					character_allow_ragdoll(LOCAL_PLAYER, true)
					set_player_can_take_human_shields(LOCAL_PLAYER, true)
					sandbox_message(" Pleasantville walk activated")
					if COOP_COMMANDS and coop_is_active() then
						set_animation_for_gender(REMOTE_PLAYER)
						character_set_animation_overrides(REMOTE_PLAYER, "M02 confused stand", "M02 confused walk", "M02 confused walk")
						character_allow_ragdoll(REMOTE_PLAYER, true)
						set_player_can_take_human_shields(REMOTE_PLAYER, true)
					end
				elseif ANIM_SWAP == 4 then
					character_set_animation_overrides(LOCAL_PLAYER, "streaking stand", "streaking run", "streaking run")
					hud_unarmed_icon_override_set("ui_rm_unethical_sm")
					sandbox_message(" Streaking animations activated")
					if COOP_COMMANDS and coop_is_active() then
						character_set_animation_overrides(REMOTE_PLAYER, "streaking stand", "streaking run", "streaking run")
					end
				elseif ANIM_SWAP == 5 then
					character_set_animation_overrides(LOCAL_PLAYER, nil, nil, nil)
					set_animation_set(LOCAL_PLAYER, "zombie")
					hud_unarmed_icon_override_set("ui_homie_35_lin")
					character_allow_ragdoll(LOCAL_PLAYER, true)
					sandbox_message(" Zombie animations activated")
					if COOP_COMMANDS and coop_is_active() then
						character_set_animation_overrides(REMOTE_PLAYER, nil, nil, nil)
						set_animation_set(REMOTE_PLAYER, "zombie")
						character_allow_ragdoll(REMOTE_PLAYER, true)
					end
				elseif ANIM_SWAP == 6 then
					set_animation_set(LOCAL_PLAYER, "drunk")
					hud_unarmed_icon_override_set("ui_weap_beer")
					character_allow_ragdoll(LOCAL_PLAYER, true)
					set_player_can_take_human_shields(LOCAL_PLAYER, true)
					sandbox_message(" Drunk animations activated")
					if COOP_COMMANDS and coop_is_active() then
						set_animation_set(REMOTE_PLAYER, "drunk")
						character_allow_ragdoll(REMOTE_PLAYER, true)
						set_player_can_take_human_shields(REMOTE_PLAYER, true)
					end
				elseif ANIM_SWAP == 7 then
					set_animation_for_gender(LOCAL_PLAYER)
					hud_unarmed_icon_override_clear()
					inv_weapon_disable_all_slots(false)
					sandbox_message(" Animation swaps deactivated")
					if COOP_COMMANDS and coop_is_active() then
						set_animation_for_gender(REMOTE_PLAYER)
					end
				end
				if ANIM_SWAP == 7 then
					ANIM_SWAP = 1
				else
					ANIM_SWAP = ANIM_SWAP + 1
				end
				delay(0.75)
			elseif player_action_is_pressed(B_PGUP) and not USE_PUSHED then
				-- CYCLE DRUNK STATES
				if DRUNK == 1 then
					drug_effect_set_override_values(1,0)
					character_set_animation_overrides(LOCAL_PLAYER, "M02 confused stand", "", "")
					hud_unarmed_icon_override_set("ui_weap_beer")
					sandbox_message(" Player is drunk")
					if COOP_COMMANDS and coop_is_active() then
						character_set_animation_overrides(REMOTE_PLAYER, "M02 confused stand", "", "")
					end
				elseif DRUNK == 2 then
					drug_effect_set_override_values(3,0)
					character_set_animation_overrides(LOCAL_PLAYER, nil, nil, nil)
					set_animation_set(LOCAL_PLAYER, "drunk")
					player_super_attacks_enable(false)
					sandbox_message(" Player is really drunk")
					if COOP_COMMANDS and coop_is_active() then
						character_set_animation_overrides(REMOTE_PLAYER, nil, nil, nil)
						set_animation_set(REMOTE_PLAYER, "drunk")
					end
				elseif DRUNK == 3 then
					drug_effect_set_override_values(5,0)
					refraction_situation_set("drug weakest")
					sandbox_message(" What button do I press to talk to the animals?")
				elseif DRUNK == 4 then
					drug_effect_set_override_values(0,0)
					set_animation_for_gender(LOCAL_PLAYER)
					refraction_situation_clear()
					hud_unarmed_icon_override_clear()
					inv_weapon_disable_all_slots(false)
					sandbox_message(" Player sobriety restored")
					if COOP_COMMANDS and coop_is_active() then
						set_animation_for_gender(REMOTE_PLAYER)
					end
				end
				if DRUNK == 4 then
					DRUNK = 1
				else
					DRUNK = DRUNK + 1
				end
				delay(0.75)
			elseif player_action_is_pressed(B_DELETE) and not USE_PUSHED then
				-- CYCLE DRUG EFFECTS
				if DRUGS == 1 then
					get_fucking_high_bitches(0.25)
					sandbox_message(" Drug effect - weak")
				elseif DRUGS == 2 then
					get_fucking_high_bitches(0.5)
					sandbox_message(" Drug effect - medium")
				elseif DRUGS == 3 then
					get_fucking_high_bitches(0.75)
					sandbox_message(" Drug effect - strong")
				elseif DRUGS == 4 then
					get_fucking_high_bitches(1.0)
					sandbox_message(" Player is one with the universe")
				elseif DRUGS == 5 then
					get_fucking_high_bitches(0)
					sandbox_message(" Drug effect deactivated")
				end
				if DRUGS == 5 then
					DRUGS = 1
				else
					DRUGS = DRUGS + 1
				end
				delay(0.75)
			elseif player_action_is_pressed(B_END) and not USE_PUSHED then
				-- TOGGLE GLITCH EFFECT
				if not GLITCH then
					sandbox_message(" Glitch effect activated")
				else
					sandbox_message(" Glitch effect deactivated")
				end
				GLITCH = not GLITCH
				delay(0.75)
			elseif player_action_is_pressed(B_PGDWN) and not USE_PUSHED then
				-- TOGGLE VR EFFECT
                -- Sit in Seats
				if SEATS == 1 then
					player_force_vehicle_seat(LOCAL_PLAYER, 1)
					sandbox_message(" Player is force to seat in the seat (1)")
				elseif SEATS == 2 then
					player_force_vehicle_seat(LOCAL_PLAYER, 2)
					sandbox_message(" Player is force to seat in the seat (2)")	
				elseif SEATS == 3 then
					player_force_vehicle_seat(LOCAL_PLAYER, 3)
					sandbox_message(" Player is force to seat in the seat (3)")	
				elseif SEATS == 4 then
					player_force_vehicle_seat(LOCAL_PLAYER, 4)
					sandbox_message(" Player is force to seat in the seat (4)")	
				elseif SEATS == 5 then
					player_force_vehicle_seat(LOCAL_PLAYER, 5)
					sandbox_message(" Player is force to seat in the seat (5)")	
				elseif SEATS == 6 then
					player_force_vehicle_seat(LOCAL_PLAYER, 6)
					sandbox_message(" Player is force to seat in the seat (6)")
				elseif SEATS == 7 then
					player_force_vehicle_seat(LOCAL_PLAYER, 7)
					sandbox_message(" Player is force to seat in the seat (7)")						
				elseif SEATS == 8 then
					player_force_vehicle_seat(LOCAL_PLAYER, 0)
					sandbox_message(" Player is force to seat in the seat (0)")	
				end
				if SEATS == 8 then
					SEATS = 1
				else
					SEATS = SEATS + 1
				end
				delay(0.75)
			elseif player_action_is_pressed(B_RIGHT) and not USE_PUSHED then
				-- ATTACH EXPLOSIONS TO THE PLAYER
				if effects_count == 1 then
					effects_current = "BlackHole_Exp"
					effects_delay = 2
				elseif effects_count == 2 then
					effects_current = "Car Bomb"
					effects_delay = 2
				elseif effects_count == 3 then
					effects_current = "Car Bomb Big"
					effects_delay = 2
				elseif effects_count == 4 then
					effects_current = "Death_From_Above3"
					effects_delay = 5
				elseif effects_count == 5 then
					effects_current = "Exp Gas Station"
					effects_delay = 3
				elseif effects_count == 6 then
					effects_current = "Grenade"
					effects_delay = 2
				elseif effects_count == 7 then
					effects_current = "Murderbot_exp"
					effects_delay = 2
				elseif effects_count == 8 then
					effects_toggle = false
				end
				if effects_count == 8 then
					sandbox_message(" Removed attached explosions from the player")
					effects_toggle = false
					effects_count = 1
				else
					sandbox_message(" Attach "..effects_current.." to the player")
					effects_toggle = true
					effects_count = effects_count + 1
				end
				delay(0.75)
			elseif player_action_is_pressed(B_LEFT) and not USE_PUSHED then
				-- REVIVE ALL DOWNED FOLLOWERS
				if human_is_downed("#FOLLOWER1#") then
					npc_revive("#FOLLOWER1#")
				elseif human_is_downed("#FOLLOWER2#") then
					npc_revive("#FOLLOWER2#")
				elseif human_is_downed("#FOLLOWER3#") then
					npc_revive("#FOLLOWER3#")
				else
					alert_message(" None of your followers need revival")
				end
				USE_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not USE_PUSHED then
				-- DECREASE PLAYER HEIGHT
				if HEIGHT_DOWN == 1 then
					player_change_default_size(LOCAL_PLAYER, 0.9, false)
					sandbox_message(" Player height decreased to 0.9")
					if COOP_COMMANDS and coop_is_active() then
						player_change_default_size(REMOTE_PLAYER, 0.9, false)
					end
				elseif HEIGHT_DOWN == 2 then
					player_change_default_size(LOCAL_PLAYER, 0.8, false)
					sandbox_message(" Player height decreased to 0.8")
					if COOP_COMMANDS and coop_is_active() then
						player_change_default_size(REMOTE_PLAYER, 0.8, false)
					end
				elseif HEIGHT_DOWN == 3 then
					player_change_default_size(LOCAL_PLAYER, 0.7, false)
					sandbox_message(" Player height decreased to 0.7")
					if COOP_COMMANDS and coop_is_active() then
						player_change_default_size(REMOTE_PLAYER, 0.7, false)
					end
				elseif HEIGHT_DOWN == 4 then
					player_change_default_size(LOCAL_PLAYER, 0.6, false)
					sandbox_message(" Player height decreased to 0.6")
					if COOP_COMMANDS and coop_is_active() then
						player_change_default_size(REMOTE_PLAYER, 0.6, false)
					end
				elseif HEIGHT_DOWN == 5 then
					player_change_default_size(LOCAL_PLAYER, 0.5, false)
					sandbox_message(" Player height decreased to 0.5")
					if COOP_COMMANDS and coop_is_active() then
						player_change_default_size(REMOTE_PLAYER, 0.5, false)
					end
				elseif HEIGHT_DOWN == 6 then
					player_change_default_size(LOCAL_PLAYER, 0.1, false)
					sandbox_message(" Player height decreased to 0.1")
					if COOP_COMMANDS and coop_is_active() then
						player_change_default_size(REMOTE_PLAYER, 0.1, false)
					end
				elseif HEIGHT_DOWN == 7 then
					player_change_default_size(LOCAL_PLAYER, 1.0, false)
					sandbox_message(" Player height restored to default")
					if COOP_COMMANDS and coop_is_active() then
						player_change_default_size(REMOTE_PLAYER, 1.0, false)
					end
				end
				if HEIGHT_DOWN == 7 then
					HEIGHT_DOWN = 1
				else
					HEIGHT_DOWN = HEIGHT_DOWN + 1
				end
				delay(0.75)
			elseif player_action_is_pressed(B_UP) and not USE_PUSHED then
				-- INCREASE PLAYER HEIGHT
				if HEIGHT_UP == 1 then
					player_change_default_size(LOCAL_PLAYER, 1.1, false)
					sandbox_message(" Player height increased to 1.1")
					if COOP_COMMANDS and coop_is_active() then
						player_change_default_size(REMOTE_PLAYER, 1.1, false)
					end
				elseif HEIGHT_UP == 2 then
					player_change_default_size(LOCAL_PLAYER, 1.2, false)
					sandbox_message(" Player height increased to 1.2")
					if COOP_COMMANDS and coop_is_active() then
						player_change_default_size(REMOTE_PLAYER, 1.2, false)
					end
				elseif HEIGHT_UP == 3 then
					player_change_default_size(LOCAL_PLAYER, 1.3, false)
					sandbox_message(" Player height increased to 1.3")
					if COOP_COMMANDS and coop_is_active() then
						player_change_default_size(REMOTE_PLAYER, 1.3, false)
					end
				elseif HEIGHT_UP == 4 then
					player_change_default_size(LOCAL_PLAYER, 1.4, false)
					sandbox_message(" Player height increased to 1.4")
					if COOP_COMMANDS and coop_is_active() then
						player_change_default_size(REMOTE_PLAYER, 1.4, false)
					end
				elseif HEIGHT_UP == 5 then
					player_change_default_size(LOCAL_PLAYER, 1.5, false)
					sandbox_message(" Player height increased to 1.5")
					if COOP_COMMANDS and coop_is_active() then
						player_change_default_size(REMOTE_PLAYER, 1.5, false)
					end
				elseif HEIGHT_UP == 6 then
					player_change_default_size(LOCAL_PLAYER, 1.6, false)
					sandbox_message(" Player height increased to 1.6")
					if COOP_COMMANDS and coop_is_active() then
						player_change_default_size(REMOTE_PLAYER, 1.6, false)
					end
				elseif HEIGHT_UP == 7 then
					player_change_default_size(LOCAL_PLAYER, 1.7, false)
					sandbox_message(" Player height increased to 1.7")
					if COOP_COMMANDS and coop_is_active() then
						player_change_default_size(REMOTE_PLAYER, 1.7, false)
					end
				elseif HEIGHT_UP == 8 then
					player_change_default_size(LOCAL_PLAYER, 1.8, false)
					sandbox_message(" Player height increased to 1.8")
					if COOP_COMMANDS and coop_is_active() then
						player_change_default_size(REMOTE_PLAYER, 1.8, false)
					end
				elseif HEIGHT_UP == 9 then
					player_change_default_size(LOCAL_PLAYER, 1.9, false)
					sandbox_message(" Player height increased to 1.9")
					if COOP_COMMANDS and coop_is_active() then
						player_change_default_size(REMOTE_PLAYER, 1.9, false)
					end
				elseif HEIGHT_UP == 10 then
					player_change_default_size(LOCAL_PLAYER, 2.0, false)
					sandbox_message(" Player height increased to 2.0")
					if COOP_COMMANDS and coop_is_active() then
						player_change_default_size(REMOTE_PLAYER, 2.0, false)
					end
				elseif HEIGHT_UP == 11 then
					player_change_default_size(LOCAL_PLAYER, 10.0, false)
					sandbox_message(" Player height increased to 10.0")
					if COOP_COMMANDS and coop_is_active() then
						player_change_default_size(REMOTE_PLAYER, 10.0, false)
					end
				elseif HEIGHT_UP == 12 then
					player_change_default_size(LOCAL_PLAYER, 30.0, false)
					sandbox_message(" Player height increased to 30.0")
					if COOP_COMMANDS and coop_is_active() then
						player_change_default_size(REMOTE_PLAYER, 30.0, false)
					end
				elseif HEIGHT_UP == 13 then
					player_change_default_size(LOCAL_PLAYER, 1.0, false)
					sandbox_message(" Player height restored to default")
					if COOP_COMMANDS and coop_is_active() then
						player_change_default_size(REMOTE_PLAYER, 1.0, false)
					end
				end
				if HEIGHT_UP == 14 then
					HEIGHT_UP = 1
				else
					HEIGHT_UP = HEIGHT_UP + 1
				end
				delay(0.75)
			elseif player_action_is_pressed(B_LBRACKET) and not USE_PUSHED then
				-- CYCLE TEAMS (POLICE, ZIN, SAINTS, or etc.)
				if TEAM == 1 then
					set_team(LOCAL_PLAYER, "Police")
					sandbox_message(" Team switched to police")
					if COOP_COMMANDS and coop_is_active() then
						set_team(REMOTE_PLAYER, "Police")
					end
				elseif TEAM == 2 then
					set_team(LOCAL_PLAYER, "Luchadores")
					sandbox_message(" Team switched to Luchadores")
					if COOP_COMMANDS and coop_is_active() then
						set_team(REMOTE_PLAYER, "Luchadores")
					end
				elseif TEAM == 3 then
					set_team(LOCAL_PLAYER, "Deckers")
					sandbox_message(" Team switched to Deckers")
					if COOP_COMMANDS and coop_is_active() then
						set_team(REMOTE_PLAYER, "Luchadores")
					end
				elseif TEAM == 4 then
					set_team(LOCAL_PLAYER, "Morningstar")
					sandbox_message(" Team switched to Morningstar")
					if COOP_COMMANDS and coop_is_active() then
						set_team(REMOTE_PLAYER, "Morningstar")
					end
				elseif TEAM == 5 then
					set_team(LOCAL_PLAYER, "STAG")
					sandbox_message(" Team switched to STAG")
					if COOP_COMMANDS and coop_is_active() then
						set_team(REMOTE_PLAYER, "STAG")
					end
				elseif TEAM == 6 then
					set_team(LOCAL_PLAYER, "Neutral Gang")
					sandbox_message(" Team switched to Neutral Gang")
					if COOP_COMMANDS and coop_is_active() then
						set_team(REMOTE_PLAYER, "Neutral Gang")
					end
				elseif TEAM == 7 then
					set_team(LOCAL_PLAYER, "Civilian")
					sandbox_message(" Team switched to Civilian")
					if COOP_COMMANDS and coop_is_active() then
						set_team(REMOTE_PLAYER, "Civilian")
					end
				elseif TEAM == 8 then
					set_team(LOCAL_PLAYER, "Playas")
					heaven_audio()
					sandbox_message(" Team switched to Saints")
					if COOP_COMMANDS and coop_is_active() then
						set_team(REMOTE_PLAYER, "Playas")
					end
				end
				if TEAM == 9 then
					TEAM = 1
				else
					TEAM = TEAM + 1
				end
				delay(0.75)
			elseif player_action_is_pressed(B_RBRACKET) and not USE_PUSHED then
				-- CYCLE WEAPON SETS FOR FOLLOWERS
				inv_item_remove_all("#FOLLOWER1#")
				inv_item_remove_all("#FOLLOWER2#")
				inv_item_remove_all("#FOLLOWER3#")
				ding_finish_audio()
				if FLWR_WEAPS == 1 then
					inv_item_add("SMG-Storm",10,"#FOLLOWER1#",true)
					inv_item_add("Shotgun-Gang",10,"#FOLLOWER2#",true)
					inv_item_add("Rifle-Gang",10,"#FOLLOWER3#",true)
					sandbox_message(" Followers armed with gang weapons")	-- Back in the hood
				elseif FLWR_WEAPS == 2 then
					inv_item_add("SMG-Gang",10,"#FOLLOWER1#",true)
					inv_item_add("Shotgun-Police",10,"#FOLLOWER2#",true)
					inv_item_add("Rifle-NG",10,"#FOLLOWER3#",true)
					sandbox_message(" Followers armed with police weapons")	-- Roger that!
				elseif FLWR_WEAPS == 3 then
					inv_item_add("Pistol-Laser",10,"#FOLLOWER1#",true)
					inv_item_add("Rifle-Thumpgun",10,"#FOLLOWER2#",true)
					inv_item_add("Rifle-Laser",10,"#FOLLOWER3#",true)
					sandbox_message(" Followers armed with laser weapons")	-- Pew, pew!
				elseif FLWR_WEAPS == 4 then
					sandbox_message(" Followers fight with bare fists")	-- Bare knuckles
				end
				if FLWR_WEAPS == 4 then
					FLWR_WEAPS = 1
				else
					FLWR_WEAPS = FLWR_WEAPS + 1
				end
				delay(0.75)
			end

		elseif player_action_is_pressed("CBA_OFC_PICKUP_RELOAD") then -- R (reload) - SPECIAL COMMANDS
			if player_action_is_pressed(B_INSERT) and not RELOAD_PUSHED then
				-- CYCLE CUSTOM SPAWNING
				if CUSTOM_SPAWNING == 1 then
					spawn_global_override_clear_category()
					spawn_global_override_set_category("sp_cat_Arapice_Zombies")
					sandbox_message(" Zombie spawning enabled")
				elseif CUSTOM_SPAWNING == 2 then
					spawn_global_override_clear_category()
					spawn_global_override_set_category("sp_cat_Cheat_Ho")
					sandbox_message(" Pimps and Hos spawning enabled")
				elseif CUSTOM_SPAWNING == 3 then
					spawn_global_override_clear_category()
					spawn_global_override_set_category("sp_cat_Cheat_Mascot")
					sandbox_message(" Mascot spawning enabled")
				elseif CUSTOM_SPAWNING == 4 then
					spawn_global_override_clear_category()
					spawn_global_override_set_category("sp_cat_ForbiddenZone")
					sandbox_message(" Rift Glitch spawning enabled")
				elseif CUSTOM_SPAWNING == 5 then
					spawn_global_override_clear_category()
					spawn_global_override_set_category("m14_clonearmy")
					sandbox_message(" Clone army spawning enabled")
				elseif CUSTOM_SPAWNING == 6 then
					spawn_global_override_clear_category()
					spawn_global_override_set_category("sp_cat_Pleasantville")
					sandbox_message(" Pleasantville spawning enabled")
				elseif CUSTOM_SPAWNING == 7 then
					spawn_global_override_clear_category()
					sandbox_message(" Custom spawning disabled")
				end
				if CUSTOM_SPAWNING == 7 then
					CUSTOM_SPAWNING = 1
				else
					CUSTOM_SPAWNING = CUSTOM_SPAWNING + 1
				end
				delay(0.75)
			elseif player_action_is_pressed(B_HOME) and not RELOAD_PUSHED then
				-- CYCLE CUSTOM NOTORIETY
				if CUSTOM_NOTORIETY == 1 then
					notoriety_reset("police")
					notoriety_enable_custom_spawning("m02 Pleasant Police")
					notoriety_set_min_and_max("police", 1, 5)
					golden_cid_enable(false)
					sandbox_message(" Pleasantville police notoriety enabled")
				elseif CUSTOM_NOTORIETY == 2 then
					notoriety_reset("police")
					notoriety_enable_custom_spawning("m14 Clone Army")
					notoriety_set_min_and_max("police", 1, 5)
					golden_cid_enable(false)
					sandbox_message(" Clone army notoriety enabled")
				elseif CUSTOM_NOTORIETY == 3 then
					notoriety_reset("police")
					notoriety_enable_custom_spawning("mascots")
					notoriety_set_min_and_max("police", 1, 5)
					golden_cid_enable(false)
					sandbox_message(" Mascots notoriety enabled")
				elseif CUSTOM_NOTORIETY == 4 then
					notoriety_reset("police")
					notoriety_enable_custom_spawning("mol_p01_brotherhood")
					notoriety_set_min_and_max("police", 1, 5)
					golden_cid_enable(false)
					sandbox_message(" Brotherhood notoriety enabled")
				elseif CUSTOM_NOTORIETY == 5 then
					notoriety_reset("police")
					notoriety_enable_custom_spawning("survival_glitched")
					notoriety_set_min_and_max("police", 1, 5)
					golden_cid_enable(false)
					sandbox_message(" Survival glitched notoriety enabled")
				elseif CUSTOM_NOTORIETY == 6 then
					notoriety_reset("police")
					notoriety_enable_custom_spawning("survival_mascots")
					notoriety_set_min_and_max("police", 1, 5)
					golden_cid_enable(false)
					sandbox_message(" Survival mascots notoriety enabled")
				elseif CUSTOM_NOTORIETY == 7 then
					notoriety_reset("police")
					notoriety_enable_custom_spawning("survival_bikers")
					notoriety_set_min_and_max("police", 1, 5)
					golden_cid_enable(false)
					sandbox_message(" Survival bikers notoriety enabled")
				elseif CUSTOM_NOTORIETY == 8 then
					notoriety_reset("police")
					notoriety_enable_custom_spawning("survival_strippers")
					notoriety_set_min_and_max("police", 1, 5)
					golden_cid_enable(false)
					sandbox_message(" Survival strippers notoriety enabled")
				elseif CUSTOM_NOTORIETY == 9 then
					notoriety_reset("police")
					golden_cid_enable(true)
					sandbox_message(" Custom notoriety disabled")
				end
				if CUSTOM_NOTORIETY == 9 then
					CUSTOM_NOTORIETY = 1
				else
					CUSTOM_NOTORIETY = CUSTOM_NOTORIETY + 1
				end
				delay(0.75)
			elseif player_action_is_pressed(B_PGUP) and not RELOAD_PUSHED then
				-- CYCLE ZIN NOTORIETY LOCKS (INCREASE ZIN NOTORIETY)
				if NOTORIETY_ZIN == 1 then
					notoriety_set_min_and_max("police", 0, 0)
					sandbox_message(" Zin notoriety locked at 0")
				elseif NOTORIETY_ZIN == 2 then
					if LOCK_NOTORIETY then
						notoriety_set_min_and_max("police", 1, 1)
						golden_cid_enable(false)
						sandbox_message(" Zin notoriety locked at 1")
					else
						notoriety_set_min_and_max("police", 0, 6)
						notoriety_set("police", 1)
						sandbox_message(" Zin notoriety lock removed and notoriety set to 1")
					end
				elseif NOTORIETY_ZIN == 3 then
					if LOCK_NOTORIETY then
						notoriety_set_min_and_max("police", 2, 2)
						golden_cid_enable(false)
						sandbox_message(" Zin notoriety locked at 2")
					else
						notoriety_set("police", 2)
						sandbox_message(" Zin notoriety set to 2")
					end
				elseif NOTORIETY_ZIN == 4 then
					if LOCK_NOTORIETY then
						notoriety_set_min_and_max("police", 3, 3)
						golden_cid_enable(false)
						sandbox_message(" Zin notoriety locked at 3")
					else
						notoriety_set("police", 3)
						sandbox_message(" Zin notoriety set to 3")
					end
				elseif NOTORIETY_ZIN == 5 then
					if LOCK_NOTORIETY then
						notoriety_set_min_and_max("police", 4, 4)
						golden_cid_enable(false)
						sandbox_message(" Zin notoriety locked at 4")
					else
						notoriety_set("police", 4)
						sandbox_message(" Zin notoriety set to 4")
					end
				elseif NOTORIETY_ZIN == 6 then
					if LOCK_NOTORIETY then
						notoriety_set_min_and_max("police", 5, 5)
						golden_cid_enable(false)
						sandbox_message(" Zin notoriety locked at 5")
					else
						notoriety_set("police", 5)
						sandbox_message(" Zin notoriety set to 5")
					end
				elseif NOTORIETY_ZIN == 7 then
					notoriety_reset("police")
					if LOCK_NOTORIETY then
						golden_cid_enable(true)
					end
					sandbox_message(" Zin notoriety reset")
				end
				if NOTORIETY_ZIN == 7 then
					NOTORIETY_ZIN = 1
				else
					NOTORIETY_ZIN = NOTORIETY_ZIN + 1
				end
				delay(0.75)
			elseif player_action_is_pressed(B_DELETE) and not RELOAD_PUSHED then
				-- SPAWN WARDEN INSTANTLY (CLEAR WARDEN NOTORIETY)
				if SANDBOX_COP_NOTORIETY_CHECK < 6.0 then
					WARDEN_INSTANT = false
				else
					WARDEN_INSTANT = true
				end
				if not WARDEN_INSTANT then
					notoriety_set("police", 6)
					delay(7.7)	-- Make the message show up after the cutscene (and prevent disabling Warden notoriety during the cutscene)
					sandbox_message(" Here comes the Warden!")
				else
					notoriety_reset("police")
					sandbox_message(" Yeah, sure, hide like a pussy and tell everyone how badass you are")
				end
				delay(0.75)
			elseif player_action_is_pressed(B_END) and not RELOAD_PUSHED then
				-- SLEW MODE (FREE CAMERA)
				if SLEW_MODE == 1 then
					slew_mode(true)
					sandbox_message(" Slew mode activated")
					SLEW_MODE = 2
				elseif SLEW_MODE == 2 then
					character_hide(LOCAL_PLAYER)
					sandbox_message(" Player hidden")
					if COOP_COMMANDS and coop_is_active() then
						character_hide(REMOTE_PLAYER)
					end
					if character_is_in_vehicle(LOCAL_PLAYER) then
						SLEW_MODE = 3
					else
						SLEW_MODE = 4
					end
				elseif SLEW_MODE == 3 then
					vehicle_hide(LOCAL_PLAYER)
					sandbox_message(" Player vehicle hidden")
					if COOP_COMMANDS and coop_is_active() then
						vehicle_hide(REMOTE_PLAYER)
					end
					SLEW_MODE = 4
				elseif SLEW_MODE == 4 then
					character_show(LOCAL_PLAYER)
					vehicle_show(LOCAL_PLAYER)
					slew_mode(false)
					sandbox_message(" Slew mode deactivated")
					if COOP_COMMANDS and coop_is_active() then
						character_show(REMOTE_PLAYER)
						vehicle_show(REMOTE_PLAYER)
					end
					SLEW_MODE = 1
				end
				delay(0.75)
			elseif player_action_is_pressed(B_PGDWN) and not RELOAD_PUSHED then
				-- RESET ALL TIME OF DAY CYCLES (TOGGLE TIME OF DAY AUTOMATIC TRANSITION)
				TOD_COUNTER = 1
				TOD_COUNTER_GOOH = 1
				TOD_COUNTER_SRTT = 1
				TOD_COUNTER_CUSTOM = 1
				TEAM = 7
				FOLLOWER_TEAM = 7
				UNDERCOVER_TEAM = 7
				mission_override_clear_all_temp()
				if mission_is_complete("m23") then
					if not TOD_AUTO then
						sandbox_message(" All time of day cycles reset and time of day automatic transition enabled")
					else
						sandbox_message(" All time of day cycles reset and time of day automatic transition disabled")
					end
					TOD_AUTO = not TOD_AUTO
					delay(0.75)
				else
					sandbox_message(" All time of day cycles reset")
					RELOAD_PUSHED = true
				end
			elseif player_action_is_pressed(B_RIGHT) and not RELOAD_PUSHED then
				-- CYCLE SAINTS ROW IV TIMES OF DAY
				mission_override_clear_all_temp()
				if TOD_COUNTER == 1 then
					mission_override_push_temp("blue_pd_tod_override.todx")
					sandbox_message(" Time of day set to blue_pd")
				elseif TOD_COUNTER == 2 then
					mission_override_push_temp("blue_predawn_tod_override.todx")
					sandbox_message(" Time of day set to blue_predawn")
				elseif TOD_COUNTER == 3 then
					mission_override_push_temp("blue_tod_override.todx")
					sandbox_message(" Time of day set to blue")
				elseif TOD_COUNTER == 4 then
					mission_override_push_temp("classic_tod_override.todx")
					sandbox_message(" Time of day set to classic")
				elseif TOD_COUNTER == 5 then
					mission_override_push_temp("day_tod_override.todx")
					sandbox_message(" Time of day set to day")
				elseif TOD_COUNTER == 6 then
					mission_override_push_temp("dlc1_m01_tod_override.todx")
					sandbox_message(" Time of day set to dlc1_m01")
				elseif TOD_COUNTER == 7 then
					mission_override_push_temp("dlc1_m02_tod_override.todx")
					sandbox_message(" Time of day set to dlc1_m02")
				elseif TOD_COUNTER == 8 then
					mission_override_push_temp("dlc1_m03_tod_override.todx")
					sandbox_message(" Time of day set to dlc1_m03")
				elseif TOD_COUNTER == 9 then
					mission_override_push_temp("dlc1_m04_tod_override.todx")
					sandbox_message(" Time of day set to dlc1_m04")
				elseif TOD_COUNTER == 10 then
					mission_override_push_temp("dlc1_m05_tod_override.todx")
					sandbox_message(" Time of day set to dlc1_m05")
				elseif TOD_COUNTER == 11 then
					mission_override_push_temp("dlc2_gnw_tod_override.todx")
					sandbox_message(" Time of day set to dlc2_gnw")
				elseif TOD_COUNTER == 12 then
					mission_override_push_temp("dlc2_m01_tod_override.todx")
					sandbox_message(" Time of day set to dlc2_m01")
				elseif TOD_COUNTER == 13 then
					mission_override_push_temp("dlc2_m01day_tod_override.todx")
					sandbox_message(" Time of day set to dlc2_m01day")
				elseif TOD_COUNTER == 14 then
					mission_override_push_temp("dlc2_m03_tod_override.todx")
					sandbox_message(" Time of day set to dlc2_m03")
				elseif TOD_COUNTER == 15 then
					mission_override_push_temp("dlc2_m03b_tod_override.todx")
					sandbox_message(" Time of day set to dlc2_m03b")
				elseif TOD_COUNTER == 16 then
					mission_override_push_temp("dlc2_m03cin_tod_override.todx")
					sandbox_message(" Time of day set to dlc2_m03cin")
				elseif TOD_COUNTER == 17 then
					mission_override_push_temp("infrared_tod_override.todx")
					sandbox_message(" Time of day set to infrared")
				elseif TOD_COUNTER == 18 then
					mission_override_push_temp("m00_n_tod_override.todx")
					sandbox_message(" Time of day set to m00_n")
				elseif TOD_COUNTER == 19 then
					mission_override_push_temp("m00_out_tod_override.todx")
					sandbox_message(" Time of day set to m00_out")
				elseif TOD_COUNTER == 20 then
					mission_override_push_temp("m00_tod_override.todx")
					sandbox_message(" Time of day set to m00")
				elseif TOD_COUNTER == 21 then
					mission_override_push_temp("m01test_tod_override.todx")
					sandbox_message(" Time of day set to m01test")
				elseif TOD_COUNTER == 22 then
					mission_override_push_temp("m02_tod_override.todx")
					sandbox_message(" Time of day set to m02")
				elseif TOD_COUNTER == 23 then
					mission_override_push_temp("m03_spacefox.todx")
					sandbox_message(" Time of day set to m03_spacefox")
				elseif TOD_COUNTER == 24 then
					mission_override_push_temp("m08_tod_override.todx")
					sandbox_message(" Time of day set to m08")
				elseif TOD_COUNTER == 25 then
					mission_override_push_temp("m15_tod_override.todx")
					sandbox_message(" Time of day set to m15")
				elseif TOD_COUNTER == 26 then
					mission_override_push_temp("m16_tod_override.todx")
					sandbox_message(" Time of day set to m16")
				elseif TOD_COUNTER == 27 then
					mission_override_push_temp("modern_tod_override.todx")
					sandbox_message(" Time of day set to modern")
				elseif TOD_COUNTER == 28 then
					mission_override_push_temp("mothership_tod_override.todx")
					sandbox_message(" Time of day set to mothership")
				elseif TOD_COUNTER == 29 then
					mission_override_push_temp("neutral_light.todx")
					sandbox_message(" Time of day set to neutral_light")
				elseif TOD_COUNTER == 30 then
					mission_override_push_temp("nightmare_dark_tod_override.todx")
					sandbox_message(" Time of day set to nightmare_dark")
				elseif TOD_COUNTER == 31 then
					mission_override_push_temp("nm_02out_tod_override.todx")
					sandbox_message(" Time of day set to nm_02out")
				elseif TOD_COUNTER == 32 then
					mission_override_push_temp("nm_cheat_tod_override.todx")
					sandbox_message(" Time of day set to nm_cheat")
				elseif TOD_COUNTER == 33 then
					mission_override_push_temp("nm_dark_tod_override.todx")
					sandbox_message(" Time of day set to nm_dark")
				elseif TOD_COUNTER == 34 then
					mission_override_push_temp("nm_noon_tod_override.todx")
					sandbox_message(" Time of day set to nm_noon")
				elseif TOD_COUNTER == 35 then
					mission_override_push_temp("nm_noonb_tod_override.todx")
					sandbox_message(" Time of day set to nm_noonb")
				elseif TOD_COUNTER == 36 then
					mission_override_push_temp("noir_tod_override.todx")
					sandbox_message(" Time of day set to noir")
				elseif TOD_COUNTER == 37 then
					mission_override_push_temp("orange_tod_override.todx")
					sandbox_message(" Time of day set to orange")
				elseif TOD_COUNTER == 38 then
					mission_override_push_temp("r_leap01_tod_override.todx")
					sandbox_message(" Time of day set to r_leap01")
				elseif TOD_COUNTER == 39 then
					mission_override_push_temp("red_tod_override.todx")
					sandbox_message(" Time of day set to red")
				elseif TOD_COUNTER == 40 then
					mission_override_push_temp("space_tod_override.todx")
					sandbox_message(" Time of day set to space")
				elseif TOD_COUNTER == 41 then
					mission_override_push_temp("spacelit_tod_override.todx")
					sandbox_message(" Time of day set to spacelit")
				elseif TOD_COUNTER == 42 then
					mission_override_push_temp("suburbia_tod_override.todx")
					sandbox_message(" Time of day set to suburbia")
				elseif TOD_COUNTER == 43 then
					mission_override_push_temp("sunrise_tod_override.todx")
					sandbox_message(" Time of day set to sunrise")
				elseif TOD_COUNTER == 44 then
					mission_override_push_temp("sunset_tod_override.todx")
					sandbox_message(" Time of day set to sunset")
				elseif TOD_COUNTER == 45 then
					mission_override_push_temp("training_tod_override.todx")
					sandbox_message(" Time of day set to training")
				elseif TOD_COUNTER == 46 then
					mission_override_push_temp("vintage_tod_override.todx")
					sandbox_message(" Time of day set to vintage")
				elseif TOD_COUNTER == 47 then
					mission_override_push_temp("violet_tod_override.todx")
					sandbox_message(" Time of day set to violet")
				elseif TOD_COUNTER == 48 then
					mission_override_push_temp("warden_tod_override_noon.todx")
					sandbox_message(" Time of day set to warden")
				elseif TOD_COUNTER == 49 then
					sandbox_message(" Restored original time of day")
				end
				if TOD_COUNTER == 49 then
					TOD_COUNTER = 1
				else
					TOD_COUNTER = TOD_COUNTER + 1
				end
				delay(0.75)
			elseif player_action_is_pressed(B_LEFT) and not RELOAD_PUSHED then
				-- CYCLE SAINTS ROW: GAT OUT OF HELL TIMES OF DAY
				mission_override_clear_all_temp()
				if TOD_COUNTER_GOOH == 1 then
					mission_override_push_temp("gooh_crags_cave.todx")
					sandbox_message(" Time of day set to gooh_crags_cave")
				elseif TOD_COUNTER_GOOH == 2 then
					mission_override_push_temp("gooh_crags_cave_tod_ovr.todx")
					sandbox_message(" Time of day set to gooh_crags_cave_tod_ovr")
				elseif TOD_COUNTER_GOOH == 3 then
					mission_override_push_temp("gooh_crags_tod_ovr.todx")
					sandbox_message(" Time of day set to gooh_crags_tod_ovr")
				elseif TOD_COUNTER_GOOH == 4 then
					mission_override_push_temp("gooh_downtown_tod_ovr.todx")
					sandbox_message(" Time of day set to gooh_downtown_tod_ovr")
				elseif TOD_COUNTER_GOOH == 5 then
					mission_override_push_temp("gooh_dwellings_tod_ovr.todx")
					sandbox_message(" Time of day set to gooh_dwellings_tod_ovr")
				elseif TOD_COUNTER_GOOH == 6 then
					mission_override_push_temp("gooh_dwellings_tunnels_tod.todx")
					sandbox_message(" Time of day set to gooh_dwellings_tunnels")
				elseif TOD_COUNTER_GOOH == 7 then
					mission_override_push_temp("gooh_ent_bs_tod_ovr.todx")
					sandbox_message(" Time of day set to gooh_ent_bs_tod_ovr")
				elseif TOD_COUNTER_GOOH == 8 then
					mission_override_push_temp("gooh_factories_tod_ovr.todx")
					sandbox_message(" Time of day set to gooh_factories_tod_ovr")
				elseif TOD_COUNTER_GOOH == 9 then
					mission_override_push_temp("gooh_hell_base.todx")
					sandbox_message(" Time of day set to gooh_hell_base")
				elseif TOD_COUNTER_GOOH == 10 then
					mission_override_push_temp("gooh_hell_night_override2.todx")
					sandbox_message(" Time of day set to gooh_hell_night_override2")
				elseif TOD_COUNTER_GOOH == 11 then
					mission_override_push_temp("gooh_intro_tod.todx")
					sandbox_message(" Time of day set to gooh_intro_tod")
				elseif TOD_COUNTER_GOOH == 12 then
					mission_override_push_temp("gooh_test.todx")
					sandbox_message(" Time of day set to gooh_test")
				elseif TOD_COUNTER_GOOH == 13 then
					sandbox_message(" Restored original time of day")
				end
				if TOD_COUNTER_GOOH == 13 then
					TOD_COUNTER_GOOH = 1
				else
					TOD_COUNTER_GOOH = TOD_COUNTER_GOOH + 1
				end
				delay(0.75)
			elseif player_action_is_pressed(B_DOWN) and not RELOAD_PUSHED then
				-- CYCLE SAINTS ROW: THE THIRD TIMES OF DAY
				mission_override_clear_all_temp()
				if TOD_COUNTER_SRTT == 1 then
					mission_override_push_temp("srtt_dlc1_genki_tod_override.todx")
					sandbox_message(" Time of day set to srtt_dlc1_genki")
				elseif TOD_COUNTER_SRTT == 2 then
					mission_override_push_temp("srtt_dlc2_m01_tod_override.todx")
					sandbox_message(" Time of day set to srtt_dlc2_m01")
				elseif TOD_COUNTER_SRTT == 3 then
					mission_override_push_temp("srtt_dlc2_m02_tod_override.todx")
					sandbox_message(" Time of day set to srtt_dlc2_m02")
				elseif TOD_COUNTER_SRTT == 4 then
					mission_override_push_temp("srtt_dlc2_m03_tod_override.todx")
					sandbox_message(" Time of day set to srtt_dlc2_m03")
				elseif TOD_COUNTER_SRTT == 5 then
					mission_override_push_temp("srtt_dlc3_m01_tod_override.todx")
					sandbox_message(" Time of day set to srtt_dlc3_m01")
				elseif TOD_COUNTER_SRTT == 6 then
					mission_override_push_temp("srtt_dlc3_m02_tod_override.todx")
					sandbox_message(" Time of day set to srtt_dlc3_m02")
				elseif TOD_COUNTER_SRTT == 7 then
					mission_override_push_temp("srtt_dlc3_m03_tod_override.todx")
					sandbox_message(" Time of day set to srtt_dlc3_m03")
				elseif TOD_COUNTER_SRTT == 8 then
					mission_override_push_temp("srtt_m01_tod_override.todx")
					sandbox_message(" Time of day set to srtt_m01")
				elseif TOD_COUNTER_SRTT == 9 then
					mission_override_push_temp("srtt_m02_tod_override.todx")
					sandbox_message(" Time of day set to srtt_m02")
				elseif TOD_COUNTER_SRTT == 10 then
					mission_override_push_temp("srtt_m03_tod_override.todx")
					sandbox_message(" Time of day set to srtt_m03")
				elseif TOD_COUNTER_SRTT == 11 then
					mission_override_push_temp("srtt_m05_tod_override.todx")
					sandbox_message(" Time of day set to srtt_m05")
				elseif TOD_COUNTER_SRTT == 12 then
					mission_override_push_temp("srtt_m06_tod_override.todx")
					sandbox_message(" Time of day set to srtt_m06")
				elseif TOD_COUNTER_SRTT == 13 then
					mission_override_push_temp("srtt_m07_tod_override.todx")
					sandbox_message(" Time of day set to srtt_m07")
				elseif TOD_COUNTER_SRTT == 14 then
					mission_override_push_temp("srtt_m07in_tod_override.todx")
					sandbox_message(" Time of day set to srtt_m07in")
				elseif TOD_COUNTER_SRTT == 15 then
					mission_override_push_temp("srtt_m08_tod_override.todx")
					sandbox_message(" Time of day set to srtt_m08")
				elseif TOD_COUNTER_SRTT == 16 then
					mission_override_push_temp("srtt_m09_tod_override.todx")
					sandbox_message(" Time of day set to srtt_m09")
				elseif TOD_COUNTER_SRTT == 17 then
					mission_override_push_temp("srtt_m10_tod_override.todx")
					sandbox_message(" Time of day set to srtt_m10")
				elseif TOD_COUNTER_SRTT == 18 then
					mission_override_push_temp("srtt_m11_tod_override.todx")
					sandbox_message(" Time of day set to srtt_m11")
				elseif TOD_COUNTER_SRTT == 19 then
					mission_override_push_temp("srtt_m11out_tod_override.todx")
					sandbox_message(" Time of day set to srtt_m11out")
				elseif TOD_COUNTER_SRTT == 20 then
					mission_override_push_temp("srtt_m12_tod_override.todx")
					sandbox_message(" Time of day set to srtt_m12")
				elseif TOD_COUNTER_SRTT == 21 then
					mission_override_push_temp("srtt_m13_tod_override.todx")
					sandbox_message(" Time of day set to srtt_m13")
				elseif TOD_COUNTER_SRTT == 22 then
					mission_override_push_temp("srtt_m14_tod_override.todx")
					sandbox_message(" Time of day set to srtt_m14")
				elseif TOD_COUNTER_SRTT == 23 then
					mission_override_push_temp("srtt_m15_tod_override.todx")
					sandbox_message(" Time of day set to srtt_m15")
				elseif TOD_COUNTER_SRTT == 24 then
					mission_override_push_temp("srtt_m16_tod_override.todx")
					sandbox_message(" Time of day set to srtt_m16")
				elseif TOD_COUNTER_SRTT == 25 then
					mission_override_push_temp("srtt_m17_tod_override.todx")
					sandbox_message(" Time of day set to srtt_m17")
				elseif TOD_COUNTER_SRTT == 26 then
					mission_override_push_temp("srtt_m18_tod_override.todx")
					sandbox_message(" Time of day set to srtt_m18")
				elseif TOD_COUNTER_SRTT == 27 then
					mission_override_push_temp("srtt_m19_tod_override.todx")
					sandbox_message(" Time of day set to srtt_m19")
				elseif TOD_COUNTER_SRTT == 28 then
					mission_override_push_temp("srtt_m20_tod_override.todx")
					sandbox_message(" Time of day set to srtt_m20")
				elseif TOD_COUNTER_SRTT == 29 then
					mission_override_push_temp("srtt_m22_tod_override.todx")
					sandbox_message(" Time of day set to srtt_m22")
				elseif TOD_COUNTER_SRTT == 30 then
					mission_override_push_temp("srtt_m23_tod_override.todx")
					sandbox_message(" Time of day set to srtt_m23")
				elseif TOD_COUNTER_SRTT == 31 then
					mission_override_push_temp("srtt_m24_tod_override.todx")
					sandbox_message(" Time of day set to srtt_m24")
				elseif TOD_COUNTER_SRTT == 32 then
					mission_override_push_temp("srtt_sh01_tod_override.todx")
					sandbox_message(" Time of day set to srtt_sh01")
				elseif TOD_COUNTER_SRTT == 33 then
					mission_override_push_temp("srtt_sh02_tod_override.todx")
					sandbox_message(" Time of day set to srtt_sh02")
				elseif TOD_COUNTER_SRTT == 34 then
					mission_override_push_temp("srtt_sh03_tod_override.todx")
					sandbox_message(" Time of day set to srtt_sh03")
				elseif TOD_COUNTER_SRTT == 35 then
					sandbox_message(" Restored original time of day")
				end
				if TOD_COUNTER_SRTT == 35 then
					TOD_COUNTER_SRTT = 1
				else
					TOD_COUNTER_SRTT = TOD_COUNTER_SRTT + 1
				end
				delay(0.75)
			elseif player_action_is_pressed(B_UP) and not RELOAD_PUSHED then
				-- CYCLE CUSTOM TIMES OF DAY
				-- Welcome to custom TOD cycle! Here's Fan of Saints, I'll do my best to explain how it works.
				mission_override_clear_all_temp()
				-- ^This command cleans up any other TOD overrides.
				if TOD_COUNTER_CUSTOM == 1 then
					mission_override_push_temp("custom01.todx")
					-- ^The most important part - TOD override. It swaps current TOD with the one you would like to see.
					-- ^All TODs are stored in TODX files - you can create your own one and just put it in the main folder. I used Admixon's Blue Hell TOD as an example, it's called custom01.todx. Duplicate it and change filename to custom02.
					-- ^You can now open the file and change whatever you want - everything is smartly arranged so you shouldn't have problems to find what you want. Your TOD will be displayed right after Admixon's one.
					sandbox_message(" Time of day set to custom01 (Admixon's Blue Hell)")
					-- ^This is a message which will be displayed every time you go to this TOD. You can write whatever you want, just don't forget about quotes.
				elseif TOD_COUNTER_CUSTOM == 2 then
					mission_override_push_temp("custom02.todx")
					-- ^Here's your new TOD. If you can see it in-game, well done, you got it!
					-- ^If TOD reverts to the original one, you either named your file wrong or just did some stupid mistake. If you're sure that you did everything right and it still doesn't work, post your TOD in my thread and I'll check it myself.
					sandbox_message(" Time of day set to custom02 ('s Snowy Sky)")
					-- ^Write your own name in the message once your TOD is ready. :)
				elseif TOD_COUNTER_CUSTOM == 3 then
						mission_override_push_temp("custom03.todx")
				-- ^If you would like to add more TODs, just duplicate Admixon's file again and call it custom03, custom04, etc. This cycle allows you to load 60 TODs - if that's too few, write me a message and I'll add more entries.
					sandbox_message(" Time of day set to custom03")
					-- That's it, have fun!
				elseif TOD_COUNTER_CUSTOM == 4 then
					mission_override_push_temp("custom04.todx")
					sandbox_message(" Time of day set to custom04")
				elseif TOD_COUNTER_CUSTOM == 5 then
					mission_override_push_temp("custom05.todx")
					sandbox_message(" Time of day set to custom05")
				elseif TOD_COUNTER_CUSTOM == 6 then
					mission_override_push_temp("custom06.todx")
					sandbox_message(" Time of day set to custom06")
				elseif TOD_COUNTER_CUSTOM == 7 then
					mission_override_push_temp("custom07.todx")
					sandbox_message(" Time of day set to custom07")
				elseif TOD_COUNTER_CUSTOM == 8 then
					mission_override_push_temp("custom08.todx")
					sandbox_message(" Time of day set to custom08")
				elseif TOD_COUNTER_CUSTOM == 9 then
					mission_override_push_temp("custom09.todx")
					sandbox_message(" Time of day set to custom09")
				elseif TOD_COUNTER_CUSTOM == 10 then
					mission_override_push_temp("custom10.todx")
					sandbox_message(" Time of day set to custom10")
				elseif TOD_COUNTER_CUSTOM == 11 then
					mission_override_push_temp("custom11.todx")
					sandbox_message(" Time of day set to custom11")
				elseif TOD_COUNTER_CUSTOM == 12 then
					mission_override_push_temp("custom12.todx")
					sandbox_message(" Time of day set to custom12")
				elseif TOD_COUNTER_CUSTOM == 13 then
					mission_override_push_temp("custom13.todx")
					sandbox_message(" Time of day set to custom13")
				elseif TOD_COUNTER_CUSTOM == 14 then
					mission_override_push_temp("custom14.todx")
					sandbox_message(" Time of day set to custom14")
				elseif TOD_COUNTER_CUSTOM == 15 then
					mission_override_push_temp("custom15.todx")
					sandbox_message(" Time of day set to custom15")
				elseif TOD_COUNTER_CUSTOM == 16 then
					mission_override_push_temp("custom16.todx")
					sandbox_message(" Time of day set to custom16")
				elseif TOD_COUNTER_CUSTOM == 17 then
					mission_override_push_temp("custom17.todx")
					sandbox_message(" Time of day set to custom17")
				elseif TOD_COUNTER_CUSTOM == 18 then
					mission_override_push_temp("custom18.todx")
					sandbox_message(" Time of day set to custom18")
				elseif TOD_COUNTER_CUSTOM == 19 then
					mission_override_push_temp("custom19.todx")
					sandbox_message(" Time of day set to custom19")
				elseif TOD_COUNTER_CUSTOM == 20 then
					mission_override_push_temp("custom20.todx")
					sandbox_message(" Time of day set to custom20")
				elseif TOD_COUNTER_CUSTOM == 21 then
					mission_override_push_temp("custom21.todx")
					sandbox_message(" Time of day set to custom21")
				elseif TOD_COUNTER_CUSTOM == 22 then
					mission_override_push_temp("custom22.todx")
					sandbox_message(" Time of day set to custom22")
				elseif TOD_COUNTER_CUSTOM == 23 then
					mission_override_push_temp("custom23.todx")
					sandbox_message(" Time of day set to custom23")
				elseif TOD_COUNTER_CUSTOM == 24 then
					mission_override_push_temp("custom24.todx")
					sandbox_message(" Time of day set to custom24")
				elseif TOD_COUNTER_CUSTOM == 25 then
					mission_override_push_temp("custom25.todx")
					sandbox_message(" Time of day set to custom25")
				elseif TOD_COUNTER_CUSTOM == 26 then
					mission_override_push_temp("custom26.todx")
					sandbox_message(" Time of day set to custom26")
				elseif TOD_COUNTER_CUSTOM == 27 then
					mission_override_push_temp("custom27.todx")
					sandbox_message(" Time of day set to custom27")
				elseif TOD_COUNTER_CUSTOM == 28 then
					mission_override_push_temp("custom28.todx")
					sandbox_message(" Time of day set to custom28")
				elseif TOD_COUNTER_CUSTOM == 29 then
					mission_override_push_temp("custom29.todx")
					sandbox_message(" Time of day set to custom29")
				elseif TOD_COUNTER_CUSTOM == 30 then
					mission_override_push_temp("custom30.todx")
					sandbox_message(" Time of day set to custom30")
				elseif TOD_COUNTER_CUSTOM == 31 then
					mission_override_push_temp("custom31.todx")
					sandbox_message(" Time of day set to custom31")
				elseif TOD_COUNTER_CUSTOM == 32 then
					mission_override_push_temp("custom32.todx")
					sandbox_message(" Time of day set to custom32")
				elseif TOD_COUNTER_CUSTOM == 33 then
					mission_override_push_temp("custom33.todx")
					sandbox_message(" Time of day set to custom33")
				elseif TOD_COUNTER_CUSTOM == 34 then
					mission_override_push_temp("custom34.todx")
					sandbox_message(" Time of day set to custom34")
				elseif TOD_COUNTER_CUSTOM == 35 then
					mission_override_push_temp("custom35.todx")
					sandbox_message(" Time of day set to custom35")
				elseif TOD_COUNTER_CUSTOM == 36 then
					mission_override_push_temp("custom36.todx")
					sandbox_message(" Time of day set to custom36")
				elseif TOD_COUNTER_CUSTOM == 37 then
					mission_override_push_temp("custom37.todx")
					sandbox_message(" Time of day set to custom37")
				elseif TOD_COUNTER_CUSTOM == 38 then
					mission_override_push_temp("custom38.todx")
					sandbox_message(" Time of day set to custom38")
				elseif TOD_COUNTER_CUSTOM == 39 then
					mission_override_push_temp("custom39.todx")
					sandbox_message(" Time of day set to custom39")
				elseif TOD_COUNTER_CUSTOM == 40 then
					mission_override_push_temp("custom40.todx")
					sandbox_message(" Time of day set to custom40")
				elseif TOD_COUNTER_CUSTOM == 41 then
					mission_override_push_temp("custom41.todx")
					sandbox_message(" Time of day set to custom41")
				elseif TOD_COUNTER_CUSTOM == 42 then
					mission_override_push_temp("custom42.todx")
					sandbox_message(" Time of day set to custom42")
				elseif TOD_COUNTER_CUSTOM == 43 then
					mission_override_push_temp("custom43.todx")
					sandbox_message(" Time of day set to custom43")
				elseif TOD_COUNTER_CUSTOM == 44 then
					mission_override_push_temp("custom44.todx")
					sandbox_message(" Time of day set to custom44")
				elseif TOD_COUNTER_CUSTOM == 45 then
					mission_override_push_temp("custom45.todx")
					sandbox_message(" Time of day set to custom45")
				elseif TOD_COUNTER_CUSTOM == 46 then
					mission_override_push_temp("custom46.todx")
					sandbox_message(" Time of day set to custom46")
				elseif TOD_COUNTER_CUSTOM == 47 then
					mission_override_push_temp("custom47.todx")
					sandbox_message(" Time of day set to custom47")
				elseif TOD_COUNTER_CUSTOM == 48 then
					mission_override_push_temp("custom48.todx")
					sandbox_message(" Time of day set to custom48")
				elseif TOD_COUNTER_CUSTOM == 49 then
					mission_override_push_temp("custom49.todx")
					sandbox_message(" Time of day set to custom49")
				elseif TOD_COUNTER_CUSTOM == 50 then
					mission_override_push_temp("custom50.todx")
					sandbox_message(" Time of day set to custom50")
				elseif TOD_COUNTER_CUSTOM == 51 then
					mission_override_push_temp("custom51.todx")
					sandbox_message(" Time of day set to custom51")
				elseif TOD_COUNTER_CUSTOM == 52 then
					mission_override_push_temp("custom52.todx")
					sandbox_message(" Time of day set to custom52")
				elseif TOD_COUNTER_CUSTOM == 53 then
					mission_override_push_temp("custom53.todx")
					sandbox_message(" Time of day set to custom53")
				elseif TOD_COUNTER_CUSTOM == 54 then
					mission_override_push_temp("custom54.todx")
					sandbox_message(" Time of day set to custom54")
				elseif TOD_COUNTER_CUSTOM == 55 then
					mission_override_push_temp("custom55.todx")
					sandbox_message(" Time of day set to custom55")
				elseif TOD_COUNTER_CUSTOM == 56 then
					mission_override_push_temp("custom56.todx")
					sandbox_message(" Time of day set to custom56")
				elseif TOD_COUNTER_CUSTOM == 57 then
					mission_override_push_temp("custom57.todx")
					sandbox_message(" Time of day set to custom57")
				elseif TOD_COUNTER_CUSTOM == 58 then
					mission_override_push_temp("custom58.todx")
					sandbox_message(" Time of day set to custom58")
				elseif TOD_COUNTER_CUSTOM == 59 then
					mission_override_push_temp("custom59.todx")
					sandbox_message(" Time of day set to custom59")
				elseif TOD_COUNTER_CUSTOM == 60 then
					mission_override_push_temp("custom60.todx")
					sandbox_message(" Time of day set to custom60")
				elseif TOD_COUNTER_CUSTOM == 61 then
					sandbox_message(" Restored original time of day")
				end
				if TOD_COUNTER_CUSTOM == 61 then
					TOD_COUNTER_CUSTOM = 1
				else
					TOD_COUNTER_CUSTOM = TOD_COUNTER_CUSTOM + 1
				end
				delay(0.75)
			elseif player_action_is_pressed(B_LBRACKET) and not RELOAD_PUSHED then
				-- TOGGLE POLICE SHOOTING FROM VEHICLES
				if POLICE_DRIVEBY then
					sandbox_message(" Police shooting from vehicles disabled")
				else
					sandbox_message(" Police will now shoot from vehicles at second notoriety level or higher")
				end
				POLICE_DRIVEBY = not POLICE_DRIVEBY
				delay(0.75)
			elseif player_action_is_pressed(B_RBRACKET) and not RELOAD_PUSHED then
				-- TOGGLE WARDEN NOTORIETY
				if WARDEN_NOTORIETY then
					notoriety_set_min_and_max("police", 0, 5)
					sandbox_message(" Warden notoriety disabled")
				else
					notoriety_set_min_and_max("police", 0, 6)
					sandbox_message(" Warden notoriety enabled")
				end
				WARDEN_NOTORIETY = not WARDEN_NOTORIETY
				delay(0.75)
			end

		elseif player_action_is_pressed("CBA_GAC_WEAPON_SELECT_1") then -- 1 - CUTSCENES
			if player_action_is_pressed(B_INSERT) and not ONE_PUSHED then
									if mission_is_active() then
				if FOLLOWERS_INVULNERABLE then 
													ding_finish_audio()
																turn_invulnerable(MOL_MM_01_group.start.matt)
					set_attack_enemies_flag(MOL_MM_01_group.start.matt, true)
				set_always_sees_player_flag(MOL_MM_01_group.start.matt, false)
												set_never_turn_on_player(MOL_MM_01_group.start.matt, true)
									set_attack_peds_flag(MOL_MM_01_group.start.matt, true)
									set_attack_player_flag(MOL_MM_01_group.start.matt, true)
														ai_clear_priority_target(MOL_MM_01_group.start.matt)
					ai_add_enemy_target(MOL_MM_01_group.start.matt, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, false)

					sandbox_message("Matt Miller randomly attack random peds and gangs and be nice to you")
				else
													ding_finish_audio()
																turn_invulnerable(MOL_MM_01_group.start.matt)
		set_never_turn_on_player(MOL_MM_01_group.start.matt, false)
					set_attack_enemies_flag(MOL_MM_01_group.start.matt, false )
				set_always_sees_player_flag(MOL_MM_01_group.start.matt, true )
				set_never_turn_on_player(MOL_MM_01_group.start.matt, true)
																		ai_clear_priority_target(MOL_MM_01_group.start.matt)
									set_attack_peds_flag(MOL_MM_01_group.start.matt, false)
									set_attack_player_flag(MOL_MM_01_group.start.matt, false)
					ai_add_enemy_target(MOL_MM_01_group.start.matt, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, false)

					sandbox_message("Matt Miller turns back to normal and be nice to you")

				end
							else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				FOLLOWERS_INVULNERABLE = not FOLLOWERS_INVULNERABLE
				ONE_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not ONE_PUSHED then
						if mission_is_active() then
				if FOLLOWERS_INVULNERABLE then 
													ding_finish_audio()
																turn_invulnerable(MOL_MM_01_group.start.matt)
					set_attack_enemies_flag(MOL_MM_01_group.start.matt, true)
				set_always_sees_player_flag(MOL_MM_01_group.start.matt, false)
												set_never_turn_on_player(MOL_MM_01_group.start.matt, false)
									set_attack_peds_flag(MOL_MM_01_group.start.matt, true)
									set_attack_player_flag(MOL_MM_01_group.start.matt, true)
														ai_clear_priority_target(MOL_MM_01_group.start.matt)
					ai_add_enemy_target(MOL_MM_01_group.start.matt, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, false)

					sandbox_message("Matt Miller disliked you and your gangs!")
				else
			
																turn_invulnerable(MOL_MM_01_group.start.matt)
		set_never_turn_on_player(MOL_MM_01_group.start.matt, false)
					set_attack_enemies_flag(MOL_MM_01_group.start.matt, false )
				set_always_sees_player_flag(MOL_MM_01_group.start.matt, true )
									set_attack_peds_flag(MOL_MM_01_group.start.matt, false)
									set_attack_player_flag(MOL_MM_01_group.start.matt, true)
					ai_add_enemy_target(MOL_MM_01_group.start.matt, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true)

					alert_message("Matt Miller is turns on you!")

				end
							else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				FOLLOWERS_INVULNERABLE = not FOLLOWERS_INVULNERABLE
				ONE_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not ONE_PUSHED then
												if mission_is_active() then
				if PLAYA_DANCE_COUNTER_B == 1 then
				--
									set_team(MOL_MM_01_group.start.matt, "Playas")
									sandbox_message(" Matt Miller teams on Saints")
				elseif PLAYA_DANCE_COUNTER_B == 2 then
									set_team(MOL_MM_01_group.start.matt, "STAG")
									sandbox_message(" Matt Miller teams on STAG")
				elseif PLAYA_DANCE_COUNTER_B == 3 then
									set_team(MOL_MM_01_group.start.matt, "Luchadores")
									sandbox_message(" Matt Miller teams on Zin")
				elseif PLAYA_DANCE_COUNTER_B == 4 then
									set_team(MOL_MM_01_group.start.matt, "Morningstar")
									sandbox_message(" Matt Miller teams on Alien")
				elseif PLAYA_DANCE_COUNTER_B == 5 then
									set_team(MOL_MM_01_group.start.matt, "Neutral Gang")
									sandbox_message(" Matt Miller teams on Neutral Gang")
			
				end
				if PLAYA_DANCE_COUNTER_B == 5 then
					PLAYA_DANCE_COUNTER_B = 1
				else
					PLAYA_DANCE_COUNTER_B = PLAYA_DANCE_COUNTER_B + 1
				end	
							else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				ONE_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not ONE_PUSHED then
									if mission_is_active() then
				if FOLLOWERS_INVULNERABLE then 
													ding_finish_audio()
																turn_invulnerable(MOL_MM_01_group.start.matt)
					set_attack_enemies_flag(MOL_MM_01_group.start.matt, true)
				set_always_sees_player_flag(MOL_MM_01_group.start.matt, false)
												set_never_turn_on_player(MOL_MM_01_group.start.matt, false)
									set_attack_peds_flag(MOL_MM_01_group.start.matt, true)
									set_attack_player_flag(MOL_MM_01_group.start.matt, true)
														ai_clear_priority_target(MOL_MM_01_group.start.matt)
					ai_add_enemy_target(MOL_MM_01_group.start.matt, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true)

					sandbox_message("Matt Miller is normal and attacking peds and gangs don't shoot him!")
				else
													ding_finish_audio()
												turn_invulnerable(MOL_MM_01_group.start.matt)
		set_never_turn_on_player(MOL_MM_01_group.start.matt, false)
				set_always_sees_player_flag(MOL_MM_01_group.start.matt, false )
									set_attack_peds_flag(MOL_MM_01_group.start.matt, false)
					set_attack_enemies_flag(MOL_MM_01_group.start.matt, false )
									set_attack_player_flag(MOL_MM_01_group.start.matt, false)
											
					ai_add_enemy_target(MOL_MM_01_group.start.matt, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true)

					sandbox_message("Matt Miller is normal but don't shoot him!")

				end
							else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				FOLLOWERS_INVULNERABLE = not FOLLOWERS_INVULNERABLE
				ONE_PUSHED = true
			elseif player_action_is_pressed(B_END) and not ONE_PUSHED then
				if FOLLOWERS_INVULNERABLE then 
						if mission_is_active() then
													ding_finish_audio()
					character_prevent_explosion_fling(MOL_MM_01_group.start.matt, true)
					character_prevent_kneecapping(MOL_MM_01_group.start.matt, true)
					character_set_never_catch_fire(MOL_MM_01_group.start.matt, true)
					character_set_damage_multiplier(MOL_MM_01_group.start.matt, 0.00)
													turn_invulnerable(MOL_MM_01_group.start.matt)
					character_set_never_fall(MOL_MM_01_group.start.matt, true)
					character_allow_ragdoll(MOL_MM_01_group.start.matt, false)
					character_prevent_bumping(MOL_MM_01_group.start.matt, true)
			character_set_counter_on_grabbed( MOL_MM_01_group.start.matt, true )
	                                human_set_invulnerable_to_telekinesis(MOL_MM_01_group.start.matt, true)
					human_set_invulnerable_to_freeze(MOL_MM_01_group.start.matt, true)
					character_set_immune_to_explosion_vomit(MOL_MM_01_group.start.matt, true)
					character_set_no_explosive_panic(MOL_MM_01_group.start.matt, true)
	                                character_prevent_flinching(MOL_MM_01_group.start.matt, true)
							sandbox_message("Matt Miller is in god mode")

				else
													ding_finish_audio()
					character_prevent_explosion_fling(MOL_MM_01_group.start.matt, false)
					character_prevent_kneecapping(MOL_MM_01_group.start.matt, false)
					character_set_never_catch_fire(MOL_MM_01_group.start.matt, false)
					character_set_damage_multiplier(MOL_MM_01_group.start.matt, 0.00)
													turn_invulnerable(MOL_MM_01_group.start.matt)
					character_set_never_fall(MOL_MM_01_group.start.matt, false)
					character_allow_ragdoll(MOL_MM_01_group.start.matt, false)
					character_prevent_bumping(MOL_MM_01_group.start.matt, false)
			character_set_counter_on_grabbed( MOL_MM_01_group.start.matt, true )
	                                human_set_invulnerable_to_telekinesis(MOL_MM_01_group.start.matt, false)
					human_set_invulnerable_to_freeze(MOL_MM_01_group.start.matt, false)
					character_set_immune_to_explosion_vomit(MOL_MM_01_group.start.matt, true)
					character_set_no_explosive_panic(MOL_MM_01_group.start.matt, true)
	                                character_prevent_flinching(MOL_MM_01_group.start.matt, false)
							sandbox_message("Matt Miller restored back to normal")

				end
											else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				FOLLOWERS_INVULNERABLE = not FOLLOWERS_INVULNERABLE

				ONE_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not ONE_PUSHED then
		if mission_is_active() then
						vehicle_enter_teleport(MOL_MM_01_group.start.matt, get_char_vehicle_name(LOCAL_PLAYER), 1) 
						sandbox_message("Matt Miller teleports to your vehicle")
							else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				ONE_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not ONE_PUSHED then
											if mission_is_active() then
				if FOLLOWERS_INVULNERABLE then --zimos
		party_add(MOL_KZ_01_homie.kinzie, LOCAL_PLAYER)

					sandbox_message("Kinzie is added to your party as long as Kinzie is not mad at you!")
				else
	on_dismiss( "", MOL_KZ_01_homie.kinzie )
	party_dismiss( MOL_KZ_01_homie.kinzie )
					sandbox_message("Kinzie is dismiss from your party")

				end
							else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				FOLLOWERS_INVULNERABLE = not FOLLOWERS_INVULNERABLE
				ONE_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not ONE_PUSHED then
			--
				if FOLLOWERS_PSYCHO then
					set_civilians_invulnerable(true)
					set_attack_player_flag("#FOLLOWER1#", true)
		                        set_attack_player_flag("#FOLLOWER2#", true)
		                        set_attack_player_flag("#FOLLOWER3#", true)
												set_always_sees_player_flag( "#FOLLOWER3#", true )
				set_always_sees_player_flag( "#FOLLOWER2#", true )
				set_always_sees_player_flag( "#FOLLOWER1#", true )
					ai_add_enemy_target("#FOLLOWER1#", LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true, true)
					ai_add_enemy_target("#FOLLOWER2#", LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true, true)
					ai_add_enemy_target("#FOLLOWER3#", LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true, true)

					sandbox_message("All Civilians are invulnerable")
				else
					set_civilians_invulnerable(false)
					set_attack_player_flag("#FOLLOWER1#", true)
		                        set_attack_player_flag("#FOLLOWER2#", true)
		                        set_attack_player_flag("#FOLLOWER3#", true)
												set_always_sees_player_flag( "#FOLLOWER3#", false )
				set_always_sees_player_flag( "#FOLLOWER2#", false )
				set_always_sees_player_flag( "#FOLLOWER1#", false )
					ai_add_enemy_target("#FOLLOWER1#", LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true, true)
					ai_add_enemy_target("#FOLLOWER2#", LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true, true)
					ai_add_enemy_target("#FOLLOWER3#", LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true, true)

					sandbox_message("All civilians are vulnerable")

				end
				FOLLOWERS_PSYCHO = not FOLLOWERS_PSYCHO
				ONE_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not ONE_PUSHED then
								if mission_is_active() then
						vehicle_enter_teleport(M11_homie.asha, get_char_vehicle_name(LOCAL_PLAYER), 1) 

					sandbox_message("Asha teleports in your vehicle")
								else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				ONE_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not ONE_PUSHED then
														if mission_is_active() then
				if FOLLOWERS_PSYCHO then
				--M06
		party_add(M11_homie.asha, LOCAL_PLAYER)
																follower_set_can_abandon( M11_homie.asha, false )
					sandbox_message("Asha is added to your party")
				else
																				follower_set_can_abandon( M11_homie.asha, false )
		on_dismiss( "", M11_homie.asha )
	party_dismiss( M11_homie.asha )
					sandbox_message("Asha is dismiss from your party")									
									
				end
							else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				FOLLOWERS_PSYCHO = not FOLLOWERS_PSYCHO
				ONE_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not ONE_PUSHED then
			--
				if not NOTORIETY_ZERO then
					notoriety_set_min_and_max("police", 0, 0)
					sandbox_message("Notoriety locked at zero")
				else
					notoriety_reset("police")
					sandbox_message("Notoriety lock removed")
				end
				NOTORIETY_ZERO = not NOTORIETY_ZERO --SAVED
				ONE_PUSHED = true
			elseif player_action_is_pressed(B_RBRACKET) and not ONE_PUSHED then
				if FOLLOWERS_PSYCHO then
								ding_finish_audio()

			vehicle_suppress_npc_exit(get_char_vehicle_name(LOCAL_PLAYER), true)

				sandbox_message("The vehicle that no one can't exit out of the vehicle")

				else
								ding_finish_audio()
			vehicle_suppress_npc_exit(get_char_vehicle_name(LOCAL_PLAYER), false)
				sandbox_message("The vehicle your allow to exit out of the vehicle")
				end

				FOLLOWERS_PSYCHO = not FOLLOWERS_PSYCHO
				ONE_PUSHED = true
			end

		elseif player_action_is_pressed("CBA_GAC_WEAPON_SELECT_2") then -- 2 - CUTSCENES
			if player_action_is_pressed(B_INSERT) and not TWO_PUSHED then
			--REMOVE THIS
																	if mission_is_active() then
				if FOLLOWERS_INVULNERABLE then 
					npc_leash_remove(M11_homie.asha)
					follower_make_independent(M11_homie.asha, false)
					clear_animation_state(M11_homie.asha)
	ding_finish_audio()
														npc_weapon_pickup_override(M11_homie.asha, false)
								m00_character_combat_movement_enable(M11_homie.asha, false)
																	ding_finish_audio()
						set_animation_set(M11_homie.asha, "gangf")
											character_set_always_combat_ready(M11_homie.asha, false)
					set_attack_enemies_flag(M11_homie.asha, true)
				set_always_sees_player_flag(M11_homie.asha, true)
												set_never_turn_on_player(M11_homie.asha, false)
									set_attack_peds_flag(M11_homie.asha, true)
									set_attack_player_flag(M11_homie.asha, true)
					ai_add_enemy_target(M11_homie.asha, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, false)
						vehicle_suppress_npc_exit(M11_homie.asha, false)
								turn_invulnerable(M11_homie.asha)
														ai_clear_priority_target(M11_homie.asha)
					ai_add_enemy_target(M11_homie.asha, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, false)
								turn_invulnerable(M11_homie.asha)

					sandbox_message("Asha dislike you and the others!")
				else
					npc_leash_remove(M11_homie.asha)
																		npc_weapon_pickup_override(M11_homie.asha, false)
					follower_make_independent(M11_homie.asha, false)
												npc_combat_enable(M11_homie.asha, true)
												m00_character_combat_movement_enable(M11_homie.asha, false)
																	ding_finish_audio()
										set_animation_set(M11_homie.asha, "gangf")
											character_set_always_combat_ready(M11_homie.asha, false)
		set_never_turn_on_player(M11_homie.asha, false)
					set_attack_enemies_flag(M11_homie.asha, true )
				set_always_sees_player_flag(M11_homie.asha, true )
									set_attack_peds_flag(M11_homie.asha, true)
									set_attack_player_flag(M11_homie.asha, true)
					ai_add_enemy_target(M11_homie.asha, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true)
						vehicle_suppress_npc_exit(M11_homie.asha, true)
											turn_invulnerable(M11_homie.asha)
					ai_add_enemy_target(M11_homie.asha, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true)
											turn_invulnerable(M11_homie.asha)

					alert_message("You ruined Asha's mission!")

				end
							else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				FOLLOWERS_INVULNERABLE = not FOLLOWERS_INVULNERABLE
				TWO_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not TWO_PUSHED then
														if mission_is_active() then
				if FOLLOWERS_PSYCHO then
													ding_finish_audio()
																										npc_weapon_pickup_override(M11_homie.asha, false)
																		set_cant_cower_flag(M11_homie.asha, true)
					set_cant_flee_flag(M11_homie.asha, true)
					character_prevent_explosion_fling(M11_homie.asha, true)
					character_prevent_kneecapping(M11_homie.asha, true)
					character_set_never_catch_fire(M11_homie.asha, true)
					character_set_damage_multiplier(M11_homie.asha, 0.00)
					character_set_never_fall(M11_homie.asha, true)
					character_allow_ragdoll(M11_homie.asha, false)
					character_prevent_bumping(M11_homie.asha, true)
			character_set_counter_on_grabbed( M11_homie.asha , true )
	                                human_set_invulnerable_to_telekinesis(M11_homie.asha, true)
					human_set_invulnerable_to_freeze(M11_homie.asha, true)
					character_set_immune_to_explosion_vomit(M11_homie.asha, true)
					character_set_no_explosive_panic(M11_homie.asha, true)
	                                character_prevent_flinching(M11_homie.asha, true)
							sandbox_message("Asha is in god mode")

				else
													ding_finish_audio()
																										npc_weapon_pickup_override(M11_homie.asha, false)
																															set_cant_cower_flag(M11_homie.asha, true)
					set_cant_flee_flag(M11_homie.asha, true)
					character_prevent_explosion_fling(M11_homie.asha, false)
					character_prevent_kneecapping(M11_homie.asha, true)
					character_set_never_catch_fire(M11_homie.asha, true)
					character_set_damage_multiplier(M11_homie.asha, 0.00)
					character_set_never_fall(M11_homie.asha, false)
					character_allow_ragdoll(M11_homie.asha, true)
					character_prevent_bumping(M11_homie.asha, true)
			character_set_counter_on_grabbed( M11_homie.asha , true )
	                                human_set_invulnerable_to_telekinesis(M11_homie.asha, true)
					human_set_invulnerable_to_freeze(M11_homie.asha, true)
					character_set_immune_to_explosion_vomit(M11_homie.asha, true)
					character_set_no_explosive_panic(M11_homie.asha, true)
	                                character_prevent_flinching(M11_homie.asha, false)
							sandbox_message("Asha is restore back to normal")
				end
							else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				FOLLOWERS_PSYCHO = not FOLLOWERS_PSYCHO

				TWO_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not TWO_PUSHED then
				if FOLLOWERS_INVULNERABLE then
	human_all_stop_dropping_cash(true)
	human_all_stop_dropping_weapons(true)
					sandbox_message("No One Drops Any Weapons")
				else
	human_all_stop_dropping_cash(false)
	human_all_stop_dropping_weapons(false)
					sandbox_message("Now Anyone Drops Weapons Now")

				end
				FOLLOWERS_INVULNERABLE = not FOLLOWERS_INVULNERABLE
				TWO_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not TWO_PUSHED then
				-- SLEW MODE (FREE CAMERA) --Kinzie Mission Only mol_kz_01_modal.str2_pc --FWIP
											if mission_is_active() then
				if FOLLOWERS_INVULNERABLE then 
													ding_finish_audio()
					character_hide(MOL_KZ_01_homie.kinzie)
					sandbox_message("Kinzie is now hidden")
				else
													ding_finish_audio()
					character_show(MOL_KZ_01_homie.kinzie)
		set_never_turn_on_player(MOL_KZ_01_homie.kinzie, false)
					set_attack_enemies_flag(MOL_KZ_01_homie.kinzie, true )
				set_always_sees_player_flag(MOL_KZ_01_homie.kinzie, true )
									set_attack_peds_flag(MOL_KZ_01_homie.kinzie, true)
									set_attack_player_flag(MOL_KZ_01_homie.kinzie, true)
					ai_add_enemy_target(MOL_KZ_01_homie.kinzie, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true)
					alert_message("Kinzie not hidden")

				end
			else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				FOLLOWERS_INVULNERABLE = not FOLLOWERS_INVULNERABLE

				TWO_PUSHED = true
			elseif player_action_is_pressed(B_END) and not TWO_PUSHED then
														if mission_is_active() then
				if FOLLOWERS_INVULNERABLE then --zimos
													ding_finish_audio()
					character_set_always_combat_ready(MOL_KZ_01_homie.kinzie, true)

					sandbox_message("Kinzie is stuck on combat forever")
				else
													ding_finish_audio()
					character_set_always_combat_ready(MOL_KZ_01_homie.kinzie, false)
					sandbox_message("Kinzie's combat is restored to normal")
					end
												else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
									FOLLOWERS_INVULNERABLE = not FOLLOWERS_INVULNERABLE
				TWO_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not TWO_PUSHED then
														if mission_is_active() then
				if FOLLOWERS_INVULNERABLE then 
					set_dont_attack_me_on_sight_flag(MOL_KZ_01_homie.kinzie, true)
					sandbox_message("No one attacks Kinzie!")
				else
					set_dont_attack_me_on_sight_flag(MOL_KZ_01_homie.kinzie, false)
					sandbox_message("Now they will attack Kinzie")

				end
							else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				FOLLOWERS_INVULNERABLE = not FOLLOWERS_INVULNERABLE
				delay(0.75)
				TWO_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not TWO_PUSHED then
																	if mission_is_active() then
				if FOLLOWERS_INVULNERABLE then 
					set_ignore_ai_flag(M18_group.alley_vp.roddy, false)
					set_ignore_ai_flag(M18_group.alley_vp.julius, false)

																	ding_finish_audio()
											character_set_always_combat_ready(M18_group.alley_vp.roddy, false)
					set_attack_enemies_flag(M18_group.alley_vp.roddy, true)
				set_always_sees_player_flag(M18_group.alley_vp.roddy, true)
												set_never_turn_on_player(M18_group.alley_vp.roddy, false)
									set_attack_peds_flag(M18_group.alley_vp.roddy, true)
									set_attack_player_flag(M18_group.alley_vp.roddy, true)
					ai_add_enemy_target(M18_group.alley_vp.roddy, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, false)
						vehicle_suppress_npc_exit(M18_group.alley_vp.roddy, false)
								turn_invulnerable(M18_group.alley_vp.roddy)
														ai_clear_priority_target(M18_group.alley_vp.roddy)
					ai_add_enemy_target(M18_group.alley_vp.roddy, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, false)
								turn_invulnerable(M18_group.alley_vp.roddy)

																			character_set_always_combat_ready(M18_group.alley_vp.julius, false)
					set_attack_enemies_flag(M18_group.alley_vp.julius, true)
				set_always_sees_player_flag(M18_group.alley_vp.julius, true)
												set_never_turn_on_player(M18_group.alley_vp.julius, false)
									set_attack_peds_flag(M18_group.alley_vp.julius, true)
									set_attack_player_flag(M18_group.alley_vp.julius, true)
					ai_add_enemy_target(M18_group.alley_vp.julius, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, false)
						vehicle_suppress_npc_exit(M18_group.alley_vp.julius, false)
								turn_invulnerable(M18_group.alley_vp.julius)
														ai_clear_priority_target(M18_group.alley_vp.julius)
					ai_add_enemy_target(M18_group.alley_vp.julius, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, false)
								turn_invulnerable(M18_group.alley_vp.julius)
					sandbox_message("Roddy and Keith fight the others and you!")
				else
					set_ignore_ai_flag(M18_group.alley_vp.roddy, false)
					set_ignore_ai_flag(M18_group.alley_vp.julius, false)
			
											character_set_always_combat_ready(M18_group.alley_vp.roddy, false)
		set_never_turn_on_player(M18_group.alley_vp.roddy, false)
					set_attack_enemies_flag(M18_group.alley_vp.roddy, true )
				set_always_sees_player_flag(M18_group.alley_vp.roddy, true )
									set_attack_peds_flag(M18_group.alley_vp.roddy, true)
									set_attack_player_flag(M18_group.alley_vp.roddy, true)
					ai_add_enemy_target(M18_group.alley_vp.roddy, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true)
						vehicle_suppress_npc_exit(M18_group.alley_vp.roddy, true)
											turn_invulnerable(M18_group.alley_vp.roddy)
					ai_add_enemy_target(M18_group.alley_vp.roddy, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true)
											turn_invulnerable(M18_group.alley_vp.roddy)

																						character_set_always_combat_ready(M18_group.alley_vp.julius, false)
		set_never_turn_on_player(M18_group.alley_vp.julius, false)
					set_attack_enemies_flag(M18_group.alley_vp.julius, true )
				set_always_sees_player_flag(M18_group.alley_vp.julius, true )
									set_attack_peds_flag(M18_group.alley_vp.julius, true)
									set_attack_player_flag(M18_group.alley_vp.julius, true)
					ai_add_enemy_target(M18_group.alley_vp.julius, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true)
						vehicle_suppress_npc_exit(M18_group.alley_vp.julius, true)
											turn_invulnerable(M18_group.alley_vp.julius)
					ai_add_enemy_target(M18_group.alley_vp.julius, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true)
											turn_invulnerable(M18_group.alley_vp.julius)

					alert_message("Roddy and Keith is ready to fight with you!")

				end
							else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				FOLLOWERS_INVULNERABLE = not FOLLOWERS_INVULNERABLE
				
				TWO_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not TWO_PUSHED then
												if mission_is_active() then
				if FOLLOWERS_PSYCHO then
													ding_finish_audio()
																		set_cant_cower_flag(M18_group.alley_vp.roddy, true)
					set_cant_flee_flag(M18_group.alley_vp.roddy, true)
					character_prevent_explosion_fling(M18_group.alley_vp.roddy, true)
					character_prevent_kneecapping(M18_group.alley_vp.roddy, true)
					character_set_never_catch_fire(M18_group.alley_vp.roddy, true)
					character_set_damage_multiplier(M18_group.alley_vp.roddy, 0.00)
					character_set_never_fall(M18_group.alley_vp.roddy, true)
					character_allow_ragdoll(M18_group.alley_vp.roddy, false)
					character_prevent_bumping(M18_group.alley_vp.roddy, true)
			character_set_counter_on_grabbed( M18_group.alley_vp.roddy , true )
	                                human_set_invulnerable_to_telekinesis(M18_group.alley_vp.roddy, true)
					human_set_invulnerable_to_freeze(M18_group.alley_vp.roddy, true)
					character_set_immune_to_explosion_vomit(M18_group.alley_vp.roddy, true)
					character_set_no_explosive_panic(M18_group.alley_vp.roddy, true)
	                                character_prevent_flinching(M18_group.alley_vp.roddy, true)
									
																		set_cant_cower_flag(M18_group.alley_vp.julius, true)
					set_cant_flee_flag(M18_group.alley_vp.julius, true)
					character_prevent_explosion_fling(M18_group.alley_vp.julius, true)
					character_prevent_kneecapping(M18_group.alley_vp.julius, true)
					character_set_never_catch_fire(M18_group.alley_vp.julius, true)
					character_set_damage_multiplier(M18_group.alley_vp.julius, 0.00)
					character_set_never_fall(M18_group.alley_vp.julius, true)
					character_allow_ragdoll(M18_group.alley_vp.julius, false)
					character_prevent_bumping(M18_group.alley_vp.julius, true)
			character_set_counter_on_grabbed( M18_group.alley_vp.julius , true )
	                                human_set_invulnerable_to_telekinesis(M18_group.alley_vp.julius, true)
					human_set_invulnerable_to_freeze(M18_group.alley_vp.julius, true)
					character_set_immune_to_explosion_vomit(M18_group.alley_vp.julius, true)
					character_set_no_explosive_panic(M18_group.alley_vp.julius, true)
	                                character_prevent_flinching(M18_group.alley_vp.julius, true)
							sandbox_message("Roddy and Keith are in god mode")

				else
													ding_finish_audio()
						set_cant_cower_flag(M18_group.alley_vp.roddy, true)
					set_cant_flee_flag(M18_group.alley_vp.roddy, true)
					character_prevent_explosion_fling(M18_group.alley_vp.roddy, false)
					character_prevent_kneecapping(M18_group.alley_vp.roddy, true)
					character_set_never_catch_fire(M18_group.alley_vp.roddy, true)
					character_set_damage_multiplier(M18_group.alley_vp.roddy, 0.00)
					character_set_never_fall(M18_group.alley_vp.roddy, false)
					character_allow_ragdoll(M18_group.alley_vp.roddy, true)
					character_prevent_bumping(M18_group.alley_vp.roddy, true)
			character_set_counter_on_grabbed( M18_group.alley_vp.roddy , true )
	                                human_set_invulnerable_to_telekinesis(M18_group.alley_vp.roddy, false)
					human_set_invulnerable_to_freeze(M18_group.alley_vp.roddy, true)
					character_set_immune_to_explosion_vomit(M18_group.alley_vp.roddy, true)
					character_set_no_explosive_panic(M18_group.alley_vp.roddy, true)
	                                character_prevent_flinching(M18_group.alley_vp.roddy, false)

						set_cant_cower_flag(M18_group.alley_vp.roddy, true)									
					set_cant_flee_flag(M18_group.alley_vp.julius, true)
					character_prevent_explosion_fling(M18_group.alley_vp.julius, false)
					character_prevent_kneecapping(M18_group.alley_vp.julius, true)
					character_set_never_catch_fire(M18_group.alley_vp.julius, true)
					character_set_damage_multiplier(M18_group.alley_vp.julius, 0.00)
					character_set_never_fall(M18_group.alley_vp.julius, false)
					character_allow_ragdoll(M18_group.alley_vp.julius, true)
					character_prevent_bumping(M18_group.alley_vp.julius, true)
			character_set_counter_on_grabbed( M18_group.alley_vp.julius , true )
	                                human_set_invulnerable_to_telekinesis(M18_group.alley_vp.julius, false)
					human_set_invulnerable_to_freeze(M18_group.alley_vp.julius, true)
					character_set_immune_to_explosion_vomit(M18_group.alley_vp.julius, true)
					character_set_no_explosive_panic(M18_group.alley_vp.julius, true)
	                                character_prevent_flinching(M18_group.alley_vp.julius, false)
							sandbox_message("Roddy and Keith are restore back to normal")
				end
													else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				FOLLOWERS_PSYCHO = not FOLLOWERS_PSYCHO
				TWO_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not TWO_PUSHED then
--UNUSED Ben King
						if mission_is_active() then
				if MISSION_WEAPONS == 1 then --M02
																	npc_weapon_pickup_override(M11_homie.asha, false)
					npc_combat_enable(M11_homie.asha, true)
												inv_item_remove_all(M11_homie.asha)
																					delay(0.20)
					inv_item_add("baseball_bat",10, M11_homie.asha,true)
     				sandbox_message("Asha armed with baseball bat.") 
				elseif MISSION_WEAPONS == 2 then
												inv_item_remove_all(M11_homie.asha)
																					delay(0.20)
					inv_item_add("light_sword",10, M11_homie.asha,true)
					sandbox_message("asha armed with light sword.") 
				elseif MISSION_WEAPONS == 3 then
												inv_item_remove_all(M11_homie.asha)
																					delay(0.20)
					inv_item_add("Pistol-Gang",10, M11_homie.asha,true)
					sandbox_message("asha armed with pistol.") 
				elseif MISSION_WEAPONS == 4 then
												inv_item_remove_all(M11_homie.asha)
																					delay(0.20)
					inv_item_add("SMG-Gang",10, M11_homie.asha,true)
					sandbox_message("asha armed with sub-machine gun.") 
				elseif MISSION_WEAPONS == 5 then
												inv_item_remove_all(M11_homie.asha)
																					delay(0.20)
					inv_item_add("Shotgun-Police",10, M11_homie.asha,true)
					sandbox_message("asha armed with shotgun.") 
				elseif MISSION_WEAPONS == 6 then
												inv_item_remove_all(M11_homie.asha)
																					delay(0.20)
					inv_item_add("Rifle-Gang",10, M11_homie.asha,true)
					sandbox_message("asha armed with rifle.") 
				elseif MISSION_WEAPONS == 7 then
								inv_item_remove_all(M11_homie.asha)
																					delay(0.20)
					inv_item_add("Special-SniperRifle",10, M11_homie.asha,true)
					sandbox_message("asha armed with sniper")
				elseif MISSION_WEAPONS == 8 then
									inv_item_remove_all(M11_homie.asha)
													delay(0.20)
					inv_item_add("Explosive-RocketLauncher",10, M11_homie.asha,true)
					sandbox_message("asha armed with RPG.")
				elseif MISSION_WEAPONS == 9 then
					npc_combat_enable(M11_homie.asha, true)
					sandbox_message("asha fight with bare fists.")
					inv_item_remove_all(M11_homie.asha)

				end
				if MISSION_WEAPONS == 9 then
					MISSION_WEAPONS = 1
				else
					MISSION_WEAPONS = MISSION_WEAPONS + 1
				end
											else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				TWO_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not TWO_PUSHED then
									if mission_is_active() then
				if FOLLOWERS_INVULNERABLE then 
																	npc_weapon_pickup_override(M11_homie.asha, false)
					follower_make_independent(M11_homie.asha, false)
						npc_leash_remove(M11_homie.asha)
					npc_combat_enable(M11_homie.asha, true)
																	ding_finish_audio()
									turn_invulnerable(M11_homie.asha)
					set_attack_enemies_flag(M11_homie.asha, true)
				set_always_sees_player_flag(M11_homie.asha, false)
												set_never_turn_on_player(M11_homie.asha, true)
									set_attack_peds_flag(M11_homie.asha, true)
									set_attack_player_flag(M11_homie.asha, false)
																	human_set_invulnerable_to_freeze(M11_homie.asha, true)
														ai_clear_priority_target(M11_homie.asha)
					ai_add_enemy_target(M11_homie.asha, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, false)

					sandbox_message("You and Asha are great teammates")
				else
																	npc_weapon_pickup_override(M11_homie.asha, false)
					follower_make_independent(M11_homie.asha, false)
						npc_leash_remove(M11_homie.asha)
					npc_combat_enable(M11_homie.asha, true)
																	ding_finish_audio()
													inv_item_remove_all(M11_homie.asha)
													turn_invulnerable(M11_homie.asha)
		set_never_turn_on_player(M11_homie.asha, false)
					set_attack_enemies_flag(M11_homie.asha, false )
				set_always_sees_player_flag(M11_homie.asha, false )
									human_set_invulnerable_to_freeze(M11_homie.asha, true)
									set_attack_peds_flag(M11_homie.asha, false)
									set_attack_player_flag(M11_homie.asha, false)
					ai_add_enemy_target(M11_homie.asha, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, false)

					sandbox_message("Asha's behavior is normal")

				end
							else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				FOLLOWERS_INVULNERABLE = not FOLLOWERS_INVULNERABLE	
				TWO_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not TWO_PUSHED then
												if mission_is_active() then
				if FOLLOWERS_PSYCHO then
				-- hostile Kinzie Mission
				
													ding_finish_audio()
					set_attack_enemies_flag(MOL_KZ_01_homie.kinzie, false)
				set_always_sees_player_flag(MOL_KZ_01_homie.kinzie, false)
								set_never_turn_on_player(MOL_KZ_01_homie.kinzie, true)
									set_attack_peds_flag(MOL_KZ_01_homie.kinzie,false)
									set_attack_player_flag(MOL_KZ_01_homie.kinzie, false)
														ai_clear_priority_target(MOL_KZ_01_homie.kinzie)
					ai_add_enemy_target(MOL_KZ_01_homie.kinzie, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, false)
					sandbox_message("Kinzie is back to normal as she is")
				else
													ding_finish_audio()
					set_attack_enemies_flag(MOL_KZ_01_homie.kinzie, true)
				set_always_sees_player_flag(MOL_KZ_01_homie.kinzie, false)
								set_never_turn_on_player(MOL_KZ_01_homie.kinzie, true)
									set_attack_peds_flag(MOL_KZ_01_homie.kinzie, true)
									set_attack_player_flag(MOL_KZ_01_homie.kinzie, false)
														ai_clear_priority_target(MOL_KZ_01_homie.kinzie)
					ai_add_enemy_target(MOL_KZ_01_homie.kinzie, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, false)
					sandbox_message("Kinzie attacks random peds and gangs")

				end
											else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				FOLLOWERS_PSYCHO = not FOLLOWERS_PSYCHO
				TWO_PUSHED = true
			elseif player_action_is_pressed(B_RBRACKET) and not TWO_PUSHED then
						if mission_is_active() then
				if FOLLOWERS_INVULNERABLE then 
													ding_finish_audio()
					set_attack_enemies_flag(MOL_KZ_01_homie.kinzie, true)
				set_always_sees_player_flag(MOL_KZ_01_homie.kinzie, false)
												set_never_turn_on_player(MOL_KZ_01_homie.kinzie, false)
									set_attack_peds_flag(MOL_KZ_01_homie.kinzie, true)
									set_attack_player_flag(MOL_KZ_01_homie.kinzie, true)
														ai_clear_priority_target(MOL_KZ_01_homie.kinzie)
					ai_add_enemy_target(MOL_KZ_01_homie.kinzie, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, false)

					sandbox_message("That fix her problem but she still dislike you, okay and don't screw this up, alright?")
				else
												
		set_never_turn_on_player(MOL_KZ_01_homie.kinzie, false)
					set_attack_enemies_flag(MOL_KZ_01_homie.kinzie, true )
				set_always_sees_player_flag(MOL_KZ_01_homie.kinzie, true )
									set_attack_peds_flag(MOL_KZ_01_homie.kinzie, true)
									set_attack_player_flag(MOL_KZ_01_homie.kinzie, true)
					ai_add_enemy_target(MOL_KZ_01_homie.kinzie, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true)

					alert_message("Kinzie is gonna find you and she's breaking up and also you screw this up!")

				end
					else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				FOLLOWERS_INVULNERABLE = not FOLLOWERS_INVULNERABLE
				TWO_PUSHED = true
			end

		elseif player_action_is_pressed("CBA_GAC_WEAPON_SELECT_3") then -- 3 - CUTSCENES
			if player_action_is_pressed(B_INSERT) and not THREE_PUSHED then
									if mission_is_active() then
				if FOLLOWERS_PSYCHO then
													ding_finish_audio()
					set_ignore_ai_flag(MOL_KZ_01_homie.kinzie, true)
					character_set_never_catch_fire(MOL_KZ_01_homie.kinzie, true)
					human_set_invulnerable_to_freeze(MOL_KZ_01_homie.kinzie, true)
					sandbox_message("Kinzie Ingores You!")


				else
													ding_finish_audio()
					set_ignore_ai_flag(MOL_KZ_01_homie.kinzie, false)
					sandbox_message("Kinzie Don't Ingores You!")
				end
									else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				FOLLOWERS_PSYCHO = not FOLLOWERS_PSYCHO
				THREE_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not THREE_PUSHED then
												if mission_is_active() then
				if FOLLOWERS_PSYCHO then
													ding_finish_audio()
																		set_cant_cower_flag(MOL_KZ_01_homie.kinzie, true)
					set_cant_flee_flag(MOL_KZ_01_homie.kinzie, true)
					character_prevent_explosion_fling(MOL_KZ_01_homie.kinzie, true)
					character_prevent_kneecapping(MOL_KZ_01_homie.kinzie, true)
					character_set_never_catch_fire(MOL_KZ_01_homie.kinzie, true)
					character_set_damage_multiplier(MOL_KZ_01_homie.kinzie, 0.00)
					character_set_never_fall(MOL_KZ_01_homie.kinzie, true)
					character_allow_ragdoll(MOL_KZ_01_homie.kinzie, false)
					character_prevent_bumping(MOL_KZ_01_homie.kinzie, true)
			character_set_counter_on_grabbed( MOL_KZ_01_homie.kinzie , true )
	                                human_set_invulnerable_to_telekinesis(MOL_KZ_01_homie.kinzie, true)
					human_set_invulnerable_to_freeze(MOL_KZ_01_homie.kinzie, true)
					character_set_immune_to_explosion_vomit(MOL_KZ_01_homie.kinzie, true)
					character_set_no_explosive_panic(MOL_KZ_01_homie.kinzie, true)
	                                character_prevent_flinching(MOL_KZ_01_homie.kinzie, true)
							sandbox_message("Kinzie is in god mode")

				else
													ding_finish_audio()
																															set_cant_cower_flag(MOL_KZ_01_homie.kinzie, true)
					set_cant_flee_flag(MOL_KZ_01_homie.kinzie, true)
					character_prevent_explosion_fling(MOL_KZ_01_homie.kinzie, false)
					character_prevent_kneecapping(MOL_KZ_01_homie.kinzie, true)
					character_set_never_catch_fire(MOL_KZ_01_homie.kinzie, true)
					character_set_damage_multiplier(MOL_KZ_01_homie.kinzie, 0.00)
					character_set_never_fall(MOL_KZ_01_homie.kinzie, false)
					character_allow_ragdoll(MOL_KZ_01_homie.kinzie, true)
					character_prevent_bumping(MOL_KZ_01_homie.kinzie, true)
			character_set_counter_on_grabbed( MOL_KZ_01_homie.kinzie , true )
	                                human_set_invulnerable_to_telekinesis(MOL_KZ_01_homie.kinzie, true)
					human_set_invulnerable_to_freeze(MOL_KZ_01_homie.kinzie, true)
					character_set_immune_to_explosion_vomit(MOL_KZ_01_homie.kinzie, true)
					character_set_no_explosive_panic(MOL_KZ_01_homie.kinzie, true)
	                                character_prevent_flinching(MOL_KZ_01_homie.kinzie, false)
							sandbox_message("Kinzie is restore back to normal")
				end
													else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				FOLLOWERS_PSYCHO = not FOLLOWERS_PSYCHO

				THREE_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not THREE_PUSHED then
			--edited later
				--TELEPORT TO 3 COUNT CASINO 
				reset_all_zones()
				local tposx,tposy,tposz = (1199.270 - ctele_Posx), (1429.662 - ctele_Posy), (23.795 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				sandbox_message(" Teleported to 3 Count Casino")
				if COOP_COMMANDS and coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				THREE_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not THREE_PUSHED then
				if mission_is_active() then
				if PLAYA_DANCE_COUNTER_B == 1 then
				--
									set_team(MOL_KZ_01_homie.kinzie, "Playas")
									sandbox_message(" Kinzie teams on Saints")
				elseif PLAYA_DANCE_COUNTER_B == 2 then
									set_team(MOL_KZ_01_homie.kinzie, "STAG")
									sandbox_message(" Kinzie teams on STAG")
				elseif PLAYA_DANCE_COUNTER_B == 3 then
									set_team(MOL_KZ_01_homie.kinzie, "Luchadores")
									sandbox_message(" Kinzie teams on Luchadores")
				elseif PLAYA_DANCE_COUNTER_B == 4 then
									set_team(MOL_KZ_01_homie.kinzie, "Morningstar")
									sandbox_message(" Kinzie teams on Morningstar")
				elseif PLAYA_DANCE_COUNTER_B == 5 then
									set_team(MOL_KZ_01_homie.kinzie, "Neutral Gang")
									sandbox_message(" Kinzie teams on Neutral Gang")
				elseif PLAYA_DANCE_COUNTER_B == 6 then
									set_team(MOL_KZ_01_homie.kinzie, "Police")
									sandbox_message(" Kinzie teams on Police")
				elseif PLAYA_DANCE_COUNTER_B == 7 then
									set_team(MOL_KZ_01_homie.kinzie, "Deckers")
									sandbox_message(" Kinzie teams on Deckers")
				elseif PLAYA_DANCE_COUNTER_B == 8 then
									set_team(MOL_KZ_01_homie.kinzie, "Civilian")
									sandbox_message(" Kinzie teams on Civilian")

				end
				if PLAYA_DANCE_COUNTER_B == 8 then
					PLAYA_DANCE_COUNTER_B = 1
				else
					PLAYA_DANCE_COUNTER_B = PLAYA_DANCE_COUNTER_B + 1
				end	
							else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				THREE_PUSHED = true
			elseif player_action_is_pressed(B_END) and not THREE_PUSHED then
							if mission_is_active() then
				if PLAYA_DANCE_COUNTER_B == 1 then
				-- --REMOVE THIS
				
													set_team(M11_homie.asha, "Playas")
									set_team(M11_homie.asha, "Playas")
									sandbox_message("  Asha teams on Saints")
				elseif PLAYA_DANCE_COUNTER_B == 2 then
																	set_team(M11_homie.asha, "Police")
									set_team(M11_homie.asha, "Police")
									sandbox_message("  Asha teams on Police")
				elseif PLAYA_DANCE_COUNTER_B == 3 then
																	set_team(M11_homie.asha, "STAG")
									set_team(M11_homie.asha, "STAG")
									sandbox_message("  Asha teams on STAG")
				elseif PLAYA_DANCE_COUNTER_B == 4 then
																	set_team(M11_homie.asha, "Luchadores")
									set_team(M11_homie.asha, "Luchadores")
									sandbox_message("  Asha teams on Zin")
				elseif PLAYA_DANCE_COUNTER_B == 5 then
																	set_team(M11_homie.asha, "Morningstar")
									set_team(M11_homie.asha, "Morningstar")
									sandbox_message(" Asha teams on Alien")
				elseif PLAYA_DANCE_COUNTER_B == 6 then
																	set_team(M11_homie.asha, "Neutral Gang")
									set_team(M11_homie.asha, "Neutral Gang")
									sandbox_message(" Asha teams on Neutral Gang")
				elseif PLAYA_DANCE_COUNTER_B == 7 then
																	set_team(M11_homie.asha, "Civilian")
									set_team(M11_homie.asha, "Civilian")
									sandbox_message(" Asha teams on Civilian")
			
				end
				if PLAYA_DANCE_COUNTER_B == 7 then
					PLAYA_DANCE_COUNTER_B = 1
				else
					PLAYA_DANCE_COUNTER_B = PLAYA_DANCE_COUNTER_B + 1
				end	
											else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				THREE_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not THREE_PUSHED then
										if mission_is_active() then
				if FOLLOWERS_PSYCHO then
				--REMOVE THIS
													npc_weapon_pickup_override(M11_homie.asha, false)
																	ding_finish_audio()
					set_ignore_ai_flag(M11_homie.asha, true)
					set_ignore_ai_flag(M11_homie.asha, true)				
					sandbox_message("Asha Ingores You!")

				else
																	npc_weapon_pickup_override(M11_homie.asha, false)
																	ding_finish_audio()
					set_ignore_ai_flag(M11_homie.asha, false)
	    			set_ignore_ai_flag(M11_homie.asha, false)
					sandbox_message("Asha Don't Ingores You!")
				end
															else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				FOLLOWERS_PSYCHO = not FOLLOWERS_PSYCHO
				THREE_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not THREE_PUSHED then
			--UNUSED
													if mission_is_active() then
						vehicle_enter_teleport(MOL_KZ_01_homie.kinzie, get_char_vehicle_name(LOCAL_PLAYER), 1) 
						sandbox_message("Kinzie teleports to your vehicle")
															else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				THREE_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not THREE_PUSHED then
												if mission_is_active() then
				if FOLLOWERS_PSYCHO then
				-- hostile Kinzie Mission
									set_ignore_ai_flag(M18_group.alley_vp.roddy, false)
					set_ignore_ai_flag(M18_group.alley_vp.julius, false)
													ding_finish_audio()
					set_attack_enemies_flag(M18_group.alley_vp.roddy, false)
				set_always_sees_player_flag(M18_group.alley_vp.roddy, false)
								set_never_turn_on_player(M18_group.alley_vp.roddy, true)
									set_attack_peds_flag(M18_group.alley_vp.roddy,false)
									set_attack_player_flag(M18_group.alley_vp.roddy, false)
														ai_clear_priority_target(M18_group.alley_vp.roddy)
					ai_add_enemy_target(M18_group.alley_vp.roddy, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, false)
					
													ding_finish_audio()
					set_attack_enemies_flag(M18_group.alley_vp.julius, false)
				set_always_sees_player_flag(M18_group.alley_vp.julius, false)
								set_never_turn_on_player(M18_group.alley_vp.julius, true)
									set_attack_peds_flag(M18_group.alley_vp.julius,false)
									set_attack_player_flag(M18_group.alley_vp.julius, false)
														ai_clear_priority_target(M18_group.alley_vp.julius)
					ai_add_enemy_target(M18_group.alley_vp.julius, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, false)
					sandbox_message("Roddy and Keith are back to normal as they are")
				else
									set_ignore_ai_flag(M18_group.alley_vp.roddy, false)
					set_ignore_ai_flag(M18_group.alley_vp.julius, false)
													ding_finish_audio()
					set_attack_enemies_flag(M18_group.alley_vp.roddy, true)
				set_always_sees_player_flag(M18_group.alley_vp.roddy, false)
								set_never_turn_on_player(M18_group.alley_vp.roddy, true)
									set_attack_peds_flag(M18_group.alley_vp.roddy, true)
									set_attack_player_flag(M18_group.alley_vp.roddy, false)
														ai_clear_priority_target(M18_group.alley_vp.roddy)
					ai_add_enemy_target(M18_group.alley_vp.roddy, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, false)
					
					set_attack_enemies_flag(M18_group.alley_vp.julius, true)
				set_always_sees_player_flag(M18_group.alley_vp.julius, false)
								set_never_turn_on_player(M18_group.alley_vp.julius, true)
									set_attack_peds_flag(M18_group.alley_vp.julius, true)
									set_attack_player_flag(M18_group.alley_vp.julius, false)
														ai_clear_priority_target(M18_group.alley_vp.julius)
					ai_add_enemy_target(M18_group.alley_vp.julius, LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, false)
					sandbox_message("Roddy and Keith attacks random peds and gangs")

				end
											else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				FOLLOWERS_PSYCHO = not FOLLOWERS_PSYCHO
				THREE_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not THREE_PUSHED then
								if mission_is_active() then
				if MISSION_WEAPONS == 1 then --M02
					inv_item_add("baseball_bat",10, MOL_KZ_01_homie.kinzie,true)
     				sandbox_message("Kinzie is armed with baseball bat.") 
				elseif MISSION_WEAPONS == 2 then
					inv_item_add("Light_sword",10, MOL_KZ_01_homie.kinzie,true)
     				sandbox_message("Kinzie is armed with light sword bat.") 
				elseif MISSION_WEAPONS == 3 then
					inv_item_add("Pistol-Gang",10, MOL_KZ_01_homie.kinzie,true)
					sandbox_message("Kinzie is armed with pistol.") 
				elseif MISSION_WEAPONS == 4 then
					inv_item_add("SMG-Gang",10, MOL_KZ_01_homie.kinzie,true)
					sandbox_message("Kinzie is armed with sub-machine gun.") 
				elseif MISSION_WEAPONS == 5 then
					inv_item_add("Shotgun-Police",10, MOL_KZ_01_homie.kinzie,true)
					sandbox_message("Kinzie is armed with shotgun police.") 
				elseif MISSION_WEAPONS == 6 then
					inv_item_add("Shotgun-Gang",10, MOL_KZ_01_homie.kinzie,true)
					sandbox_message("Kinzie is armed with shotgun gang.") 
				elseif MISSION_WEAPONS == 7 then
					inv_item_add("Rifle-Gang",10, MOL_KZ_01_homie.kinzie,true)
					sandbox_message("Kinzie is armed with rifle.") 
				elseif MISSION_WEAPONS == 8 then
					inv_item_add("Special-SniperRifle",10, MOL_KZ_01_homie.kinzie,true)
					sandbox_message("Kinzie is armed with sniper")
				elseif MISSION_WEAPONS == 9 then
					inv_item_add("Explosive-RocketLauncher",10, MOL_KZ_01_homie.kinzie,true)
					sandbox_message("Kinzie is armed with RPG.")
				elseif MISSION_WEAPONS == 10 then
					sandbox_message("Kinzie is fight with bare fists.")
					inv_item_remove_all(MOL_KZ_01_homie.kinzie)

				end
				if MISSION_WEAPONS == 10 then
					MISSION_WEAPONS = 1
				else
					MISSION_WEAPONS = MISSION_WEAPONS + 1
				end
																							else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				THREE_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not THREE_PUSHED then
			-- ai add enemy target
				if FOLLOWERS_PSYCHO then
					ai_set_personality("#FOLLOWER1#", "Gang offensive")
					ai_set_personality("#FOLLOWER2#", "Gang offensive")
					ai_set_personality("#FOLLOWER3#", "Gang offensive")
					turn_invulnerable(FOLLOWER1)
					turn_invulnerable(FOLLOWER2)
					turn_invulnerable(FOLLOWER3)
					human_set_invulnerable_to_freeze("#FOLLOWER3#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER1#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER2#", true)
					character_set_damage_multiplier("#FOLLOWER1#", 0.00)
					character_set_damage_multiplier("#FOLLOWER2#", 0.00)
					character_set_damage_multiplier("#FOLLOWER3#", 0.00)
					set_attack_enemies_flag("#FOLLOWER3#", true)
					set_attack_enemies_flag("#FOLLOWER2#", true)
					set_attack_enemies_flag("#FOLLOWER1#", true)
					set_attack_player_flag("#FOLLOWER1#", true)
									set_always_sees_player_flag("#FOLLOWER1#", true)
									set_always_sees_player_flag("#FOLLOWER2#", true)
									set_always_sees_player_flag("#FOLLOWER3#", true)
		                        set_attack_player_flag("#FOLLOWER2#", true)
		                        set_attack_player_flag("#FOLLOWER3#", true)
	                                health_pickups_enable(true)
					set_behavior_set( "#FOLLOWER3#", "Super Saint" ) 
					set_behavior_set( "#FOLLOWER2#", "Super Saint" ) 
					set_behavior_set( "#FOLLOWER1#", "Super Saint" )
					set_attack_peds_flag("#FOLLOWER1#", ATTACK_NOW_NEVER_LOSE, true)
					set_attack_peds_flag("#FOLLOWER2#", ATTACK_NOW_NEVER_LOSE, true)
					set_attack_peds_flag("#FOLLOWER3#", ATTACK_NOW_NEVER_LOSE, true)



					sandbox_message("Followers will aggressively attacks for the people")
				else

					ai_set_personality("#FOLLOWER1#", "Gang defensive")
					ai_set_personality("#FOLLOWER2#", "Gang defensive")
					ai_set_personality("#FOLLOWER3#", "Gang defensive")
					ai_clear_priority_target("#FOLLOWER1#")
					ai_clear_priority_target("#FOLLOWER2#")
					ai_clear_priority_target("#FOLLOWER3#")
					set_attack_peds_flag("#FOLLOWER1#", false)
					set_attack_peds_flag("#FOLLOWER2#", false)
					set_attack_peds_flag("#FOLLOWER3#", false)
								set_attack_player_flag("#FOLLOWER1#", false)
		                        set_attack_player_flag("#FOLLOWER2#", false)
		                        set_attack_player_flag("#FOLLOWER3#", false)
					ai_force_team_idle("None")
	                                health_pickups_enable(false)
					sandbox_message("Follower is restored back to normal")

				end
				FOLLOWERS_PSYCHO = not FOLLOWERS_PSYCHO
				THREE_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not THREE_PUSHED then
			-- ai add enemy target
				if FOLLOWERS_PSYCHO then
					ai_set_personality("#FOLLOWER1#", "Gang offensive")
					ai_set_personality("#FOLLOWER2#", "Gang offensive")
					ai_set_personality("#FOLLOWER3#", "Gang offensive")
					turn_invulnerable(FOLLOWER1)
					turn_invulnerable(FOLLOWER2)
					turn_invulnerable(FOLLOWER3)
					human_set_invulnerable_to_freeze("#FOLLOWER3#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER1#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER2#", true)
					character_set_damage_multiplier("#FOLLOWER1#", 0.00)
					character_set_damage_multiplier("#FOLLOWER2#", 0.00)
					character_set_damage_multiplier("#FOLLOWER3#", 0.00)
	                                ai_add_enemy_target("#FOLLOWER1#", LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true, true)
	                                ai_add_enemy_target("#FOLLOWER2#", LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true, true)
	                                ai_add_enemy_target("#FOLLOWER3#", LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true, true)
					set_attack_enemies_flag("#FOLLOWER3#", true)
					set_attack_enemies_flag("#FOLLOWER2#", true)
					set_attack_enemies_flag("#FOLLOWER1#", true)
					set_attack_player_flag("#FOLLOWER1#", true)
									set_always_sees_player_flag("#FOLLOWER1#", true)
									set_always_sees_player_flag("#FOLLOWER2#", true)
									set_always_sees_player_flag("#FOLLOWER3#", true)
		                        set_attack_player_flag("#FOLLOWER2#", true)
		                        set_attack_player_flag("#FOLLOWER3#", true)
					set_behavior_set( "#FOLLOWER3#", "Super Saint" ) 
					set_behavior_set( "#FOLLOWER2#", "Super Saint" ) 
					set_behavior_set( "#FOLLOWER1#", "Super Saint" )
					character_set_always_combat_ready("#FOLLOWER1#", true)
					character_set_always_combat_ready("#FOLLOWER2#", true)
					character_set_always_combat_ready("#FOLLOWER3#", true) 
					set_attack_peds_flag("#FOLLOWER1#", ATTACK_NOW_NEVER_LOSE, true)
					set_attack_peds_flag("#FOLLOWER2#", ATTACK_NOW_NEVER_LOSE, true)
					set_attack_peds_flag("#FOLLOWER3#", ATTACK_NOW_NEVER_LOSE, true)



					sandbox_message("Followers will aggressively attacks for the people")
				else

					ai_set_personality("#FOLLOWER1#", "Gang defensive")
					ai_set_personality("#FOLLOWER2#", "Gang defensive")
					ai_set_personality("#FOLLOWER3#", "Gang defensive")
					ai_clear_priority_target("#FOLLOWER1#")
					ai_clear_priority_target("#FOLLOWER2#")
					ai_clear_priority_target("#FOLLOWER3#")
					set_attack_peds_flag("#FOLLOWER1#", false)
					set_attack_peds_flag("#FOLLOWER2#", false)
					set_attack_peds_flag("#FOLLOWER3#", false)
									set_always_sees_player_flag("#FOLLOWER1#", false)
									set_always_sees_player_flag("#FOLLOWER2#", false)
									set_always_sees_player_flag("#FOLLOWER3#", false)
								set_attack_player_flag("#FOLLOWER1#", false)
		                        set_attack_player_flag("#FOLLOWER2#", false)
		                        set_attack_player_flag("#FOLLOWER3#", false)
					character_set_always_combat_ready("#FOLLOWER1#", false)
					character_set_always_combat_ready("#FOLLOWER2#", false)
					character_set_always_combat_ready("#FOLLOWER3#", false)
					ai_force_team_idle("None")
					sandbox_message("Follower is restored back to normal")

				end
				FOLLOWERS_PSYCHO = not FOLLOWERS_PSYCHO
				THREE_PUSHED = true
			elseif player_action_is_pressed(B_RBRACKET) and not THREE_PUSHED then
			-- combat ready
				if COMBAT_READY then
					character_set_always_combat_ready("#FOLLOWER1#", true)
					character_set_always_combat_ready("#FOLLOWER2#", true)
					character_set_always_combat_ready("#FOLLOWER3#", true)
					character_set_always_combat_ready(LOCAL_PLAYER, true)
					sandbox_message("You and your followers are now combat ready")
				else
					character_set_always_combat_ready(LOCAL_PLAYER, false)
					character_set_always_combat_ready("#FOLLOWER1#", false)
					character_set_always_combat_ready("#FOLLOWER2#", false)
					character_set_always_combat_ready("#FOLLOWER3#", false)
					sandbox_message("You and your followers are not combat ready")
				end
				COMBAT_READY = not COMBAT_READY
				THREE_PUSHED = true
			end

		elseif player_action_is_pressed("CBA_GAC_WEAPON_SELECT_4") then -- 4 - CUTSCENES
			if player_action_is_pressed(B_INSERT) and not FOUR_PUSHED then
--UNUSED FWIP
								if mission_is_active() then
						vehicle_enter_teleport(MOL_KZ_01_homie.kinzie, get_char_vehicle_name(LOCAL_PLAYER), 0) 
						sandbox_message("Kinzie will be the driver")
									else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				FOUR_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not FOUR_PUSHED then
				if PLAYA_DANCE_COUNTER == 1 then
				--
					set_animation_state(LOCAL_PLAYER, "tai chi")
					sandbox_message(" Reactions: tai chi")
				elseif PLAYA_DANCE_COUNTER == 2 then
					set_animation_state(LOCAL_PLAYER, "yoga")
					sandbox_message(" Reactions: yoga")
				elseif PLAYA_DANCE_COUNTER == 3 then
					set_animation_state(LOCAL_PLAYER, "talk stand")
					sandbox_message(" Reactions: talk stand")
				elseif PLAYA_DANCE_COUNTER == 4 then
					set_animation_state(LOCAL_PLAYER, "vomitting")
					sandbox_message(" Reactions: vomitting")
				elseif PLAYA_DANCE_COUNTER == 5 then
					set_animation_state(LOCAL_PLAYER, "hoe talk a")
					sandbox_message(" Reactions: hoe talk a")
				elseif PLAYA_DANCE_COUNTER == 6 then
					set_animation_state(LOCAL_PLAYER, "hoe talk b")
					sandbox_message(" Reactions: hoe talk b")
				elseif PLAYA_DANCE_COUNTER == 7 then
					set_animation_state(LOCAL_PLAYER, "hoe talk c")
					sandbox_message(" Reactions: hoe talk c")
				elseif PLAYA_DANCE_COUNTER == 8 then
					set_animation_state(LOCAL_PLAYER, "hoe talk d")
					sandbox_message(" Reactions: hoe talk d")
				elseif PLAYA_DANCE_COUNTER == 9 then
					set_animation_state(LOCAL_PLAYER, "hoe stand smoke")
					sandbox_message(" Reactions: hoe stand smoke")
				elseif PLAYA_DANCE_COUNTER == 10 then
					clear_animation_state(LOCAL_PLAYER)
					sandbox_message(" Party's over")
			
				end
				if PLAYA_DANCE_COUNTER == 10 then
					PLAYA_DANCE_COUNTER = 1
				else
					PLAYA_DANCE_COUNTER = PLAYA_DANCE_COUNTER + 1
				end	
				FOUR_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not FOUR_PUSHED then
				if COMBAT_READY then
health_pickups_enable(true)
					sandbox_message("Health Pickups Enabled")
				else
health_pickups_enable(false)
					sandbox_message("Health Pickups Disabled")
				end
				COMBAT_READY = not COMBAT_READY	                                
				FOUR_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not FOUR_PUSHED then
											if mission_is_active() then
	                                mission_shutdown()
		sandbox_message("Mission Shutdown")
					else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				FOUR_PUSHED = true
			elseif player_action_is_pressed(B_END) and not FOUR_PUSHED then
--UNDERCOVER UNUSED
											if mission_is_active() then
				if FOLLOWERS_INVULNERABLE then --zimos
		party_add(MOL_MM_01_group.start.matt, LOCAL_PLAYER)

					sandbox_message("Matt Miller is added to your party")
				else
	on_dismiss( "", MOL_MM_01_group.start.matt )
	party_dismiss( MOL_MM_01_group.start.matt )
					sandbox_message("Matt Miller is dismissed")

				end
									else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				FOLLOWERS_INVULNERABLE = not FOLLOWERS_INVULNERABLE
				FOUR_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not FOUR_PUSHED then
			--
				if PLAYA_DANCE_COUNTER == 1 then
					set_animation_state(LOCAL_PLAYER, "casino dealer")
					sandbox_message(" Playa dance party casino dealer")
				elseif PLAYA_DANCE_COUNTER == 2 then
					set_animation_state(LOCAL_PLAYER, "pole dancing a")
					sandbox_message(" Playa dance party: pole dancing a")
				elseif PLAYA_DANCE_COUNTER == 3 then
					clear_animation_state(LOCAL_PLAYER)
					sandbox_message(" Party's over")
				elseif PLAYA_DANCE_COUNTER == 4 then
					set_animation_state(LOCAL_PLAYER, "pole dancing b")
					sandbox_message(" Playa dance party: pole dancing b")
				elseif PLAYA_DANCE_COUNTER == 5 then
					set_animation_state(LOCAL_PLAYER, "pole dancing c")
					sandbox_message(" Playa dance party: pole dancing c")
				elseif PLAYA_DANCE_COUNTER == 6 then
					clear_animation_state(LOCAL_PLAYER)
					sandbox_message(" Party's over")
				elseif PLAYA_DANCE_COUNTER == 7 then
					set_animation_state(LOCAL_PLAYER, "pole dancing d")
					sandbox_message(" Playa dance party: pole dancing d")
				elseif PLAYA_DANCE_COUNTER == 8 then
					set_animation_state(LOCAL_PLAYER, "abduction")
					sandbox_message(" Playa dance party: abduction")
				elseif PLAYA_DANCE_COUNTER == 9 then
					clear_animation_state(LOCAL_PLAYER)
					sandbox_message(" Party's over")
                elseif PLAYA_DANCE_COUNTER == 10 then
					set_animation_state(LOCAL_PLAYER, "arcade")
					sandbox_message(" Playa dance party: arcade")
				elseif PLAYA_DANCE_COUNTER == 11 then
					set_animation_state(LOCAL_PLAYER, "surrender")
					sandbox_message(" Playa dance party 19: surrender")
				elseif PLAYA_DANCE_COUNTER == 12 then
					set_animation_state(LOCAL_PLAYER, "Slot Machine Stand Happy")
					sandbox_message(" Playa dance party 20: Slot Machine Stand Happy")
				elseif PLAYA_DANCE_COUNTER == 13 then
					set_animation_state(LOCAL_PLAYER, "Slot Machine Stand Dissapointed")
					sandbox_message(" Playa dance party 21: Slot Machine Stand Dissapointed")
				elseif PLAYA_DANCE_COUNTER == 14 then
					set_animation_state(LOCAL_PLAYER, "Slot Machine Stand Angry")
					sandbox_message(" Playa dance party 22: Slot Machine Stand Angry")
				elseif PLAYA_DANCE_COUNTER == 15 then
					clear_animation_state(LOCAL_PLAYER)
					sandbox_message(" Party's over")
				elseif PLAYA_DANCE_COUNTER == 16 then
					set_animation_state(LOCAL_PLAYER, "slot machine sit idle")
					sandbox_message(" Playa dance party: slot machine sit idle")
				elseif PLAYA_DANCE_COUNTER == 17 then
					set_animation_state(LOCAL_PLAYER, "slot machine stand idle")
					sandbox_message(" Playa dance party: slot machine stand idle")
				elseif PLAYA_DANCE_COUNTER == 18 then
					clear_animation_state(LOCAL_PLAYER)
					sandbox_message(" Party's over")
				elseif PLAYA_DANCE_COUNTER == 19 then
					set_animation_state(LOCAL_PLAYER, "pinball")
					sandbox_message(" Playa dance party: pinball")
				elseif PLAYA_DANCE_COUNTER == 20 then
					set_animation_state(LOCAL_PLAYER, "hsg stand")
					sandbox_message(" Playa dance party: hsg stand")
				elseif PLAYA_DANCE_COUNTER == 21 then
					set_animation_state(LOCAL_PLAYER, "hs victim stand")
					sandbox_message(" Playa dance party: hs victim stand")
				elseif PLAYA_DANCE_COUNTER == 22 then
					clear_animation_state(LOCAL_PLAYER)
					sandbox_message(" Party's over")

				end
				if PLAYA_DANCE_COUNTER == 22 then
					PLAYA_DANCE_COUNTER = 1
				else
					PLAYA_DANCE_COUNTER = PLAYA_DANCE_COUNTER + 1
				end	
				FOUR_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not FOUR_PUSHED then
			-- bums
				if PLAYA_DANCE_COUNTER == 1 then
					set_animation_state(LOCAL_PLAYER, "crackhead ground")
					sandbox_message(" Be a bum: crackhead ground")
				elseif PLAYA_DANCE_COUNTER == 2 then
					set_animation_state(LOCAL_PLAYER, "Bum Box Sleep")
					sandbox_message(" Be a bum: Bum Box Sleep")
				elseif PLAYA_DANCE_COUNTER == 3 then
					set_animation_state(LOCAL_PLAYER, "Bum Box Cower")
					sandbox_message(" Be a bum: Bum Box Cower")
				elseif PLAYA_DANCE_COUNTER == 4 then
					set_animation_state(LOCAL_PLAYER, "bum ground sleep")
					sandbox_message(" Be a bum: bum ground sleep")
				elseif PLAYA_DANCE_COUNTER == 5 then
					set_animation_state(LOCAL_PLAYER, "Bum Ground Drink Sip")
					sandbox_message(" Be a bum: Bum Ground Drink Sip")
				elseif PLAYA_DANCE_COUNTER == 6 then
					set_animation_state(LOCAL_PLAYER, "bum ground beg idle")
					sandbox_message(" Be a bum: bum ground beg idle")
				elseif PLAYA_DANCE_COUNTER == 7 then
					set_animation_state(LOCAL_PLAYER, "bum ground smoke")
					sandbox_message(" Be a bum: bum ground smoke")
				elseif PLAYA_DANCE_COUNTER == 8 then
					set_animation_state(LOCAL_PLAYER, "Crackhead Tweaking")
					sandbox_message(" Be a bum: Crackhead Tweaking")
				elseif PLAYA_DANCE_COUNTER == 9 then
					clear_animation_state(LOCAL_PLAYER)
					sandbox_message(" Party's over")
			
				end
				if PLAYA_DANCE_COUNTER == 9 then
					PLAYA_DANCE_COUNTER = 1
				else
					PLAYA_DANCE_COUNTER = PLAYA_DANCE_COUNTER + 1
				end	
				FOUR_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not FOUR_PUSHED then
			-- ai ingores
				if FOLLOWERS_PSYCHO then
					ai_set_personality("#FOLLOWER1#", "Gang offensive")
					ai_set_personality("#FOLLOWER2#", "Gang offensive")
					ai_set_personality("#FOLLOWER3#", "Gang offensive")
					set_ignore_ai_flag("#FOLLOWER1#", true)
					set_ignore_ai_flag("#FOLLOWER2#", true)
					set_ignore_ai_flag("#FOLLOWER3#", true)
					turn_invulnerable(FOLLOWER1)
					turn_invulnerable(FOLLOWER2)
					turn_invulnerable(FOLLOWER3)
					character_set_never_catch_fire("#FOLLOWER1#", true)
					character_set_never_catch_fire("#FOLLOWER2#", true)
					character_set_never_catch_fire("#FOLLOWER3#", true)
					set_dont_attack_me_on_sight_flag("#FOLLOWER3#", true)
					set_dont_attack_me_on_sight_flag("#FOLLOWER2#", true)
					set_dont_attack_me_on_sight_flag("#FOLLOWER1#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER3#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER1#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER2#", true)
					sandbox_message("Followers are deaf in their ears seeing nothing special!")


				else
					ai_set_personality("#FOLLOWER1#", "Gang defensive")
					ai_set_personality("#FOLLOWER2#", "Gang defensive")
					ai_set_personality("#FOLLOWER3#", "Gang defensive")
					set_ignore_ai_flag("#FOLLOWER1#", false)
					set_ignore_ai_flag("#FOLLOWER2#", false)
					set_ignore_ai_flag("#FOLLOWER3#", false)
					turn_vulnerable(FOLLOWER1)
					turn_vulnerable(FOLLOWER2)
					turn_vulnerable(FOLLOWER3)
					human_set_invulnerable_to_freeze("#FOLLOWER3#", false)
					human_set_invulnerable_to_freeze("#FOLLOWER1#", false)
					human_set_invulnerable_to_freeze("#FOLLOWER2#", false)
					character_set_never_catch_fire("#FOLLOWER1#", false)
					character_set_never_catch_fire("#FOLLOWER2#", false)
					character_set_never_catch_fire("#FOLLOWER3#", false)
					set_dont_attack_me_on_sight_flag("#FOLLOWER3#", false)
					set_dont_attack_me_on_sight_flag("#FOLLOWER2#", false)
					set_dont_attack_me_on_sight_flag("#FOLLOWER1#", false)
					ai_force_team_idle("None")
					sandbox_message("Followers aren't deaf no more.")
				end
				FOLLOWERS_PSYCHO = not FOLLOWERS_PSYCHO
				FOUR_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not FOUR_PUSHED then
			--
				if PLAYER_VISIBLE then
					character_hide(LOCAL_PLAYER)
					vehicle_hide(LOCAL_PLAYER)
					sandbox_message("Player is now invisible")
				else
					character_show(LOCAL_PLAYER)
					vehicle_show(LOCAL_PLAYER)
					sandbox_message("Player is now visible")
				end
				PLAYER_VISIBLE = not PLAYER_VISIBLE
				FOUR_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not FOUR_PUSHED then
				if PLAYA_DANCE_COUNTER == 1 then
				--
					set_animation_state(LOCAL_PLAYER, "stripclub drink sit")
					sandbox_message(" Reactions: stripclub drink sit")
				elseif PLAYA_DANCE_COUNTER == 2 then
					set_animation_state(LOCAL_PLAYER, "table talk a")
					sandbox_message(" Reactions: table talk a")
				elseif PLAYA_DANCE_COUNTER == 3 then
					set_animation_state(LOCAL_PLAYER, "table talk b")
					sandbox_message(" Reactions: table talk b")
				elseif PLAYA_DANCE_COUNTER == 4 then
					set_animation_state(LOCAL_PLAYER, "table eat")
					sandbox_message(" Reactions: table eat")
				elseif PLAYA_DANCE_COUNTER == 5 then
					set_animation_state(LOCAL_PLAYER, "table drink")
					sandbox_message(" Reactions: table drink")
				elseif PLAYA_DANCE_COUNTER == 6 then
					set_animation_state(LOCAL_PLAYER, "stripclub sit")
					sandbox_message(" Reactions: stripclub sit")
				elseif PLAYA_DANCE_COUNTER == 7 then
					set_animation_state(LOCAL_PLAYER, "stripclub smoke sit")
					sandbox_message(" Reactions: stripclub smoke sit")
				elseif PLAYA_DANCE_COUNTER == 8 then
					set_animation_state(LOCAL_PLAYER, "table clutter")
					sandbox_message(" Reactions: table clutter")
				elseif PLAYA_DANCE_COUNTER == 9 then
					set_animation_state(LOCAL_PLAYER, "table talk a")
					sandbox_message(" Reactions: table talk a")
				elseif PLAYA_DANCE_COUNTER == 10 then
					set_animation_state(LOCAL_PLAYER, "table talk b")
					sandbox_message(" Reactions: table talk b")
				elseif PLAYA_DANCE_COUNTER == 11 then
					set_animation_state(LOCAL_PLAYER, "table laptop")
					sandbox_message(" Reactions: table laptop")
				elseif PLAYA_DANCE_COUNTER == 12 then
					set_animation_state(LOCAL_PLAYER, "table cower c")
					sandbox_message(" Reactions: table cower c")
				elseif PLAYA_DANCE_COUNTER == 13 then
					set_animation_state(LOCAL_PLAYER, "table cower b")
					sandbox_message(" Reactions: table cower b")
				elseif PLAYA_DANCE_COUNTER == 14 then
					set_animation_state(LOCAL_PLAYER, "table cower a")
					sandbox_message(" Reactions: table cower a")
				elseif PLAYA_DANCE_COUNTER == 15 then
					clear_animation_state(LOCAL_PLAYER)
					sandbox_message(" Reaction's over")
			
				end
				if PLAYA_DANCE_COUNTER == 15 then
					PLAYA_DANCE_COUNTER = 1
				else
					PLAYA_DANCE_COUNTER = PLAYA_DANCE_COUNTER + 1
				end		
				FOUR_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not FOUR_PUSHED then
			-- Very own sets of weapon types
				if FOLLOWER_WEAPONS == 1 then
					inv_item_add("baseball_bat",10,"#FOLLOWER1#",true)
					inv_item_add("dildo_bat",10,"#FOLLOWER2#",true)
					inv_item_add("Light_Sword",10,"#FOLLOWER3#",true)
					sandbox_message("Followers armed with melee weapons.") 
				elseif FOLLOWER_WEAPONS == 2 then
					inv_item_add("Pistol-Gang",10,"#FOLLOWER1#",true)
					inv_item_add("Pistol-Police",10,"#FOLLOWER2#",true)
					inv_item_add("Pistol-Laser",10,"#FOLLOWER3#",true)
					sandbox_message("Followers armed with pistols.") 
				elseif FOLLOWER_WEAPONS == 3 then
					inv_item_add("SMG-Gang",10,"#FOLLOWER1#",true)
					inv_item_add("SMG-Storm",10,"#FOLLOWER2#",true)
					inv_item_add("SMG-StormM00",10,"#FOLLOWER3#",true)
					sandbox_message("Followers armed with sub-machine guns.") 
				elseif FOLLOWER_WEAPONS == 4 then
					inv_item_add("Shotgun-Gang",10,"#FOLLOWER1#",true)
					inv_item_add("Shotgun-Police",10,"#FOLLOWER2#",true)
					inv_item_add("Rifle-Commander",10,"#FOLLOWER3#",true)
					sandbox_message("Followers armed with shotguns.") 
				elseif FOLLOWER_WEAPONS == 5 then
					inv_item_add("Rifle-Gang",10,"#FOLLOWER1#",true)
					inv_item_add("Rifle-Laser",10,"#FOLLOWER2#",true)
					inv_item_add("Rifle-NG",10,"#FOLLOWER3#",true)
					sandbox_message("Followers armed with rifles.") 
				elseif FOLLOWER_WEAPONS == 6 then
					inv_item_add("Special-SniperRifle",10,"#FOLLOWER1#",true)
					inv_item_add("Explosive-PlasmaCannon",10,"#FOLLOWER2#",true)
					inv_item_add("Explosive-RocketLauncher",10,"#FOLLOWER3#",true)
					sandbox_message("Followers armed with explosives.")
				elseif FOLLOWER_WEAPONS == 7 then
					sandbox_message("Followers fight with bare fists.")
					inv_item_remove_all("#FOLLOWER1#")
					inv_item_remove_all("#FOLLOWER2#")
					inv_item_remove_all("#FOLLOWER3#")
				end
				if FOLLOWER_WEAPONS == 7 then
					FOLLOWER_WEAPONS = 1
				else
					FOLLOWER_WEAPONS = FOLLOWER_WEAPONS + 1
				end
				FOUR_PUSHED = true
			elseif player_action_is_pressed(B_RBRACKET) and not FOUR_PUSHED then
				if GOD_MODE_FOLLOWERS == 1 then --Fixed
					heaven_audio()
			character_set_counter_on_grabbed( "#FOLLOWER3#" , true )
			character_set_counter_on_grabbed( "#FOLLOWER2#" , true )
			character_set_counter_on_grabbed( "#FOLLOWER1#" , true )
					character_prevent_explosion_fling("#FOLLOWER1#", true)
					character_prevent_explosion_fling("#FOLLOWER2#", true)
					character_prevent_explosion_fling("#FOLLOWER3#", true)
					character_prevent_kneecapping("#FOLLOWER3#", true)
					character_prevent_kneecapping("#FOLLOWER2#", true)
					character_prevent_kneecapping("#FOLLOWER1#", true)
					character_ragdoll_stop("#FOLLOWER3#") 
					character_ragdoll_stop("#FOLLOWER2#") 
					character_ragdoll_stop("#FOLLOWER1#") 
					character_set_never_catch_fire("#FOLLOWER1#", true)
					character_set_never_catch_fire("#FOLLOWER2#", true)
					character_set_never_catch_fire("#FOLLOWER3#", true)
					character_set_damage_multiplier("#FOLLOWER1#", 0.00)
					character_set_damage_multiplier("#FOLLOWER2#", 0.00)
					character_set_damage_multiplier("#FOLLOWER3#", 0.00)
					character_set_never_fall("#FOLLOWER1#", true)
					character_set_never_fall("#FOLLOWER2#", true)
					character_set_never_fall("#FOLLOWER3#", true)
					character_allow_ragdoll("#FOLLOWER1#", false)
					character_allow_ragdoll("#FOLLOWER2#", false)
					character_allow_ragdoll("#FOLLOWER3#", false)
					character_prevent_bumping("#FOLLOWER1#", true)
					character_prevent_bumping("#FOLLOWER2#", true)
					character_prevent_bumping("#FOLLOWER3#", true)
			character_set_counter_on_grabbed( "#FOLLOWER1#" , true )
			character_set_counter_on_grabbed( "#FOLLOWER2#" , true )
			character_set_counter_on_grabbed( "#FOLLOWER3#" , true )
	                                human_set_invulnerable_to_telekinesis("#FOLLOWER3#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER3#", true)
	                                human_set_invulnerable_to_telekinesis("#FOLLOWER1#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER1#", true)
	                                human_set_invulnerable_to_telekinesis("#FOLLOWER2#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER2#", true)
					character_set_immune_to_explosion_vomit("#FOLLOWER1#", true)
					character_set_immune_to_explosion_vomit("#FOLLOWER2#", true)
					character_set_immune_to_explosion_vomit("#FOLLOWER3#", true)
					character_set_no_explosive_panic("#FOLLOWER1#", true)
					character_set_no_explosive_panic("#FOLLOWER2#", true)
					character_set_no_explosive_panic("#FOLLOWER3#", true)
					turn_invulnerable(FOLLOWER1)
					turn_invulnerable(FOLLOWER2)
					turn_invulnerable(FOLLOWER3)
	                                character_prevent_flinching("#FOLLOWER1#", true)
	                                character_prevent_flinching("#FOLLOWER2#", true)
	                                character_prevent_flinching("#FOLLOWER3#", true)
					sandbox_message(" Followers are now very tougher")
				elseif GOD_MODE_FOLLOWERS == 2 then
					heaven_audio()
					character_prevent_explosion_fling("#FOLLOWER1#", true)
					character_prevent_explosion_fling("#FOLLOWER2#", true)
					character_prevent_explosion_fling("#FOLLOWER3#", true)
					character_prevent_kneecapping("#FOLLOWER3#", false)
					character_prevent_kneecapping("#FOLLOWER2#", false)
					character_prevent_kneecapping("#FOLLOWER1#", false)
	                                human_set_invulnerable_to_telekinesis("#FOLLOWER3#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER3#", true)
	                                human_set_invulnerable_to_telekinesis("#FOLLOWER1#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER1#", true)
	                                human_set_invulnerable_to_telekinesis("#FOLLOWER2#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER2#", true)
					character_set_never_catch_fire("#FOLLOWER1#", true)
					character_set_never_catch_fire("#FOLLOWER2#", true)
					character_set_never_catch_fire("#FOLLOWER3#", true)
					character_set_damage_multiplier("#FOLLOWER1#", 0.00)
					character_set_damage_multiplier("#FOLLOWER2#", 0.00)
					character_set_damage_multiplier("#FOLLOWER3#", 0.00)
					character_set_never_fall("#FOLLOWER1#", false)
					character_set_never_fall("#FOLLOWER2#", false)
					character_set_never_fall("#FOLLOWER3#", false)
					character_allow_ragdoll("#FOLLOWER1#", false)
					character_allow_ragdoll("#FOLLOWER2#", false)
					character_allow_ragdoll("#FOLLOWER3#", false)
					character_prevent_bumping("#FOLLOWER1#", true)
					character_prevent_bumping("#FOLLOWER2#", true)
					character_prevent_bumping("#FOLLOWER3#", true)
					character_set_immune_to_explosion_vomit("#FOLLOWER1#", true)
					character_set_immune_to_explosion_vomit("#FOLLOWER2#", true)
					character_set_immune_to_explosion_vomit("#FOLLOWER3#", true)
					character_set_no_explosive_panic("#FOLLOWER1#", false)
					character_set_no_explosive_panic("#FOLLOWER2#", false)
					character_set_no_explosive_panic("#FOLLOWER3#", false)
					turn_invulnerable("#FOLLOWER1#")
					turn_invulnerable("#FOLLOWER2#")
					turn_invulnerable("#FOLLOWER3#")
	                                character_prevent_flinching("#FOLLOWER1#", false)
	                                character_prevent_flinching("#FOLLOWER2#", false)
	                                character_prevent_flinching("#FOLLOWER3#", false)
					sandbox_message(" Followers are now tougher")
				elseif GOD_MODE_FOLLOWERS == 3 then
					heaven_audio()
					character_prevent_explosion_fling("#FOLLOWER1#", true)
					character_prevent_explosion_fling("#FOLLOWER2#", true)
					character_prevent_explosion_fling("#FOLLOWER3#", true)
					character_set_never_catch_fire("#FOLLOWER1#", true)
					character_set_never_catch_fire("#FOLLOWER2#", true)
					character_set_never_catch_fire("#FOLLOWER3#", true)
					character_set_damage_multiplier("#FOLLOWER1#", 0.00)
					character_set_damage_multiplier("#FOLLOWER2#", 0.00)
					character_set_damage_multiplier("#FOLLOWER3#", 0.00)
					character_set_never_fall("#FOLLOWER1#", false)
					character_set_never_fall("#FOLLOWER2#", false)
					character_set_never_fall("#FOLLOWER3#", false)
					character_allow_ragdoll("#FOLLOWER1#", false)
					character_allow_ragdoll("#FOLLOWER2#", false)
					character_allow_ragdoll("#FOLLOWER3#", false)
					character_prevent_bumping("#FOLLOWER1#", true)
					character_prevent_bumping("#FOLLOWER2#", true)
					character_prevent_bumping("#FOLLOWER3#", true)
					character_set_immune_to_explosion_vomit("#FOLLOWER1#", false)
					character_set_immune_to_explosion_vomit("#FOLLOWER2#", false)
					character_set_immune_to_explosion_vomit("#FOLLOWER3#", false)
					character_set_no_explosive_panic("#FOLLOWER1#", false)
					character_set_no_explosive_panic("#FOLLOWER2#", false)
					character_set_no_explosive_panic("#FOLLOWER3#", false)
					turn_invulnerable(FOLLOWER1)
					turn_invulnerable(FOLLOWER2)
					turn_invulnerable(FOLLOWER3)
	                                character_prevent_flinching("#FOLLOWER1#", false)
	                                character_prevent_flinching("#FOLLOWER2#", false)
	                                character_prevent_flinching("#FOLLOWER3#", false)
	                                human_set_invulnerable_to_telekinesis("#FOLLOWER3#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER3#", true)
	                                human_set_invulnerable_to_telekinesis("#FOLLOWER1#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER1#", true)
	                                human_set_invulnerable_to_telekinesis("#FOLLOWER2#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER2#", true)
					sandbox_message(" Followers are now tough")
				elseif GOD_MODE_FOLLOWERS == 4 then
					heaven_audio()
					character_prevent_explosion_fling("#FOLLOWER1#", false)
					character_prevent_explosion_fling("#FOLLOWER2#", false)
					character_prevent_explosion_fling("#FOLLOWER3#", false)
					character_set_never_catch_fire("#FOLLOWER1#", false)
					character_set_never_catch_fire("#FOLLOWER2#", false)
					character_set_never_catch_fire("#FOLLOWER3#", false)
					character_set_damage_multiplier("#FOLLOWER1#", 0.00)
					character_set_damage_multiplier("#FOLLOWER2#", 0.00)
					character_set_damage_multiplier("#FOLLOWER3#", 0.00)
					character_set_never_fall("#FOLLOWER1#", false)
					character_set_never_fall("#FOLLOWER2#", false)
					character_set_never_fall("#FOLLOWER3#", false)
					character_allow_ragdoll("#FOLLOWER1#", false)
					character_allow_ragdoll("#FOLLOWER2#", false)
					character_allow_ragdoll("#FOLLOWER3#", false)
					character_prevent_bumping("#FOLLOWER1#", true)
					character_prevent_bumping("#FOLLOWER2#", true)
					character_prevent_bumping("#FOLLOWER3#", true)
					character_set_immune_to_explosion_vomit("#FOLLOWER1#", false)
					character_set_immune_to_explosion_vomit("#FOLLOWER2#", false)
					character_set_immune_to_explosion_vomit("#FOLLOWER3#", false)
					character_set_no_explosive_panic("#FOLLOWER1#", false)
					character_set_no_explosive_panic("#FOLLOWER2#", false)
					character_set_no_explosive_panic("#FOLLOWER3#", false)
					turn_invulnerable(FOLLOWER1)
					turn_invulnerable(FOLLOWER2)
					turn_invulnerable(FOLLOWER3)
	                                character_prevent_flinching("#FOLLOWER1#", false)
	                                character_prevent_flinching("#FOLLOWER2#", false)
	                                character_prevent_flinching("#FOLLOWER3#", false)
	                                human_set_invulnerable_to_telekinesis("#FOLLOWER3#", false)
					human_set_invulnerable_to_freeze("#FOLLOWER3#", true)
	                                human_set_invulnerable_to_telekinesis("#FOLLOWER1#", false)
					human_set_invulnerable_to_freeze("#FOLLOWER1#", true)
	                                human_set_invulnerable_to_telekinesis("#FOLLOWER2#", false)
					human_set_invulnerable_to_freeze("#FOLLOWER2#", true)
					sandbox_message(" Followers are less tough")
				elseif GOD_MODE_FOLLOWERS == 5 then
					heaven_audio()
					character_prevent_explosion_fling("#FOLLOWER1#", false)
					character_prevent_explosion_fling("#FOLLOWER2#", false)
					character_prevent_explosion_fling("#FOLLOWER3#", false)
					character_set_never_catch_fire("#FOLLOWER1#", false)
					character_set_never_catch_fire("#FOLLOWER2#", false)
					character_set_never_catch_fire("#FOLLOWER3#", false)
					character_set_damage_multiplier("#FOLLOWER1#", 1.00)
					character_set_damage_multiplier("#FOLLOWER2#", 1.00)
					character_set_damage_multiplier("#FOLLOWER3#", 1.00)
					character_set_never_fall("#FOLLOWER1#", false)
					character_set_never_fall("#FOLLOWER2#", false)
					character_set_never_fall("#FOLLOWER3#", false)
					character_allow_ragdoll("#FOLLOWER1#", true)
					character_allow_ragdoll("#FOLLOWER2#", true)
					character_allow_ragdoll("#FOLLOWER3#", true)
					character_prevent_bumping("#FOLLOWER1#", false)
					character_prevent_bumping("#FOLLOWER2#", false)
					character_prevent_bumping("#FOLLOWER3#", false)
					character_set_immune_to_explosion_vomit("#FOLLOWER1#", false)
					character_set_immune_to_explosion_vomit("#FOLLOWER2#", false)
					character_set_immune_to_explosion_vomit("#FOLLOWER3#", false)
					character_set_no_explosive_panic("#FOLLOWER1#", false)
					character_set_no_explosive_panic("#FOLLOWER2#", false)
					character_set_no_explosive_panic("#FOLLOWER3#", false)
					turn_vulnerable(FOLLOWER1)
					turn_vulnerable(FOLLOWER2)
					turn_vulnerable(FOLLOWER3)
	                                character_prevent_flinching("#FOLLOWER1#", false)
	                                character_prevent_flinching("#FOLLOWER2#", false)
	                                character_prevent_flinching("#FOLLOWER3#", false)
	                                human_set_invulnerable_to_telekinesis("#FOLLOWER3#", false)
					human_set_invulnerable_to_freeze("#FOLLOWER3#", false)
	                                human_set_invulnerable_to_telekinesis("#FOLLOWER1#", false)
					human_set_invulnerable_to_freeze("#FOLLOWER1#", false)
	                                human_set_invulnerable_to_telekinesis("#FOLLOWER2#", false)
					human_set_invulnerable_to_freeze("#FOLLOWER2#", false)
					sandbox_message(" Followers are restored back to normal")
				end
				if GOD_MODE_FOLLOWERS == 5 then
					GOD_MODE_FOLLOWERS = 1
				else
					GOD_MODE_FOLLOWERS = GOD_MODE_FOLLOWERS + 1
				end
				FOUR_PUSHED = true
			end

		elseif player_action_is_pressed("CBA_GAC_WEAPON_SELECT_5") then -- 5 - CUTSCENES, UTILITIES
			if player_action_is_pressed(B_INSERT) and not FIVE_PUSHED then
			--
				local myride = get_char_vehicle_name(LOCAL_PLAYER)
				local driver = vehicle_get_driver(myride)
				if (passenger_activated == 0) then
					--if (1) passenger mode is disabled and (2) you're on foot... enable passenger mode.
					set_unjackable_flag( myride, false ) -- Useful when you're entering the same car for the second time and keybind is tapped inside a vehicle.
					vehicle_set_crazy(myride, false)
					vehicle_suppress_npc_exit(myride, false)
					player_force_vehicle_seat(LOCAL_PLAYER, 1) -- Force the player take passenger seat.
					sandbox_message("Passenger mode ENABLED (1).\nFind a vehicle, enter it and wait for your followers. Then tap this keybind again.")
					set_ignore_ai_flag("#FOLLOWER1#", true)
					vehicle_suppress_npc_exit(myride, false)
					character_set_never_catch_fire("#FOLLOWER1#", true)
					character_set_damage_multiplier("#FOLLOWER1#", 0.00)
					set_dont_attack_me_on_sight_flag("#FOLLOWER1#", true)
					passenger_activated = 1 -- Prepare your car for riding as a passenger in a proper mode. Your current one is very buggy.
					-- IMPROVEMENT IDEA NO 1: maybe make the function automatically enter "drive calmly" mode after all followers are in?
					-- And clear "no npc exit", "vehicle crazy" mode automatically?
				elseif (passenger_activated == 1) and character_is_in_vehicle(LOCAL_PLAYER) and (driver == "#FOLLOWER#") then
					--if (1) passenger mode is enabled and (2) you're in a car and (3)you're driver is your follower ... activate riding as a passenger.
					ai_force_team_idle("None")		-- Helps in a runaways.
					set_unjackable_flag( myride, false )	-- I decided to turn it on.
					vehicle_set_crazy(myride, false)	-- It *should* help a bit, but no guaranty on that!
					vehicle_suppress_npc_exit(myride, true)	-- Prevents player and his followers from forced exiting the vehicle
					set_ignore_ai_flag("#FOLLOWER2#", false) -- Make followers careless about enemies attacks and drive calmly
					set_ignore_ai_flag("#FOLLOWER3#", false)
					set_ignore_ai_flag("#FOLLOWER1#", true)
					vehicle_set_crazy(myride, true) 	-- We have to be in a rush! Driver doesn't obey to traffic law.
					vehicle_max_speed(myride, 200.0) 	-- Caps the top-speed of car. Prevents windshield cannons and going so fast so you can't aim at anything.
					sandbox_message("SMOOTH RIDE mode.")
					passenger_activated = 2 		-- Next time player taps passenger mode combination he's gonna activate "drive aggresively" mode.
				elseif (passenger_activated ~= 0) and character_is_in_vehicle(LOCAL_PLAYER) and (driver == LOCAL_PLAYER) then
					-- if (1) passenger mode is enabled (2) you're in a car and (3) you're a driver.... don't let it execute the instruction below ;)
					sandbox_message("Exit the vehicle, enter it again and wait for your followers. Tap this keybind again to begin riding as a passenger!")
				elseif (passenger_activated ~= 0) and character_is_in_vehicle(LOCAL_PLAYER) and (driver ~= "#FOLLOWER#") and (driver ~= LOCAL_PLAYER) then
					--if (1) passenger mode is enabled and (2) you're in a car and (3) you DON'T have a follower as a driver and (4) you're not a driver ... force followers to appear in player's car.
					-- This piece of code is used for situation when - for whatever reason - your driver (or some of your followers) didn't find their ways
					-- to player's vehicle. It might be because they decided to take another car or are just too far away for you to wait.
					vehicle_suppress_npc_exit(myride, false) 		--Temporary lock. Maybe it's useless, maybe it's not.
					set_player_can_enter_exit_vehicles(LOCAL_PLAYER, false)	-- Locking players ability to get out of the car. This is just temporary.
					vehicle_exit_teleport(driver) 				-- Two things to describe here. As I still don't get the difference between "#FOLLOWER#" and "#FOLLOWER1#" 
					vehicle_exit_teleport("#FOLLOWER#")			-- and this function is kinda crucial for the whole passenger-thing, I decided to make it as as safe as it gets.
					vehicle_exit_teleport("#FOLLOWER1#") 			-- Second: it's purpose is to make followers exit any car they're currently in and rearrange their appearance 
					vehicle_exit_teleport("#FOLLOWER2#") 			-- in player's car. It takes a tic to do that and I think it works very well! We're forcing evey one of
					vehicle_exit_teleport("#FOLLOWER3#") 			-- them - even those still sitting in your car as they should - to prevent seat-blocking.
					--delay(1.0)						-- You may want to enable that line to see if homies really exit their cars before appearing in player's one. Useful for hunting down "#FOLLOWER#" stuff!
					vehicle_enter_teleport("#FOLLOWER#", myride,0) 		-- Here we're forcing - already on-foot - followers to enter player's car.
					vehicle_enter_teleport("#FOLLOWER2#", myride,2)		-- Also: #FOLLOWER# works fine so MAYBE there's no need for "#FOLLOWER1#?
					vehicle_enter_teleport("#FOLLOWER3#", myride,3)
					set_player_can_enter_exit_vehicles(LOCAL_PLAYER, true)	-- If player could exit the car before teleporting homies, function might flopped!
					vehicle_suppress_npc_exit(myride, true)			-- Force the followers to stay in car.
					passenger_activated = 1 				-- Again we're in that weird mode where followers drive the car for you but it's a mode that isn't fun even for a bit.
												-- IMPROVEMENT IDEA NO 1 for the second time!
					sandbox_message("Followers teleported to your car. Tap this keybind again to begin riding as a passenger!")					
				elseif (passenger_activated ~= 0) and not character_is_in_vehicle(LOCAL_PLAYER) then
					--if (1) passenger mode is enabled and (2) player is in foot then... quit the passenger mode and become a driver again!
					set_ignore_ai_flag("#FOLLOWER2#", false) 		-- If player want to leave the passenger mode during "drive calmly" phase,
					set_ignore_ai_flag("#FOLLOWER3#", false) 		-- we have to give them back their original behavior.
					set_ignore_ai_flag("#FOLLOWER1#", false)
					set_ignore_ai_flag("#FOLLOWER#", false)			-- Once again: difference between "#FOLLOWER1#" and "#FOLLOWER#" is a big mystery for me. Sometimes it works, sometime don't.
					player_force_vehicle_seat(LOCAL_PLAYER, 0)		-- Make the player to take the driver's seat.
					vehicle_exit_teleport(driver) 				-- Another longer description. As you might remember, we made the car "unexitable" (via vehicle_suppress_npc_exit()).
					vehicle_exit_teleport("#FOLLOWER#") 			-- If those lines over here didn't exists, player who quits passenger mode wouldn't have his followers back
					vehicle_exit_teleport("#FOLLOWER1#") 			-- because it's impossible to clear "unexitable" flag while on-foot: we can only adress a function to a named
					vehicle_exit_teleport("#FOLLOWER2#") 			-- vehicle - it means player's current - and there's nothing like "#PLAYERS_LAST_CAR#. So here we're
					vehicle_exit_teleport("#FOLLOWER3#") 			-- forcing followers to leave via teleporting them. Unexitable flag will be activated when player enters the car again as a passenger.
					passenger_activated = 0
					sandbox_message("Passenger mode DISABLED.\nIf something is wrong with your followers AI - press this keybind again. If that doesn't help, dismiss and recruit followers again.")
				elseif (passenger_activated == 2) and character_is_in_vehicle(LOCAL_PLAYER) then
					passenger_activated = 1
					vehicle_set_crazy(myride, false)			-- It *should* help a bit, but no guaranty on that!
					set_ignore_ai_flag("#FOLLOWER2#", false) 		-- Make the followers use their "gang deffensive" AI again. Now they will return fire, pull over
					set_ignore_ai_flag("#FOLLOWER3#", false) 		-- attacking enemies but - since "vehicle_surpress_npc_exit()" is still on - they won't leave
					set_ignore_ai_flag("#FOLLOWER1#", false) 		-- the player's car. Drive-by, baby.
					vehicle_set_crazy(myride,true)				-- It *should* help a bit, but no guaranty on that!
					sandbox_message("DRIVE-BY mode.")
				else 
					sandbox_message("You're not in a car, you don't have a driver yet, or something else went wrong.") -- Player shouldn't see this message too often.
				end
				FIVE_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not FIVE_PUSHED then
			--
				local myride = get_char_vehicle_name(LOCAL_PLAYER)
				local driver = vehicle_get_driver(myride)
				if (passenger_activated == 0) then
					--if (1) passenger mode is disabled and (2) you're on foot... enable passenger mode.
					set_unjackable_flag( myride, false ) -- Useful when you're entering the same car for the second time and keybind is tapped inside a vehicle.
					vehicle_set_crazy(myride, false)
					vehicle_suppress_npc_exit(myride, false)
					player_force_vehicle_seat(LOCAL_PLAYER, 3) -- Force the player take passenger seat.
					sandbox_message("Passenger mode ENABLED (2).\nFind a vehicle, enter it and wait for your followers. Then tap this keybind again.")
					vehicle_suppress_npc_exit(myride, false)
					set_ignore_ai_flag("#FOLLOWER1#", true)
					character_set_never_catch_fire("#FOLLOWER1#", true)
					character_set_damage_multiplier("#FOLLOWER1#", 0.00)
					set_dont_attack_me_on_sight_flag("#FOLLOWER1#", true)
					passenger_activated = 1 -- Prepare your car for riding as a passenger in a proper mode. Your current one is very buggy.
					-- IMPROVEMENT IDEA NO 1: maybe make the function automatically enter "drive calmly" mode after all followers are in?
					-- And clear "no npc exit", "vehicle crazy" mode automatically?
				elseif (passenger_activated == 1) and character_is_in_vehicle(LOCAL_PLAYER) and (driver == "#FOLLOWER#") then
					--if (1) passenger mode is enabled and (2) you're in a car and (3)you're driver is your follower ... activate riding as a passenger.
					ai_force_team_idle("None")		-- Helps in a runaways.
					set_unjackable_flag( myride, false )	-- I decided to turn it on.
					vehicle_set_crazy(myride, false)	-- It *should* help a bit, but no guaranty on that!
					vehicle_suppress_npc_exit(myride, true)	-- Prevents player and his followers from forced exiting the vehicle
					set_ignore_ai_flag("#FOLLOWER2#", false)	-- Make followers careless about enemies attacks and drive calmly
					set_ignore_ai_flag("#FOLLOWER3#", false)
					set_ignore_ai_flag("#FOLLOWER1#", true)
					vehicle_set_crazy(myride, true) 	-- We have to be in a rush! Driver doesn't obey to traffic law.
					vehicle_max_speed(myride, 500.0) 	-- Caps the top-speed of car. Prevents windshield cannons and going so fast so you can't aim at anything.
					sandbox_message("SMOOTH RIDE mode.")
					passenger_activated = 2 		-- Next time player taps passenger mode combination he's gonna activate "drive aggresively" mode.
				elseif (passenger_activated ~= 0) and character_is_in_vehicle(LOCAL_PLAYER) and (driver == LOCAL_PLAYER) then
					-- if (1) passenger mode is enabled (2) you're in a car and (3) you're a driver.... don't let it execute the instruction below ;)
					sandbox_message("Exit the vehicle, enter it again and wait for your followers. Tap this keybind again to begin riding as a passenger!")
				elseif (passenger_activated ~= 0) and character_is_in_vehicle(LOCAL_PLAYER) and (driver ~= "#FOLLOWER#") and (driver ~= LOCAL_PLAYER) then
					--if (1) passenger mode is enabled and (2) you're in a car and (3) you DON'T have a follower as a driver and (4) you're not a driver ... force followers to appear in player's car.
					-- This piece of code is used for situation when - for whatever reason - your driver (or some of your followers) didn't find their ways
					-- to player's vehicle. It might be because they decided to take another car or are just too far away for you to wait.
					vehicle_suppress_npc_exit(myride, false) 		--Temporary lock. Maybe it's useless, maybe it's not.
					set_player_can_enter_exit_vehicles(LOCAL_PLAYER, false)	-- Locking players ability to get out of the car. This is just temporary.
					vehicle_exit_teleport(driver) 				-- Two things to describe here. As I still don't get the difference between "#FOLLOWER#" and "#FOLLOWER1#" 
					vehicle_exit_teleport("#FOLLOWER#")			-- and this function is kinda crucial for the whole passenger-thing, I decided to make it as as safe as it gets.
					vehicle_exit_teleport("#FOLLOWER1#") 			-- Second: it's purpose is to make followers exit any car they're currently in and rearrange their appearance 
					vehicle_exit_teleport("#FOLLOWER2#") 			-- in player's car. It takes a tic to do that and I think it works very well! We're forcing evey one of
					vehicle_exit_teleport("#FOLLOWER3#") 			-- them - even those still sitting in your car as they should - to prevent seat-blocking.
					--delay(1.0)						-- You may want to enable that line to see if homies really exit their cars before appearing in player's one. Useful for hunting down "#FOLLOWER#" stuff!
					vehicle_enter_teleport("#FOLLOWER#", myride,0) 		-- Here we're forcing - already on-foot - followers to enter player's car.
					vehicle_enter_teleport("#FOLLOWER2#", myride,2)		-- Also: #FOLLOWER# works fine so MAYBE there's no need for "#FOLLOWER1#?
					vehicle_enter_teleport("#FOLLOWER3#", myride,1)
					set_player_can_enter_exit_vehicles(LOCAL_PLAYER, true)	-- If player could exit the car before teleporting homies, function might flopped!
					vehicle_suppress_npc_exit(myride, true)			-- Force the followers to stay in car.
					passenger_activated = 1 				-- Again we're in that weird mode where followers drive the car for you but it's a mode that isn't fun even for a bit.
												-- IMPROVEMENT IDEA NO 1 for the second time!
					sandbox_message("Followers teleported to your car. Tap this keybind again to begin riding as a passenger!")					
				elseif (passenger_activated ~= 0) and not character_is_in_vehicle(LOCAL_PLAYER) then
					--if (1) passenger mode is enabled and (2) player is in foot then... quit the passenger mode and become a driver again!
					set_ignore_ai_flag("#FOLLOWER2#", false) 		-- If player want to leave the passenger mode during "drive calmly" phase,
					set_ignore_ai_flag("#FOLLOWER3#", false) 		-- we have to give them back their original behavior.
					set_ignore_ai_flag("#FOLLOWER1#", false)
					set_ignore_ai_flag("#FOLLOWER#", false)			-- Once again: difference between "#FOLLOWER1#" and "#FOLLOWER#" is a big mystery for me. Sometimes it works, sometime don't.
					player_force_vehicle_seat(LOCAL_PLAYER, 0)		-- Make the player to take the driver's seat.
					vehicle_exit_teleport(driver) 				-- Another longer description. As you might remember, we made the car "unexitable" (via vehicle_suppress_npc_exit()).
					vehicle_exit_teleport("#FOLLOWER#") 			-- If those lines over here didn't exists, player who quits passenger mode wouldn't have his followers back
					vehicle_exit_teleport("#FOLLOWER1#") 			-- because it's impossible to clear "unexitable" flag while on-foot: we can only adress a function to a named
					vehicle_exit_teleport("#FOLLOWER2#") 			-- vehicle - it means player's current - and there's nothing like "#PLAYERS_LAST_CAR#. So here we're
					vehicle_exit_teleport("#FOLLOWER3#") 			-- forcing followers to leave via teleporting them. Unexitable flag will be activated when player enters the car again as a passenger.
					passenger_activated = 0
					sandbox_message("Passenger mode DISABLED.\nIf something is wrong with your followers AI - press this keybind again. If that doesn't help, dismiss and recruit followers again.")
				elseif (passenger_activated == 2) and character_is_in_vehicle(LOCAL_PLAYER) then
					passenger_activated = 1
					vehicle_set_crazy(myride, false)			-- It *should* help a bit, but no guaranty on that!
					set_ignore_ai_flag("#FOLLOWER2#", false) 		-- Make the followers use their "gang deffensive" AI again. Now they will return fire, pull over
					set_ignore_ai_flag("#FOLLOWER3#", false) 		-- attacking enemies but - since "vehicle_surpress_npc_exit()" is still on - they won't leave
					set_ignore_ai_flag("#FOLLOWER1#", false) 		-- the player's car. Drive-by, baby.
					vehicle_set_crazy(myride,true)				-- It *should* help a bit, but no guaranty on that!
					sandbox_message("DRIVE-BY mode.")
				else 
					sandbox_message("You're not in a car, you don't have a driver yet, or something else went wrong.") -- Player shouldn't see this message too often.
				end
				FIVE_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not FIVE_PUSHED then
			--
				local myride = get_char_vehicle_name(LOCAL_PLAYER)
				local driver = vehicle_get_driver(myride)
				if (passenger_activated == 0) then
					--if (1) passenger mode is disabled and (2) you're on foot... enable passenger mode.
					set_unjackable_flag( myride, false ) -- Useful when you're entering the same car for the second time and keybind is tapped inside a vehicle.
					vehicle_set_crazy(myride, false)
					vehicle_suppress_npc_exit(myride, false)
					player_force_vehicle_seat(LOCAL_PLAYER, 2) -- Force the player take passenger seat.
					sandbox_message("Passenger mode ENABLED (3).\nFind a vehicle, enter it and wait for your followers. Then tap this keybind again.")
					passenger_activated = 1 -- Prepare your car for riding as a passenger in a proper mode. Your current one is very buggy.
					vehicle_suppress_npc_exit(myride, false)
					set_ignore_ai_flag("#FOLLOWER1#", true)
					character_set_never_catch_fire("#FOLLOWER1#", true)
					character_set_damage_multiplier("#FOLLOWER1#", 0.00)
					set_dont_attack_me_on_sight_flag("#FOLLOWER1#", true)
					-- IMPROVEMENT IDEA NO 1: maybe make the function automatically enter "drive calmly" mode after all followers are in?
					-- And clear "no npc exit", "vehicle crazy" mode automatically?
				elseif (passenger_activated == 1) and character_is_in_vehicle(LOCAL_PLAYER) and (driver == "#FOLLOWER#") then
					--if (1) passenger mode is enabled and (2) you're in a car and (3)you're driver is your follower ... activate riding as a passenger.
					ai_force_team_idle("None")		-- Helps in a runaways.
					set_unjackable_flag( myride, false )	-- I decided to turn it on.
					vehicle_set_crazy(myride, false)	-- It *should* help a bit, but no guaranty on that!
					vehicle_suppress_npc_exit(myride, true)	-- Prevents player and his followers from forced exiting the vehicle
					set_ignore_ai_flag("#FOLLOWER2#", false)	-- Make followers careless about enemies attacks and drive calmly
					set_ignore_ai_flag("#FOLLOWER3#", false)
					set_ignore_ai_flag("#FOLLOWER1#", true)
					vehicle_set_crazy(myride, true) 	-- We have to be in a rush! Driver doesn't obey to traffic law.
					vehicle_max_speed(myride, 300.0) 	-- Caps the top-speed of car. Prevents windshield cannons and going so fast so you can't aim at anything.
					sandbox_message("SMOOTH RIDE mode.")
					passenger_activated = 2 		-- Next time player taps passenger mode combination he's gonna activate "drive aggresively" mode.
				elseif (passenger_activated ~= 0) and character_is_in_vehicle(LOCAL_PLAYER) and (driver == LOCAL_PLAYER) then
					-- if (1) passenger mode is enabled (2) you're in a car and (3) you're a driver.... don't let it execute the instruction below ;)
					sandbox_message("Exit the vehicle, enter it again and wait for your followers. Tap this keybind again to begin riding as a passenger!")
				elseif (passenger_activated ~= 0) and character_is_in_vehicle(LOCAL_PLAYER) and (driver ~= "#FOLLOWER#") and (driver ~= LOCAL_PLAYER) then
					--if (1) passenger mode is enabled and (2) you're in a car and (3) you DON'T have a follower as a driver and (4) you're not a driver ... force followers to appear in player's car.
					-- This piece of code is used for situation when - for whatever reason - your driver (or some of your followers) didn't find their ways
					-- to player's vehicle. It might be because they decided to take another car or are just too far away for you to wait.
					vehicle_suppress_npc_exit(myride, false) 		--Temporary lock. Maybe it's useless, maybe it's not.
					set_player_can_enter_exit_vehicles(LOCAL_PLAYER, false)	-- Locking players ability to get out of the car. This is just temporary.
					vehicle_exit_teleport(driver) 				-- Two things to describe here. As I still don't get the difference between "#FOLLOWER#" and "#FOLLOWER1#" 
					vehicle_exit_teleport("#FOLLOWER#")			-- and this function is kinda crucial for the whole passenger-thing, I decided to make it as as safe as it gets.
					vehicle_exit_teleport("#FOLLOWER1#") 			-- Second: it's purpose is to make followers exit any car they're currently in and rearrange their appearance 
					vehicle_exit_teleport("#FOLLOWER2#") 			-- in player's car. It takes a tic to do that and I think it works very well! We're forcing evey one of
					vehicle_exit_teleport("#FOLLOWER3#") 			-- them - even those still sitting in your car as they should - to prevent seat-blocking.
					--delay(1.0)						-- You may want to enable that line to see if homies really exit their cars before appearing in player's one. Useful for hunting down "#FOLLOWER#" stuff!
					vehicle_enter_teleport("#FOLLOWER#", myride,0) 		-- Here we're forcing - already on-foot - followers to enter player's car.
					vehicle_enter_teleport("#FOLLOWER2#", myride,1)		-- Also: #FOLLOWER# works fine so MAYBE there's no need for "#FOLLOWER1#?
					vehicle_enter_teleport("#FOLLOWER3#", myride,3)
					set_player_can_enter_exit_vehicles(LOCAL_PLAYER, true)	-- If player could exit the car before teleporting homies, function might flopped!
					vehicle_suppress_npc_exit(myride, true)			-- Force the followers to stay in car.
					passenger_activated = 1 				-- Again we're in that weird mode where followers drive the car for you but it's a mode that isn't fun even for a bit.
												-- IMPROVEMENT IDEA NO 1 for the second time!
					sandbox_message("Followers teleported to your car. Tap this keybind again to begin riding as a passenger!")					
				elseif (passenger_activated ~= 0) and not character_is_in_vehicle(LOCAL_PLAYER) then
					--if (1) passenger mode is enabled and (2) player is in foot then... quit the passenger mode and become a driver again!
					set_ignore_ai_flag("#FOLLOWER2#", false) 		-- If player want to leave the passenger mode during "drive calmly" phase,
					set_ignore_ai_flag("#FOLLOWER3#", false) 		-- we have to give them back their original behavior.
					set_ignore_ai_flag("#FOLLOWER1#", false)
					set_ignore_ai_flag("#FOLLOWER#", false)			-- Once again: difference between "#FOLLOWER1#" and "#FOLLOWER#" is a big mystery for me. Sometimes it works, sometime don't.
					player_force_vehicle_seat(LOCAL_PLAYER, 0)		-- Make the player to take the driver's seat.
					vehicle_exit_teleport(driver) 				-- Another longer description. As you might remember, we made the car "unexitable" (via vehicle_suppress_npc_exit()).
					vehicle_exit_teleport("#FOLLOWER#") 			-- If those lines over here didn't exists, player who quits passenger mode wouldn't have his followers back
					vehicle_exit_teleport("#FOLLOWER1#") 			-- because it's impossible to clear "unexitable" flag while on-foot: we can only adress a function to a named
					vehicle_exit_teleport("#FOLLOWER2#") 			-- vehicle - it means player's current - and there's nothing like "#PLAYERS_LAST_CAR#. So here we're
					vehicle_exit_teleport("#FOLLOWER3#") 			-- forcing followers to leave via teleporting them. Unexitable flag will be activated when player enters the car again as a passenger.
					passenger_activated = 0
					sandbox_message("Passenger mode DISABLED.\nIf something is wrong with your followers AI - press this keybind again. If that doesn't help, dismiss and recruit followers again.")
				elseif (passenger_activated == 2) and character_is_in_vehicle(LOCAL_PLAYER) then
					passenger_activated = 1
					vehicle_set_crazy(myride, false)			-- It *should* help a bit, but no guaranty on that!
					set_ignore_ai_flag("#FOLLOWER2#", false) 		-- Make the followers use their "gang deffensive" AI again. Now they will return fire, pull over
					set_ignore_ai_flag("#FOLLOWER3#", false) 		-- attacking enemies but - since "vehicle_surpress_npc_exit()" is still on - they won't leave
					set_ignore_ai_flag("#FOLLOWER1#", false) 		-- the player's car. Drive-by, baby.
					vehicle_set_crazy(myride,true)				-- It *should* help a bit, but no guaranty on that!
					sandbox_message("DRIVE-BY mode.")
				else 
					sandbox_message("You're not in a car, you don't have a driver yet, or something else went wrong.") -- Player shouldn't see this message too often.
				end
				FIVE_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not FIVE_PUSHED then
			--
				if not DRUNK_ANIMS then
					player_movement_enable(LOCAL_PLAYER)
					player_actions_enable(LOCAL_PLAYER)
					clear_animation_state(LOCAL_PLAYER) 
					player_controls_enable(LOCAL_PLAYER)
	                                party_set_dismissable(true)
					set_civilians_glitching(false)
					set_civilians_flee(false, false)
					set_player_can_enter_exit_vehicles(LOCAL_PLAYER, true)
					sandbox_message(" Player Controls Enabled and Civilians Fleeing")
				else
					player_movement_enable(LOCAL_PLAYER)
					player_actions_enable(LOCAL_PLAYER)
					clear_animation_state(LOCAL_PLAYER)
					player_controls_enable(LOCAL_PLAYER)
					set_civilians_glitching(false)
					set_civilians_flee(true, true)
					set_player_can_enter_exit_vehicles(LOCAL_PLAYER, true)
					sandbox_message(" Player Controls Enabled and Civilians Stop Fleeing")
				end
				FIVE_PUSHED = true
			elseif player_action_is_pressed(B_END) and not FIVE_PUSHED then
				if FOLLOWERS_PSYCHO then
				--
					ai_set_personality("#FOLLOWER1#", "Gang offensive")
					ai_set_personality("#FOLLOWER2#", "Gang offensive")
					ai_set_personality("#FOLLOWER3#", "Gang offensive")
					turn_invulnerable(FOLLOWER1)
					turn_invulnerable(FOLLOWER2)
					turn_invulnerable(FOLLOWER3)
					set_attack_peds_flag("#FOLLOWER1#", ATTACK_NOW_NEVER_LOSE, true)
					set_attack_peds_flag("#FOLLOWER2#", ATTACK_NOW_NEVER_LOSE, true)
					set_attack_peds_flag("#FOLLOWER3#", ATTACK_NOW_NEVER_LOSE, true)
					set_attack_enemies_flag("#FOLLOWER3#", ATTACK_NOW_NEVER_LOSE, true)
					set_attack_enemies_flag("#FOLLOWER2#", ATTACK_NOW_NEVER_LOSE, true)
					set_attack_enemies_flag("#FOLLOWER1#", ATTACK_NOW_NEVER_LOSE, true)
					ai_add_enemy_target("#FOLLOWER1#", LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true, true)
					ai_add_enemy_target("#FOLLOWER2#", LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true, true)
					ai_add_enemy_target("#FOLLOWER3#", LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true, true)
					set_behavior_set( "#FOLLOWER3#", "Super Saint" ) 
					set_behavior_set( "#FOLLOWER2#", "Super Saint" ) 
					set_behavior_set( "#FOLLOWER1#", "Super Saint" ) 
									set_always_sees_player_flag( "#FOLLOWER3#", true )
				set_always_sees_player_flag( "#FOLLOWER2#", true )
				set_always_sees_player_flag( "#FOLLOWER1#", true )
					human_set_invulnerable_to_freeze("#FOLLOWER3#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER1#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER2#", true)
					set_attack_enemies_flag("#FOLLOWER#", true)
					character_set_damage_multiplier("#FOLLOWER1#", 0.00)
					character_set_damage_multiplier("#FOLLOWER2#", 0.00)
					character_set_damage_multiplier("#FOLLOWER3#", 0.00)




					sandbox_message("Followers are ready for a combat against people")
				else

					ai_set_personality("#FOLLOWER1#", "Gang defensive")
					ai_set_personality("#FOLLOWER2#", "Gang defensive")
					ai_set_personality("#FOLLOWER3#", "Gang defensive")
					ai_clear_priority_target("#FOLLOWER1#")
					ai_clear_priority_target("#FOLLOWER2#")
					ai_clear_priority_target("#FOLLOWER3#")
					ai_force_team_idle("None")
					sandbox_message("Follower is restored back to normal")

				end
				FOLLOWERS_PSYCHO = not FOLLOWERS_PSYCHO
				FIVE_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not FIVE_PUSHED then
			--  target bink
				if FOLLOWER_TEAM == 1 then
		                        set_team("#FOLLOWER2#", "Police")
		                        set_team("#FOLLOWER1#", "Police")
		                        set_team("#FOLLOWER3#", "Police")
					sandbox_message("Followers are teamed police")
				elseif FOLLOWER_TEAM == 2 then
		                        set_team("#FOLLOWER2#", "Luchadores")
		                        set_team("#FOLLOWER1#", "Luchadores")
		                        set_team("#FOLLOWER3#", "Luchadores")
					sandbox_message("Followers are teamed luchadores")
				elseif FOLLOWER_TEAM == 3 then
		                        set_team("#FOLLOWER2#", "Deckers")
		                        set_team("#FOLLOWER1#", "Deckers")
		                        set_team("#FOLLOWER3#", "Deckers")
					sandbox_message("Followers are teamed deckers")
				elseif FOLLOWER_TEAM == 4 then
		                        set_team("#FOLLOWER2#", "Morningstar")
		                        set_team("#FOLLOWER1#", "Morningstar")
		                        set_team("#FOLLOWER3#", "Morningstar")
					sandbox_message("Followers are teamed morningstar")
				elseif FOLLOWER_TEAM == 5 then
		                        set_team("#FOLLOWER2#", "Stag")
		                        set_team("#FOLLOWER1#", "Stag")
		                        set_team("#FOLLOWER3#", "Stag")
					sandbox_message("Followers are teamed stag")
				elseif FOLLOWER_TEAM == 6 then
		                        set_team("#FOLLOWER2#", "Neutral Gang")
		                        set_team("#FOLLOWER1#", "Neutral Gang")
		                        set_team("#FOLLOWER3#", "Neutral Gang")
					sandbox_message("Followers are teamed neutral gang")
				elseif FOLLOWER_TEAM == 7 then
		                        set_team("#FOLLOWER2#", "Civilian")
		                        set_team("#FOLLOWER1#", "Civilian")
		                        set_team("#FOLLOWER3#", "Civilian")
					sandbox_message("Followers are teamed civilian")
				elseif FOLLOWER_TEAM == 8 then
		                        set_team("#FOLLOWER2#", "Playas")
		                        set_team("#FOLLOWER1#", "Playas")
		                        set_team("#FOLLOWER3#", "Playas")
					sandbox_message("Followers are teamed saints")
			
				end
				if FOLLOWER_TEAM == 8 then
					FOLLOWER_TEAM = 1
				else
					FOLLOWER_TEAM = FOLLOWER_TEAM + 1
				end
				FIVE_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not FIVE_PUSHED then
				if not GENDER then
				set_animation_set(LOCAL_PLAYER, "PLYM")
				set_animation_set(REMOTE_PLAYER, "PLYM")
					sandbox_message("Player Male")
				else
				set_animation_set(LOCAL_PLAYER, "PLYF")
				set_animation_set(REMOTE_PLAYER, "PLYF")
					sandbox_message("Player Female")
				end
				GENDER = not GENDER
				FIVE_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not FIVE_PUSHED then
			-- 
				if TRAFFIC_DENSITY == 1 then
					set_traffic_density(0.1)
					sandbox_message(" set_traffic_density 0.1")
				elseif TRAFFIC_DENSITY == 2 then
					character_force_real_world_health_regen(LOCAL_PLAYER, true)
					set_traffic_density(0.2)
					set_civilians_glitching(false)
					sandbox_message(" set_traffic_density 0.2")
				elseif TRAFFIC_DENSITY == 3 then
					set_traffic_density(1)
					set_civilians_glitching(true)
					sandbox_message(" set_traffic_density 1")
				elseif TRAFFIC_DENSITY == 4 then
					set_traffic_density(2)
					set_civilians_glitching(false)
					sandbox_message(" set_traffic_density 2")
				elseif TRAFFIC_DENSITY == 5 then
					set_traffic_density(5)
					character_force_real_world_health_regen(LOCAL_PLAYER, false)
					sandbox_message(" set_traffic_density 5")
			
				end
				if TRAFFIC_DENSITY == 5 then
					TRAFFIC_DENSITY = 1
				else
					TRAFFIC_DENSITY = TRAFFIC_DENSITY + 1
				end		
				FIVE_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not FIVE_PUSHED then
			-- target 
				if TEAM_FIRE == 1 then
					character_set_never_catch_fire("#FOLLOWER1#", true)
					character_set_never_catch_fire("#FOLLOWER2#", true)
					character_set_never_catch_fire("#FOLLOWER3#", true)
					sandbox_message("Followers are fireproof")
				elseif TEAM_FIRE == 2 then
					character_set_never_catch_fire("#FOLLOWER1#", false)
					character_set_never_catch_fire("#FOLLOWER2#", false)
					character_set_never_catch_fire("#FOLLOWER3#", false)
					sandbox_message("Followers are not fireproof")
					end
				if TEAM_FIRE < 2 then
					TEAM_FIRE = TEAM_FIRE + 1
				else
					TEAM_FIRE = 1
				end
				FIVE_PUSHED = true
			elseif player_action_is_pressed(B_UP) and not FIVE_PUSHED then
				-- TOGGLE SANDBOX+ MESSAGES AND SOUND EFFECTS
				if character_is_in_vehicle(LOCAL_PLAYER) then
					if not VEHICLE_INVULNERABLE then
						heaven_audio()
						sandbox_message("Player vehicle is now invulnerable")
						vehicle_set_invulnerable( get_char_vehicle_name(LOCAL_PLAYER) )
                                                vehicle_set_prevent_freeze( get_char_vehicle_name(LOCAL_PLAYER, true) )
						vehicle_prevent_explosion_fling( get_char_vehicle_name(LOCAL_PLAYER, true) )
						vehicle_disable_fire_from_vehicle( get_char_vehicle_name(LOCAL_PLAYER, true) )
						vehicle_set_bulletproof_glass( get_char_vehicle_name(LOCAL_PLAYER, true) )
						vehicle_set_prevent_supersprint_push( get_char_vehicle_name(LOCAL_PLAYER, true) )
						if character_is_in_vehicle(REMOTE_PLAYER) then
							if COOP_COMMANDS and coop_is_active() then
								vehicle_set_invulnerable( get_char_vehicle_name(REMOTE_PLAYER) )
                                                		vehicle_set_prevent_freeze( get_char_vehicle_name(REMOTE_PLAYER, true) )
								vehicle_prevent_explosion_fling( get_char_vehicle_name(REMOTE_PLAYER, true) )
								vehicle_disable_fire_from_vehicle( get_char_vehicle_name(REMOTE_PLAYER, true) )
								vehicle_set_bulletproof_glass( get_char_vehicle_name(REMOTE_PLAYER, true) )
								vehicle_set_prevent_supersprint_push( get_char_vehicle_name(REMOTE_PLAYER, true) )
							end
						end
					else
						sandbox_message("Player vehicle is now vulnerable")
						vehicle_set_vulnerable( get_char_vehicle_name(LOCAL_PLAYER) )
                                                vehicle_set_prevent_freeze( get_char_vehicle_name(LOCAL_PLAYER, false) )
						vehicle_prevent_explosion_fling( get_char_vehicle_name(LOCAL_PLAYER, false) )
						vehicle_disable_fire_from_vehicle( get_char_vehicle_name(LOCAL_PLAYER, false) )
						vehicle_set_bulletproof_glass( get_char_vehicle_name(LOCAL_PLAYER, false) )
						vehicle_set_prevent_supersprint_push( get_char_vehicle_name(LOCAL_PLAYER, false) )
						if character_is_in_vehicle(REMOTE_PLAYER) then
							if COOP_COMMANDS and coop_is_active() then
								vehicle_set_vulnerable( get_char_vehicle_name(REMOTE_PLAYER) )
                                                		vehicle_set_prevent_freeze( get_char_vehicle_name(REMOTE_PLAYER, false) )
								vehicle_prevent_explosion_fling( get_char_vehicle_name(REMOTE_PLAYER, false) )
								vehicle_disable_fire_from_vehicle( get_char_vehicle_name(REMOTE_PLAYER, false) )
								vehicle_set_bulletproof_glass( get_char_vehicle_name(REMOTE_PLAYER, false) )
								vehicle_set_prevent_supersprint_push( get_char_vehicle_name(REMOTE_PLAYER, false) )
							end
						end
					end
					VEHICLE_INVULNERABLE = not VEHICLE_INVULNERABLE
				else
					--mgs_alert_audio()
					sandbox_message("Toggle vehicle invulnerability FAILED")
				end
				delay(0.75)
			elseif player_action_is_pressed(B_LBRACKET) and not FIVE_PUSHED then
				-- TOGGLE HUD
				if HUD_NORMAL then
					Openworld_hud_state.hide_everything = hud_display_create_state()
					hud_display_set_element(Openworld_hud_state.hide_everything, HUD_ALL_ELEM, HUD_FADE_HIDDEN)
					hud_display_commit_state(Openworld_hud_state.hide_everything)
				else
					for i, hud_state in pairs(Openworld_hud_state) do
						if (hud_state ~= -1) then
							hud_display_remove_state(hud_state)
							hud_state = -1
						end
					end
					sandbox_message(" HUD restored")
				end
				HUD_NORMAL = not HUD_NORMAL
				delay(0.75)
			elseif player_action_is_pressed(B_RBRACKET) and not FIVE_PUSHED then
				-- SHOW PLAYER POSITION (XYZ)
				local posx,posz,posy = get_object_pos(LOCAL_PLAYER)
				sandbox_message(" Player Pos:".."\n".."X: "..posx .."\n".."Y: "..posy.."\n".."Z: "..posz.."\n")
				FIVE_PUSHED = true
			end

		elseif player_action_is_pressed("CBA_GAC_WEAPON_SELECT_6") then -- 6 - SPECIAL COMMANDS
			if player_action_is_pressed(B_INSERT) and not SIX_PUSHED then
				-- RESET KINZIE'S WAREHOUSE HOTSPOT  --Player undercover
				if UNDERCOVER_TEAM == 1 then
				set_player_undercover_team(LOCAL_PLAYER, "Morningstar")
					sandbox_message("Player is undercover team with morningstar")
				elseif UNDERCOVER_TEAM == 2 then
				set_player_undercover_team(LOCAL_PLAYER, "Luchadores")
					sandbox_message("Player is undercover team with luchadores")
				elseif UNDERCOVER_TEAM == 3 then
				set_player_undercover_team(LOCAL_PLAYER, "Deckers")
					sandbox_message("Player is undercover team with deckers")
				elseif UNDERCOVER_TEAM == 4 then
				set_player_undercover_team(LOCAL_PLAYER, "Police")
					sandbox_message("Player is undercover team with police")
				elseif UNDERCOVER_TEAM == 5 then
				set_player_undercover_team(LOCAL_PLAYER, "Stag")
					sandbox_message("Player is undercover team with stag")
				elseif UNDERCOVER_TEAM == 6 then
				set_player_undercover_team(LOCAL_PLAYER, "Neutral Gang")
					sandbox_message("Player is undercover team with neutral gang")
				elseif UNDERCOVER_TEAM == 7 then
				set_player_undercover_team(LOCAL_PLAYER, "Playas")
					sandbox_message("Player is undercover team with saints")
				elseif UNDERCOVER_TEAM == 8 then
				set_player_undercover_team(LOCAL_PLAYER, "Civilian")
					sandbox_message("Player is undercover team with civilian")
				elseif UNDERCOVER_TEAM == 9 then
				set_player_undercover_team(LOCAL_PLAYER, "None")
					sandbox_message("Player is back to normal with your current team")
			
				end
				if UNDERCOVER_TEAM == 9 then
					UNDERCOVER_TEAM = 1
				else
					UNDERCOVER_TEAM = UNDERCOVER_TEAM + 1
				end	
				SIX_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not SIX_PUSHED then
				-- RESET STEELPORT ARENA HOTSPOT
				if FOLLOWERS_INVULNERABLE then
						        set_team("#FOLLOWER2#", "Civilian")
		                        set_team("#FOLLOWER1#", "Civilian")
		                        set_team("#FOLLOWER3#", "Civilian")
								set_civilians_invulnerable(true)
								delay(0.10)
								ding_finish_audio()
								set_team("#FOLLOWER2#", "Neutral Gang")
		                        set_team("#FOLLOWER1#", "Morningstar")
		                        set_team("#FOLLOWER3#", "Luchadores")
					human_set_invulnerable_to_freeze("#FOLLOWER3#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER1#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER2#", true)
								delay(0.10)
					set_civilians_invulnerable(false)

					sandbox_message("Your followers are invulnerable (Mixed Team A, Neutral Gang, Morningstar and Luchadores)")
				else
						        set_team("#FOLLOWER2#", "Civilian")
		                        set_team("#FOLLOWER1#", "Civilian")
		                        set_team("#FOLLOWER3#", "Civilian")
								set_civilians_invulnerable(true)
								delay(0.10)
								ding_finish_audio()
								set_team("#FOLLOWER2#", "Police")
		                        set_team("#FOLLOWER1#", "Stag")
		                        set_team("#FOLLOWER3#", "playas")
					human_set_invulnerable_to_freeze("#FOLLOWER3#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER1#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER2#", true)
								delay(0.10)
					set_civilians_invulnerable(false)

					sandbox_message("Your followers are invulnerable (Mixed Team B, Police, Stag and Saints)")

				end
				FOLLOWERS_INVULNERABLE = not FOLLOWERS_INVULNERABLE
				SIX_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not SIX_PUSHED then
				-- RESET ANGEL'S GYM HOTSPOT
				if FOLLOWERS_INVULNERABLE then
	set_never_turn_on_player("#FOLLOWER2#", true)
	set_never_turn_on_player("#FOLLOWER1#", true)
	set_never_turn_on_player("#FOLLOWER3#", true)
					sandbox_message("Followers will nolonger turn on the player")
				else
	set_never_turn_on_player("#FOLLOWER2#", false)
	set_never_turn_on_player("#FOLLOWER1#", false)
	set_never_turn_on_player("#FOLLOWER3#", false)
					sandbox_message("Followers will now turn on the player")

				end
				FOLLOWERS_INVULNERABLE = not FOLLOWERS_INVULNERABLE
				SIX_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not SIX_PUSHED then
						if mission_is_active() then
				if MISSION_WEAPONS2 == 1 then --M02
																					delay(0.20)
					inv_item_add("baseball_bat",10, M18_group.alley_vp.roddy,true)
								inv_item_add("baseball_bat",10, M18_group.alley_vp.julius,true)
										inv_item_add("baseball_bat",10, M18_group.alley_vp.roddy,true)
															inv_item_add("baseball_bat",10, M18_group.alley_vp.julius,true)
     				sandbox_message("Roddy and Keith are armed with baseball bat.") 
				elseif MISSION_WEAPONS2 == 2 then
												inv_item_remove_all(M18_group.alley_vp.roddy)
																inv_item_remove_all(M18_group.alley_vp.julius)
																					delay(0.20)
					inv_item_add("light_sword",10, M18_group.alley_vp.roddy,true)
										inv_item_add("light_sword",10, M18_group.alley_vp.julius,true)
					sandbox_message("Roddy and Keith are armed with light sword.") 
				elseif MISSION_WEAPONS2 == 3 then
												inv_item_remove_all(M18_group.alley_vp.roddy)
																inv_item_remove_all(M18_group.alley_vp.julius)
																					delay(0.20)
				inv_item_remove_all(M18_group.alley_vp.roddy)
										inv_item_add("Pistol-Gang",10, M18_group.alley_vp.julius,true)
					sandbox_message("Keith armed with pistol.") 
				elseif MISSION_WEAPONS2 == 4 then
												inv_item_remove_all(M18_group.alley_vp.roddy)
																inv_item_remove_all(M18_group.alley_vp.julius)
																					delay(0.20)

										inv_item_add("Shotgun-Gang",10, M18_group.alley_vp.julius,true)
					sandbox_message("Keith armed with Shotgun.") 
				elseif MISSION_WEAPONS2 == 5 then
												inv_item_remove_all(M18_group.alley_vp.roddy)
																inv_item_remove_all(M18_group.alley_vp.julius)
																					delay(0.20)
					inv_item_add("baseball bat",10, M18_group.alley_vp.roddy,true)
										inv_item_add("Rifle-Gang",10, M18_group.alley_vp.julius,true)
					sandbox_message("Keith armed with rifle.") 
				elseif MISSION_WEAPONS2 == 6 then
								inv_item_remove_all(M18_group.alley_vp.roddy)
												inv_item_remove_all(M18_group.alley_vp.julius)
																					delay(0.20)
					inv_item_add("light_sword",10, M18_group.alley_vp.roddy,true)
										inv_item_add("Special-SniperRifle",10, M18_group.alley_vp.julius,true)
					sandbox_message("Keith armed with sniper")
				elseif MISSION_WEAPONS2 == 7 then
								inv_item_remove_all(M18_group.alley_vp.roddy)
																					delay(0.20)
					sandbox_message("Keith is still armed with sniper and Roddy fights with barefist")
				elseif MISSION_WEAPONS2 == 8 then
								inv_item_remove_all(M18_group.alley_vp.roddy)
																					delay(0.20)
													inv_item_add("baseball_bat",10, M18_group.alley_vp.roddy,true)
					sandbox_message("Keith is still armed with sniper and Roddy fights with his baseball bat")
				elseif MISSION_WEAPONS2 == 9 then
					sandbox_message("Roddy and Keith fight with bare fists.")
					inv_item_remove_all(M18_group.alley_vp.roddy)
									inv_item_remove_all(M18_group.alley_vp.julius)

				end
				if MISSION_WEAPONS2 == 9 then
					MISSION_WEAPONS2 = 1
				else
					MISSION_WEAPONS2 = MISSION_WEAPONS2 + 1
				end
											else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				SIX_PUSHED = true
			elseif player_action_is_pressed(B_END) and not SIX_PUSHED then
				-- RESET DECKERS' TOWER HOTSPOT
				-- RESET ANGEL'S GYM HOTSPOT
														if mission_is_active() then
				if FOLLOWERS_PSYCHO then
				--M06
		party_add(M18_group.alley_vp.roddy, LOCAL_PLAYER)
				party_add(M18_group.alley_vp.julius, LOCAL_PLAYER)
																follower_set_can_abandon( M18_group.alley_vp.roddy, false )
																follower_set_can_abandon( M18_group.alley_vp.julius, false )
					sandbox_message("Roddy and Keith are added to your party")
				else
																				follower_set_can_abandon( M18_group.alley_vp.roddy, false )
																				follower_set_can_abandon( M18_group.alley_vp.julius, false )
		on_dismiss( "", M18_group.alley_vp.roddy )
	party_dismiss( M18_group.alley_vp.roddy )
			on_dismiss( "", M18_group.alley_vp.julius )
	party_dismiss( M18_group.alley_vp.julius )
					sandbox_message("Roddy and Keith are dismissed from your party")									
									
				end
							else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				FOLLOWERS_PSYCHO = not FOLLOWERS_PSYCHO
				SIX_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not SIX_PUSHED then
				-- RESET SAFEWORD HOTSPOT
				if DRUNK_COUNTER == 0 then
					sandbox_message("Ped Density 1")
					set_ped_override_density(1) 
				elseif DRUNK_COUNTER == 1 then
					sandbox_message("Player is ped density 2")
					set_ped_override_density(2) 
				elseif DRUNK_COUNTER == 2 then
					sandbox_message("Player is ped density 3")
					set_ped_override_density(3) 
				elseif DRUNK_COUNTER == 3 then
					sandbox_message("Player is ped density 5")
					set_ped_override_density(5) 
				elseif DRUNK_COUNTER == 4 then
					sandbox_message("Player is ped density 10")
					set_ped_override_density(10) 


				end
				if DRUNK_COUNTER == 4 then
					DRUNK_COUNTER = 0
				else
					DRUNK_COUNTER = DRUNK_COUNTER + 1
				end
				SIX_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not SIX_PUSHED then
				-- RESET ALL ZONES TO DEFAULT
				reset_all_zones()
				ding_finish_audio()
				sandbox_message(" All zones reset to default")
				SIX_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not SIX_PUSHED then
				-- TOGGLE THREE COUNT STATE
				if not INSIDE_THREECOUNT and not mission_is_active("mol_mm_01") and not mission_is_active("dlc1_m01") then
					ding_finish_audio()
					if THREECOUNT_SAINTS_ALT then
						THREECOUNT_SAINTS = false
						city_zone_swap("dlc1_3c", false)
						sandbox_message(" Three Count state changed to Luchadores casino")
					else
						THREECOUNT_SAINTS = true
						city_zone_swap("dlc1_3c", true)
						sandbox_message(" Three Count state changed to Saints crib")
					end
					THREECOUNT_SAINTS_ALT = not THREECOUNT_SAINTS_ALT
					delay(0.75)
				else
					alert_message(" You cannot use this command inside Three Count interior!")
					SIX_PUSHED = true
				end
			elseif player_action_is_pressed(B_DOWN) and not SIX_PUSHED then
				-- TOGGLE RESTRICTED ZONES
				ding_finish_audio()
				if RESTRICTED_ZONES then
					notoriety_restricted_zones_enable(false)
					sandbox_message(" Restricted zones disabled")
				else
					notoriety_restricted_zones_enable(true)
					sandbox_message(" Restricted zones enabled")
				end
				RESTRICTED_ZONES = not RESTRICTED_ZONES
				delay(0.75)
			elseif player_action_is_pressed(B_UP) and not SIX_PUSHED then
				-- SWITCH NOTORIETY CYCLE MODE
				NOTORIETY_ZIN = 1
				notoriety_reset("police")
				if LOCK_NOTORIETY then
					golden_cid_enable(true)
					sandbox_message(" From now on notoriety cycle won't lock notoriety (except notoriety zero)")
				else
					sandbox_message(" From now on notoriety cycle will lock notoriety")
				end
				LOCK_NOTORIETY = not LOCK_NOTORIETY
				delay(0.75)
			elseif player_action_is_pressed(B_LBRACKET) and not SIX_PUSHED then
				-- TOGGLE CO-OP COMMANDS
				if mission_is_active() then
				if PLAYA_DANCE_COUNTER_B == 1 then
				--
									set_team(M18_group.alley_vp.roddy, "Playas")
											set_team(M18_group.alley_vp.julius, "Playas")
									sandbox_message(" Roddy and Keith teams on Saints")
				elseif PLAYA_DANCE_COUNTER_B == 2 then
									set_team(M18_group.alley_vp.roddy, "STAG")
											set_team(M18_group.alley_vp.julius, "STAG")
									sandbox_message(" Roddy and Keith teams on STAG")
				elseif PLAYA_DANCE_COUNTER_B == 3 then
									set_team(M18_group.alley_vp.roddy, "Luchadores")
										set_team(M18_group.alley_vp.julius, "Luchadores")
									sandbox_message(" Roddy and Keith teams on Luchadores")
				elseif PLAYA_DANCE_COUNTER_B == 4 then
									set_team(M18_group.alley_vp.roddy, "Morningstar")
											set_team(M18_group.alley_vp.julius, "Morningstar")
									sandbox_message(" Roddy and Keith teams on Morningstar")
				elseif PLAYA_DANCE_COUNTER_B == 5 then
									set_team(M18_group.alley_vp.roddy, "Neutral Gang")
											set_team(M18_group.alley_vp.julius, "Neutral Gang")
									sandbox_message(" Roddy and Keith teams on Neutral Gang")
				elseif PLAYA_DANCE_COUNTER_B == 6 then
									set_team(M18_group.alley_vp.roddy, "Police")
											set_team(M18_group.alley_vp.julius, "Police")
									sandbox_message(" Roddy and Keith teams on Police")
				elseif PLAYA_DANCE_COUNTER_B == 7 then
									set_team(M18_group.alley_vp.roddy, "Deckers")
												set_team(M18_group.alley_vp.julius, "Morningstar")
									sandbox_message(" Roddy and Keith teams on Deckers")
				elseif PLAYA_DANCE_COUNTER_B == 8 then
									set_team(M18_group.alley_vp.roddy, "Civilian")
																set_team(M18_group.alley_vp.julius, "Civilian")
									sandbox_message(" Roddy and Keith teams on Civilian")

				end
				if PLAYA_DANCE_COUNTER_B == 8 then
					PLAYA_DANCE_COUNTER_B = 1
				else
					PLAYA_DANCE_COUNTER_B = PLAYA_DANCE_COUNTER_B + 1
				end	
							else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				delay(0.75)
			elseif player_action_is_pressed(B_RBRACKET) and not SIX_PUSHED then
				-- TOGGLE TUTORIAL POPUPS
								if mission_is_active() then
						vehicle_enter_teleport(M18_group.alley_vp.roddy, get_char_vehicle_name(LOCAL_PLAYER), 1) 
										vehicle_enter_teleport(M18_group.alley_vp.julius, get_char_vehicle_name(LOCAL_PLAYER), 2) 
						sandbox_message("Roddy and Keith are teleported to your vehicle")
									else
					alert_message("Your not in the current mission right now because your just free-roaming right now")				
			end
				delay(0.75)
			end

		elseif player_action_is_pressed("CBA_GAC_WEAPON_SELECT_7") then -- 7 - SPECIAL COMMANDS
			if player_action_is_pressed(B_INSERT) and not SEVEN_PUSHED then
				-- ACTIVATE TERMINAL Z-01 MENU
				if FOLLOWERS_PSYCHO then
					ai_set_personality("#FOLLOWER1#", "Gang offensive")
					ai_set_personality("#FOLLOWER2#", "Gang offensive")
					ai_set_personality("#FOLLOWER3#", "Gang offensive")
					character_set_damage_multiplier(LOCAL_PLAYER, 0.00)
					set_attack_enemies_flag(LOCAL_PLAYER, true)
					set_attack_peds_flag(LOCAL_PLAYER, true)




					sandbox_message("Now, the player should no longer dies in the DANGER ZONER during missions and no timer kills the player!")
				else
					set_attack_enemies_flag(LOCAL_PLAYER, false)
					set_attack_peds_flag(LOCAL_PLAYER, false)
					character_set_damage_multiplier(LOCAL_PLAYER, 1.00)
					sandbox_message("Oh, yeah your damage should be restored by now, sorry but be careful!")

				end
				FOLLOWERS_PSYCHO = not FOLLOWERS_PSYCHO
				SEVEN_PUSHED = true
			elseif player_action_is_pressed(B_HOME) and not SEVEN_PUSHED then
				-- ACTIVATE TEXT ADVENTURE FROM MILLER-SPACE
				if PED == 1 then
					customization_swap_player_rig( "cf_body.rig", "pedf" )
					sandbox_message(" Player is a Pedestrian Female")
				elseif PED == 2 then
					customization_swap_player_rig( "cm_body.rig", "pedm" )
					sandbox_message(" Player is a Pedestrian Male")
				elseif PED == 3 then
					customization_restore_player_rig()
					sandbox_message(" Player is restored")
				end
				if PED == 3 then
					PED = 1
				else
					PED = PED + 1
				end
				SEVEN_PUSHED = true
			elseif player_action_is_pressed(B_PGUP) and not SEVEN_PUSHED then
				-- ACTIVATE IMAGINED AS EDGES MENU
				hud_push_screen("store_common", SYNC_LOCAL)
				hud_push_screen("store_character", SYNC_LOCAL)
				if COOP_COMMANDS and coop_is_active() then
					hud_push_screen("store_common", SYNC_REMOTE)
					hud_push_screen("store_character", SYNC_REMOTE)
				end
				SEVEN_PUSHED = true
			elseif player_action_is_pressed(B_DELETE) and not SEVEN_PUSHED then
				-- ACTIVATE LET'S PRETEND MENU
				hud_push_screen("store_common", SYNC_LOCAL)
				hud_push_screen("store_clothing", SYNC_LOCAL)
				if COOP_COMMANDS and coop_is_active() then
					hud_push_screen("store_common", SYNC_REMOTE)
					hud_push_screen("store_clothing", SYNC_REMOTE)
				end
				SEVEN_PUSHED = true
			elseif player_action_is_pressed(B_END) and not SEVEN_PUSHED then
				-- ACTIVATE GATEWAY MENU
				hud_push_screen("store_common", SYNC_LOCAL)
				hud_push_screen("store_crib", SYNC_LOCAL)
				if COOP_COMMANDS and coop_is_active() then
					hud_push_screen("store_common", SYNC_REMOTE)
					hud_push_screen("store_crib", SYNC_REMOTE)
				end
				SEVEN_PUSHED = true
			elseif player_action_is_pressed(B_PGDWN) and not SEVEN_PUSHED then
				-- ACTIVATE RUSTY'S NEEDLE MENU
				hud_push_screen("store_common", SYNC_LOCAL)
				hud_push_screen("store_tattoo", SYNC_LOCAL)
				if COOP_COMMANDS and coop_is_active() then
					hud_push_screen("store_common", SYNC_REMOTE)
					hud_push_screen("store_tattoo", SYNC_REMOTE)
				end
				SEVEN_PUSHED = true
			elseif player_action_is_pressed(B_RIGHT) and not SEVEN_PUSHED then
				-- ACTIVATE VENDOR MENU
				if INSIDE_THREECOUNT then
					-- TELEPORT TO THREE COUNT EXTERIOR
					arrive_threecount_ext()
					local tposx,tposy,tposz = (1200.829 - ctele_Posx), (1342.975 - ctele_Posy), (24.193 - ctele_Posz)
					teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
					if COOP_COMMANDS and coop_is_active() then
						teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
					end
				end
				hud_push_screen("store_vendor", SYNC_LOCAL)
				if COOP_COMMANDS and coop_is_active() then
					hud_push_screen("store_vendor", SYNC_REMOTE)
				end
				SEVEN_PUSHED = true
			elseif player_action_is_pressed(B_LEFT) and not SEVEN_PUSHED then
				-- ACTIVATE FRIENDLY FIRE MENU
				hud_push_screen("store_common", SYNC_LOCAL)
				hud_push_screen("store_weapon", SYNC_LOCAL)
				if COOP_COMMANDS and coop_is_active() then
					hud_push_screen("store_common", SYNC_REMOTE)
					hud_push_screen("store_weapon", SYNC_REMOTE)
				end
				SEVEN_PUSHED = true
			elseif player_action_is_pressed(B_DOWN) and not SEVEN_PUSHED then
				-- TOGGLE ASCII MODE
				if FOLLOWERS_PSYCHO then
					ai_set_personality("#FOLLOWER1#", "Gang offensive")
					ai_set_personality("#FOLLOWER2#", "Gang offensive")
					ai_set_personality("#FOLLOWER3#", "Gang offensive")
					turn_invulnerable(FOLLOWER1)
					turn_invulnerable(FOLLOWER2)
					turn_invulnerable(FOLLOWER3)
					human_set_invulnerable_to_freeze("#FOLLOWER3#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER1#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER2#", true)
	                                health_pickups_enable(false)
					set_behavior_set( "#FOLLOWER3#", "Super Saint" ) 
					set_behavior_set( "#FOLLOWER2#", "Super Saint" ) 
					set_behavior_set( "#FOLLOWER1#", "Super Saint" )
					character_set_always_combat_ready("#FOLLOWER1#", true)
					character_set_always_combat_ready("#FOLLOWER2#", true)
					character_set_always_combat_ready("#FOLLOWER3#", true) 
					set_attack_peds_flag("#FOLLOWER1#", ATTACK_NOW_NEVER_LOSE, true)
					set_attack_peds_flag("#FOLLOWER2#", ATTACK_NOW_NEVER_LOSE, true)
					set_attack_peds_flag("#FOLLOWER3#", ATTACK_NOW_NEVER_LOSE, true)
					set_attack_enemies_flag("#FOLLOWER3#", true)
					set_attack_enemies_flag("#FOLLOWER2#", true)
					set_attack_enemies_flag("#FOLLOWER1#", true)
									set_always_sees_player_flag( "#FOLLOWER3#", true )
				set_always_sees_player_flag( "#FOLLOWER2#", true )
				set_always_sees_player_flag( "#FOLLOWER1#", true )
					ai_add_enemy_target("#FOLLOWER1#", LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true, true)
					ai_add_enemy_target("#FOLLOWER2#", LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true, true)
					ai_add_enemy_target("#FOLLOWER3#", LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true, true)



					sandbox_message("Followers will aggressively kills people and Super Saint with damage")
				else

					ai_set_personality("#FOLLOWER1#", "Gang defensive")
					ai_set_personality("#FOLLOWER2#", "Gang defensive")
					ai_set_personality("#FOLLOWER3#", "Gang defensive")
					ai_clear_priority_target("#FOLLOWER1#")
					ai_clear_priority_target("#FOLLOWER2#")
					ai_clear_priority_target("#FOLLOWER3#")
					character_set_always_combat_ready("#FOLLOWER1#", false)
					character_set_always_combat_ready("#FOLLOWER2#", false)
					character_set_always_combat_ready("#FOLLOWER3#", false)
					ai_force_team_idle("None")
	                                health_pickups_enable(true)
					delay(0.60)
					ding_finish_audio()
					ai_add_enemy_target("#FOLLOWER1#", LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true, true)
					ai_add_enemy_target("#FOLLOWER2#", LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true, true)
					ai_add_enemy_target("#FOLLOWER3#", LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true, true)

					sandbox_message("Follower is restored back to normal, broken")

				end
				FOLLOWERS_PSYCHO = not FOLLOWERS_PSYCHO
				delay(0.75)
			elseif player_action_is_pressed(B_UP) and not SEVEN_PUSHED then
				-- CYCLE RETICLE OVERRIDES
				if PICKUP then
						npc_weapon_pickup_override("#FOLLOWER1#", false)
							npc_weapon_pickup_override("#FOLLOWER2#", false)
								npc_weapon_pickup_override("#FOLLOWER3#", false)
					sandbox_message("Followers will not pickup their weapons")
				else
										npc_weapon_pickup_override("#FOLLOWER1#", true)
							npc_weapon_pickup_override("#FOLLOWER2#", true)
								npc_weapon_pickup_override("#FOLLOWER3#", true)
					sandbox_message("Followers will pickup their weapons")
				end
				PICKUP = not PICKUP
				delay(0.75)
			elseif player_action_is_pressed(B_LBRACKET) and not SEVEN_PUSHED then
				-- GIVE $100,000 CASH
			-- CALLED
				if FOLLOWERS_INVULNERABLE then
						        set_team("#FOLLOWER2#", "Civilian")
		                        set_team("#FOLLOWER1#", "Civilian")
		                        set_team("#FOLLOWER3#", "Civilian")
								set_civilians_invulnerable(true)
								delay(0.10)
								ding_finish_audio()
								set_team("#FOLLOWER2#", "Playas")
		                        set_team("#FOLLOWER1#", "Playas")
		                        set_team("#FOLLOWER3#", "Playas")
					human_set_invulnerable_to_freeze("#FOLLOWER3#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER1#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER2#", true)
								delay(0.10)
					set_civilians_invulnerable(false)

					sandbox_message("Your followers are invulnerable (Saints)")
				else
						        set_team("#FOLLOWER2#", "Civilian")
		                        set_team("#FOLLOWER1#", "Civilian")
		                        set_team("#FOLLOWER3#", "Civilian")
								set_civilians_invulnerable(true)
								delay(0.10)
								ding_finish_audio()
								set_team("#FOLLOWER2#", "Stag")
		                        set_team("#FOLLOWER1#", "Stag")
		                        set_team("#FOLLOWER3#", "Stag")
					human_set_invulnerable_to_freeze("#FOLLOWER3#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER1#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER2#", true)
								delay(0.10)
					set_civilians_invulnerable(false)

					sandbox_message("Your followers are invulnerable (STAG)")

				end
				FOLLOWERS_INVULNERABLE = not FOLLOWERS_INVULNERABLE
				delay(0.75)
			elseif player_action_is_pressed(B_RBRACKET) and not SEVEN_PUSHED then
				-- TOGGLE INSANE FOLLOWERS
				if not FOLLOWERS_INSANE then
					ai_set_personality("#FOLLOWER1#", "Gang offensive")
					ai_set_personality("#FOLLOWER2#", "Gang offensive")
					ai_set_personality("#FOLLOWER3#", "Gang offensive")
					set_attack_peds_flag("#FOLLOWER1#", true)
					set_attack_peds_flag("#FOLLOWER2#", true)
					set_attack_peds_flag("#FOLLOWER3#", true)
					sandbox_message(" Followers will aggressively attack all pedestrians")
				else
					set_attack_peds_flag("#FOLLOWER1#", false)
					set_attack_peds_flag("#FOLLOWER2#", false)
					set_attack_peds_flag("#FOLLOWER3#", false)
					ai_clear_priority_target("#FOLLOWER1#")
					ai_clear_priority_target("#FOLLOWER2#")
					ai_clear_priority_target("#FOLLOWER3#")
					ai_set_personality("#FOLLOWER1#", "Gang defensive")
					ai_set_personality("#FOLLOWER2#", "Gang defensive")
					ai_set_personality("#FOLLOWER3#", "Gang defensive")
					ai_force_team_idle("None")
					sandbox_message(" Follower behavior restored to normal")
				end
				FOLLOWERS_INSANE = not FOLLOWERS_INSANE
				delay(0.75)
			end

		elseif player_action_is_pressed("CBA_GAC_WEAPON_SELECT_8") then -- 8 - SPECIAL COMMANDS
			if player_action_is_pressed(B_INSERT) and not EIGHT_PUSHED then
				-- REPAIR PLAYER VEHICLE
				if not character_is_in_vehicle(LOCAL_PLAYER) and not character_is_in_vehicle(REMOTE_PLAYER) then
					alert_message(" Player is not in a vehicle!")
					EIGHT_PUSHED = true
				end
				if character_is_in_vehicle(LOCAL_PLAYER) then
					vehicle_repair(LOCAL_PLAYER)
					if not character_is_in_vehicle(REMOTE_PLAYER) then
						sandbox_message(" Player vehicle repaired")
					end
				end
				if character_is_in_vehicle(REMOTE_PLAYER) then
					vehicle_repair(REMOTE_PLAYER)
					if not character_is_in_vehicle(LOCAL_PLAYER) then
						sandbox_message(" Co-op client vehicle repaired")
					else
						sandbox_message(" Host and co-op client vehicles repaired")
					end
				end
				delay(0.75)
			elseif player_action_is_pressed(B_HOME) and not EIGHT_PUSHED then
				-- TOGGLE INVULNERABILITY FOR PLAYER VEHICLE 
				if not character_is_in_vehicle(LOCAL_PLAYER) and not character_is_in_vehicle(REMOTE_PLAYER) then
					alert_message(" Player is not in a vehicle!")
					EIGHT_PUSHED = true
				end
				if character_is_in_vehicle(LOCAL_PLAYER) then
					if not VEHICLE_INVULNERABLE then
						vehicle_set_invulnerable(LOCAL_PLAYER)
						if not character_is_in_vehicle(REMOTE_PLAYER) then
							heaven_audio()
							sandbox_message(" Player vehicle is now invulnerable")
						end
					else
						vehicle_set_vulnerable(LOCAL_PLAYER)
						if not character_is_in_vehicle(REMOTE_PLAYER) then
							sandbox_message(" Player vehicle is now vulnerable")
						end
					end
				end
				if character_is_in_vehicle(REMOTE_PLAYER) then
					if not VEHICLE_INVULNERABLE then
						vehicle_set_invulnerable(REMOTE_PLAYER)
						heaven_audio()
						if not character_is_in_vehicle(LOCAL_PLAYER) then
							sandbox_message(" Co-op client vehicle is now invulnerable")
						else
							sandbox_message(" Host and co-op client vehicles are now invulnerable")
						end
					else
						vehicle_set_vulnerable(REMOTE_PLAYER)
						if not character_is_in_vehicle(LOCAL_PLAYER) then
							sandbox_message(" Co-op client vehicle is now vulnerable")
						else
							sandbox_message(" Host and co-op client vehicles are now vulnerable")
						end
					end
				end
				if character_is_in_vehicle(LOCAL_PLAYER) or character_is_in_vehicle(REMOTE_PLAYER) then
					VEHICLE_INVULNERABLE = not VEHICLE_INVULNERABLE
				end
				delay(0.75)
			elseif player_action_is_pressed(B_PGUP) and not EIGHT_PUSHED then
				-- TOGGLE INFINITE MASS FOR PLAYER VEHICLE
				if not character_is_in_vehicle(LOCAL_PLAYER) and not character_is_in_vehicle(REMOTE_PLAYER) then
					alert_message(" Player is not in a vehicle!")
					EIGHT_PUSHED = true
				end
				if character_is_in_vehicle(LOCAL_PLAYER) then
					if not VEHICLE_MASS then
						vehicle_infinite_mass(LOCAL_PLAYER, true)
						if not character_is_in_vehicle(REMOTE_PLAYER) then
							heaven_audio()
							sandbox_message(" Player vehicle now has infinite mass")
						end
					else
						vehicle_infinite_mass(LOCAL_PLAYER, false)
						if not character_is_in_vehicle(REMOTE_PLAYER) then
							sandbox_message(" Player vehicle mass is now normal")
						end
					end
				end
				if character_is_in_vehicle(REMOTE_PLAYER) then
					if not VEHICLE_MASS then
						vehicle_infinite_mass(REMOTE_PLAYER, true)
						heaven_audio()
						if not character_is_in_vehicle(LOCAL_PLAYER) then
							sandbox_message(" Co-op client vehicle now has infinite mass")
						else
							sandbox_message(" Host and co-op client vehicles now have infinite mass")
						end
					else
						vehicle_infinite_mass(REMOTE_PLAYER, false)
						if not character_is_in_vehicle(LOCAL_PLAYER) then
							sandbox_message(" Co-op client vehicle mass is now normal")
						else
							sandbox_message(" Host and co-op client vehicle mass is now normal")
						end
					end
				end
				if character_is_in_vehicle(LOCAL_PLAYER) or character_is_in_vehicle(REMOTE_PLAYER) then
					VEHICLE_MASS = not VEHICLE_MASS
				end
				delay(0.75)
			elseif player_action_is_pressed(B_DELETE) and not EIGHT_PUSHED then
				-- TOGGLE KNEECAPPERS FOR PLAYER VEHICLE
				if not character_is_in_vehicle(LOCAL_PLAYER) and not character_is_in_vehicle(REMOTE_PLAYER) then
					alert_message(" Player is not in a vehicle!")
					EIGHT_PUSHED = true
				end
				if character_is_in_vehicle(LOCAL_PLAYER) then
					ding_finish_audio()
					if not VEHICLE_KNEECAPPERS then
						vehicle_set_kneecappers(LOCAL_PLAYER, true)
						if not character_is_in_vehicle(REMOTE_PLAYER) then
							sandbox_message(" Kneecappers equipped on player vehicle")
						end
					else
						vehicle_set_kneecappers(LOCAL_PLAYER, false)
						if not character_is_in_vehicle(REMOTE_PLAYER) then
							sandbox_message(" Kneecappers unequipped on player vehicle")
						end
					end
				end
				if character_is_in_vehicle(REMOTE_PLAYER) then
					ding_finish_audio()
					if not VEHICLE_KNEECAPPERS then
						vehicle_set_kneecappers(REMOTE_PLAYER, true)
						if not character_is_in_vehicle(LOCAL_PLAYER) then
							sandbox_message(" Kneecappers equipped on co-op client vehicle")
						else
							sandbox_message(" Kneecappers equipped on host and co-op client vehicles")
						end
					else
						vehicle_set_kneecappers(REMOTE_PLAYER, false)
						if not character_is_in_vehicle(LOCAL_PLAYER) then
							sandbox_message(" Kneecappers unequipped on co-op client vehicle")
						else
							sandbox_message(" Kneecappers unequipped on host and co-op client vehicles")
						end
					end
				end
				if character_is_in_vehicle(LOCAL_PLAYER) or character_is_in_vehicle(REMOTE_PLAYER) then
					VEHICLE_KNEECAPPERS = not VEHICLE_KNEECAPPERS
				end
				delay(0.75)
			elseif player_action_is_pressed(B_END) and not EIGHT_PUSHED then
				-- TOGGLE LIGHTS FOR PLAYER VEHICLE
				if not character_is_in_vehicle(LOCAL_PLAYER) and not character_is_in_vehicle(REMOTE_PLAYER) then
					alert_message(" Player is not in a vehicle!")
					EIGHT_PUSHED = true
				end
				if character_is_in_vehicle(LOCAL_PLAYER) then
					if not VEHICLE_LIGHTS then
						vehicle_lights_on(LOCAL_PLAYER)
						if not character_is_in_vehicle(REMOTE_PLAYER) then
							sandbox_message(" Player vehicle lights turned on")
						end
					else
						vehicle_lights_off(LOCAL_PLAYER)
						if not character_is_in_vehicle(REMOTE_PLAYER) then
							sandbox_message(" Player vehicle lights turned off")
						end
					end
				end
				if character_is_in_vehicle(REMOTE_PLAYER) then
					if not VEHICLE_LIGHTS then
						vehicle_lights_on(REMOTE_PLAYER)
						if not character_is_in_vehicle(LOCAL_PLAYER) then
							sandbox_message(" Co-op client vehicle lights turned on")
						else
							sandbox_message(" Host and co-op client vehicle lights turned on")
						end
					else
						vehicle_lights_off(REMOTE_PLAYER)
						if not character_is_in_vehicle(LOCAL_PLAYER) then
							sandbox_message(" Co-op client vehicle lights turned off")
						else
							sandbox_message(" Host and co-op client vehicle lights turned off")
						end
					end
				end
				if character_is_in_vehicle(LOCAL_PLAYER) or character_is_in_vehicle(REMOTE_PLAYER) then
					VEHICLE_LIGHTS = not VEHICLE_LIGHTS
				end
				delay(0.75)
			elseif player_action_is_pressed(B_PGDWN) and not EIGHT_PUSHED then
				-- TOGGLE UNJACKABLE STATUS FOR PLAYER VEHICLE
				if not character_is_in_vehicle(LOCAL_PLAYER) and not character_is_in_vehicle(REMOTE_PLAYER) then
					alert_message(" Player is not in a vehicle!")
					EIGHT_PUSHED = true
				end
				if character_is_in_vehicle(LOCAL_PLAYER) then
					if not VEHICLE_LOCKED then
						set_unjackable_flag(LOCAL_PLAYER, true)
						if not character_is_in_vehicle(REMOTE_PLAYER) then
							sandbox_message(" Player vehicle can no longer be car jacked")
						end
					else
						set_unjackable_flag(LOCAL_PLAYER, false)
						if not character_is_in_vehicle(REMOTE_PLAYER) then
							sandbox_message(" Player vehicle can now be car jacked")
						end
					end
				end
				if character_is_in_vehicle(REMOTE_PLAYER) then
					if not VEHICLE_LOCKED then
						set_unjackable_flag(REMOTE_PLAYER, true)
						if not character_is_in_vehicle(LOCAL_PLAYER) then
							sandbox_message(" Co-op client vehicle can no longer be car jacked")
						else
							sandbox_message(" Host and co-op client vehicles can no longer be car jacked")
						end
					else
						set_unjackable_flag(REMOTE_PLAYER, false)
						if not character_is_in_vehicle(LOCAL_PLAYER) then
							sandbox_message(" Co-op client vehicle can now be car jacked")
						else
							sandbox_message(" Host and co-op client vehicles can now be car jacked")
						end
					end
				end
				if character_is_in_vehicle(LOCAL_PLAYER) or character_is_in_vehicle(REMOTE_PLAYER) then
					VEHICLE_LOCKED = not VEHICLE_LOCKED
				end
				delay(0.75)
			elseif player_action_is_pressed(B_RIGHT) and not EIGHT_PUSHED then
				-- TOGGLE NO-FLIP MODE FOR PLAYER VEHICLE
				if not character_is_in_vehicle(LOCAL_PLAYER) and not character_is_in_vehicle(REMOTE_PLAYER) then
					alert_message(" Player is not in a vehicle!")
					EIGHT_PUSHED = true
				end
				if character_is_in_vehicle(LOCAL_PLAYER) then
					if not VEHICLE_NOFLIP then
						vehicle_suppress_flipping(LOCAL_PLAYER, true)
						if not character_is_in_vehicle(REMOTE_PLAYER) then
							heaven_audio()
							sandbox_message(" Player vehicle can no longer be flipped")
						end
					else
						vehicle_suppress_flipping(LOCAL_PLAYER, false)
						if not character_is_in_vehicle(REMOTE_PLAYER) then
							sandbox_message(" Player vehicle can now be flipped")
						end
					end
				end
				if character_is_in_vehicle(REMOTE_PLAYER) then
					if not VEHICLE_NOFLIP then
						vehicle_suppress_flipping(REMOTE_PLAYER, true)
						heaven_audio()
						if not character_is_in_vehicle(LOCAL_PLAYER) then
							sandbox_message(" Co-op client vehicle can no longer be flipped")
						else
							sandbox_message(" Host and co-op client vehicles can no longer be flipped")
						end
					else
						vehicle_suppress_flipping(REMOTE_PLAYER, false)
						if not character_is_in_vehicle(LOCAL_PLAYER) then
							sandbox_message(" Co-op client vehicle can now be flipped")
						else
							sandbox_message(" Host and co-op client vehicles can now be flipped")
						end
					end
				end
				if character_is_in_vehicle(LOCAL_PLAYER) or character_is_in_vehicle(REMOTE_PLAYER) then
					VEHICLE_NOFLIP = not VEHICLE_NOFLIP
				end
				delay(0.75)
			elseif player_action_is_pressed(B_LEFT) and not EIGHT_PUSHED then
				-- TOGGLE VEHICLES EXPLODING WHEN UPSIDE DOWN (REQUIRES MODDING PATCH!)
				if MODDING_PATCH then
					if not VEHICLE_EXPLODE then
						sandbox_message(" Vehicles will explode when upside down")
					else
						sandbox_message(" Vehicles won't explode when upside down")
					end
					VEHICLE_EXPLODE = not VEHICLE_EXPLODE
					delay(0.75)
				else
					alert_message(" This command requires modding patch, sorry my friend.")
					EIGHT_PUSHED = true
				end
			elseif player_action_is_pressed(B_DOWN) and not EIGHT_PUSHED then
				-- TOGGLE TRAIL BLAZING MODE FOR PLAYER VEHICLE
				if not character_is_in_vehicle(LOCAL_PLAYER) and not character_is_in_vehicle(REMOTE_PLAYER) then
					alert_message(" Player is not in a vehicle!")
					EIGHT_PUSHED = true
				end
				if character_is_in_vehicle(LOCAL_PLAYER) then
					if not VEHICLE_FIRE then
						vehicle_set_smoke_and_fire_state(LOCAL_PLAYER)
						if not character_is_in_vehicle(REMOTE_PLAYER) then
							sandbox_message(" Trail Blazing mode enabled on player vehicle")
						end
					else
						vehicle_repair(LOCAL_PLAYER)
						if not character_is_in_vehicle(REMOTE_PLAYER) then
							sandbox_message(" Trail Blazing mode disabled on player vehicle")
						end
					end
				end
				if character_is_in_vehicle(REMOTE_PLAYER) then
					if not VEHICLE_FIRE then
						vehicle_set_smoke_and_fire_state(REMOTE_PLAYER)
						if not character_is_in_vehicle(LOCAL_PLAYER) then
							sandbox_message(" Trail Blazing mode enabled on co-op client vehicle")
						else
							sandbox_message(" Trail Blazing mode enabled on host and co-op client vehicles")
						end
					else
						vehicle_repair(REMOTE_PLAYER)
						if not character_is_in_vehicle(LOCAL_PLAYER) then
							sandbox_message(" Trail Blazing mode disabled on co-op client vehicle")
						else
							sandbox_message(" Trail Blazing mode disabled on host and co-op client vehicles")
						end
					end
				end
				if character_is_in_vehicle(LOCAL_PLAYER) or character_is_in_vehicle(REMOTE_PLAYER) then
					VEHICLE_FIRE = not VEHICLE_FIRE
				end
				delay(0.75)
			elseif player_action_is_pressed(B_UP) and not EIGHT_PUSHED then
				-- DETONATE PLAYER VEHICLE
				if not character_is_in_vehicle(LOCAL_PLAYER) and not character_is_in_vehicle(REMOTE_PLAYER) then
					alert_message(" Player is not in a vehicle!")
				end
				if character_is_in_vehicle(LOCAL_PLAYER) then
					vehicle_detonate(LOCAL_PLAYER)
					if not character_is_in_vehicle(REMOTE_PLAYER) then
						sandbox_message(" Player vehicle goes BOOM!")
					end
				end
				if character_is_in_vehicle(REMOTE_PLAYER) then
					vehicle_detonate(REMOTE_PLAYER)
					if not character_is_in_vehicle(LOCAL_PLAYER) then
						sandbox_message(" Co-op client vehicle goes BOOM!")
					else
						sandbox_message(" Host and co-op client vehicles go BOOM!")
					end
				end
				EIGHT_PUSHED = true
			elseif player_action_is_pressed(B_LBRACKET) and not EIGHT_PUSHED then
				if FOLLOWERS_PSYCHO then
					ai_set_personality("#FOLLOWER1#", "Gang offensive")
					ai_set_personality("#FOLLOWER2#", "Gang offensive")
					ai_set_personality("#FOLLOWER3#", "Gang offensive")
					turn_invulnerable(FOLLOWER1)
					turn_invulnerable(FOLLOWER2)
					turn_invulnerable(FOLLOWER3)
									set_always_sees_player_flag( "#FOLLOWER3#", true )
				set_always_sees_player_flag( "#FOLLOWER2#", true )
				set_always_sees_player_flag( "#FOLLOWER1#", true )
					human_set_invulnerable_to_freeze("#FOLLOWER3#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER1#", true)
					human_set_invulnerable_to_freeze("#FOLLOWER2#", true)
					character_set_damage_multiplier("#FOLLOWER1#", 0.00)
					character_set_damage_multiplier("#FOLLOWER2#", 0.00)
					character_set_damage_multiplier("#FOLLOWER3#", 0.00)
	                                health_pickups_enable(false)
					ai_add_enemy_target("#FOLLOWER1#", LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true, true)
					ai_add_enemy_target("#FOLLOWER2#", LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true, true)
					ai_add_enemy_target("#FOLLOWER3#", LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true, true)
					set_behavior_set( "#FOLLOWER3#", "Super Jump Only" ) 
					set_behavior_set( "#FOLLOWER2#", "Super Jump Only" ) 
					set_behavior_set( "#FOLLOWER1#", "Super Jump Only" )
					character_set_always_combat_ready("#FOLLOWER1#", true)
					character_set_always_combat_ready("#FOLLOWER2#", true)
					character_set_always_combat_ready("#FOLLOWER3#", true) 
					set_attack_peds_flag("#FOLLOWER1#", ATTACK_NOW_NEVER_LOSE, true)
					set_attack_peds_flag("#FOLLOWER2#", ATTACK_NOW_NEVER_LOSE, true)
					set_attack_peds_flag("#FOLLOWER3#", ATTACK_NOW_NEVER_LOSE, true)
					set_attack_enemies_flag("#FOLLOWER3#", true)
					set_attack_enemies_flag("#FOLLOWER2#", true)
					set_attack_enemies_flag("#FOLLOWER1#", true)
					set_attack_enemies_flag("#FOLLOWER3#", ATTACK_NOW_NEVER_LOSE, true)
					set_attack_enemies_flag("#FOLLOWER2#", ATTACK_NOW_NEVER_LOSE, true)
					set_attack_enemies_flag("#FOLLOWER1#", ATTACK_NOW_NEVER_LOSE, true)



					sandbox_message("Followers will aggressively kills people and Super Jump Only")
				else

					ai_set_personality("#FOLLOWER1#", "Gang defensive")
					ai_set_personality("#FOLLOWER2#", "Gang defensive")
					ai_set_personality("#FOLLOWER3#", "Gang defensive")
					set_attack_enemies_flag("#FOLLOWER3#", ATTACK_NOW_NEVER_LOSE, false)
					set_attack_enemies_flag("#FOLLOWER2#", ATTACK_NOW_NEVER_LOSE, false)
					set_attack_enemies_flag("#FOLLOWER1#", ATTACK_NOW_NEVER_LOSE, false)
					ai_clear_priority_target("#FOLLOWER1#")
					ai_clear_priority_target("#FOLLOWER2#")
					ai_clear_priority_target("#FOLLOWER3#")
									set_always_sees_player_flag( "#FOLLOWER3#", true )
				set_always_sees_player_flag( "#FOLLOWER2#", true )
				set_always_sees_player_flag( "#FOLLOWER1#", true )
					character_set_always_combat_ready("#FOLLOWER1#", false)
					character_set_always_combat_ready("#FOLLOWER2#", false)
					character_set_always_combat_ready("#FOLLOWER3#", false)
					ai_force_team_idle("None")
	                                health_pickups_enable(true)
													delay(0.75)
					ai_add_enemy_target("#FOLLOWER1#", LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true, true)
					ai_add_enemy_target("#FOLLOWER2#", LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true, true)
					ai_add_enemy_target("#FOLLOWER3#", LOCAL_PLAYER, ATTACK_NOW_NEVER_LOSE, true, true)
					sandbox_message("Follower is restored back to normal, broken")

				end
				FOLLOWERS_PSYCHO = not FOLLOWERS_PSYCHO
				delay(0.75)
			elseif player_action_is_pressed(B_RBRACKET) and not EIGHT_PUSHED then
				-- PLAYA DANCE PARTY
				if PLAYA_DANCE_PARTY == 1 then
					set_animation_state(LOCAL_PLAYER, "dance b")
					set_player_can_take_human_shields(LOCAL_PLAYER, true)
					sandbox_message(" Playa dance party engage")
					if COOP_COMMANDS and coop_is_active() then
						set_animation_state(REMOTE_PLAYER, "dance b")
						set_player_can_take_human_shields(REMOTE_PLAYER, true)
					end
				elseif PLAYA_DANCE_PARTY == 2 then
					set_animation_state(LOCAL_PLAYER, "dance c")
					sandbox_message(" Playa dance party 2: Electric Boogaloo")
					if COOP_COMMANDS and coop_is_active() then
						set_animation_state(REMOTE_PLAYER, "dance c")
					end
				elseif PLAYA_DANCE_PARTY == 3 then
					set_animation_state(LOCAL_PLAYER, "cage dance a")
					sandbox_message(" Playa dance party 3: Cage Dance A")
					if COOP_COMMANDS and coop_is_active() then
						set_animation_state(REMOTE_PLAYER, "cage dance a")
					end
				elseif PLAYA_DANCE_PARTY == 4 then
					set_animation_state(LOCAL_PLAYER, "cage dance b")
					sandbox_message(" Playa dance party 4: Cage Dance B")
					if COOP_COMMANDS and coop_is_active() then
						set_animation_state(REMOTE_PLAYER, "cage dance b")
					end
				elseif PLAYA_DANCE_PARTY == 5 then
					set_animation_state(LOCAL_PLAYER, "cheer routine a")
					sandbox_message(" Playa dance party 5: Cheer Routine")
					if COOP_COMMANDS and coop_is_active() then
						set_animation_state(REMOTE_PLAYER, "cheer routine a")
					end
				elseif PLAYA_DANCE_PARTY == 6 then
					set_animation_state(LOCAL_PLAYER, "crowd close cheer a")
					sandbox_message(" Playa dance party 6: Crowd Close Cheer A")
					if COOP_COMMANDS and coop_is_active() then
						set_animation_state(REMOTE_PLAYER, "crowd close cheer a")
					end
				elseif PLAYA_DANCE_PARTY == 7 then
					set_animation_state(LOCAL_PLAYER, "crowd close cheer b")
					sandbox_message(" Playa dance party 7: Crowd Close Cheer B")
					if COOP_COMMANDS and coop_is_active() then
						set_animation_state(REMOTE_PLAYER, "crowd close cheer b")
					end
				elseif PLAYA_DANCE_PARTY == 8 then
					set_animation_state(LOCAL_PLAYER, "crowd close cheer c")
					sandbox_message(" Playa dance party 8: Crowd Close Cheer C")
					if COOP_COMMANDS and coop_is_active() then
						set_animation_state(REMOTE_PLAYER, "crowd close cheer c")
					end
				elseif PLAYA_DANCE_PARTY == 9 then
					set_animation_state(LOCAL_PLAYER, "crowd close cheer d")
					sandbox_message(" Playa dance party 9: Crowd Close Cheer D")
					if COOP_COMMANDS and coop_is_active() then
						set_animation_state(REMOTE_PLAYER, "crowd close cheer d")
					end
				elseif PLAYA_DANCE_PARTY == 10 then
					set_animation_state(LOCAL_PLAYER, "lap dance 1 a")
					sandbox_message(" Playa dance party 10: Lap Dance 1")
					if COOP_COMMANDS and coop_is_active() then
						set_animation_state(REMOTE_PLAYER, "lap dance 1 a")
					end
				elseif PLAYA_DANCE_PARTY == 11 then
					set_animation_state(LOCAL_PLAYER, "lap dance 2 a")
					sandbox_message(" Playa dance party 11: Lap Dance 2")
					if COOP_COMMANDS and coop_is_active() then
						set_animation_state(REMOTE_PLAYER, "lap dance 2 a")
					end
				elseif PLAYA_DANCE_PARTY == 12 then
					set_animation_state(LOCAL_PLAYER, "lap dance 3 a")
					sandbox_message(" Playa dance party 12: Lap Dance 3")
					if COOP_COMMANDS and coop_is_active() then
						set_animation_state(REMOTE_PLAYER, "lap dance 3 a")
					end
				elseif PLAYA_DANCE_PARTY == 13 then
					set_animation_state(LOCAL_PLAYER, "mascot attract a")
					sandbox_message(" Playa dance party 13: Mascot Attract A")
					if COOP_COMMANDS and coop_is_active() then
						set_animation_state(REMOTE_PLAYER, "mascot attract a")
					end
				elseif PLAYA_DANCE_PARTY == 14 then
					set_animation_state(LOCAL_PLAYER, "mascot attract b")
					sandbox_message(" Playa dance party 14: Mascot Attract B")
					if COOP_COMMANDS and coop_is_active() then
						set_animation_state(REMOTE_PLAYER, "mascot attract b")
					end
				elseif PLAYA_DANCE_PARTY == 15 then
					set_animation_state(LOCAL_PLAYER, "pole dancing a")
					sandbox_message(" Playa dance party 15: Pole Dancing A")
					if COOP_COMMANDS and coop_is_active() then
						set_animation_state(REMOTE_PLAYER, "pole dancing a")
					end
				elseif PLAYA_DANCE_PARTY == 16 then
					set_animation_state(LOCAL_PLAYER, "pole dancing b")
					sandbox_message(" Playa dance party 16: Pole Dancing B")
					if COOP_COMMANDS and coop_is_active() then
						set_animation_state(REMOTE_PLAYER, "pole dancing b")
					end
				elseif PLAYA_DANCE_PARTY == 17 then
					set_animation_state(LOCAL_PLAYER, "pole dancing c")
					sandbox_message(" Playa dance party 17: Pole Dancing C")
					if COOP_COMMANDS and coop_is_active() then
						set_animation_state(REMOTE_PLAYER, "pole dancing c")
					end
				elseif PLAYA_DANCE_PARTY == 18 then
					set_animation_state(LOCAL_PLAYER, "pole dancing d")
					sandbox_message(" Playa dance party 18: Pole Dancing D")
					if COOP_COMMANDS and coop_is_active() then
						set_animation_state(REMOTE_PLAYER, "pole dancing d")
					end
				elseif PLAYA_DANCE_PARTY == 19 then
					clear_animation_state(LOCAL_PLAYER)
					set_player_can_take_human_shields(LOCAL_PLAYER, true)
					sandbox_message(" Party's over!")
					if COOP_COMMANDS and coop_is_active() then
						clear_animation_state(REMOTE_PLAYER)
						set_player_can_take_human_shields(REMOTE_PLAYER, true)
					end
				end
				if PLAYA_DANCE_PARTY == 19 then
					PLAYA_DANCE_PARTY = 1
				else
					PLAYA_DANCE_PARTY = PLAYA_DANCE_PARTY + 1
				end
				delay(0.75)
			end
		end

		if not player_action_is_pressed("CBA_GAC_RECRUIT_DISMISS") then
			RECRUIT_PUSHED = false
		end
		if not player_action_is_pressed("CBA_OFC_TAUNT_TWO") then
			TAUNT_PUSHED = false
		end
		if not player_action_is_pressed("CBA_OFC_TAUNT_THREE") then
			COMPLIMENT_PUSHED = false
		end
		if not player_action_is_pressed("CBA_OFC_CROUCH") then
			CROUCH_PUSHED = false
		end
		if not player_action_is_pressed("CBA_GAC_ACTION") then
			USE_PUSHED = false
		end
		if not player_action_is_pressed("CBA_OFC_PICKUP_RELOAD") then
			RELOAD_PUSHED = false
		end
		if not player_action_is_pressed("CBA_OFC_MELEE_NUT_SHOT") then
			MELEE_PUSHED = false
		end
		if not player_action_is_pressed("CBA_GAC_GRENADE_SWITCH") then
			GRENADE_PUSHED = false
		end
		if not player_action_is_pressed("CBA_GAC_WEAPON_SELECT_1") then
			ONE_PUSHED = false
		end
		if not player_action_is_pressed("CBA_GAC_WEAPON_SELECT_2") then
			TWO_PUSHED = false
		end
		if not player_action_is_pressed("CBA_GAC_WEAPON_SELECT_3") then
			THREE_PUSHED = false
		end
		if not player_action_is_pressed("CBA_GAC_WEAPON_SELECT_4") then
			FOUR_PUSHED = false
		end
		if not player_action_is_pressed("CBA_GAC_WEAPON_SELECT_5") then
			FIVE_PUSHED = false
		end
		if not player_action_is_pressed("CBA_GAC_WEAPON_SELECT_6") then
			SIX_PUSHED = false
		end
		if not player_action_is_pressed("CBA_GAC_WEAPON_SELECT_7") then
			SEVEN_PUSHED = false
		end
		if not player_action_is_pressed("CBA_GAC_WEAPON_SELECT_8") then
			EIGHT_PUSHED = false
		end
	delay(0.5)
	end
end

function ding_finish_audio()
	if HUD_MSG then
		audio_object_post_event("WEAPON_PURCHASE")
	end
end

function heaven_audio()
	if HUD_MSG then
		audio_object_post_event("M02_GENKI_STINGER")
	end
end

function alert_message(hud_text_msg)
	-- HIGH PRIORITY MESSAGES WITH ALERT SOUND EFFECT
	-- THEY CANNOT BE TURNED OFF
	audio_object_post_event("UI_TOD_TOGGLE")
	mission_help_table(hud_text_msg, SYNC_LOCAL)
end

function sandbox_message(hud_text_msg)
	-- LOW PRIORITY MESSAGES
	-- THEY DON'T HAVE SPECIFIC SOUND EFFECT, YOU CAN SET YOUR CUSTOM ONE
	if HUD_MSG then
		mission_help_table(hud_text_msg, SYNC_LOCAL)
	end
end

function get_fucking_high_bitches(scalar)
	drug_effect_set_override_values(scalar, scalar)	
	if scalar >= 1.0 then
		refraction_situation_set("drug strong")
	elseif scalar >= 0.75 and scalar < 1.0 then
		refraction_situation_set("drug weak")
	elseif scalar >= 0.5 and scalar < 0.75 then
		refraction_situation_set("drug weakest")
	else
		refraction_situation_clear()
	end
end

function sandbox_cutscene(cutscene)
	reset_crib_interior()
	cutscene_play(cutscene)
	reset_all_zones()
	if CRIB_CUTSCENE and mission_is_complete("m23") then
		if CRIB_CUTSCENE == "brokenshillelagh" then
			local tposx,tposy,tposz = (-291.518 - ctele_Posx), (352.450 - ctele_Posy), (12.186 - ctele_Posz)
			teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
			if coop_is_active() then
				teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
			end
		elseif CRIB_CUTSCENE == "kinziewarehouse" then
			local tposx,tposy,tposz = (2098.579 - ctele_Posx), (-273.290 - ctele_Posy), (9.112 - ctele_Posz)
			teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
			if coop_is_active() then
				teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
			end
		elseif CRIB_CUTSCENE == "saintshq" then
			arrive_saintshq_int()
			local tposx,tposy,tposz = (-1457.096 - ctele_Posx), (1083.600 - ctele_Posy), (149.743 - ctele_Posz)
			teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
			if coop_is_active() then
				teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
			end
		elseif CRIB_CUTSCENE == "threecount" then
			arrive_threecount_int()
			local tposx,tposy,tposz = (1189.881 - ctele_Posx), (1439.622 - ctele_Posy), (227.406 - ctele_Posz)
			teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
			if coop_is_active() then
				teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
			end
		end
	else
		-- TELEPORT TO GATEWAY SUNSET PARK
		local tposx,tposy,tposz = (40.008 - ctele_Posx), (673.332 - ctele_Posy), (7.833 - ctele_Posz)
		teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
		if coop_is_active() then
			teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
		end
	end
end

function set_animation_for_gender(player)
	if character_get_gender(player) == GENDER_TYPE_MALE then
		set_animation_set(player, "PLYM")
	else
		set_animation_set(player, "PLYF")
	end
end

function reset_all_zones()
	city_zone_swap("M_00", false)
	city_zone_swap("wh", false)
	city_zone_swap("pv", false)
	city_zone_swap("m11", false)
	city_zone_swap("m3", false)
	city_zone_swap("2D", false)
	city_zone_swap("training", false)
	city_zone_swap("m3_escape", false)
	city_zone_swap("m3_fox", false)
	city_zone_swap("m7_matt", false)
	city_zone_swap("m3", false)
	city_zone_swap("int_m2", false)
	city_zone_swap("sprint_1", false)
	city_zone_swap("sprint_2", false)
	city_zone_swap("sprint_3", false)
	city_zone_swap("tk_1_swap", false)
	city_zone_swap("tk_2", false)
	city_zone_swap("spfc", false)
	city_zone_swap("m15_gat", false)
	city_zone_swap("gat_loyalty", false)
	city_zone_swap("m17", false)
	city_zone_swap("m18_tv", false)
	city_zone_swap("m5", false)
	city_zone_swap("m22_3_ship", false)
	city_zone_swap("m22_3_dive", false)
	city_zone_swap("arena", false)
	city_zone_swap("leap_1", false)
	city_zone_swap("leap_2_swap", false)
	city_zone_swap("vr", false)
	city_zone_swap("dlc1_bdclub", false)
	city_zone_swap("dlc1_4p", false)
	city_zone_swap("dlc2_wpv", false)
	city_zone_swap("dlc2_nps", false)
	city_zone_swap("dlc2_r", false)
end

function reset_crib_interior()
	if INSIDE_SAINTSHQ then
		arrive_saintshq_ext()
	elseif INSIDE_THREECOUNT then
		arrive_threecount_ext()
	end
end

-- ****************************************************************************************************
-- END KEYCOMBO THREAD
-- ****************************************************************************************************


-- ****************************************************************************************************
-- BEGIN ATTACH EFFECTS THREAD
-- ****************************************************************************************************

function effects_thread()
	while EFFECTS_THREAD_ON == 1 do
		if effects_toggle then
			explosion_create(effects_current, LOCAL_PLAYER)
			if COOP_COMMANDS and coop_is_active() then
				explosion_create(effects_current, REMOTE_PLAYER)
			end
		end
		delay(effects_delay)
	end
end

-- ****************************************************************************************************
-- END ATTACH EFFECTS THREAD
-- ****************************************************************************************************


-- ****************************************************************************************************
-- BEGIN EXPANDED ARSENAL MOD THREAD
-- THIS THREAD COOPERATES WITH EXPANDED ARSENAL MOD AND WON'T AFFECT GAMEPLAY IF IT ISN'T INSTALLED
-- ****************************************************************************************************
-- HUD PROMPT PRIORITY: LOW
-- MIGHT BE OVERRIDDEN BY CRIB THREAD AND WORKING ELEVATORS MOD THREAD
-- ****************************************************************************************************

function eam_thread()
	while EAM_THREAD_ON == 1 do
		
		-- ENHANCED WEAPONS SCRIPT
		if EAM_WEAPONS then

			-- MELEE - FEAR GUN
			if inv_item_is_equipped("EAM-FearGun", LOCAL_PLAYER) then
				if not EAM_FEARGUN then
					hud_prompt(LOCAL_PLAYER, "EAM_FEARGUN_DISABLED", "EAM_FearGun_enable")
				else
					hud_prompt(LOCAL_PLAYER, "EAM_FEARGUN_ENABLED", "EAM_FearGun_disable")
				end
			else
				if EAM_FEARGUN then
					EAM_FearGun_disable()
					EAM_FEARGUN = false
				end
			end

			-- SHOTGUN - MICRONIZER
			if inv_item_is_equipped("EAM-Micronizer", LOCAL_PLAYER) then
				if not EAM_MICRONIZER then
					hud_prompt(LOCAL_PLAYER, "EAM_MICRONIZER_DISABLED", "EAM_Micronizer_enable")
				else
					hud_prompt(LOCAL_PLAYER, "EAM_MICRONIZER_ENABLED", "EAM_Micronizer_disable")
				end
			else
				if EAM_MICRONIZER then
					EAM_Micronizer_disable()
					EAM_MICRONIZER = false
				end
			end

			-- RIFLE - GLITCHMASTER 3000
			if inv_item_is_equipped("EAM-GlitchGun", LOCAL_PLAYER) then
				if not EAM_GLITCHGUN then
					hud_prompt(LOCAL_PLAYER, "EAM_GLITCHGUN_DISABLED", "EAM_GlitchGun_enable")
				else
					hud_prompt(LOCAL_PLAYER, "EAM_GLITCHGUN_ENABLED", "EAM_GlitchGun_disable")
				end
			else
				if EAM_GLITCHGUN then
					EAM_GlitchGun_disable()
					EAM_GLITCHGUN = false
				end
			end

			-- RIFLE - LAZARUS RIFLE
			if inv_item_is_equipped("EAM-LazarusRifle", LOCAL_PLAYER) then
				if human_is_downed("#FOLLOWER1#") or human_is_downed("#FOLLOWER2#") or human_is_downed("#FOLLOWER3#") then
					hud_prompt(LOCAL_PLAYER, "HUD_DOWNED_REVIVE", "EAM_LazarusRifle")
				end
			end

		end

		-- SATCHEL CHARGES FIX
		if EAM_SATCHEL then
			if inv_item_is_equipped("satchel", LOCAL_PLAYER) or inv_item_is_equipped("satchel", REMOTE_PLAYER) then
				if SUPERPOWER_ATTACKS then
					EAM_SATCHEL_TEMP = true
				end
				SUPERPOWER_ATTACKS = false
				player_super_attacks_enable(false)
			else
				if EAM_SATCHEL_TEMP then
					SUPERPOWER_ATTACKS = true
					player_super_attacks_enable(true)
					EAM_SATCHEL_TEMP = false
				end
			end
		end

		delay(0.5)
	end
end

function EAM_FearGun_enable()
	EAM_FEARGUN = true
	set_civilians_flee(true)
end

function EAM_FearGun_disable()
	EAM_FEARGUN = false
	set_civilians_flee(false)
end

function EAM_Micronizer_enable()
	EAM_MICRONIZER = true
	player_change_default_size(LOCAL_PLAYER, 0.5, false)
	if COOP_COMMANDS and coop_is_active() then
		player_change_default_size(REMOTE_PLAYER, 0.5, false)
	end
end

function EAM_Micronizer_disable()
	EAM_MICRONIZER = false
	player_change_default_size(LOCAL_PLAYER, 1.0, false)
	if COOP_COMMANDS and coop_is_active() then
		player_change_default_size(REMOTE_PLAYER, 1.0, false)
	end
end

function EAM_GlitchGun_enable()
	EAM_GLITCHGUN = true
	VIRTUAL_REALITY = true
	hdr_bloom_set_multiplier(1.5)
	refraction_situation_set("cyber_m16")
	CIV_GLITCHED = true
	set_civilians_glitching(true)
end

function EAM_GlitchGun_disable()
	EAM_GLITCHGUN = false
	VIRTUAL_REALITY = false
	hdr_bloom_set_multiplier(1)
	refraction_situation_clear()
	CIV_GLITCHED = false
	set_civilians_glitching(false)
end

function EAM_LazarusRifle()
	if human_is_downed("#FOLLOWER1#") then
		npc_revive("#FOLLOWER1#")
	elseif human_is_downed("#FOLLOWER2#") then
		npc_revive("#FOLLOWER2#")
	elseif human_is_downed("#FOLLOWER3#") then
		npc_revive("#FOLLOWER3#")
	end
end

-- ****************************************************************************************************
-- END EXPANDED ARSENAL MOD THREAD
-- ****************************************************************************************************


-- ****************************************************************************************************
-- BEGIN CRIB THREAD
-- IT COOPERATES WITH WORKING ELEVATORS MOD THREAD
-- ****************************************************************************************************
-- HUD PROMPT PRIORITY: MEDIUM
-- MIGHT BE OVERRIDDEN BY WORKING ELEVATORS MOD THREAD
-- ****************************************************************************************************

function crib_thread()
	while CRIB_THREAD_ON == 1 do

		-- SET THREECOUNT_SAINTS
		if not mission_is_active("dlc1_m01") and mission_is_complete("m23") then
			if THREECOUNT_SAINTS then
				THREECOUNT_SAINTS_ALT = true	-- Sync THREECOUNT_SAINTS_ALT var
				city_zone_swap("dlc1_3c", true)	-- Change Three Count state to Saints crib (only if the storyline is completed)
			else
				THREECOUNT_SAINTS_ALT = false
				city_zone_swap("dlc1_3c", false)	-- Revert Three Count state to vanilla
			end
		end

		-- SET CRIB_STARTUP
		if mission_is_complete("m23") then
			if CRIB_STARTUP == "brokenshillelagh" then
				local tposx,tposy,tposz = (-286.297 - ctele_Posx), (348.463 - ctele_Posy), (12.197 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
			elseif CRIB_STARTUP == "kinziewarehouse" then
				local tposx,tposy,tposz = (2142.167 - ctele_Posx), (-268.511 - ctele_Posy), (4.125 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
			elseif CRIB_STARTUP == "saintshq" then
				arrive_saintshq_int()
				local tposx,tposy,tposz = (-1478.377 - ctele_Posx), (1098.159 - ctele_Posy), (145.782 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
			elseif CRIB_STARTUP == "threecount" then
				arrive_threecount_int()
				local tposx,tposy,tposz = (1203.540 - ctele_Posx), (1450.141 - ctele_Posy), (228.156 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
			end
			CRIB_STARTUP = false
		end

		-- REVERT THREE COUNT TO VANILLA IF NYTEFALL MISSION IS ACTIVE
		-- THIS IS TO PREVENT MISSION REPLAY ISSUES
		if mission_is_active("mol_mm_01") then
			if THREECOUNT_SAINTS_ALT then
				THREECOUNT_SAINTS_REPLAY = true
			end
			THREECOUNT_SAINTS = false
			city_zone_swap("dlc1_3c", false)
		else
			if THREECOUNT_SAINTS_REPLAY then
				THREECOUNT_SAINTS = true
				city_zone_swap("dlc1_3c", true)
				-- TELEPORT TO THREE COUNT EXTERIOR
				local tposx,tposy,tposz = (1200.829 - ctele_Posx), (1342.975 - ctele_Posy), (24.193 - ctele_Posz)
				teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				if coop_is_active() then
					teleport_to_object(REMOTE_PLAYER, "nw_qm_nav", false, false, tposx , tposz, tposy , false)
				end
				THREECOUNT_SAINTS_REPLAY = false
			end
		end

		-- CHECK IF PLAYER IS INSIDE THE CRIB AND ENABLE FUNCTIONAL CRIB FUNCTIONS
		if mission_is_complete("m23") and not mission_is_active() then

			-- SAINTS HQ INTERIOR PROMPTS
			if INSIDE_SAINTSHQ then
				local x, z, y = get_object_pos(LOCAL_PLAYER)
				if x > -1507 and x < -1450 and y > 1044 and y < 1107 and z > 144 and z < 151 then
					if CRIB_PROMPTS then
						hud_prompt(LOCAL_PLAYER, "CRIB_GATEWAY", "crib_gateway")
					end
					if not CRIB_NOTORIETY then
						notoriety_reset("police")
					end
				end
				if (x > -1463 and x < -1449 and y > 1079 and y < 1087 and z > 144 and z < 148) or (x > -1460 and x < -1453 and y > 1080 and y < 1087 and z > 149 and z < 151) then
					if CRIB_PROMPTS then
						hud_prompt(LOCAL_PLAYER, "CRIB_TERMINAL", "crib_terminal")
					end
				end
				if (x > -1463 and x < -1452 and y > 1096 and y < 1102 and z > 144 and z < 148) or (x > -1461 and x < -1457 and y > 1087 and y < 1099 and z > 149 and z < 151) then
					if CRIB_PROMPTS then
						hud_prompt(LOCAL_PLAYER, "CRIB_CHARACTER", "crib_character")
					end
				end
				if x > -1491 and x < -1467 and y > 1014 and y < 1037 and z > 141 and z < 144 then
					if CRIB_PROMPTS then
						hud_prompt(LOCAL_PLAYER, "CRIB_WEAPON", "crib_weapon")
					end
				end
				if x > -1500 and x < -1495 and y > 1080 and y < 1094 and z > 149 and z < 151 then
					if CRIB_PROMPTS then
						if not CRIB_DRUG then
							hud_prompt(LOCAL_PLAYER, "CRIB_DRUG_FREE", "crib_drug_begin")
						elseif CRIB_DRUG >= 0.05 and CRIB_DRUG < 1.0 then
							hud_prompt(LOCAL_PLAYER, "CRIB_DRUG_PAID", "crib_drug_increase")
						elseif CRIB_DRUG >= 1.0 then
							hud_prompt(LOCAL_PLAYER, "CRIB_DRUG_PAID", "crib_drug_overkill")
						end
					end
				end
				if x > -1501 and x < -1489 and y > 1096 and y < 1106 and z > 144 and z < 151 then
					if CRIB_PROMPTS then
						if CRIB_DRUG then
							hud_prompt(LOCAL_PLAYER, "CRIB_DRUG_CURE", "crib_drug_disable")
						end
					end
				end
				if (x > -1510 and x < -1443 and y > 1049 and y < 1105 and z > 25 and z < 33) or (x > -1481 and x < -1475 and y > 1073 and y < 1078 and z > 144 and z < 148) or (x > -1480 and x < -1476 and y > 1078 and y < 1082 and z > 144 and z < 148) then
					if CRIB_PROMPTS then
						if not SAINTSHQ_SUPERPOWERS then
							hud_prompt(LOCAL_PLAYER, "CRIB_SUPERPOWERS_DEACTIVATED", "crib_superpowers_activate")
						else
							hud_prompt(LOCAL_PLAYER, "CRIB_SUPERPOWERS_ACTIVATED", "crib_superpowers_deactivate")
						end
					end
				end

			-- THREE COUNT INTERIOR PROMPTS
			elseif INSIDE_THREECOUNT then
				local x, z, y = get_object_pos(LOCAL_PLAYER)
				if x > 1187 and x < 1215 and y > 1431 and y < 1465 and z > 227 and z < 234 then
					if CRIB_PROMPTS then
						hud_prompt(LOCAL_PLAYER, "CRIB_GATEWAY", "crib_gateway")
					end
					if not CRIB_NOTORIETY then
						notoriety_reset("police")
					end
				end
				if x > 1187 and x < 1192 and y > 1437 and y < 1442 and z > 227 and z < 229 then
					if CRIB_PROMPTS then
						hud_prompt(LOCAL_PLAYER, "CRIB_TERMINAL", "crib_terminal")
					end
				end
				if x > 1195 and x < 1206 and y > 1459 and y < 1464 and z > 230 and z < 234 then
					if CRIB_PROMPTS then
						hud_prompt(LOCAL_PLAYER, "CRIB_CHARACTER", "crib_character")
					end
				end
				if x > 1201 and x < 1205 and y > 1441 and y < 1444 and z > 227 and z < 229 then
					if CRIB_PROMPTS then
						if not CRIB_DRUG then
							hud_prompt(LOCAL_PLAYER, "CRIB_DRUG_FREE", "crib_drug_begin")
						elseif CRIB_DRUG >= 0.05 and CRIB_DRUG < 1.0 then
							hud_prompt(LOCAL_PLAYER, "CRIB_DRUG_PAID", "crib_drug_increase")
						elseif CRIB_DRUG >= 1.0 then
							hud_prompt(LOCAL_PLAYER, "CRIB_DRUG_PAID", "crib_drug_overkill")
						end
					end
				end
				if x > 1210 and x < 1213 and y > 1435 and y < 1442 and z > 227 and z < 229 then
					if CRIB_PROMPTS then
						if CRIB_DRUG then
							hud_prompt(LOCAL_PLAYER, "CRIB_DRUG_CURE", "crib_drug_disable")
						end
					end
				end

			-- THREE COUNT HELIPAD PROMPTS
			elseif THREECOUNT_SAINTS_ALT then
				local x, z, y = get_object_pos(LOCAL_PLAYER)
				if x > 1190 and x < 1214 and y > 1397 and y < 1420 and z > 440 and z < 444 then
					if CRIB_PROMPTS then
						hud_prompt(LOCAL_PLAYER, "CRIB_WEAPON", "crib_weapon")
					end
				end
			end

			-- BROKEN SHILLELAGH INTERIOR PROMPTS
			if BROKEN_SHILLELAGH then
				local x, z, y = get_object_pos(LOCAL_PLAYER)
				if x > -293 and x < -279 and y > 341 and y < 355 and z > 12 and z < 13 then
					if CRIB_PROMPTS then
						hud_prompt(LOCAL_PLAYER, "CRIB_GATEWAY", "crib_gateway")
					end
					if not CRIB_NOTORIETY then
						notoriety_reset("police")
					end
				end
				if x > -293 and x < -290 and y > 350 and y < 355 and z > 12 and z < 13 then
					if CRIB_PROMPTS then
						hud_prompt(LOCAL_PLAYER, "CRIB_TEXT_ADVENTURE", "crib_text_adventure")
					end
				end
				if x > -293 and x < -280 and y > 341 and y < 345 and z > 12 and z < 13 then
					if CRIB_PROMPTS then
						if not CRIB_DRUG then
							hud_prompt(LOCAL_PLAYER, "CRIB_DRUG_FREE", "crib_drug_begin")
						elseif CRIB_DRUG >= 0.05 and CRIB_DRUG < 1.0 then
							hud_prompt(LOCAL_PLAYER, "CRIB_DRUG_PAID", "crib_drug_increase")
						elseif CRIB_DRUG >= 1.0 then
							hud_prompt(LOCAL_PLAYER, "CRIB_DRUG_PAID", "crib_drug_overkill")
						end
					end
				end
				if x > -300 and x < -293 and y > 347 and y < 350 and z > 12 and z < 13 then
					if CRIB_PROMPTS then
						if CRIB_DRUG then
							hud_prompt(LOCAL_PLAYER, "CRIB_DRUG_CURE", "crib_drug_disable")
						else
							hud_prompt(LOCAL_PLAYER, "CRIB_GATEWAY", "crib_gateway")
						end
					end
				end
			end
		end

			-- KINZIE'S WAREHOUSE INTERIOR PROMPTS
			if KINZIE_WAREHOUSE then
				local x, z, y = get_object_pos(LOCAL_PLAYER)
				if (x > 2096 and x < 2156 and y > -291 and y < -264 and z > 4 and z < 11) or (x > 2132 and x < 2156 and y > -264 and y < -256 and z > 4 and z < 11) then
					if CRIB_PROMPTS then
						hud_prompt(LOCAL_PLAYER, "CRIB_GATEWAY", "crib_gateway")
					end
					if not CRIB_NOTORIETY then
						notoriety_reset("police")
					end
				end
				if x > 2100 and x < 2116 and y > -290 and y < -284 and z > 9 and z < 11 then
					if CRIB_PROMPTS then
						hud_prompt(LOCAL_PLAYER, "CRIB_TERMINAL", "crib_terminal")
					end
				end
				if x > 2108 and x < 2112 and y > -271 and y < -268 and z > 9 and z < 11 then
					if CRIB_PROMPTS then
						if not CRIB_DRUG then
							hud_prompt(LOCAL_PLAYER, "CRIB_DRUG_FREE", "crib_drug_begin")
						elseif CRIB_DRUG >= 0.05 and CRIB_DRUG < 1.0 then
							hud_prompt(LOCAL_PLAYER, "CRIB_DRUG_PAID", "crib_drug_increase")
						elseif CRIB_DRUG >= 1.0 then
							hud_prompt(LOCAL_PLAYER, "CRIB_DRUG_PAID", "crib_drug_overkill")
						end
					end
				end
				if x > 2104 and x < 2112 and y > -268 and y < -265 and z > 9 and z < 11 then
					if CRIB_PROMPTS then
						if CRIB_DRUG then
							hud_prompt(LOCAL_PLAYER, "CRIB_DRUG_CURE", "crib_drug_disable")
						end
					end
				end
			end

		delay(0.5)
	end
end

function crib_gateway()
	hud_push_screen("store_common", SYNC_LOCAL)
	hud_push_screen("store_crib", SYNC_LOCAL)
end

function crib_terminal()
	hud_push_screen("col_main", SYNC_LOCAL)
end

function crib_text_adventure()
	hud_push_screen("msn_text_adventure", SYNC_LOCAL)
end

function crib_character()
	cash_remove(250, LOCAL_PLAYER)
	hud_push_screen("store_common", SYNC_LOCAL)
	hud_push_screen("store_character", SYNC_LOCAL)
end

function crib_weapon()
	hud_push_screen("store_common", SYNC_LOCAL)
	hud_push_screen("store_weapon", SYNC_LOCAL)
end

function crib_drug_begin()
	CRIB_DRUG = 0.05
	get_fucking_high_bitches(CRIB_DRUG)
end

function crib_drug_increase()
	CRIB_DRUG = CRIB_DRUG + 0.05
	cash_remove(125, LOCAL_PLAYER)
	get_fucking_high_bitches(CRIB_DRUG)
end

function crib_drug_overkill()
	character_kill(LOCAL_PLAYER, true, "vomitting", false)
	crib_drug_disable()
end

function crib_drug_disable()
	CRIB_DRUG = false
	if not character_is_dead(LOCAL_PLAYER) then
		cash_remove(1500, LOCAL_PLAYER)
	end
	get_fucking_high_bitches(0)
end

function crib_superpowers_activate()
	SAINTSHQ_SUPERPOWERS = true
	SUPERPOWER_MOVEMENT = 1
	player_super_movement_enable(true)
	human_allow_freefall(false)
	human_allow_parachute(false)
end

function crib_superpowers_deactivate()
	SAINTSHQ_SUPERPOWERS = false
	SUPERPOWER_MOVEMENT = 4
	player_super_movement_enable(false)
	human_allow_freefall(true)
	human_allow_parachute(true)
end

-- ****************************************************************************************************
-- END CRIB THREAD
-- ****************************************************************************************************


-- ****************************************************************************************************
-- BEGIN WORKING ELEVATORS MOD THREAD
-- IT COOPERATES WITH CRIB THREAD
-- ****************************************************************************************************
-- HUD PROMPT PRIORITY: HIGH
-- CANNOT BE OVERRIDDEN BY ANY OTHER THREAD
-- ****************************************************************************************************

function elevator_thread()
	while ELEVATOR_THREAD_ON == 1 do
		if ELEVATOR_MOD and not mission_is_active() then
			local x, z, y = get_object_pos(LOCAL_PLAYER)
			for name, stop in pairs(elevator_stops) do
				if x > stop.x0 and x < stop.x1 and y > stop.y0 and y < stop.y1 and z > stop.z0 and z < stop.z1 then
					local next_stop
					if stop.depart_func then
						next_stop = _G[stop.depart_func]()
						if next_stop then
							hud_prompt(LOCAL_PLAYER, stop.message, "teleport_if_at_elevator")
						end
					else
						hud_prompt(LOCAL_PLAYER, stop.message, "teleport_if_at_elevator")
					end
				end
			end
		end

		delay(0.5)
	end
end

function depart_storyline_check()
	return mission_is_complete("m23") == true
end

function arrive_saintshq_ext()
	INSIDE_SAINTSHQ = false
	if SAINTSHQ_JOE then
		city_zone_swap("molp1_joe", false)
	else
		city_zone_swap("molp1_no", false)
	end
	if not SAINTSHQ_SUPERPOWERS then
		SUPERPOWER_MOVEMENT = 1
		player_super_movement_enable(true)
		human_allow_freefall(false)
		human_allow_parachute(false)
	end
	if CRIB_PROMPTS and mission_is_complete("m23") and not mission_is_active() then
		set_player_can_take_human_shields(LOCAL_PLAYER, true)
	end
	if SAINTSHQ_TOD then
		mission_override_clear_all_temp()
	end
end

function arrive_saintshq_int()
	INSIDE_SAINTSHQ = true
	if SAINTSHQ_JOE then
		city_zone_swap("molp1_joe", true)
	else
		city_zone_swap("molp1_no", true)
	end
	if not SAINTSHQ_SUPERPOWERS then
		SUPERPOWER_MOVEMENT = 4
		player_super_movement_enable(false)
		human_allow_freefall(true)
		human_allow_parachute(true)
	end
	if CRIB_PROMPTS and mission_is_complete("m23") and not mission_is_active() then
		set_player_can_take_human_shields(LOCAL_PLAYER, false)
	end
	if SAINTSHQ_TOD then
		mission_override_push_temp(SAINTSHQ_TOD..".todx")
	end
end

function depart_threecount_ext()
	return THREECOUNT_SAINTS_ALT == true
end

function arrive_threecount_ext()
	INSIDE_THREECOUNT = false
	if THREECOUNT_SAINTS_TEMP then
		THREECOUNT_SAINTS = true
		city_zone_swap("dlc1_3c", true)
	end
	city_zone_swap("dlc1_3s", false)
	spawning_pedestrians(false)
	SUPERPOWER_MOVEMENT = 1
	player_super_movement_enable(true)
	if CRIB_PROMPTS and mission_is_complete("m23") and not mission_is_active() then
		set_player_can_take_human_shields(LOCAL_PLAYER, true)
	end
	if THREECOUNT_MUSIC then
		audio_stop(AMBIENT_MUSIC)
	end
	if THREECOUNT_TOD then
		mission_override_clear_all_temp()
	end
	spawning_pedestrians(true)
end

function depart_threecount_int()
    if THREECOUNT_SAINTS_TEMP then
		return "threecount_ext"
	else
		return "threecount_lobby"
	end
end

function arrive_threecount_int()
	INSIDE_THREECOUNT = true
	if THREECOUNT_SAINTS_ALT then
		THREECOUNT_SAINTS_TEMP = true
	else
		THREECOUNT_SAINTS_TEMP = false
	end
	THREECOUNT_SAINTS = false
	city_zone_swap("dlc1_3c", false)
	city_zone_swap("dlc1_3s", true)
	SUPERPOWER_MOVEMENT = 4
	player_super_movement_enable(false)
	if CRIB_PROMPTS and mission_is_complete("m23") and not mission_is_active() then
		set_player_can_take_human_shields(LOCAL_PLAYER, false)
	end
	if THREECOUNT_MUSIC then
		AMBIENT_MUSIC = audio_object_post_event("AMB_DT_SLEAZYMUSIC")
	end
	if THREECOUNT_TOD then
		mission_override_push_temp(THREECOUNT_TOD..".todx")
	end
end

function arrive_threecount_lobby()
	arrive_threecount_ext()
	-- Teleport to the Three Count lobby to trigger loading the interior
	teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, false, 1200.0 - ctele_Posx, 25.79 - ctele_Posz, 1384.0 - ctele_Posy)
	while teleport_check_done(LOCAL_PLAYER) == false do
		thread_yield()
	end
end

function depart_threecount_heli_int()
	if THREECOUNT_SAINTS_TEMP then
		return "threecount_heli_pad"
	else
		return "threecount_heli_roof"
	end
end

elevator_stops = {
	-- TECHNICALLY LEGAL ELEVATORS
	tech_legal_int         = { x0=  992.62, y0=-627.91, z0= 12.50, x1=  996.57, y1=-623.97, z1= 12.60, next="tech_legal_roof"   , r=1,
						       message="USE_TRIGGER_HE_CRIB_ENTER" },
	tech_legal_roof        = { x0=  992.74, y0=-627.92, z0= 32.50, x1=  996.69, y1=-623.98, z1= 32.60, next="tech_legal_int" , r=1,
						       message="USE_TRIGGER_HE_CRIB_EXIT" },
	-- MAGARAC ISLAND ELEVATORS
	-- MISSION ZONE (THE SAINTS FLOW)
	magarac_down           = { x0=-2210.79, y0=1085.77, z0= 12.30, x1=-2207.93, y1=1088.70, z1= 12.40, next="magarac_up"   , r=2,
						       message="USE_TRIGGER_HE_CRIB_ENTER" },
	magarac_up             = { x0=-2207.55, y0=1070.96, z0= 88.50, x1=-2202.35, y1=1077.29, z1= 88.60, next="magarac_down" , r=8,
						       message="USE_TRIGGER_HE_CRIB_EXIT" },
	-- SAINTS HQ INTERIOR ELEVATORS
	-- FUNCTIONAL CRIB
	saintshq_ext           = { x0=   90.44, y0=1006.09, z0=  8.15, x1=  102.52, y1=1031.49, z1= 10.25, next="saintshq_int"  , r=4,
	                           depart_func="depart_storyline_check", arrive_func="arrive_saintshq_ext",
						       message="USE_TRIGGER_PENTHOUSE" },
	saintshq_int           = { x0=-1479.53, y0=1107.81, z0=145.70, x1=-1476.60, y1=1110.67, z1=145.80, next="saintshq_ext"  , r=4,
	                           arrive_func="arrive_saintshq_int",
						       message="USE_TRIGGER_LOBBY" },
	saintshq_lobby         = { x0=-1492.73, y0=1015.08, z0=  8.00, x1=-1466.58, y1=1049.67, z1=8.70, next="saintshq_int"  , r=4,
						       message="VCUST_RETURN_TO_CRIB" },
	-- SAINTS HQ FOYER ELEVATORS
	-- FUNCTIONAL CRIB
	saintshq_foyer_down    = { x0=-1479.97, y0=1051.45, z0= 32.13, x1=-1472.18, y1=1058.65, z1= 32.23, next="saintshq_foyer_up"  , r=4,
						       message="USE_TRIGGER_HE_CRIB_ENTER" },
	saintshq_foyer_up      = { x0=-1479.06, y0=1107.23, z0=149.70, x1=-1476.60, y1=1110.67, z1=149.80, next="saintshq_foyer_down"  , r=4,
						       message="USE_TRIGGER_HE_CRIB_EXIT" },
	-- THREE COUNT INTERIOR ELEVATORS
	-- FUNCTIONAL CRIB
	threecount_ext         = { x0= 1195.14, y0=1364.56, z0= 25.10, x1= 1206.17, y1=1366.47, z1= 25.90, next="threecount_int"  , r=4,
	                           x = 1200.64, y =1364.73, z = 25.15, r = 4,
	                           depart_func="depart_threecount_ext", arrive_func="arrive_threecount_ext",
						       message="USE_TRIGGER_PENTHOUSE" },
	threecount_int         = { x0= 1195.12, y0=1460.95, z0=228.15, x1= 1198.00, y1=1463.88, z1=228.25, r=2,
	                           depart_func="depart_threecount_int", arrive_func="arrive_threecount_int",
						       message="USE_TRIGGER_LOBBY" },
	threecount_lobby       = { x0= 1166.22, y0=1419.70, z0= 31.77, x1 =1169.10, y1=1427.40, z1= 31.87, next="threecount_int"  , r=2,
	                           depart_func="depart_storyline_check", arrive_func="arrive_threecount_lobby",
						       message="USE_TRIGGER_PENTHOUSE" },
	-- THREE COUNT HELIPAD ELEVATORS
	-- FUNCTIONAL CRIB
	threecount_heli_int    = { x0= 1203.65, y0=1460.95, z0=228.15, x1= 1206.51, y1=1463.89, z1=228.25, r=6,
	                           depart_func="depart_threecount_heli_int", arrive_func="arrive_threecount_int",
							   message="USE_TRIGGER_HELI" },
	threecount_heli_pad    = { x0= 1198.59, y0=1437.70, z0=443.40, x1= 1202.59, y1=1442.30, z1=444.25, next="threecount_heli_int" , r=4,
	                           arrive_func="arrive_threecount_ext",
							   message="VCUST_RETURN_TO_CRIB" },
	threecount_heli_roof   = { x0= 1169.88, y0=1453.66, z0= 99.15, x1= 1172.88, y1=1456.66, z1= 99.25, next="threecount_heli_int" , r=4,
	                           depart_func="depart_storyline_check", arrive_func="arrive_threecount_ext",
							   message="VCUST_RETURN_TO_CRIB" }

}

function teleport_if_at_elevator()
	for name, stop in pairs(elevator_stops) do
		local x, z, y = get_object_pos(LOCAL_PLAYER)
		if x > stop.x0 and x < stop.x1 and y > stop.y0 and y < stop.y1 and z > stop.z0 and z < stop.z1 then
            local next_stop
			-- Figure out if and where to go next
			if stop.depart_func then
				next_stop = _G[stop.depart_func]()
				if not next_stop then
					return false
				elseif next_stop == true then
					next_stop = stop.next
				end
            else
				next_stop = stop.next
			end
			local next = elevator_stops[next_stop]
			-- Determine the target coordinates
			local tx, ty, tz = (next.x0 + next.x1) / 2, (next.y0 + next.y1) / 2, (next.z0 + next.z1) / 2
			if next.x and next.y and next.z then
				tx, ty, tz = next.x, next.y, next.z
			end
			-- Do the teleport
			mission_start_fade_out()
			if next.arrive_func then
				_G[next.arrive_func]()
			end
			teleport_to_object(LOCAL_PLAYER, "nw_qm_nav", false, true, tx - ctele_Posx, tz - ctele_Posz, ty - ctele_Posy, false, next.r)
			while teleport_check_done(LOCAL_PLAYER) == false do
				thread_yield()
			end
			mission_start_fade_in()
			return true
		end
	end
	return false
end

-- ****************************************************************************************************
-- END WORKING ELEVATORS MOD THREAD
-- ****************************************************************************************************


-- ****************************************************************************************************
-- BEGIN VANILLA VARS
-- ****************************************************************************************************

-- Gameplay Choice IDs -
-- these should match values from level_scripts.cpp
MISSION_06_CHOICE = 0
MISSION_22_CHOICE = 1
MISSION_21_CHOICE = 2

M06_CHOICE_BLOWN_TOWER = true;
M06_CHOICE_BRANDED_TOWER = false;
M22_CHOICE_KILLBANE_KILL = true;
M22_CHOICE_KILLBANE_ESCAPE = false;
M21_CHOICE_KILLBANE_UNMASKED = true;
M21_CHOICE_KILLBANE_NOT_UNMASKED = false;

QOC_ASHA				= 0
QOC_BEN_KING		= 1
QOC_CID				= 2
QOC_JOHNNY_GAT		= 3
QOC_KINZIE			= 4
QOC_MATT_MILLER	= 5
QOC_PIERCE			= 6
QOC_VP				= 7
QOC_SHAUNDI			= 8
QOC_SR2_SHAUNDI	= 9

SR3_CITY_CONTACTS = {
	{ type = QOC_ASHA,			npc = "Asha_01",			trigger = "asha_trigger"			},
	{ type = QOC_BEN_KING,		npc = "Ben_King_01",		trigger = "ben_king_trigger"		},
	{ type = QOC_CID,				npc = "CID_01",			trigger = "cid_trigger"				},
	{ type = QOC_JOHNNY_GAT,	npc = "Johnny_Gat_01",	trigger = "johnny_gat_trigger"	},
	{ type = QOC_KINZIE,			npc = "Kinzie_01",		trigger = "kinzie_trigger"			},
	{ type = QOC_MATT_MILLER,	npc = "Matt_Miller_01",	trigger = "matt_miller_trigger"	},
	{ type = QOC_PIERCE,			npc = "Pierce_01",		trigger = "pierce_trigger"			},
	{ type = QOC_SHAUNDI,		npc = "Shaundi_01",		trigger = "shaundi_trigger"		},
	{ type = QOC_VP,				npc = "VP_01",				trigger = "vp_trigger"				},
	{ type = QOC_SR2_SHAUNDI,	trigger = "shaduni_sr2_trigger" },
}

-- ****************************************************************************************************
-- END VANILLA VARS
-- ****************************************************************************************************


-- ****************************************************************************************************
-- BEGIN SR3_CITY FUNCTIONS
-- THOSE ARE RESPONSIBLE FOR LOADING ALL THREADS, BE CAREFUL WITH THOSE!
-- ****************************************************************************************************

function sr3_city_init()
	group_create( "sr3_weapons", false)
	quest_log_configure_contact_triggers( SR3_CITY_CONTACTS )
end


function sr3_city_main()
	reset_all_zones()
	Misc_Handle = thread_new("misc_thread")
	Keycombo_Handle = thread_new("keycombo_thread")
	Effects_Handle = thread_new("effects_thread")
	EAM_Handle = thread_new("eam_thread")
	Crib_Handle = thread_new("crib_thread")
	Elevator_Handle = thread_new("elevator_thread")
	Custom_Radio_Handle = thread_new("custom_radio_monitor")
	pcall(Create_Radio_Station_Tables(randomize_music))
end

-- ****************************************************************************************************
-- END SR3_CITY FUNCTIONS
-- ****************************************************************************************************


-- ****************************************************************************************************
-- EVERYTHING BELOW IS FROM VANILLA GAME
-- ****************************************************************************************************

function sr3_city_init_client()
	quest_log_configure_contact_triggers( SR3_CITY_CONTACTS )
end

function sr3_city_main_client()
end

function mm_1_2_coop_skip( from_gamesave )
	player_unlock_super_power(6) -- Jump
	player_unlock_super_power(5) -- Sprint
end

function mm_1_3_coop_skip( from_gamesave )
	player_unlock_super_power(3) -- Blast
	unlockable_unlock("ragdoll_recovery") -- Air Recovery
end

function m05_coop_skip( from_gamesave )
	player_unlock_super_power(0) -- Telekinesis
end

function mm_4_1_coop_skip( from_gamesave )
	player_unlock_super_power(1) -- Stomp
end

function m14_coop_skip( from_gamesave )
	player_unlock_super_power(2) -- Buff
end

function m15_3_coop_skip( from_gamesave )
	player_unlock_super_power(4) -- Shield
	player_unlock_super_power(7) -- DFA
end

function mm_1_3_setup()

	-- NZ: Reset hotspot in case player abandons mission
	hotspot_reset("Hotspot_NW")

end


--===========================GLOBALS====================================
-- tables of 'line played' flags for each homie dialogue line
--======================================================================
SR3_CITY_globals = {

		-- the max number of times you'll get a modal dialogue scene with someone within the same ship visit
		num_talks_allowed = 3,

		
		--ship dialogue flags; table of flags for each line situation
		said_asha_line = {
						benking = false,
						cid = false,
						keithdavid = false,
						kinzie = false,
						pierce = false,
						shaundi = false,
						matt = false,
						gat = false,
		},
		said_cid_line = {
						asha = false,
						benking = false,
						keithdavid = false,
						kinzie = false,
						pierce = false,
						shaundi = false,
						matt = false,
						gat = false,
		},
		said_johnny_line = {
						asha = false,
						benking = false,
						cid = false,						
						keithdavid = false,
						kinzie = false,
						pierce = false,
						shaundi = false,
						matt = false,
						gat = true,
		},		
		said_king_line = {
						asha = false,
						cid = false,						
						keithdavid = false,
						kinzie = false,
						pierce = false,
						shaundi = false,
						matt = false,
						gat = false,
		},
		said_kinzie_line = {
						asha = false,
						benking = false,
						cid = false,						
						keithdavid = false,
						kinzie = true,
						pierce = false,
						shaundi = false,
						matt = false,
						gat = false,
		},		
		said_matt_line = {
						asha = false,
						benking = false,
						cid = false,						
						keithdavid = false,
						kinzie = false,
						pierce = false,
						shaundi = false,
						matt = true,
						gat = false,
		},		
		said_pierce_line = {
						asha = false,
						benking = false,
						cid = false,						
						keithdavid = false,
						kinzie = false,
						shaundi = false,
						matt = false,
						gat = false,
		},		
		said_shaundi_line = {
						asha = false,
						benking = false,
						cid = false,						
						keithdavid = false,
						kinzie = false,
						pierce = false,
						matt = false,
						gat = false,
		},
		said_shaundi_sr2_line = {
						asha = false,
						benking = false,
						cid = false,						
						keithdavid = false,
						kinzie = false,
						pierce = false,
						shaundi = false,
						matt = false,
						gat = false,
		},
		said_vp_line = {
						asha = false,
						benking = false,
						cid = false,						
						kinzie = false,
						pierce = false,
						shaundi = false,
						matt = false,
						gat = false,
		},
		said_earth_line = {
						asha = false,
						benking = false,
						cid = false,						
						keithdavid = false,
						kinzie = false,
						pierce = false,
						shaundi = false,
						matt = false,
						gat = false,
		},		
		said_key_line = {
						asha = false,
						benking = false,
						cid = false,						
						keithdavid = false,
						kinzie = false,
						pierce = false,
						shaundi = false,
						matt = false,
						gat = false,
		},
		said_kinzie_kidnapped_line = {
						asha = false,
						benking = false,
						cid = false,						
						pierce = false,
						shaundi = false,
						matt = false,
						gat = false,
		},
		said_kinzie_rescued_line = {
						asha = false,
						benking = false,
						cid = false,						
						keithdavid = false,
						kinzie = false,
						pierce = false,
						shaundi = false,
						matt = false,
						gat = false,
		},
		said_loyalty_complete_line = {
						asha = false,
						benking = false,
						keithdavid = false,
						kinzie = false,
						matt = false,
						pierce = false,
						shaundi = false,
						cid = true,
						gat = true,
		},
		said_mech_line = {
						asha = false,
						benking = false,
						cid = false,						
						keithdavid = false,
						kinzie = false,
						pierce = false,
						shaundi = false,
						matt = false,
						gat = false,
		},
		said_ship_name_line = {
						asha = false,
						benking = false,
						cid = false,						
						keithdavid = false,
						kinzie = false,
						pierce = false,
						shaundi = false,
						matt = false,
						gat = false,
		},
		said_working_on_mech_line = {
						kinzie = false,
						asha = true,
						benking = true,
						cid = true,						
						keithdavid = true,
						pierce = true,
						shaundi = true,
						matt = true,
						gat = false,
		},
	}


SR3_CITY_CRIBSHIP_num_talks = {

	-- number of times you talked to an NPC (in a modal sequence) on a given ship visit
	num_benking_talks = 0,
	num_cid_talks = 0,
	num_keithdavid_talks = 0,
	num_kinzie_talks = 0,
	num_pierce_talks = 0,
	num_shaundi_talks = 0,
	num_matt_talks = 0,
	num_gat_talks = 0,
	num_asha_talks = 0,
	
}

SR3_CITY_CRIBSHIP_sex_flags = {
		
	-- sex flags
	flag_benking_sex = false,
	flag_cid_sex = false,
	flag_keithdavid_sex = false,
	flag_kinzie_sex = false,
	flag_pierce_sex = false,
	flag_shaundi_sex = false,
	flag_matt_sex = false,
	flag_gat_sex = false,
	flag_asha_sex = false,

}
	
--===========================TRIGGERS===================================
--
--======================================================================
SR3_CITY_trigger = {
		--<trigger_name> = {
		--           name = "johnnygat_con_trig_lean",
		--           hit = false,
		--  (optional)callback = "sr3_city_function_name_cb"
		--(optional)marker = TRIGGER_LOCATION or TRIGGER_USE or custom or don't include for no marker
		--  (optional)waypoint = true,
		--  (optional)teleport_to = {
		--             host = "host_nav",
		--             client = "client_nav" 
		--},                          
		--(optional)conversation = M_RAIL_convo.convo_name  -- play a conversation
		--},
						
	talk_to_gat_lean = {
					name = "johnnygat_con_trig_lean",
					hit = false,
					callback = "sr3_city_talk_to_gat",
	},
	talk_to_gat_crates = {
					name = "johnnygat_con_trig_crates",
					hit = false,
					callback = "sr3_city_talk_to_gat",
	},	
	talk_to_gat_chair = {
					name = "johnnygat_con_trig_purplechair",
					hit = false,
					callback = "sr3_city_talk_to_gat",
	},
	talk_to_shaundi_stand = {
					name = "shaundi_con_trig_stand",
					hit = false,
					callback = "sr3_city_talk_to_shaundi",
	},
	talk_to_shaundi_catwalk = {
					name = "shaundi_con_trig_catwalk",
					hit = false,
					callback = "sr3_city_talk_to_shaundi",
	},
	talk_to_shaundi_ctrl = {
					name = "shaundi_con_trig_controlroom",
					hit = false,
					callback = "sr3_city_talk_to_shaundi",
	},
	talk_to_shaundi_sit = {
					name = "shaundi_con_trig_sit",
					hit = false,
					callback = "sr3_city_talk_to_shaundi",
	},	
	talk_to_kinzie_bag = {
					name = "kinzie_con_trig_beanbag",
					hit = false,
					callback = "sr3_city_talk_to_kinzie",
	},
	talk_to_kinzie_control = {
					name = "kinzie_con_trig_controlroom",
					hit = false,
					callback = "sr3_city_talk_to_kinzie",
	},	
	talk_to_kinzie_mech = {
					name = "kinzie_con_trig_mech",
					hit = false,
					callback = "sr3_city_talk_to_kinzie",
	},	
	talk_to_asha_bag = {
					name = "asha_con_trig_gymbag",
					hit = false,
					callback = "sr3_city_talk_to_asha",
	},
	talk_to_asha_bench = {
					name = "asha_con_trig_benchpress",
					hit = false,
					callback = "sr3_city_talk_to_asha",
	},	
	talk_to_asha_stretch = {
					name = "asha_con_trig_stretching",
					hit = false,
					callback = "sr3_city_talk_to_asha",
	},	
	talk_to_ben_lean = {
					name = "benking_con_trig_lean",
					hit = false,
					callback = "sr3_city_talk_to_benking",
	},
	talk_to_ben_chair = {
					name = "benking_con_trig_chair",
					hit = false,
					callback = "sr3_city_talk_to_benking",
	},
	talk_to_ben_toilet = {
					name = "benking_con_trig_toilet",
					hit = false,
					callback = "sr3_city_talk_to_benking",
	},	
	talk_to_cid = {
					name = "cid_con_trig_sexroom",
					hit = false,
					callback = "sr3_city_talk_to_cid",
	},
	talk_to_matt_couch = {
					name = "mattmiller_con_trig_couch",
					hit = false,
					callback = "sr3_city_talk_to_matt",
	},
	talk_to_matt_tv = {
					name = "mattmiller_con_trig_tv",
					hit = false,
					callback = "sr3_city_talk_to_matt",
	},
	talk_to_matt_crates = {
					name = "mattmiller_con_trig_crates",
					hit = false,
					callback = "sr3_city_talk_to_matt",
	},
	talk_to_matt_dep = {
					name = "mattmiller_con_trig_depressed",
					hit = false,
					callback = "sr3_city_talk_to_matt",
	},	
	talk_to_pierce = {
					name = "pierce_con_trig_couch",
					hit = false,
					callback = "sr3_city_talk_to_pierce",
	},
	talk_to_pierce_egg = {
					name = "pierce_con_trig_eggchair",
					hit = false,
					callback = "sr3_city_talk_to_pierce",
	},	
	talk_to_pierce_pool = {
					name = "pierce_con_trig_pooltable",
					hit = false,
					callback = "sr3_city_talk_to_pierce",
	},	
	talk_to_vp_vport = {
					name = "vp_con_trig_stand",
					hit = false,
					callback = "sr3_city_talk_to_vp",
	},
	talk_to_vp_cat = {
					name = "vp_con_trig_catwalk",
					hit = false,
					callback = "sr3_city_talk_to_vp",
	},
	talk_to_vp_chair = {
					name = "vp_con_trig_chair",
					hit = false,
					callback = "sr3_city_talk_to_vp",
	},	
	
	--sex triggers
	asha_sex = {
					name = "asha_sex_trigger",
					hit = false,
					callback = "sr3_city_asha_sex",
	},
	ben_king_sex = {
					name = "ben_king_sex_trigger",
					hit = false,
					callback = "sr3_city_benking_sex",
	},
	cid_sex = {
					name = "cid_sex_trigger",
					hit = false,
					callback = "sr3_city_cid_sex",
	},
	gat_sex = {
					name = "johnny_gat_sex_trigger",
					hit = false,
					callback = "sr3_city_gat_sex",
	},
	kinzie_sex = {
					name = "kinzie_sex_trigger",
					hit = false,
					callback = "sr3_city_kinzie_sex",
	},
	matt_sex = {
					name = "matt_miller_sex_trigger",
					hit = false,
					callback = "sr3_city_matt_sex",
	},
	pierce_sex = {
					name = "pierce_sex_trigger",
					hit = false,
					callback = "sr3_city_pierce_sex",
	},
	shaundi_sex = {
					name = "shaundi_sex_trigger",
					hit = false,
					callback = "sr3_city_shaundi_sex",
	},	
	vp_sex = {
					name = "vp_sex_trigger",
					hit = false,
					callback = "sr3_city_vp_sex",
	},
	
--[[	hack_cargo = {
					name = "hack_sim1_trig",
					hit = false,
					use_nav = "hack_sim1_nav",
					use_anim = "m24 computer hack",					
					callback = "sr3_city_do_hack",
	},	
]]	
	-- txt adventure computer
	start_txt_adventure = {
					name = "Text_Adventure_Trigger",
					hit = false,
					use_nav = "txt_adventure_nav",
					use_anim = "m24 computer hack",
					callback = "ship_start_text_adventure_cb",
					--conversation = SR3_CITY_convo.Matt_Talk_01
	},
}



SR3_CITY_ship_action_nodes = {

	asha = {
					{
						-- bag lean
						name = "asha_baglean", -- "asha_baglean"
						talk_trig = "asha_con_trig_gymbag",
						sex_trig = "asha_sex_trigger",
						contact_trig = "asha_trigger",
						sex_nav = "asha_sex_nav",
					},	
					{
						-- bench press
						name = "asha_benchsit", -- "asha_benchsit" "asha_bench_shp"
						talk_trig = "asha_con_trig_benchpress", -- "asha_con_trig_benchpress"
						sex_trig = "asha_sex_trigger",
						contact_trig = "asha_trigger",
						sex_nav = "asha_sex_nav",
					},	
					{
						-- on floor stretching
						name = "asha_shp_stretch", -- "asha_shp_stretch" "asha_stretch_ship" "Situps_Asha"
						talk_trig = "asha_con_trig_stretching", -- "asha_con_trig_stretching"
						sex_trig = "asha_sex_trigger",
						contact_trig = "asha_trigger",
						sex_nav = "asha_sex_nav",
					},
	},
	benking = {
					{
						-- leaning on table
						name = "King_leaning", -- "King_leaning"
						talk_trig = "benking_con_trig_lean",
						sex_trig = "ben_king_sex_trigger",
						contact_trig = "ben_king_trigger",
						sex_nav = "ben_king_sex_nav",
					},	
					{
						-- sitting in purple chair
						name = "King_ship_pchair", -- "King_ship_pchair"
						talk_trig = "benking_con_trig_chair",
						sex_trig = "ben_king_sex_trigger",
						contact_trig = "ben_king_trigger",
						sex_nav = "ben_king_sex_nav",
					},	
					{
						-- space toilet
						name = "pierce_shp_toilet", -- "pierce_shp_toilet"
						talk_trig = "benking_con_trig_toilet",
						sex_trig = "ben_king_sex_trigger",
						contact_trig = "ben_king_trigger",
						sex_nav = "benking_sex_nav_toilet",
					},
	},
	cid = {
					{
						-- sex room
						name = "Ship_Cid_Float",
						talk_trig = "cid_con_trig_sexroom",
						sex_trig = "cid_sex_trigger",
						contact_trig = "cid_trigger",
						sex_nav = "cid_sex_nav",
					},
	},
	gat = {
					{
						-- leaning on locker w/knife
						name = "Ship_Gat_Locker", -- "Ship_Gat_Locker"
						talk_trig = "johnnygat_con_trig_lean", -- "johnnygat_con_trig_lean"
						sex_trig = "johnny_gat_sex_trigger",
						contact_trig = "johnny_gat_trigger",
						sex_nav = "johnny_gat_sex_nav",
					},	
					{
						-- sitting on crate cleaning gun
						name = "gat ship gunclean", -- "gat ship gunclean"
						talk_trig = "johnnygat_con_trig_crates", -- johnnygat_con_trig_crates
						sex_trig = "johnny_gat_sex_trigger",
						contact_trig = "johnny_gat_trigger",
						sex_nav = "johnny_gat_sex_nav",
					},	
					{
						-- sitting in purple chair
						name = "Ship_Gat_sit", -- "Ship_Gat_sit"
						talk_trig = "johnnygat_con_trig_purplechair", -- johnnygat_con_trig_purplechair
						sex_trig = "johnny_gat_sex_trigger",
						contact_trig = "johnny_gat_trigger",
						sex_nav = "johnny_gat_sex_nav",
					},
	},	
	kinzie = {
					{
						-- working on mech
						name = "shp_kinz_mchbox", -- "shp_kinz_mchbox" 
						talk_trig = "kinzie_con_trig_mech", -- "kinzie_con_trig_mech",
						sex_trig = "kinzie_sex_trigger",
						contact_trig = "kinzie_trigger",
						sex_nav = "kinzie_sex_nav_mech", -- "kinzie_sex_nav_mech",
					},	
					{
						-- nemo chair
						name = "kinzie_nemo", -- "kinzie_nemo"
						talk_trig = nil,
						sex_trig = nil,
						contact_trig = nil,
						sex_nav = nil,
					},	
					{
						-- control room
						name = "Kinz_shp_computer", -- "Kinz_shp_computer"
						talk_trig = "kinzie_con_trig_controlroom", -- "kinzie_con_trig_controlroom"
						sex_trig = "kinzie_sex_trigger",
						contact_trig = "kinzie_trigger",
						sex_nav = "kinzie_sex_nav_controlroom", -- "kinzie_sex_nav_controlroom"
					},					
					{
						-- typing in beanbag chair
						name = "kinzie_typing", -- "kinzie_typing"
						talk_trig = "kinzie_con_trig_beanbag", -- "kinzie_con_trig_beanbag",
						sex_trig = "kinzie_sex_trigger",
						contact_trig = "kinzie_trigger",
						sex_nav = "kinzie_sex_nav", -- "kinzie_sex_nav"
					},
					{
						-- tube
						name = "shp_kinzie_tiptoe", -- "shp_kinzie_tiptoe"
						talk_trig = "kinzie_con_trig_beanbag", -- "kinzie_con_trig_beanbag",
						sex_trig = "kinzie_sex_trigger",
						contact_trig = "kinzie_trigger",
						sex_nav = "kinzie_sex_nav", -- "kinzie_sex_nav"
					},
	},
	matt = {
					{
						-- depressed sitting at computer
						name = "shp_matt_computer", -- "shp_matt_computer"
						talk_trig = "mattmiller_con_trig_depressed", -- "mattmiller_con_trig_depressed",
						sex_trig = "matt_miller_sex_trigger",
						contact_trig = "matt_miller_trigger",
						sex_nav = "mattmiller_sex_nav_depressed", -- "mattmiller_sex_nav_depressed",
					},	
					{
						-- couch w/game
						name = "Matt_ship_couch", -- "Matt_ship_couch"
						talk_trig = "mattmiller_con_trig_couch", -- mattmiller_con_trig_couch
						sex_trig = "matt_miller_sex_trigger",
						contact_trig = "matt_miller_trigger",
						sex_nav = "matt_miller_sex_nav", -- matt_miller_sex_nav
					},	
					{
						-- standing at tv
						name = "Matt_tv", --"Matt_tv"
						talk_trig = "mattmiller_con_trig_tv", -- "mattmiller_con_trig_tv"
						sex_trig = "matt_miller_sex_trigger",
						contact_trig = "matt_miller_trigger",
						sex_nav = "matt_miller_sex_nav", -- matt_miller_sex_nav
					},	
					{
						-- sitting on crates fixing electronics
						name = "Matt_shp_crates", --"Matt_shp_crates"
						talk_trig = "mattmiller_con_trig_crates", -- mattmiller_con_trig_crates
						sex_trig = "matt_miller_sex_trigger",
						contact_trig = "matt_miller_trigger",
						sex_nav = "mattmiller_sex_nav_crates", -- mattmiller_sex_nav_crates
					},
	},	
	pierce = {
					{
						-- laying on couch
						name = "Pierce_couch", -- "Pierce_couch"
						talk_trig = "pierce_con_trig_couch", -- pierce_con_trig_couch
						sex_trig = "pierce_sex_trigger",
						contact_trig = "pierce_trigger",
						sex_nav = "pierce_sex_nav",
					},	
					{
						-- pool table
						name = "Pirc_ship_pltable", -- "Pirc_ship_pltable"
						talk_trig = "pierce_con_trig_pooltable", -- pierce_con_trig_pooltable
						sex_trig = "pierce_sex_trigger",
						contact_trig = "pierce_trigger",
						sex_nav = "pierce_sex_nav",
					},	
					{
						-- egg chair
						name = "Peirce_reading", -- "Peirce_reading"
						talk_trig = "pierce_con_trig_eggchair", -- pierce_con_trig_eggchair
						sex_trig = "pierce_sex_trigger",
						contact_trig = "pierce_trigger",
						sex_nav = "pierce_sex_nav",
					},
	},	
	shaundi = {
					{
						-- control room
						name = "Shp_shndi_pTble", -- "Shp_shndi_pTble"
						talk_trig = "shaundi_con_trig_controlroom", -- "shaundi_con_trig_controlroom",
						sex_trig = "shaundi_sex_trigger",
						contact_trig = "shaundi_trigger",
						sex_nav = "shaundi_sex_nav_controlroom", -- "shaundi_sex_nav_controlroom",
					},	
					{
						-- depressed sitting on catwalk
						name = "Shndi_railsit", -- "Shndi_railsit"
						talk_trig = "shaundi_con_trig_catwalk", -- "shaundi_con_trig_catwalk",
						sex_trig = "shaundi_sex_trigger",
						contact_trig = "shaundi_trigger",
						sex_nav = "shaundi_sex_nav_catwalk", -- "shaundi_sex_nav_catwalk",
					},	
					{
						-- standing on bridge
						name = "shaundi_shp_stnd", -- "shaundi_shp_stnd"
						talk_trig = "shaundi_con_trig_stand", -- shaundi_con_trig_stand
						sex_trig = "shaundi_sex_trigger",
						contact_trig = "shaundi_trigger",
						sex_nav = "shaundi_sex_nav",
					},
					{
						-- in/near chair on bridge
						name = "Shandi_bridge_sit", -- "Shandi_bridge_sit"
						talk_trig = "shaundi_con_trig_sit", -- shaundi_con_trig_sit
						sex_trig = "shaundi_sex_trigger",
						contact_trig = "shaundi_trigger",
						sex_nav = "shaundi_sex_nav",
					},
	},		
	vp = {
					{
						-- standing on catwalk
						name = "kiethD_shp_catwlk", -- "kiethD_shp_catwlk"
						talk_trig = "vp_con_trig_catwalk", -- "vp_con_trig_catwalk"
						sex_trig = "vp_sex_trigger",
						contact_trig = "vp_trigger",
						sex_nav = nil,
					},	
					{
						-- sitting in chair on bridge
						name = "Keith_cmpter_shp", -- "Keith_cmpter_shp"
						talk_trig = "vp_con_trig_chair", -- vp_con_trig_chair
						sex_trig = "vp_sex_trigger",
						contact_trig = "vp_trigger",
						sex_nav = nil,
					},	
					{
						-- standing in bridge looking thru viewfinder
						name = "shp_keith_vport", -- "shp_keith_vport"
						talk_trig = "vp_con_trig_stand", -- vp_con_trig_stand
						sex_trig = "vp_sex_trigger",
						contact_trig = "vp_trigger",
						sex_nav = nil,
					},	
	},		
}


--========================CONVERSATIONS=================================
-- have around 200 lines, all of which play outside a mission context and mostly in modal sequences, so no convo table currently
-- lines play as individual persona lines
-- however if we find we need a convo table added let me (alvan) know
--
--======================================================================

SR3_CITY_convo = {}

--called from do_dialogue; decides what line to play based on player progression and returns string for that line situation
function get_line_situation( npc )

	if ( ( npc == "asha" and mission_is_complete( "mol_jb_01" ) and SR3_CITY_globals.said_loyalty_complete_line[npc] == false ) or
		( npc == "benking" and mission_is_complete( "mol_bk_01" ) and SR3_CITY_globals.said_loyalty_complete_line[npc] == false ) or
		( npc == "gat" and mission_is_complete( "mol_jg_01" ) and SR3_CITY_globals.said_loyalty_complete_line[npc] == false ) or
		( npc == "kinzie" and mission_is_complete( "mol_kz_01" ) and SR3_CITY_globals.said_loyalty_complete_line[npc] == false ) or
		( npc == "matt" and mission_is_complete( "mol_mm_01" ) and SR3_CITY_globals.said_loyalty_complete_line[npc] == false ) or
		( npc == "pierce" and mission_is_complete( "mol_p01" ) and SR3_CITY_globals.said_loyalty_complete_line[npc] == false ) or
		( npc == "shaundi" and mission_is_complete( "mol_sh01" ) and SR3_CITY_globals.said_loyalty_complete_line[npc] == false ) ) then
		
		SR3_CITY_globals.said_loyalty_complete_line[npc] = true	
		return "ship_loyalty_complete"

	elseif mission_is_complete( "m19" ) and not mission_is_complete( "m22-1" ) and (SR3_CITY_globals.said_key_line[npc] == false) then
		--message("key line", 2.0, false)
		SR3_CITY_globals.said_key_line[npc] = true	
		return "ship_getting_key_ready"
		
	elseif mission_is_complete( "m19" ) and (SR3_CITY_globals.said_kinzie_rescued_line[npc] == false) then
		--message("kinzie rescued line", 2.0, false)
		SR3_CITY_globals.said_kinzie_rescued_line[npc] = true	
		return "ship_kinzie_rescued"
		
	elseif mission_is_complete( "m16" ) and not mission_is_complete( "m19" ) and (SR3_CITY_globals.said_kinzie_kidnapped_line[npc] == false) then
		--message("kinzie kidnapped line", 2.0, false)
		SR3_CITY_globals.said_kinzie_kidnapped_line[npc] = true	
		return "ship_kinzie_kidnapped"
		
	elseif mission_is_complete( "m15_3" ) and (SR3_CITY_globals.said_johnny_line[npc] == false) then
		--message("johnny line", 2.0, false)
		SR3_CITY_globals.said_johnny_line[npc] = true
		return "ship_comment_on_johnny"
		
	elseif mission_is_complete( "m11" ) and (SR3_CITY_globals.said_asha_line[npc] == false) then
		--message("asha line", 2.0, false)
		SR3_CITY_globals.said_asha_line[npc] = true	
		return "ship_comment_on_asha"
		
	elseif mission_is_complete( "m10" ) and (SR3_CITY_globals.said_king_line[npc] == false) then
		--message("king line", 2.0, false)
		SR3_CITY_globals.said_king_line[npc] = true	
		return "ship_comment_on_king"
		
	elseif mission_is_complete( "m09" ) and (SR3_CITY_globals.said_pierce_line[npc] == false) then
		--message("pierce line", 2.0, false)
		SR3_CITY_globals.said_pierce_line[npc] = true	
		return "ship_comment_on_pierce"
		
	elseif mission_is_complete( "m08" ) and (SR3_CITY_globals.said_shaundi_line[npc] == false) then	
		--message("shaundi line", 2.0, false)
		SR3_CITY_globals.said_shaundi_line[npc] = true	
		return "ship_comment_on_shaundi"
		
	elseif mission_is_complete( "m08" ) and (SR3_CITY_globals.said_shaundi_sr2_line[npc] == false) then
		--message("shaundi sr2 line", 2.0, false)
		SR3_CITY_globals.said_shaundi_sr2_line[npc] = true	
		return "ship_comment_on_shaundi_sr2"
		
	elseif mission_is_complete( "m08" ) and (SR3_CITY_globals.said_cid_line[npc] == false) then	
		--message("cid line", 2.0, false)
		SR3_CITY_globals.said_cid_line[npc] = true	
		return "ship_comment_on_cid"
		
	elseif mission_is_complete( "m07" ) and (SR3_CITY_globals.said_mech_line[npc] == false) then
		--message("mech line", 2.0, false)
		SR3_CITY_globals.said_mech_line[npc] = true	
		return "ship_mech_comment"
		
	elseif mission_is_complete( "m03" ) and (SR3_CITY_globals.said_earth_line[npc] == false) then
		--message("earth line", 2.0, false)
		SR3_CITY_globals.said_earth_line[npc] = true
		return "ship_earth_blew_up"
		
	elseif mission_is_complete( "m03" ) and (SR3_CITY_globals.said_vp_line[npc] == false) then	
		--message("vp line", 2.0, false)
		SR3_CITY_globals.said_vp_line[npc] = true
		return "ship_comment_on_vp"		
		
	elseif mission_is_complete( "m03" ) and (SR3_CITY_globals.said_kinzie_line[npc] == false) then
		--message("kinzie line", 2.0, false)
		SR3_CITY_globals.said_kinzie_line[npc] = true
		return "ship_comment_on_kinzie"
	
	else
		--message("generic line", 2.0, false)
		return "ship_generic_comment"
		
	end
end


--do modal dialogue sequence w/camera cut; selects line to play, sets camera, plays line etc.
function do_dialogue( npc_flag, npc_name )
	local count = 0
	local situation
	
	--figure out which line to play
	situation = get_line_situation( npc_flag )
	
	--setup, play
	player_controls_disable( LOCAL_PLAYER )
	camera_set_target( npc_name, true, SYNC_LOCAL )
	audio_play_persona_line( npc_name, situation )
	
	--wait till line is done playing or 20 seconds have passed
	while ( audio_persona_line_playing( npc_name ) and count <= 80 ) do
		delay(0.25)
		count = count + 1
	end
	
	--cleanup
	player_controls_enable( LOCAL_PLAYER )
	camera_revert_target( true, SYNC_LOCAL )
end


--dialogue wrapper function
function do_dialogue_wrapper( talk_trig, sex_trig, num_talks, npc_flag, npc_name )
	local count = 0
	
	SR3_CITY_CRIBSHIP_num_talks[num_talks] = SR3_CITY_CRIBSHIP_num_talks[num_talks] + 1
	trigger_enable( talk_trig, false )
	trigger_enable( sex_trig, false )
	
	if ( SR3_CITY_CRIBSHIP_num_talks[num_talks] <= SR3_CITY_globals.num_talks_allowed) then
		--do modal dialogue sequence
		character_hide( LOCAL_PLAYER ) 
		do_dialogue( npc_flag, npc_name )
		character_show( LOCAL_PLAYER ) 
	else
		--do non-modal busy line
		audio_play_persona_line( npc_name, "ship_generic_comment" )
		--audio_play_persona_line( npc_name, "ship_busy" )
		while ( audio_persona_line_playing( npc_name ) and count <= 50 ) do
			delay(0.25)
			count = count + 1
		end
	end
	
	trigger_enable( talk_trig, true )
	trigger_enable( sex_trig, true )
end


--dialogue trigger callbacks
function sr3_city_talk_to_kinzie( human, talk_trig )
	do_dialogue_wrapper( talk_trig, SR3_CITY_trigger.kinzie_sex.name, "num_kinzie_talks", "kinzie", "Kinzie_01" )
	--do_dialogue_wrapper( SR3_CITY_trigger.talk_to_kinzie.name, SR3_CITY_trigger.kinzie_sex.name, "num_kinzie_talks", "kinzie", "Kinzie_01", "kinzie_dlg_aft_player01", "kinzie_dlg_aft_cam02a", "kinzie_dlg_aft_cam02b")
end

function sr3_city_talk_to_pierce( human, talk_trig )
	do_dialogue_wrapper( talk_trig, SR3_CITY_trigger.pierce_sex.name, "num_pierce_talks", "pierce", "Pierce_01" )
	--do_dialogue_wrapper( SR3_CITY_trigger.talk_to_pierce.name, SR3_CITY_trigger.pierce_sex.name, "num_pierce_talks", "pierce", "Pierce_01", "pierce_dlg_pool_player01", "pierce_dlg_pool_cam01a", "pierce_dlg_pool_cam01b")
end

function sr3_city_talk_to_shaundi( human, talk_trig )
	do_dialogue_wrapper( talk_trig, SR3_CITY_trigger.shaundi_sex.name, "num_shaundi_talks", "shaundi", "Shaundi_01" )
	--do_dialogue_wrapper( SR3_CITY_trigger.talk_to_shaundi.name, SR3_CITY_trigger.shaundi_sex.name, "num_shaundi_talks", "shaundi", "Shaundi_01", "shaundi_dlg_brdg_player01", "shaundi_dlg_brdg_cam02a", "shaundi_dlg_brdg_cam02b")
end

function sr3_city_talk_to_asha( human, talk_trig )
	do_dialogue_wrapper( talk_trig, SR3_CITY_trigger.asha_sex.name, "num_asha_talks", "asha", "Asha_01" )
	--do_dialogue_wrapper( SR3_CITY_trigger.talk_to_asha.name, SR3_CITY_trigger.asha_sex.name, "num_asha_talks", "asha", "Asha_01", "asha_dlg_bag_player01", "asha_dlg_bag_cam01a", "asha_dlg_bag_cam01b")
end

function sr3_city_talk_to_benking( human, talk_trig )
	do_dialogue_wrapper( talk_trig, SR3_CITY_trigger.ben_king_sex.name, "num_benking_talks", "benking", "Ben_King_01" )
	--do_dialogue_wrapper( SR3_CITY_trigger.talk_to_ben.name, SR3_CITY_trigger.ben_king_sex.name, "num_benking_talks", "benking", "Ben_King_01", "benking_dlg_messhall_player01", "benking_dlg_messhall_cam01a", "benking_dlg_messhall_cam01b")
end

function sr3_city_talk_to_cid( human, talk_trig )
	do_dialogue_wrapper( talk_trig, SR3_CITY_trigger.cid_sex.name, "num_cid_talks", "cid", "CID_01" )
	--do_dialogue_wrapper( SR3_CITY_trigger.talk_to_cid.name, SR3_CITY_trigger.cid_sex.name, "num_cid_talks", "cid", "CID_01", "cid_dlg_storage_player01", "cid_dlg_storage_cam01a", "cid_dlg_storage_cam01b")
end

function sr3_city_talk_to_vp( human, talk_trig )
	do_dialogue_wrapper( talk_trig, SR3_CITY_trigger.vp_sex.name, "num_keithdavid_talks", "keithdavid", "VP_01" )
	--do_dialogue_wrapper( SR3_CITY_trigger.talk_to_vp.name, SR3_CITY_trigger.vp_sex.name, "num_keithdavid_talks", "keithdavid", "VP_01", "vp_dlg_brdg_player01", "vp_dlg_brdg_cam01a", "vp_dlg_brdg_cam01b")
end

function sr3_city_talk_to_matt( human, talk_trig )
	do_dialogue_wrapper( talk_trig, SR3_CITY_trigger.matt_sex.name, "num_matt_talks", "matt", "Matt_Miller_01" )
	--do_dialogue_wrapper( SR3_CITY_trigger.talk_to_matt.name, SR3_CITY_trigger.matt_sex.name, "num_matt_talks", "matt", "Matt_Miller_01", "matt_dlg_storage_player", "matt_dlg_storage_cam01a", "matt_dlg_storage_cam01b")
end

function sr3_city_talk_to_gat( human, talk_trig )
	do_dialogue_wrapper( talk_trig, SR3_CITY_trigger.gat_sex.name, "num_gat_talks", "gat", "Johnny_Gat_01" )
	--do_dialogue_wrapper( SR3_CITY_trigger.talk_to_gat.name, SR3_CITY_trigger.gat_sex.name, "num_gat_talks", "gat", "Johnny_Gat_01", "gat_dlg_deck_player01", "gat_dlg_deck_cam01a", "gat_dlg_deck_cam01b")
end


--====================SEX CALLBACKS AND DO_SEX FUNCTION====================
--
--
--
--=========================================================================

--do modal sex sequence OR play no sex line
function do_sex( node_table, msn_trig, npc, npc_flag, anim, length )

	local msn_trig_was_active = false
	local active_node = nil
	local active_talk_trig = nil
	local active_sex_trig = nil
	local sex_nav = nil
	local count = 0
	
	-- figure out which action node is active
	for i = 1, #node_table do
		if ( node_table[i].talk_trig ~= nil and trigger_is_enabled( node_table[i].talk_trig ) ) then
			active_node = node_table[i].name
			active_talk_trig = node_table[i].talk_trig
			active_sex_trig = node_table[i].sex_trig
			sex_nav = node_table[i].sex_nav
			break
		end
	end

	-- disable triggers
	if ( active_sex_trig ~= nil ) then
		trigger_enable( active_sex_trig, false )
	end
	if ( active_talk_trig ~= nil ) then
		trigger_enable( active_talk_trig, false )
	end	
	if ( trigger_is_enabled( msn_trig ) == true ) then
		msn_trig_was_active = true
		trigger_enable( msn_trig, false )
	end
	
	if ( npc == "VP_01" ) then
	
		-- vp
		audio_play_persona_line( npc, "ship_no_sex_ever" )

		-- wait until line finishes, or 20 seconds have passed (whichever comes first)
		while ( audio_persona_line_playing( "VP_01" ) and count <= 80 ) do
			delay(0.25)
			count = count + 1
		end
		
		delay(0.25)		
		
	else
	
		-- all other homies
		if ( SR3_CITY_CRIBSHIP_sex_flags[npc_flag] == false ) then
		
			--start modal sex sequence
			SR3_CITY_CRIBSHIP_sex_flags[npc_flag] = true
			fade_out(0.5, SFX_FADE_ALPHA_FADE, SYNC_LOCAL)
			delay(0.5)
			
			--teleport to sex nav
			if ( sex_nav ~= nil ) then
				teleport( npc, sex_nav )
			end
			
			player_controls_disable( LOCAL_PLAYER )		
			action_play_synced_non_blocking( LOCAL_PLAYER, npc, anim, sex_nav, SYNC_LOCAL )
			
			if (npc == "Shaundi_01") then
				character_hide( "VP_01" )
			end
			
			delay(0.75)
			fade_in(0.5, SFX_FADE_ALPHA_FADE, SYNC_LOCAL, {0,0,0} )

			delay( length )
			
			fade_out(0.75, SFX_FADE_ALPHA_FADE, SYNC_LOCAL)
			delay(6)
			
			if (active_node ~= nil) then
				npc_use_closest_action_node_of_type(npc, active_node, 200, true )
			end
			
			delay(0.5)
			player_controls_enable( LOCAL_PLAYER )
			
			if (npc == "Shaundi_01") then
				character_show( "VP_01" )
			end		
			
			fade_in(0.75, SFX_FADE_ALPHA_FADE, SYNC_LOCAL, {0,0,0} )
			
		else
		
			--play no sex line
			audio_play_persona_line( npc, "ship_no_sex_right_now" )	
			
			-- wait until line finishes, or 20 seconds have passed (whichever comes first)
			while ( audio_persona_line_playing( npc ) and count <= 80 ) do
				delay(0.25)
				count = count + 1
			end

			delay(0.25)
			
		end
		
	end
	
	-- reactivate triggers if necessary
	if ( active_sex_trig ~= nil ) then
		trigger_enable( active_sex_trig, true )
	end
	if ( active_talk_trig ~= nil ) then
		trigger_enable( active_talk_trig, true )
	end
	if ( msn_trig_was_active == true ) then
		trigger_enable( msn_trig, true )
	end
	
end


--sex trigger callbacks
function sr3_city_asha_sex()
	local node_table = SR3_CITY_ship_action_nodes.asha
	local contact_trig = "asha_trigger"
	local npc = "Asha_01"
	local flag = "flag_asha_sex"
	local anim = "FuckBuddy Asha"
	local anim_duration = 13.5
	
	gds_sex("Asha_01", "fb - asha")
	do_sex( node_table, contact_trig, npc, flag, anim, anim_duration )
	stat_increment("fb - asha")
	
	--do_sex( "asha_sex_nav", false, SR3_CITY_trigger.asha_sex.name, SR3_CITY_trigger.talk_to_asha.name, "", "", "", "", 14.0, "asha_baglean", true )
end

function sr3_city_benking_sex()
	local node_table = SR3_CITY_ship_action_nodes.benking
	local contact_trig = "ben_king_trigger"
	local npc = "Ben_King_01"
	local flag = "flag_benking_sex"
	local anim = "FuckBuddy King"
	local anim_duration = 32.5
	
	gds_sex("Ben_King_01", "fb - ben")
	do_sex( node_table, contact_trig, npc, flag, anim, anim_duration )
	stat_increment("fb - ben")
	
	--do_sex( "ben_king_sex_nav", true, SR3_CITY_trigger.ben_king_sex.name, SR3_CITY_trigger.talk_to_ben.name, "ben_king_trigger", "Ben_King_01", "flag_benking_sex", "FuckBuddy King", 32.5, "King_leaning", true )
end

function sr3_city_cid_sex()
	local node_table = SR3_CITY_ship_action_nodes.cid
	local contact_trig = "cid_trigger"
	local npc = "CID_01"
	local flag = "flag_cid_sex"
	local anim = "FuckBuddy Cid"
	local anim_duration = 10.25
	
	gds_sex("CID_01", "fb - cid")
	do_sex( node_table, contact_trig, npc, flag, anim, anim_duration )
	stat_increment("fb - cid")
	
	--do_sex( "cid_sex_nav", false, SR3_CITY_trigger.cid_sex.name, SR3_CITY_trigger.talk_to_cid.name, "cid_trigger", "CID_01", "flag_cid_sex", "FuckBuddy Cid", 10.25, nil, nil )
end

function sr3_city_gat_sex()
	local node_table = SR3_CITY_ship_action_nodes.gat
	local contact_trig = "johnny_gat_trigger"
	local npc = "Johnny_Gat_01"
	local flag = "flag_gat_sex"
	local anim = "FuckBuddy Gat"
	local anim_duration = 32.0
	
	gds_sex("Johnny_Gat_01", "fb - gat")
	do_sex( node_table, contact_trig, npc, flag, anim, anim_duration )
	stat_increment("fb - gat")
	
	--do_sex( "johnny_gat_sex_nav", true, SR3_CITY_trigger.gat_sex.name, SR3_CITY_trigger.talk_to_gat.name, "johnny_gat_trigger", "Johnny_Gat_01", "flag_gat_sex", "FuckBuddy Gat", 33.0, "Ship_Gat_Locker", true )
end

function sr3_city_kinzie_sex()
	local node_table = SR3_CITY_ship_action_nodes.kinzie
	local contact_trig = "kinzie_trigger"
	local npc = "Kinzie_01"
	local flag = "flag_kinzie_sex"
	local anim = "FuckBuddy Kinzie"
	local anim_duration = 5.5
	
	gds_sex("Kinzie_01", "fb - kinzie")
	do_sex( node_table, contact_trig, npc, flag, anim, anim_duration )
	stat_increment("fb - kinzie")
	
	--do_sex( "kinzie_sex_nav", false, SR3_CITY_trigger.kinzie_sex.name, SR3_CITY_trigger.talk_to_kinzie.name, "kinzie_trigger", "Kinzie_01", "flag_kinzie_sex", "FuckBuddy Kinzie", 5.5, "kinzie_typing", true )
end

function sr3_city_matt_sex()
	local node_table = SR3_CITY_ship_action_nodes.matt
	local contact_trig = "matt_miller_trigger"
	local npc = "Matt_Miller_01"
	local flag = "flag_matt_sex"
	local anim = "FuckBuddy Matt"
	local anim_duration = 20.5
	
	gds_sex("Matt_Miller_01", "fb - matt")
	do_sex( node_table, contact_trig, npc, flag, anim, anim_duration )
	stat_increment("fb - matt")
	
	--do_sex( "matt_miller_sex_nav", false, SR3_CITY_trigger.matt_sex.name, SR3_CITY_trigger.talk_to_matt.name, "matt_miller_trigger", "Matt_Miller_01", "flag_matt_sex", "FuckBuddy Matt", 20.5, "Matt_ship_couch", true )
end

function sr3_city_pierce_sex()
	local node_table = SR3_CITY_ship_action_nodes.pierce
	local contact_trig = "pierce_trigger"
	local npc = "Pierce_01"
	local flag = "flag_pierce_sex"
	local anim = "FuckBuddy Pierce"
	local anim_duration = 13.25
	
	gds_sex("Pierce_01", "fb - pierce")
	do_sex( node_table, contact_trig, npc, flag, anim, anim_duration )
	stat_increment("fb - pierce")
	
	--do_sex( "pierce_sex_nav", false, SR3_CITY_trigger.pierce_sex.name, SR3_CITY_trigger.talk_to_pierce.name, "pierce_trigger", "Pierce_01", "flag_pierce_sex", "FuckBuddy Pierce", 13.75, "Pierce_couch", true )
end

function sr3_city_shaundi_sex()
	local node_table = SR3_CITY_ship_action_nodes.shaundi
	local contact_trig = "shaundi_trigger"
	local npc = "Shaundi_01"
	local flag = "flag_shaundi_sex"
	local anim = "FuckBuddy Shaundi"
	local anim_duration = 32.0
	
	gds_sex("Shaundi_01", "fb - shaundi")
	do_sex( node_table, contact_trig, npc, flag, anim, anim_duration )
	stat_increment("fb - shaundi")
	
	--do_sex( "shaundi_sex_nav", false, SR3_CITY_trigger.shaundi_sex.name, SR3_CITY_trigger.talk_to_shaundi.name, "shaundi_trigger", "Shaundi_01", "flag_shaundi_sex", "FuckBuddy Shaundi", 32.0, nil, nil )
end

function sr3_city_vp_sex()
	local node_table = SR3_CITY_ship_action_nodes.vp
	local contact_trig = "vp_trigger"
	local npc = "VP_01"
	local flag = nil
	local anim = nil
	local anim_duration = nil
	
	gds_sex("VP_01", "fb - veep")
	do_sex( node_table, contact_trig, npc, flag, anim, anim_duration )
end

	-- text adventure completion variable
	Ship_UI_completion = {}
	

-- get the trigger table from the trigger name
--
-- trigger:		(string) trigger name
--
function crib_ship_trigger_get_table(trigger)
	local trigger_table
	for i,trig in pairs(SR3_CITY_trigger) do
		if trig.name == trigger then
			trigger_table = trig
		end
	end
	return trigger_table
end

function crib_ship_trigger_cb( human, trigger )
	-- This may be called multiple times in the same frame.  Never create groups in a trigger callback.  Use show group instead.
	
	-- find this trigger
	local table_entry = crib_ship_trigger_get_table( trigger )
	
	if table_entry ~= nil then
		if table_entry.hit == true then
			return
		end
		
		table_entry.hit = true
		table_entry.last_hit_by = human
		
		on_trigger( "", table_entry.name )
		trigger_enable( table_entry.name, false )
		
		-- Conversation system link
		if table_entry.conversation ~= nil and table_entry.conversation ~= "" then
			convo_start(table_entry.conversation)
		end
	end
end

-- CALLED FROM CODE (+++MUST RETURN IMMEDIATLY+++)
function hub_loaded( )

	mission_apply_ship_suit_to_players()
	
	convo_startup(SR3_CITY_convo)

	for i, trig in pairs(SR3_CITY_trigger) do
		if trig.callback == nil or trig.callback == "" then
			on_trigger( "crib_ship_trigger_cb", trig.name )
		else
			on_trigger( trig.callback, trig.name )
		end
		trig.hit = false
		trig.last_hit_by = nil
	end

	trigger_enable (SR3_CITY_trigger.start_txt_adventure.name, true)
	--trigger_enable (SR3_CITY_trigger.hack_cargo.name, true)
	
	-- reset global vars needed for each crib ship visit	
	for i, num_talks in pairs(SR3_CITY_CRIBSHIP_num_talks) do
		SR3_CITY_CRIBSHIP_num_talks[i] = 0
	end
	for i, sex_flag in pairs(SR3_CITY_CRIBSHIP_sex_flags) do
		SR3_CITY_CRIBSHIP_sex_flags[i] = false
	end	
	
	sr3_city_homie_setup_wrapper()
end


--set up homies wrapper function; decide which action nodes to use
function sr3_city_homie_setup_wrapper()

	
	------ KINZIE ------
	local kinzie_node = nil
	
	if mission_is_complete( "m05" ) and not mission_is_complete( "m07" ) then	
	
		-- working on mech node
		kinzie_node = SR3_CITY_ship_action_nodes.kinzie[1]
	
	elseif mission_is_complete( "m07" ) and not mission_is_complete( "m10" ) then
	
		-- beanbag, tube, or control room
		local kinzie_idx = rand_int( 3, #SR3_CITY_ship_action_nodes.kinzie )
		kinzie_node = SR3_CITY_ship_action_nodes.kinzie[kinzie_idx]	
	
	elseif mission_is_complete( "m17" ) and not mission_is_complete( "m19" ) then
	
		-- nemo chair node
		kinzie_node = SR3_CITY_ship_action_nodes.kinzie[2]
		--mesh_mover_update_control( "nemo_rig_kinzie", "is nemo open", true )
		--mesh_mover_update_control( "nemo_rig_kinzie", "closed restart", true )		
		
	else
	
		-- beanbag or tube (NOT control room)
		local kinzie_idx = rand_int( 4, #SR3_CITY_ship_action_nodes.kinzie )
		kinzie_node = SR3_CITY_ship_action_nodes.kinzie[kinzie_idx]
		
	end
	
	sr3_city_homie_setup( "Kinzie_Group_001", "Kinzie_01", kinzie_node.talk_trig, kinzie_node.sex_trig, kinzie_node.contact_trig, kinzie_node.name, true )
	
	
	------ VP ------
	local vp_idx = nil
	local vp_node = nil
	
	if not mission_is_complete ( "m08" ) then
	
		-- catwalk, bridge seat, or bridge stand
		vp_idx = rand_int( 1 , #SR3_CITY_ship_action_nodes.vp )
		vp_node = SR3_CITY_ship_action_nodes.vp[vp_idx]	
		sr3_city_homie_setup( "VP_Group_001", "VP_01", vp_node.talk_trig, vp_node.sex_trig, vp_node.contact_trig, vp_node.name, true )			
	elseif not mission_is_complete ( "m17" ) or mission_is_complete ( "m18" ) then
	
		-- bridge seat or bridge stand (NOT catwalk)
		vp_idx = rand_int( 2 , #SR3_CITY_ship_action_nodes.vp )
		vp_node = SR3_CITY_ship_action_nodes.vp[vp_idx]		
		sr3_city_homie_setup( "VP_Group_001", "VP_01", vp_node.talk_trig, vp_node.sex_trig, vp_node.contact_trig, vp_node.name, true )			
	end
	
	
	------ CID ------
	if mission_is_complete( "m05" ) then
		local cid_node = SR3_CITY_ship_action_nodes.cid[1]
		
		sr3_city_homie_setup( "CID_Group_001", "CID_01", cid_node.talk_trig, cid_node.sex_trig, cid_node.contact_trig, cid_node.name, true )
	end
	
	
	------ MATT MILLER ------
	if mission_is_complete( "m07" ) then
		local matt_node = nil
		local matt_idx = nil
	
		if not mission_is_complete( "m18" ) or mission_is_complete( "m19" ) then
		
			-- anywhere EXCEPT control room
			matt_idx = rand_int( 2, #SR3_CITY_ship_action_nodes.matt )
			matt_node = SR3_CITY_ship_action_nodes.matt[matt_idx]
		
		else
	
			-- m18 complete, m19 not complete - control room
			matt_node = SR3_CITY_ship_action_nodes.matt[1]
		
		end
		
		sr3_city_homie_setup( "Matt_Miller_Group_001", "Matt_Miller_01", matt_node.talk_trig, matt_node.sex_trig, matt_node.contact_trig, matt_node.name, true )		
	end
	
	
	------ SHAUNDI ------
	if mission_is_complete( "m08" ) then
	
		local shaundi_idx = nil
		local shaundi_node = nil
		
		if not mission_is_complete( "m10" ) then
	
			-- catwalk
			shaundi_node = SR3_CITY_ship_action_nodes.shaundi[2]
		
		elseif mission_is_complete( "m10" ) and not mission_is_complete( "m14" ) then
	
			-- control room
			shaundi_node = SR3_CITY_ship_action_nodes.shaundi[1]
		
		elseif mission_is_complete( "m14" ) and not mission_is_complete( "m19" ) then
	
			-- any on bridge
			shaundi_idx = rand_int( 3 , #SR3_CITY_ship_action_nodes.shaundi )
			shaundi_node = SR3_CITY_ship_action_nodes.shaundi[shaundi_idx]	
		
		elseif mission_is_complete( "m19" ) then
	
			-- control room
			shaundi_node = SR3_CITY_ship_action_nodes.shaundi[1]
			
		end
		
		sr3_city_homie_setup( "Shaundi_Group_001", "Shaundi_01", shaundi_node.talk_trig, shaundi_node.sex_trig, shaundi_node.contact_trig, shaundi_node.name, true )
		
	end
	
	
	------ PIERCE ------
	if mission_is_complete( "m09" ) then
		local pierce_idx = rand_int( 1 , #SR3_CITY_ship_action_nodes.pierce )
		local pierce_node = SR3_CITY_ship_action_nodes.pierce[pierce_idx]	
	
		sr3_city_homie_setup( "Pierce_Group_001", "Pierce_01", pierce_node.talk_trig, pierce_node.sex_trig, pierce_node.contact_trig, pierce_node.name, true )
	end
	
	
	------ BEN KING ------
	if mission_is_complete( "m10" ) then
		local benking_idx = rand_int( 1 , #SR3_CITY_ship_action_nodes.benking )
		local benking_node = SR3_CITY_ship_action_nodes.benking[benking_idx]
	
		sr3_city_homie_setup( "Ben_King_Group_001", "Ben_King_01", benking_node.talk_trig, benking_node.sex_trig, benking_node.contact_trig, benking_node.name, true )
	end
	
	
	------ ASHA ------
	if mission_is_complete( "m11" ) then
		local asha_idx = rand_int( 1 , #SR3_CITY_ship_action_nodes.asha )
		local asha_node = SR3_CITY_ship_action_nodes.asha[asha_idx]
		
		sr3_city_homie_setup( "Asha_Group_001", "Asha_01", asha_node.talk_trig, asha_node.sex_trig, asha_node.contact_trig, asha_node.name, true )
	end

	
	------ GAT ------	
	if mission_is_complete( "m15_3" ) then
		local gat_idx = rand_int( 1 , #SR3_CITY_ship_action_nodes.gat )
		local gat_node = SR3_CITY_ship_action_nodes.gat[gat_idx]

		sr3_city_homie_setup( "Johnny_Gat_Group_001", "Johnny_Gat_01", gat_node.talk_trig, gat_node.sex_trig, gat_node.contact_trig, gat_node.name, true )
	end

	
end

--set up homies for crib ship -- group, triggers, action node
function sr3_city_homie_setup( group, npc, talk_trig, sex_trig, contact_trig, action_node, teleport_bool )
	if not group_is_loaded(group) then
		group_create( group )
	end
	
	if (talk_trig ~= nil) then
		trigger_enable( talk_trig, true )
	end
	
	if (sex_trig ~= nil) then
		trigger_enable( sex_trig, true )
		trigger_copy_pos_from( sex_trig, talk_trig ) -- move sex trigger to same position as talk trigger
	end
	
	if (action_node ~= nil) then
		npc_use_closest_action_node_of_type( npc, action_node, 200, teleport_bool )
	end

	if (contact_trig ~= nil) then
		trigger_copy_pos_from( contact_trig, talk_trig ) -- move contact trigger to same position as talk trigger
	end
end


-- ALL FOLLOWING COOP SKIP FUNCTIONS CALLED FROM CODE (+++MUST RETURN IMMEDIATLY+++)

-- Teleport players to a mission start node
--
-- mission_name:	(string) name of the mission start node (should be same as mission name)
-- skip_teleport:	(boolean) true to basically skip this whole function, nil or not true will run it
--
function sr3_teleport_mission_start(mission_name, skip_teleport)
	if skip_teleport == nil or skip_teleport ~= true then
		-- send them to the mission start
		local vehicle_exit = true
		local offset_x = 0.5
		teleport_to_object(LOCAL_PLAYER, mission_name, vehicle_exit, nil, offset_x)
		-- remote player not on top of player
		offset_x = -0.5
		teleport_to_object(REMOTE_PLAYER, mission_name, vehicle_exit, nil, offset_x)
	end
end

function ship_use_trigger_cb(human, trigger)
	-- do default trigger behavior
	-- trigger_cb(human, trigger)
		local trigger_table = trigger_get_table(trigger)
		
	if trigger_table.use_anim ~= nil and trigger_table.use_anim ~= "" then
		local anim_name = trigger_table.use_anim
		local morph_name = anim_name
		local force_play = false	
		local percentage = 0.8
		local stand_still = true
		local zero_movement = true
		action_play(human, anim_name, morph_name, force_play, percentage, stand_still, zero_movement, trigger_table.use_nav)
	end
end

-- start the text adventure
--
-- human:		(string) name of human that tripped the trigger
-- trigger:		(string) name of the trigger
--	
function ship_start_text_adventure_cb(human, trigger)
	-- find this trigger
	local table_entry = crib_ship_trigger_get_table( trigger )
	
	if table_entry ~= nil then
		if table_entry.hit == true then
			return
		end
		
		table_entry.hit = true
		table_entry.last_hit_by = LOCAL_PLAYER
		
		on_trigger( "", table_entry.name )
		trigger_enable( table_entry.name, false )
		
		-- play anim
		action_play( LOCAL_PLAYER, table_entry.use_anim, table_entry.use_anim, false, 0.9, true, true, table_entry.use_nav )
		
		-- start the text adventure and hook up a callback to know when they're done
		Ship_UI_completion[ LOCAL_PLAYER ] = false
		hud_push_screen( "col_main", SYNC_LOCAL )
		--on_hud_screen_exit( "ship_UI_text_complete_cb", "col_main" )
		player_controls_disable(LOCAL_PLAYER)
		
		-- wait until player exits screen
		while hud_is_screen_on_stack( "col_main" ) do
			thread_yield()
		end
		
		--[[
		while not Ship_UI_completion[ LOCAL_PLAYER ] do
			thread_yield()
		end
		]]
		
		-- re-enable trigger
		table_entry.hit = false
		on_trigger( "ship_start_text_adventure_cb", table_entry.name )
		trigger_enable( table_entry.name, true )
		player_controls_enable( LOCAL_PLAYER )
		Ship_UI_completion[ LOCAL_PLAYER ] = true
	end
end

--[[
-- callback to handle text adventure being completed
--
--	screen_name:	(string) screen completed
--	player_name:	(string) player using the screen
--
function ship_UI_text_complete_cb( screen_name, player_name )
	if (screen_name ~= "col_main") then
		return
	end
	
	player_controls_enable( player_name )
	
	-- flag the player as completed
	Ship_UI_completion[ player_name ] = true	
end
]]